# Polski plik jezykowy/Polish language file.
# Tlumaczenie/Translation:
#               Armada Jaroslaw    <yoplait@yoplait.org>
#               Eskela             <eskela@gmail.com>
#               Mierzwiak Bartosz  <bartosz@mierzwiak.com>
#               Swierkosz Szymon   <szymek@adres.pl>
#               Szczyrzyca Mateusz <annihilator@ircnet.pl>
#               PolNet Team: http://www.ircnet.pl
#
# Aktualizacja/Updated: 13/10/2008
# Wersja serwisow/Anope version: svn-1477
#
# This file is encoded using iso-8859-2.
#
###########################################################################
#
# (C) 2003-2010 Anope Team
# Contact us at team@anope.org
#   
# Please read COPYING and README for further details.
#     
# Based on the original code of Epona by Lara.
# Based on the original code of Services by Andy Church. 
#
# When translating this file to another language, keep in mind that the
# order of parameters for sprintf() is fixed in the source code, so your
# messages need to take the same parameters in the same order as the
# English messages do.  (Obviously, this doesn't hold for the strftime()
# format lines immediately below.)  If you can't get a natural translation
# of a message without changing the order of the parameters, let us know
# (team@anope.org) which message is causing a problem and I'll see
# what I can do.
#
# In help messages, "%S" (capital S, not lowercase) refers to the name of
# the service sending the message; for example, in NickServ help messages,
# "%S" is replaced by "NickServ" (or whatever it is renamed to in
# services.conf).  The %S's do not count as sprintf() parameters, so they can be
# rearranged, removed, or added as necessary.
#
# Also in help messages, please try to limit line lengths to 60 characters
# of text (not including the leading tab).  This length was chosen because
# it does not cause line wrap under default settings on most current IRC
# clients.  Remember that format characters (control-B, control-_) are not
# included in that 60-character limit (since they don't show on the user's
# screen).  Also remember that format specifiers (%S, etc.) will expand
# when displayed, so remember to take this into account; you can assume
# that the length of a pseudoclient name (%S replacement) will be eight
# characters, so reduce the maximum line length by 6 for every %S on a
# line.
#
# Finally, remember to put a tab at the beginning of every line of text
# (including empty lines).  This has to be a tab, not spaces.
###########################################################################
#
# Name of this language
#
###########################################################################
# For languages other than English, this string should have the following
# format:
#     language-name-in-language (language-name-in-English)
# For example, "Espa�l (Spanish)" or "Fran�is (French)".
LANG_NAME
	Polski (Polish)

###########################################################################
#
# General messages
#
###########################################################################
# strftime() format strings.  man 3 strftime for information on the
# meanings of the format specifiers.  Short version:
#	%a = weekday name (short)	%H = hour
#	%b = month name (short)		%M = minute
#	%d = day of month		%S = second
#	%Y = year			%Z = time zone
# This is used as the format string for strftime() for a date and time
# together.
STRFTIME_DATE_TIME_FORMAT
	%d %b %Y %H:%M:%S %Z

# This is used as the format string for strftime() for a date alone in long
# format (English: including weekday).
STRFTIME_LONG_DATE_FORMAT
	%a %b %d %Y

# This is used as the format string for strftime() for a date alone in
# short format (English: without weekday).
STRFTIME_SHORT_DATE_FORMAT
	%b %d %Y

# These tell our strftime() what the names of months and days are.  If you
# don't use %a, %A, %b, or %B in your strftime() strings above, you can
# leave these empty.  However, if you enter names, they MUST stay in order,
# one per line, and the list MUST be complete!
# %a
STRFTIME_DAYS_SHORT
	Nie
	Pon
	Wto
	ro
	Czw
	Pia
	Sob

# %A
STRFTIME_DAYS_LONG
	Niedziela
	Poniedziaek
	Wtorek
	roda
	Czwartek
	Pitek
	Sobota

# %b
STRFTIME_MONTHS_SHORT
	Sty
	Lut
	Mar
	Kwi
	Maj
	Cze
	Lip
	Sie
	Wrz
	Pa
	Lis
	Gru

# %B
STRFTIME_MONTHS_LONG
	Stycze
	Luty
	Marzec
	Kwiecie
	Maj
	Czerwiec
	Lipiec
	Sierpie
	Wrzesie
	Padziernik
	Listopad
	Grudzie

# This is used in ChanServ/NickServ INFO displays.
COMMA_SPACE
	,

# Various error messages.
USER_RECORD_NOT_FOUND
	Bd wewntrzny - nie mog obsuy dania.

UNKNOWN_COMMAND
	Nieznana komenda %s.

UNKNOWN_COMMAND_HELP
	Nieznana komenda %s. Napisz "%R%s HELP" aby uzyska pomoc.

SYNTAX_ERROR
	Skadnia: %s

MORE_INFO
	Napisz %R%s HELP %s aby uzyska wicej informacji.

NO_HELP_AVAILABLE
	Brak dostpnej pomocy dla %s.

OBSOLETE_COMMAND
	Ta komenda jest ju przestarzaa. Uyj %s.

BAD_USERHOST_MASK
	Maska musi mie format ident@host.

BAD_EXPIRY_TIME
	Nieprawidowy czas wygasania.

USERHOST_MASK_TOO_WIDE
	%s jest za oglna; uyj bardziej szczegowej maski.

SERVICE_OFFLINE
	%s jest obecnie offline.

READ_ONLY_MODE
	Uwaga: Serwisy s w trybie tylko do odczytu - zmiany nie bd zapisywane!

PASSWORD_INCORRECT
	Nieprawidowe haso.

INVALID_TARGET
	"/msg %s" nie jest ju obsugiwane. Uyj "/msg %s@%s" lub "/%s".

# What's the difference between "Access denied" and "Permission denied"?
# Very little; you can safely make them the same message with no real loss
# of meaning.  If you want to make a distinction, "Access denied" is
# usually used more generally; for example, a non-oper trying to access
# OperServ gets "Access denied", while a non-Services admin trying to use
# NickServ SASET NOEXPIRE gets "Permission denied".
ACCESS_DENIED
	Odmowa dostpu.

PERMISSION_DENIED
	Brak uprawnie.

RAW_DISABLED
	Polecenie RAW zostao wyczone. Jeli chcesz go uywa,
	ustaw odpowiednio DisableRaw w konfiguracji serwisw.

MORE_OBSCURE_PASSWORD
	Prosz sprbowa ponownie z trudniejszym hasem.
	Haso powinno mie minimum 5 znakw oraz powinno
	zawiera cyfry i litery.

PASSWORD_TOO_LONG
	Twoje haso jest za dugie. Sprbuj ponownie z krtszym hasem.

NICK_NOT_REGISTERED
	Twj nick nie jest zarejestrowany.

NICK_NOT_REGISTERED_HELP
	Twj nick jest niezarejestrowany.
	Napisz %R%s HELP aby uzyska pomoc na temat rejestracji.

NICK_X_IS_SERVICES
	Nick %s jest serwisem!

NICK_X_NOT_REGISTERED
	Nick %s nie jest zarejestrowany.

NICK_X_IN_USE
	Nick %s jest aktualnie w uyciu.

NICK_X_NOT_IN_USE
	Nick %s nie jest aktualnie uywany.

NICK_X_NOT_ON_CHAN
	%s nie jest aktualnie na kanale %s.

NICK_X_FORBIDDEN
	Nick %s nie moe by rejestrowany ani uywany.

NICK_X_FORBIDDEN_OPER
	Nick %s zosta zablokowany przez %s:
	%s

NICK_X_ILLEGAL
	Nick %s jest nieprawidowy i nie moe by uywany.

NICK_X_TRUNCATED
	Nick %s zosta skrcony do %d znakw.

NICK_X_SUSPENDED
	Nick %s jest obecnie zawieszony.

CHAN_X_NOT_REGISTERED
	Kana %s nie jest zarejestrowany.

CHAN_X_NOT_IN_USE
	Kana %s nie istnieje.

CHAN_X_FORBIDDEN
	Kanau %s nie mona rejestrowa ani uywa.

CHAN_X_FORBIDDEN_OPER
	Kana %s zosta zablokowany przez %s:
	%s

CHAN_X_SUSPENDED
	     Zawieszony: [%s] %s

NICK_IDENTIFY_REQUIRED
	Aby uy tej komendy musisz si zidentyfikowa.
	Napisz %R%s IDENTIFY haso, a pniej ponw prb.

CHAN_IDENTIFY_REQUIRED
	Do uycia tej komendy wymagana jest identyfikacja.
	Napisz %R%s IDENTIFY %s haso, a pniej ponw prb.
	

MAIL_DISABLED
	Serwisy zostay skonfigurowane tak, aby nie wysya poczty.

MAIL_INVALID
	Adres e-mail dla %s nie jest prawidowy.

MAIL_X_INVALID
	%s nie jest prawidowym adresem e-mail.

MAIL_LATER
	Nie mog wysa teraz maila. Sprbuj za chwil.

MAIL_DELAYED
	Prosz odczeka %d sekund(y) i ponowi prb.
	

NO_REASON
	Bez powodu

UNKNOWN
	<nieznane>

# Duration system
DURATION_DAY
	1 dzie

DURATION_DAYS
	%d dni

DURATION_HOUR
	1 godzina

DURATION_HOURS
	%d godzin(y)

DURATION_MINUTE
	1 minuta

DURATION_MINUTES
	%d minut(y)

DURATION_SECOND
	1 sekunda

DURATION_SECONDS
	%d sekund(y)

# Human readable expiration
NO_EXPIRE
	nie wygasa

EXPIRES_SOON
	wygasa przy nastpnej aktualizacji baz

EXPIRES_M
	wygasa za %d minut(y)

EXPIRES_1M
	wygasa za %d minut

EXPIRES_HM
	wygasa za %d godzin(y) i %d minut(y)

EXPIRES_H1M
	wygasa za %d godzin i %d minut(y)

EXPIRES_1HM
	wygasa za %d godzin i %d minut(y)

EXPIRES_1H1M
	wygasa za %d godzin i %d minut

EXPIRES_D
	wygasa za %d dni

EXPIRES_1D
	wygasa za %d dzie

# Generic Footer message
END_OF_ANY_LIST
	Koniec listy %s.

# Generic List error messages
LIST_INCORRECT_RANGE
	Podano nieprawidowy zakres. Poprawny zapis to #od-do.

CS_LIST_INCORRECT_RANGE
	Aby wyszuka kanay o nazwach zaczynajcych si znakiem #
	naley ten znak pomin (anope zamiast #anope).

# Generic help limited to messages
HELP_LIMIT_SERV_OPER
	
	Polecenie dostpne tylko dla operatorw serwisw.

HELP_LIMIT_SERV_ADMIN
	
	Polecenie dostpne tylko dla administratorw serwisw.

HELP_LIMIT_SERV_ROOT
	
	Polecenie dostpne tylko dla Services Roots.

HELP_LIMIT_IRC_OPER
	
	Polecenie dostpne tylko dla IRC operatorw.

HELP_LIMIT_HOST_SETTER
	
	Polecenie dostpne tylko dla Host Setters.

HELP_LIMIT_HOST_REMOVER
	
	Polecenie dostpne tylko dla Host Removers.

###########################################################################
#
# NickServ messages
#
###########################################################################
# Automatic messages
NICK_IS_REGISTERED
	Ten nick jest zarejestrowany. Jeli to Twj nick,
	wpisz: %R%s IDENTIFY haso

NICK_IS_SECURE
	Ten nick jest zarejestrowany i chroniony.
	Zidentyfikuj si piszc: %R%s IDENTIFY haso
	jeli nick naley do Ciebie, w przeciwnym razie zmie go.

NICK_MAY_NOT_BE_USED
	Ten nick nie moe by uywany. Wybierz inny nick.

FORCENICKCHANGE_IN_1_MINUTE
	Masz jedn minut na zmian nicka, potem zostanie zmieniony si.

FORCENICKCHANGE_IN_20_SECONDS
	Masz 20 sekund na zmian nicka, potem zostanie zmieniony si.

FORCENICKCHANGE_NOW
	Ten nick zosta zarejestrowany i nie moesz go uywa.

FORCENICKCHANGE_CHANGING
	Twj nick zosta zmieniony na %s.

# REGISTER responses
NICK_REGISTER_SYNTAX
	REGISTER haso [email]

NICK_REGISTER_SYNTAX_EMAIL
	REGISTER haso email

NICK_REGISTRATION_DISABLED
	Rejestracja nickw jest tymczasowo wyczona.

NICK_REGISTRATION_FAILED
	Rejestracja nicka nie powioda si.

NICK_REG_PLEASE_WAIT
	Odczekaj %d sekund przed ponownym uyciem komendy REGISTER.

NICK_CANNOT_BE_REGISTERED
	Nick %s nie moe by rejestrowany.

NICK_ALREADY_REGISTERED
	Nick %s jest ju zarejestrowany!

NICK_REGISTERED
	Nick %s zosta zarejestrowany z mask: %s.

NICK_REGISTERED_NO_MASK
	Nick %s zosta zarejestrowany.

NICK_PASSWORD_IS
	Twoje haso do nicka to %s

NICK_REG_DELAY
	Musisz by poczony(a) duej ni %d sekund(y), aby mc zarejestrowa nick.

# GROUP responses
NICK_GROUP_SYNTAX
	GROUP nazwa haso

NICK_GROUP_DISABLED
	Grupowanie nickw jest tymczasowo wyczone.

NICK_GROUP_FAILED
	Grupowanie nie powiodo si.

NICK_GROUP_PLEASE_WAIT
	Odczekaj %d sekund przed ponownym uyciem komendy GROUP.

NICK_GROUP_CHANGE_DISABLED
	Twj nick jest ju zarejestrowany. Napisz najpierw: %R%s DROP

NICK_GROUP_SAME
	Naleysz ju do grupy %s.

NICK_GROUP_TOO_MANY
	W grupie %s jest za duo nickw, usu kilka.
	Napisz %R%s HELP GLIST i %R%s HELP DROP,
	aby uzyska wicej informacji.

NICK_GROUP_JOINED
	Naleysz teraz do grupy %s.

# IDENTIFY responses
NICK_IDENTIFY_SYNTAX
	IDENTIFY haso

NICK_IDENTIFY_FAILED
	Identyfikacja nie powioda si.

NICK_IDENTIFY_SUCCEEDED
	Haso przyjte - jeste zidentyfikowany(a).

NICK_IDENTIFY_EMAIL_REQUIRED
	Teraz ustaw adres e-mail dla Twojego nicka.
	Gdy zapomnisz hasa, zostanie ono wysane na e-mail.

NICK_IDENTIFY_EMAIL_HOWTO
	Napisz %R%S SET EMAIL e-mail, aby ustawi adres e-mail.
	Twoja prywatno bdzie uszanowana - nie bdzie podawany osobom trzecim,

NICK_ALREADY_IDENTIFIED
	Jeste ju zidentyfikowany(a).

# UPDATE responses
NICK_UPDATE_SUCCESS
	Status zaktualizowany (wiadomoci, vhosty, flagi).
	

# LOGOUT responses
NICK_LOGOUT_SYNTAX
	LOGOUT

NICK_LOGOUT_SUCCEEDED
	Twj nick zosta pomylnie wylogowany.

NICK_LOGOUT_X_SUCCEEDED
	Nick %s zosta wylogowany.

NICK_LOGOUT_SERVICESADMIN
	Nie mog wylogowa %s, bo to administrator serwisw.

# DROP responses
NICK_DROP_DISABLED
	Usuwanie nickw jest tymczasowo wyczone.

NICK_DROPPED
	Twj nick zosta odrejestrowany.

NICK_X_DROPPED
	Nick %s zosta odrejestrowany.

# SET responses
NICK_SET_SYNTAX
	SET opcja parametry

NICK_SET_SERVADMIN_SYNTAX
	SET [nick] opcja parametry

NICK_SET_DISABLED
	Modyfikacja ustawie nicka jest tymczasowo wyczona.

NICK_SET_UNKNOWN_OPTION
	Nieznana opcja komendy SET %s.

NICK_SET_OPTION_DISABLED
	Opcja %s nie jest dostpna w tej sieci.

# SET DISPLAY responses
NICK_SET_DISPLAY_INVALID
	Now nazw MUSI by jednym z nickw w grupie!

NICK_SET_DISPLAY_CHANGED
	Now nazw jest %s.

# SET PASSWORD responses
NICK_SET_PASSWORD_FAILED
	Zmiana hasa nie powioda si.

NICK_SET_PASSWORD_CHANGED
	Haso zostao zmienione.

NICK_SET_PASSWORD_CHANGED_TO
	Haso zostao zmienione na %s.

# SET LANGUAGE responses
NICK_SET_LANGUAGE_SYNTAX
	SET LANGUAGE numer

NICK_SET_LANGUAGE_UNKNOWN
	Nieznany numer jzyka %d.
	Napisz %R%s HELP SET LANGUAGE, aby uzyska list dostpnych jzykw.

NICK_SET_LANGUAGE_CHANGED
	Jzyk zosta zmieniony na Polski.

# SET URL responses
NICK_SET_URL_CHANGED
	Adres www zosta zmieniony na %s.

NICK_SET_URL_UNSET
	Adres www zosta usunity.

# SET EMAIL responses
NICK_SET_EMAIL_CHANGED
	Adres e-mail zosta zmieniony na %s.

NICK_SET_EMAIL_UNSET
	Adres e-mail zosta usunity.

NICK_SET_EMAIL_UNSET_IMPOSSIBLE
	Nie moesz usuwa adresu e-mail w tej sieci.
	

# SET ICQ responses
NICK_SET_ICQ_CHANGED
	Numer ICQ zosta zmieniony na %s.

NICK_SET_ICQ_UNSET
	Numer ICQ zosta usunity.

NICK_SET_ICQ_INVALID
	%s nie jest prawidowym numerem.
	

# SET GREET responses
NICK_SET_GREET_CHANGED
	Wiadomo powitalna zostaa zmieniona na:
	%s.

NICK_SET_GREET_UNSET
	Wiadomo powitalna zostaa usunita.

# SET PROTECT responses
NICK_SET_KILL_SYNTAX
	SET KILL {ON | QUICK | OFF}

NICK_SET_KILL_IMMED_SYNTAX
	SET KILL {ON | QUICK | IMMED | OFF}

NICK_SET_KILL_ON
	Ochrona jest teraz wczona.

NICK_SET_KILL_QUICK
	Ochrona ze zredukowanym opnieniem jest teraz wczona.

NICK_SET_KILL_IMMED
	Natychmiastowa ochrona jest teraz wczona.

NICK_SET_KILL_IMMED_DISABLED
	Opcja IMMED nie jest jest dostpna w tej sieci.

NICK_SET_KILL_OFF
	Ochrona jest teraz wyczona.

# SET SECURE responses
NICK_SET_SECURE_SYNTAX
	SET SECURE {ON | OFF}

NICK_SET_SECURE_ON
	Opcja bezpieczestwa zostaa wczona.

NICK_SET_SECURE_OFF
	Opcja bezpieczestwa zostaa wyczona.

# SET PRIVATE responses
NICK_SET_PRIVATE_SYNTAX
	SET PRIVATE {ON | OFF}

NICK_SET_PRIVATE_ON
	Opcja prywatnoci zostaa wczona.

NICK_SET_PRIVATE_OFF
	Opcja prywatnoci zostaa wyczona.

# SET HIDE responses
NICK_SET_HIDE_SYNTAX
	SET HIDE {EMAIL | USERMASK | QUIT} {ON | OFF}

NICK_SET_HIDE_EMAIL_ON
	Twj adres e-mail bdzie ukrywany w informacjach %s.

NICK_SET_HIDE_EMAIL_OFF
	Twj adres e-mail bdzie pokazywany w informacjach %s.

NICK_SET_HIDE_MASK_ON
	Twoja ostatnia maska ident@host bdzie ukrywana w informacjach %s.

NICK_SET_HIDE_MASK_OFF
	Twoja ostatnia maska ident@host bdzie pokazywana w informacjach %s.

NICK_SET_HIDE_QUIT_ON
	Twoja ostatnia wiadomo QUIT bdzie ukrywana w informacjach %s.

NICK_SET_HIDE_QUIT_OFF
	Twoja ostatnia wiadomo QUIT bdzie pokazywana w informacjach %s.

NICK_SET_HIDE_STATUS_ON
	Twj status dostpu do serwisw bdzie ukrywany w informacjach %s.

NICK_SET_HIDE_STATUS_OFF
	Twj status dostpu do serwisw bdzie pokazywany w informacjach %s.
	

# SET MSG responses
NICK_SET_MSG_SYNTAX
	SET MSG {ON | OFF}

NICK_SET_MSG_ON
	Serwisy bd teraz wysya wiadomoci.

NICK_SET_MSG_OFF
	Serwisy bd teraz wysya powiadomienia.

# SET AUTOOP responses
NICK_SET_AUTOOP_SYNTAX
	SET AUTOOP {ON | OFF}

NICK_SET_AUTOOP_ON
	Serwisy bd automatycznie nadaway Tobie uprawnienia.

NICK_SET_AUTOOP_OFF
	Serwisy nie bd ju automatycznie nadaway Tobie uprawnie.

# SASET responses
NICK_SASET_SYNTAX
	SASET nick opcja parametry

NICK_SASET_DISABLED
	Modyfikacja ustawie nicka jest tymczasowo wyczona.

NICK_SASET_UNKNOWN_OPTION
	Nieznana opcja komendy SASET %s.

NICK_SASET_BAD_NICK
	Nick %s nie jest zarejestrowany.

NICK_SASET_OPTION_DISABLED
	Opcja %s nie jest dostpna w tej sieci.

# SASET DISPLAY responses
NICK_SASET_DISPLAY_INVALID
	Nowa nazwa dla %s MUSI by jednym z nickw w grupie!

NICK_SASET_DISPLAY_CHANGED
	Now nazw jest %s.

# SASET PASSWORD responses
NICK_SASET_PASSWORD_FAILED
	Zmiana hasa dla %s nie powioda si.

NICK_SASET_PASSWORD_CHANGED
	Haso dla %s zostao zmienione.

NICK_SASET_PASSWORD_CHANGED_TO
	Haso dla %s zostao zmienione na %s.

# SASET URL responses
NICK_SASET_URL_CHANGED
	Adres www osoby %s zosta zmieniony na %s.

NICK_SASET_URL_UNSET
	Adres www osoby %s zosta usunity.

# SASET EMAIL responses
NICK_SASET_EMAIL_CHANGED
	Adres e-mail osoby %s zosta zmieniony na %s.

NICK_SASET_EMAIL_UNSET
	Adres e-mail osoby %s zosta usunity.

NICK_SASET_EMAIL_UNSET_IMPOSSIBLE
	Nie moesz usuwa adresu e-mail w tej sieci.
	

# SASET ICQ responses
NICK_SASET_ICQ_CHANGED
	Numer ICQ osoby %s zosta zmieniony na %s.

NICK_SASET_ICQ_UNSET
	Numer ICQ osoby %s zosta usunity.

NICK_SASET_ICQ_INVALID
	%s nie jest prawidowym numerem.
	

# SASET GREET responses
NICK_SASET_GREET_CHANGED
	Wiadomo powitalna osoby %s zostaa zmieniona na %s.

NICK_SASET_GREET_UNSET
	Wiadomo powitalna osoby %s zostaa usunita.

# SASET PROTECT responses
NICK_SASET_KILL_SYNTAX
	SASET nick KILL {ON | QUICK | OFF}

NICK_SASET_KILL_IMMED_SYNTAX
	SASET nick KILL {ON | QUICK | IMMED | OFF}

NICK_SASET_KILL_ON
	Ochrona dla %s jest teraz wczona.

NICK_SASET_KILL_QUICK
	Ochrona dla %s ze zredukowanym opnieniem jest teraz wczona.

NICK_SASET_KILL_IMMED
	Natychmiastowa ochrona dla %s jest teraz wczona

NICK_SASET_KILL_IMMED_DISABLED
	Opcja IMMED nie jest dostpna w tej sieci.

NICK_SASET_KILL_OFF
	Ochrona dla %s jest teraz wyczona.

# SASET SECURE responses
NICK_SASET_SECURE_SYNTAX
	SASET nick SECURE {ON | OFF}

NICK_SASET_SECURE_ON
	Opcja bezpieczestwa dla %s zostaa wczona.

NICK_SASET_SECURE_OFF
	Opcja bezpieczestwa dla %s zostaa wyczona.

# SASET PRIVATE responses
NICK_SASET_PRIVATE_SYNTAX
	SASET nick PRIVATE {ON | OFF}

NICK_SASET_PRIVATE_ON
	Opcja prywatnoci dla %s zostaa wczona.

NICK_SASET_PRIVATE_OFF
	Opcja prywatnoci dla %s zostaa wyczona.

# SASET HIDE responses
NICK_SASET_HIDE_SYNTAX
	SASET nick HIDE {EMAIL | USERMASK | QUIT} {ON | OFF}

NICK_SASET_HIDE_EMAIL_ON
	Adres e-mail osoby %s bdzie ukrywany w informacjach %s.

NICK_SASET_HIDE_EMAIL_OFF
	Adres e-mail osoby %s bdzie pokazywany w informacjach %s.

NICK_SASET_HIDE_MASK_ON
	Ostatnia maska ident@host osoby %s bdzie ukrywana w informacjach %s.

NICK_SASET_HIDE_MASK_OFF
	Ostatnia maska ident@host osoby %s bdzie pokazywana w informacjach %s.

NICK_SASET_HIDE_QUIT_ON
	Ostatnia wiadomo QUIT osoby %s bdzie ukrywana w informacjach %s.

NICK_SASET_HIDE_QUIT_OFF
	Ostatnia wiadomo QUIT osoby %s bdzie pokazywana w informacjach %s.

NICK_SASET_HIDE_STATUS_ON
	Status dostpu do serwisw osoby %s bdzie ukrywany w informacjach %s.

NICK_SASET_HIDE_STATUS_OFF
	Status dostpu do serwisw osoby %s bdzie pokazywany w informacjach %s.
	

# SASET MSG responses
NICK_SASET_MSG_SYNTAX
	SASAET nick PRIVATE {ON | OFF}

NICK_SASET_MSG_ON
	Serwisy bd teraz wysya do %s wiadomoci.

NICK_SASET_MSG_OFF
	Serwisy bd teraz wysya do %s powiadomienia.

# SASET NOEXPIRE responses
NICK_SASET_NOEXPIRE_SYNTAX
	SASET nick NOEXPIRE {ON | OFF}

NICK_SASET_NOEXPIRE_ON
	Nick %s nie wyganie.

NICK_SASET_NOEXPIRE_OFF
	Nick %s od teraz podlega zasadom wygasania.

# SASET AUTOOP responses
NICK_SASET_AUTOOP_SYNTAX
	SASET nick AUTOOP {ON | OFF}

NICK_SASET_AUTOOP_ON
	Serwisy bd automatycznie nadaway uprawnienia dla uytkownika %s.

NICK_SASET_AUTOOP_OFF
	Serwisy nie bd ju automatycznie nadaway uprawnie dla uytkownika %s.

# SASET LANGUAGE responses
NICK_SASET_LANGUAGE_SYNTAX
	SASET nick LANGUAGE numer

NICK_SASET_LANGUAGE_UNKNOWN
	Nieznany numer jzyka %d.
	Napisz %R%s HELP SET LANGUAGE, aby uzyska list dostpnych jzykw.

NICK_SASET_LANGUAGE_CHANGED
	Language for %s changed to %s.

# ACCESS responses
NICK_ACCESS_SYNTAX
	ACCESS {ADD | DEL | LIST} [maska]

NICK_ACCESS_ALREADY_PRESENT
	Maska %s jest ju w Twojej licie dostpu.

NICK_ACCESS_REACHED_LIMIT
	Moesz mie tylko %d wpisy(w) na licie dostpu.

NICK_ACCESS_ADDED
	%s dodano do Twojej listy dostpu.

NICK_ACCESS_NOT_FOUND
	%s nie znaleziono na Twojej licie dostpu.

NICK_ACCESS_DELETED
	%s usunito z Twojej listy dostpu.

NICK_ACCESS_LIST
	Lista dostpu:

NICK_ACCESS_LIST_X
	Lista dostpu dla %s:

NICK_ACCESS_LIST_EMPTY
	Twoja lista dostpu jest pusta.

NICK_ACCESS_LIST_X_EMPTY
	Lista dostpu dla %s jest pusta.

# Status messages
NICK_STATUS_0
	STATUS %s 0 (nie ma lub nie zarejestrowany)

NICK_STATUS_1
	STATUS %s 1 (nie jest zidentyfikowany)

NICK_STATUS_2
	STATUS %s 2 (identyfikacja list dostpu)

NICK_STATUS_3
	STATUS %s 3 (identyfikacja hasem)

# INFO responses
NICK_INFO_SYNTAX
	INFO nick [ALL]

NICK_INFO_REALNAME
	%s to %s

NICK_INFO_SERVICES_OPER
	%s jest operatorem serwisw.

NICK_INFO_SERVICES_ADMIN
	%s jest administratorem serwisw.

NICK_INFO_SERVICES_ROOT
	%s jest gwnym administratorem serwisw.

NICK_INFO_ADDRESS
	  Ostatni host: %s

NICK_INFO_ADDRESS_ONLINE
	 Jest online z: %s

NICK_INFO_ADDRESS_ONLINE_NOHOST
	%s jest teraz online.

NICK_INFO_TIME_REGGED
	Zarejestrowano: %s

NICK_INFO_LAST_SEEN
	      Widziano: %s

NICK_INFO_LAST_QUIT
	  Ostatni QUIT: %s

NICK_INFO_URL
	     Adres www: %s

NICK_INFO_EMAIL
	  Adres e-mail: %s

NICK_INFO_VHOST
	         vhost: %s

NICK_INFO_VHOST2
	         vhost: %s@%s

NICK_INFO_ICQ
	     Numer ICQ: %d

NICK_INFO_GREET
	     Powitanie: %s

NICK_INFO_OPTIONS
	         Opcje: %s

NICK_INFO_EXPIRE
	        Wygasa: %s

# These strings MUST NOT be empty
NICK_INFO_OPT_KILL
	KILL

NICK_INFO_OPT_SECURE
	SECURE

NICK_INFO_OPT_PRIVATE
	PRIVATE

NICK_INFO_OPT_MSG
	MSG

NICK_INFO_OPT_AUTOOP
	AUTOOP

NICK_INFO_OPT_NONE
	Brak

NICK_INFO_NO_EXPIRE
	Ten nick nie wyganie.

NICK_INFO_FOR_MORE
	Aby uzyska wicej informacji napisz %R%s INFO %s ALL.

NICK_INFO_SUSPENDED
	Ten nick jest obecnie zawieszony, powd: %s

NICK_INFO_SUSPENDED_NO_REASON
	Ten nick jest obecnie zawieszony

# LIST responses
NICK_LIST_SYNTAX
	LIST wzorzec

NICK_LIST_SERVADMIN_SYNTAX
	LIST wzorzec [FORBIDDEN] [SUSPENDED] [NOEXPIRE] [UNCONFIRMED]

NICK_LIST_HEADER
	Lista pasujcych wpisw %s:

NICK_LIST_RESULTS
	Koniec listy - %d/%d wpisw wywietlono.

# ALIST responses
NICK_ALIST_SYNTAX
	ALIST nick

NICK_ALIST_HEADER
	Kanay, na ktrych jeste na licie dostpu:
	  Nr   Kana              Poziom    Opis

NICK_ALIST_HEADER_X
	Kanay, na ktrych %s jest na licie dostpu:
	  Nr   Kana              Poziom    Opis

NICK_ALIST_XOP_FORMAT
	  %3d %c%-20s %-8s %s

NICK_ALIST_ACCESS_FORMAT
	  %3d %c%-20s %-8d %s

NICK_ALIST_FOOTER
	Koniec listy - %d/%d kanaw pokazano.

# GLIST responses
NICK_GLIST_HEADER
	Lista nickw w grupie:

NICK_GLIST_HEADER_X
	Lista nickw grupy %s:

NICK_GLIST_FOOTER
	%d nickw w grupie.

NICK_GLIST_REPLY
	   %c%s

NICK_GLIST_REPLY_ADMIN
	   %c%s (wygasa za %s)

# RECOVER responses
NICK_RECOVER_SYNTAX
	RECOVER nick [haso]

NICK_NO_RECOVER_SELF
	Nie moesz odzyska nicka, ktrego wanie uywasz!

NICK_RECOVERED
	Twj nick zosta wanie przejty przez serwisy.
	Napisz %R%s RELEASE %s, jeli nie chcesz czeka %s sekund na jego automatyczne zwolnienie.

# RELEASE responses
NICK_RELEASE_SYNTAX
	RELEASE nick [haso]

NICK_RELEASE_NOT_HELD
	Nick %s nie jest zajty przez serwisy.

NICK_RELEASED
	Serwisy wanie zwolniy twojego nicka.

# GHOST responses
NICK_GHOST_SYNTAX
	GHOST nick [haso]

NICK_NO_GHOST_SELF
	Nie moesz usun samego siebie!

NICK_GHOST_KILLED
	Nick zosta usunity z sieci.

# GETPASS responses
NICK_GETPASS_SYNTAX
	GETPASS nick

NICK_GETPASS_UNAVAILABLE
	Komenda GETPASS nie dziaa, bo hasa s szyfrowane.

NICK_GETPASS_PASSWORD_IS
	Haso dla %s to %s.

# GETEMAIL responses
NICK_GETEMAIL_SYNTAX
	GETEMAIL user@email-host Bez symboli wieloznacznych!

NICK_GETEMAIL_EMAILS_ARE
	Adresy e-mail %s pasujce do %s.

NICK_GETEMAIL_NOT_USED
	Nie ma uytkownikw z adresem e-mail %s.
	

# SENDPASS responses
NICK_SENDPASS_SYNTAX
	SENDPASS nick

NICK_SENDPASS_UNAVAILABLE
	Komenda SENDPASS nie dziaa, bo hasa s szyfrowane.

NICK_SENDPASS_SUBJECT
	Haso do nicka %s

NICK_SENDPASS_HEAD
	Witaj!

NICK_SENDPASS_LINE_1
	Zadae(a) wysania hasa do nicka %s na e-mail.

NICK_SENDPASS_LINE_2
	Twoje haso to: %s
	Dla wasnego bezpieczestwa naley to haso natychmiast zmieni na inne.

NICK_SENDPASS_LINE_3
	Jeli nie wiesz dlaczego ta wiadomo dotara do Ciebie zignoruj j. Jeli ta sytuacja bdzie si powtarza skontaktuj si z administratorem sieci.

NICK_SENDPASS_LINE_4
	PROSZ NIE ODPOWIADA NA T WIADOMO!

NICK_SENDPASS_LINE_5
	Administratorzy sieci %s.

NICK_SENDPASS_OK
	Haso do nicka %s zostao wysane.

# SUSPEND responses
NICK_SUSPEND_SYNTAX
	SUSPEND nick powd

NICK_SUSPEND_SUCCEEDED
	Nick %s zosta zawieszony.

NICK_SUSPEND_FAILED
	Zawieszenie nicka %s nie powiodo si!

# UNSUSPEND responses
NICK_UNSUSPEND_SYNTAX
	UNSUSPEND nick

NICK_UNSUSPEND_SUCCEEDED
	Nick %s zosta uwolniony.

NICK_UNSUSPEND_FAILED
	Nie mog uwolni nicka %s!

# FORBID responses
NICK_FORBID_SYNTAX
	FORBID nick [powd]

NICK_FORBID_SYNTAX_REASON
	FORBID nick powd

NICK_FORBID_SUCCEEDED
	Nick %s zosta zablokowany.

NICK_FORBID_FAILED
	Nie mog zablokowa nicka %s!

# Nick Registraion responses
NICK_REQUESTED
	Ten nick zosta ju zarejestrowany. Sprawd swoj poczt.

NICK_REG_RESENT
	Twj kod rejestracyjny zosta ponownie wysany na %s.

NICK_REG_UNABLE
	Nick nie zosta zarejestrowany. Prosz sprbowa pniej.

NICK_IS_PREREG
	Ten nick czeka na e-mail z kodem weryfikacyjnym przed zakoczeniem rejestracji.

NICK_ENTER_REG_CODE
	Kod zosta wysany na adres %s.
	Napisz %R%s CONFIRM <kod>, aby dokoczy procedur rejestracji.

NICK_CONFIRM_NOT_FOUND
	Termin wanoci kodu rejestracyjnego upyn.
	Napisz: %R%s REGISTER <haso> <email>,
	aby znowu zacz rejestracje.

NICK_CONFIRM_INVALID
	Podano nieprawidowy kod, sprawd wiadomo e-mail i sprbowa ponownie.

NICK_REG_MAIL_SUBJECT
	Rejestracja nicka %s

NICK_REG_MAIL_HEAD
	Witaj!

NICK_REG_MAIL_LINE_1
	Chcesz zarejestrowa nastpujcy nick: %s.

NICK_REG_MAIL_LINE_2
	Prosz napisa %R%s CONFIRM %s aby dokoczy rejestracj.

NICK_REG_MAIL_LINE_3
	Jeli nie wiesz dlaczego ta wiadomo dotara do Ciebie zignoruj j. Jeli sytuacja bdzie si powtarza skontaktuj si z administratorem sieci.
NICK_REG_MAIL_LINE_4
	PROSZ NIE ODPOWIADA NA T WIADOMO!

NICK_REG_MAIL_LINE_5
	Administratorzy sieci %s.

NICK_GETPASS_PASSCODE_IS
	Kod rejestracyjny dla %s to %s.

NICK_FORCE_REG
	Nick %s potwierdzony.

###########################################################################
#
# ChanServ messages
#
###########################################################################
# Access level descriptions
CHAN_LEVEL_AUTOOP
	Automatyczne nadawanie statusu operatora (+o)

CHAN_LEVEL_AUTOVOICE
	Automatyczne nadawanie prawa gosu (+v)

CHAN_LEVEL_AUTOHALFOP
	Automatyczne nadawanie statusu p-operatora (+h)

CHAN_LEVEL_AUTOPROTECT
	Automatyczne nadawanie ochrony (+a)

CHAN_LEVEL_AUTODEOP
	Automatyczne odbieranie statusu operatora (-o)

CHAN_LEVEL_NOJOIN
	Nie pozwala wej na kana w trybie RESTRICTED

CHAN_LEVEL_INVITE
	Pozwala uywa komendy INVITE

CHAN_LEVEL_AKICK
	Pozwala uywa komendy AKICK

CHAN_LEVEL_SET
	Pozwala modyfikowa ustawienia kanau

CHAN_LEVEL_CLEAR
	Pozwala uywa komendy CLEAR

CHAN_LEVEL_UNBAN
	Pozwala uywa komendy UNBAN

CHAN_LEVEL_OPDEOP
	Pozwala uywa komend OP i DEOP na innych osobach

CHAN_LEVEL_ACCESS_LIST
	Pozwala przeglda list dostpu

CHAN_LEVEL_ACCESS_CHANGE
	Pozwala modyfikowa list dostpu

CHAN_LEVEL_MEMO
	Pozwala listowa i czyta kanaowe wiadomoci

CHAN_LEVEL_ASSIGN
	Pozwala przydziela i usuwa bota

CHAN_LEVEL_BADWORDS
	Pozwala uywa komendy BADWORDS

CHAN_LEVEL_NOKICK
	Ochrona przed kopaniem za pomoc komendy KICK

CHAN_LEVEL_FANTASIA
	Pozwala uywa publicznych komend FANTASY

CHAN_LEVEL_SAY
	Pozwala uywa komend SAY i ACT

CHAN_LEVEL_GREET
	Wywietla wiadomo powitaln (greet)

CHAN_LEVEL_VOICEME
	Pozwala uywa komend VOICE i DEVOICE na sobie

CHAN_LEVEL_VOICE
	Pozwala uywa komend VOICE i DEVOICE na innych osobach

CHAN_LEVEL_GETKEY
	Pozwala uywa komendy GETKEY

CHAN_LEVEL_OPDEOPME
	Pozwala uywa komend OP i DEOP na sobie

CHAN_LEVEL_HALFOPME
	Pozwala uywa komend HALFOP i DEHALFOP na sobie

CHAN_LEVEL_HALFOP
	Pozwala uywa komend HALFOP i DEHALFOP na innych osobach

CHAN_LEVEL_PROTECTME
	Pozwala uywa komend PROTECT i DEPROTECT na sobie

CHAN_LEVEL_PROTECT
	Pozwala uywa komend PROTECT i DEPROTECT na innych osobach

CHAN_LEVEL_KICKME
	Pozwala uywa komendy KICK na sobie

CHAN_LEVEL_KICK
	Pozwala uywa komendy KICK na innych osobach

CHAN_LEVEL_SIGNKICK
	Nie podpisze kicka, gdy SIGNKICK LEVEL jest uywany

CHAN_LEVEL_BANME
	Pozwala uywa komendy BAN na sobie

CHAN_LEVEL_BAN
	Pozwala uywa komendy BAN na innych osobach

CHAN_LEVEL_TOPIC
	Pozwala uywa komendy TOPIC

CHAN_LEVEL_INFO
	Pozwala uywa opcji ALL w komendzie INFO

# Automatic responses
CHAN_IS_REGISTERED
	Ten kana zosta zarejestrowany z %s.

CHAN_NOT_ALLOWED_OP
	Nie masz uprawnie do statusu operatora na kanale %s.

CHAN_MAY_NOT_BE_USED
	Ten kana nie moe by uywany.

CHAN_NOT_ALLOWED_TO_JOIN
	Nie masz pozwolenia, aby przebywa na tym kanale.

CHAN_X_INVALID
	%s nie jest prawidowym kanaem.

# REGISTER responses
CHAN_REGISTER_SYNTAX
	REGISTER kana haso opis

CHAN_REGISTER_DISABLED
	Rejestracja kanaw jest tymczasowo wyczona.

CHAN_REGISTER_NOT_LOCAL
	Lokalne kanay nie mog by rejestrowane.

CHAN_MUST_REGISTER_NICK
	Musisz mie zarejestrowany nick. Napisz %R%s HELP, aby uzyska	wicej informacji.

CHAN_MUST_IDENTIFY_NICK
	Zidentyfikuj si najpierw u %s komend:
	%R%s IDENTIFY haso

CHAN_MAY_NOT_BE_REGISTERED
	Kanau %s nie mona rejestrowa.

CHAN_ALREADY_REGISTERED
	Kana %s jest ju zarejestrowany!

CHAN_MUST_BE_CHANOP
	Aby zarejestrowa kana musisz by jego operatorem.

CHAN_REACHED_CHANNEL_LIMIT
	Bd, ju masz osignity limit %d kanaw.

CHAN_EXCEEDED_CHANNEL_LIMIT
	Bd, ju masz przekroczony limit %d kanaw.

CHAN_REGISTRATION_FAILED
	Rejestracja nie powioda si.

CHAN_REGISTERED
	Kana %s zosta teraz zarejestrowany.
	Jako %s jeste od teraz jego wacicielem.

CHAN_PASSWORD_IS
	Haso do Twojego kanau to %s

CHAN_REGISTER_NONE_CHANNEL
	Prbujesz rejestrowa nieistniejcy kana %s

CHAN_SYMBOL_REQUIRED
	Uyj symboli # lub & podczas rejestracji

# IDENTIFY responses
CHAN_IDENTIFY_SYNTAX
	IDENTIFY kana haso

CHAN_IDENTIFY_FAILED
	Identyfikacja nie powioda si.

CHAN_IDENTIFY_SUCCEEDED
	Haso przyjte - masz uprawnienia waciciela kanau %s.

# LOGOUT responses
CHAN_LOGOUT_SYNTAX
	LOGOUT kana nick

CHAN_LOGOUT_SERVADMIN_SYNTAX
	LOGOUT kana [nick]

CHAN_LOGOUT_SUCCEEDED
	Uytkownik %s zosta wylogowany z kanau %s.
CHAN_LOGOUT_ALL_SUCCEEDED
	Wylogowano zidentyfikowanych uytkownikw z kanau %s (bez waciciela).
CHAN_LOGOUT_FOUNDER_FAILED
	Nie moesz si wylogowa z %s (jeste wacicielem).

# DROP responses
CHAN_DROP_SYNTAX
	DROP kana

CHAN_DROP_DISABLED
	Usuwanie kanaw jest tymczasowo wyczone.

CHAN_DROPPED
	Kana %s zosta odrejestrowany.

# SET responses
CHAN_SET_SYNTAX
	SET kana opcja parametry

CHAN_SET_DISABLED
	Modyfikacja ustawie kanau jest tymczasowo wyczona.

CHAN_SET_UNKNOWN_OPTION
	Nieznana opcja komendy SET: %s.

# SET FOUNDER responses
CHAN_SET_FOUNDER_TOO_MANY_CHANS
	%s posiada za duo zarejestrowanych kanaw.

CHAN_FOUNDER_CHANGED
	Wacicielem kanau %s jest teraz %s.

# SET SUCCESSOR responses
CHAN_SUCCESSOR_CHANGED
	Zastpc dla kanau %s zmieniono na %s.

CHAN_SUCCESSOR_UNSET
	Zastpc dla kanau %s usunito.

CHAN_SUCCESSOR_IS_FOUNDER
	%s nie moe by zastpc na kanale %s, poniewa jest jego wacicielem.

# SET PASSWORD responses
CHAN_SET_PASSWORD_FAILED
	Zmiana hasa nie powioda si.

CHAN_PASSWORD_CHANGED
	Haso do kanau %s zostao zmienione.

CHAN_PASSWORD_CHANGED_TO
	Haso do kanau %s zostao zmienione na %s.

# SET DESC responses
CHAN_DESC_CHANGED
	Opis kanau %s zosta zmieniony na %s.

# SET URL responses
CHAN_URL_CHANGED
	Adres www dla kanau %s zosta zmieniony na %s.

CHAN_URL_UNSET
	Adres www dla kanau %s zosta usunity.

# SET EMAIL responses
CHAN_EMAIL_CHANGED
	Adres e-mail kanau %s zosta zmieniony na %s.

CHAN_EMAIL_UNSET
	Adres e-mail kanau %s zosta usunity.

# SET ENTRYMSG responses
CHAN_ENTRY_MSG_CHANGED
	Wiadomo powitalna kanau %s zostaa zmieniona.

CHAN_ENTRY_MSG_UNSET
	Wiadomo powitalna kanau %s zostaa usunita.
	

# SET BANTYPE responses
CHAN_SET_BANTYPE_INVALID
	%s nie jest prawidowym rodzajem bana.

CHAN_SET_BANTYPE_CHANGED
	Rodzajem bana dla kanau %s jest teraz #%d.

# SET MLOCK responses
CHAN_SET_MLOCK_UNKNOWN_CHAR
	Nieznany flaga %c zostaje zignorowana.

CHAN_SET_MLOCK_IMPOSSIBLE_CHAR
	Flaga %c zostaa zignorowana, bo nie mona jej blokowa.

CHAN_SET_MLOCK_L_REQUIRED
	Musisz zaoy +l zanim zaoysz +L.

CHAN_SET_MLOCK_K_REQUIRED
	Musisz zaoy +i rwnie, aby mc zaoy +K.

CHAN_MLOCK_CHANGED
	Blokada trybw kanau %s zostaa zmieniona na: %s

# SET KEEPTOPIC responses
CHAN_SET_KEEPTOPIC_SYNTAX
	SET kana KEEPTOPIC {ON | OFF}

CHAN_SET_KEEPTOPIC_ON
	Temat kanau %s bdzie teraz utrzymywany.

CHAN_SET_KEEPTOPIC_OFF
	Temat kanau %s nie bdzie ju utrzymywany.

# SET TOPICLOCK responses
CHAN_SET_TOPICLOCK_SYNTAX
	SET kana TOPICLOCK {ON | OFF}

CHAN_SET_TOPICLOCK_ON
	Blokada tematu na kanale %s zostaa wczona.

CHAN_SET_TOPICLOCK_OFF
	Blokada tematu na kanale %s zostaa wyczona.

# SET PEACE responses
CHAN_SET_PEACE_SYNTAX
	SET kana PEACE {ON | OFF}

CHAN_SET_PEACE_ON
	Opcja PEACE dla kanau %s zostaa wczona.

CHAN_SET_PEACE_OFF
	Opcja PEACE dla kanau %s zostaa wyczona.

# SET PRIVATE responses
CHAN_SET_PRIVATE_SYNTAX
	SET kana PRIVATE {ON | OFF}

CHAN_SET_PRIVATE_ON
	Opcja PRIVATE dla kanau %s zostaa wczona.

CHAN_SET_PRIVATE_OFF
	Opcja PRIVATE dla kanau %s zostaa wyczona.

# SET SECUREOPS responses
CHAN_SET_SECUREOPS_SYNTAX
	SET kana SECUREOPS {ON | OFF}

CHAN_SET_SECUREOPS_ON
	Status operatora kanau %s bdzie teraz chroniony.

CHAN_SET_SECUREOPS_OFF
	Status operatora kanau %s nie bdzie ju chroniony.

# SET SECUREFOUNDER responses
CHAN_SET_SECUREFOUNDER_SYNTAX
	SET kana SECUREFOUNDER {ON | OFF}

CHAN_SET_SECUREFOUNDER_ON
	Status waciciela kanau %s bdzie teraz chroniony.

CHAN_SET_SECUREFOUNDER_OFF
	Status waciciela kanau %s nie bdzie ju chroniony.

# SET RESTRICTED responses
CHAN_SET_RESTRICTED_SYNTAX
	SET kana RESTRICTED {ON | OFF}

CHAN_SET_RESTRICTED_ON
	Dostp do kanau %s jest teraz ograniczony.

CHAN_SET_RESTRICTED_OFF
	Dostp do kanau %s nie jest ju ograniczony.

# SET SECURE responses
CHAN_SET_SECURE_SYNTAX
	SET kana SECURE {ON | OFF}

CHAN_SET_SECURE_ON
	Opcja bezpieczestwa dla kanau %s zostaa wczona.

CHAN_SET_SECURE_OFF
	Opcja bezpieczestwa dla kanau %s zostaa wyczona.

# SET SIGNKICK responses
CHAN_SET_SIGNKICK_SYNTAX
	SET kana SIGNKICK {ON | LEVEL | OFF}

CHAN_SET_SIGNKICK_ON
	Podpisywanie komendy KICK na kanale %s zostao wczone.

CHAN_SET_SIGNKICK_LEVEL
	Podpisywanie komendy KICK na kanale %s zostao wczone, ale
	bdzie zaleao od poziomu dostpu jaki posiada uytkownik.

CHAN_SET_SIGNKICK_OFF
	Podpisywanie komendy KICK na kanale %s zostao wyczone.

# SET OPNOTICE responses
CHAN_SET_OPNOTICE_SYNTAX
	SET kana OPNOTICE {ON | OFF}

CHAN_SET_OPNOTICE_ON
	Opcja OPNOTICE dla kanau %s zostaa wczona.

CHAN_SET_OPNOTICE_OFF
	Opcja OPNOTICE dla kanau %s zostaa wyczona.

# SET XOP responses
CHAN_SET_XOP_SYNTAX
	SET kana XOP {ON | OFF}

CHAN_SET_XOP_ON
	System list xOP na kanale %s zosta wczony.

CHAN_SET_XOP_OFF
	System list xOP na kanale %s zosta wyczony.

# SET NOEXPIRE responses
CHAN_SET_NOEXPIRE_SYNTAX
	SET kana NOEXPIRE {ON | OFF}

CHAN_SET_NOEXPIRE_ON
	Kana %s nie wyganie.

CHAN_SET_NOEXPIRE_OFF
	Kana %s od teraz podlega prawu wygasania.

# xOP messages
CHAN_XOP_REACHED_LIMIT
	Moesz mie tylko %d wpisw na listach xOP.

CHAN_XOP_LIST_FORMAT
	  %3d  %s

CHAN_XOP_ACCESS
	Nie moesz uy tej komendy. Uyj komendy ACCESS.
	Napisz %R%s HELP ACCESS, aby uzyska wicej informacji.

CHAN_XOP_NOT_AVAILABLE
	System xOP nie jest dostpny.

# AOP messages
CHAN_AOP_SYNTAX
	AOP kana {ADD|DEL|LIST|CLEAR} [nick | pozycja]

CHAN_AOP_DISABLED
	Modyfikacja listy AOP jest tymczasowo wyczona.

CHAN_AOP_NICKS_ONLY
	Kanaowa lista AOP moe zawiera jedynie zarejestrowane nicki.

CHAN_AOP_ADDED
	%s dodano do listy AOP kanau %s.

CHAN_AOP_MOVED
	%s przeniesiono do listy AOP kanau %s.

CHAN_AOP_NO_SUCH_ENTRY
	Brak wpisu (#%d) na licie AOP kanau %s.

CHAN_AOP_NOT_FOUND
	%s nie znaleziono na licie AOP kanau %s.

CHAN_AOP_NO_MATCH
	Nie znaleziono wpisw w licie AOP kanau %s.

CHAN_AOP_DELETED
	%s usunito z listy AOP kanau %s.

CHAN_AOP_DELETED_ONE
	Usunito 1 wpis z listy AOP kanau %s.

CHAN_AOP_DELETED_SEVERAL
	Usunito %d wpisw(y) z listy AOP kanau %s.

CHAN_AOP_LIST_EMPTY
	Lista AOP kanau %s jest pusta.

CHAN_AOP_LIST_HEADER
	Lista AOP kanau %s:
	  Nr   Nick

CHAN_AOP_CLEAR
	Lista AOP kanau %s zostaa wyczyszczona.

# HOP messages
CHAN_HOP_SYNTAX
	HOP kana {ADD|DEL|LIST|CLEAR} [nick | pozycja]

CHAN_HOP_DISABLED
	Modyfikacja listy HOP jest tymczasowo wyczona.

CHAN_HOP_NICKS_ONLY
	Kanaowa lista HOP moe zawiera jedynie zarejestrowane nicki.

CHAN_HOP_ADDED
	%s dodano do listy HOP kanau %s.

CHAN_HOP_MOVED
	%s przeniesiono do listy HOP kanau %s.

CHAN_HOP_NO_SUCH_ENTRY
	Brak wpisu (#%d) na licie HOP kanau %s.

CHAN_HOP_NOT_FOUND
	%s nie znaleziono na licie HOP kanau %s.

CHAN_HOP_NO_MATCH
	Nie znaleziono wpisw w licie HOP kanau %s.

CHAN_HOP_DELETED
	%s usunito z listy HOP kanau %s.

CHAN_HOP_DELETED_ONE
	Usunito 1 wpis z listy HOP kanau %s.

CHAN_HOP_DELETED_SEVERAL
	Usunito %d wpisw(y) z listy HOP kanau %s.

CHAN_HOP_LIST_EMPTY
	Lista HOP kanau %s jest pusta.

CHAN_HOP_LIST_HEADER
	Lista HOP kanau %s:
	  Nr   Nick

CHAN_HOP_CLEAR
	Lista HOP kanau %s zostaa wyczyszczona.

# SOP messages
CHAN_SOP_SYNTAX
	SOP kana {ADD|DEL|LIST|CLEAR} [nick | pozycja]

CHAN_SOP_DISABLED
	Modyfikacja listy SOP jest tymczasowo wyczona.

CHAN_SOP_NICKS_ONLY
	Kanaowa lista SOP moe zawiera jedynie zarejestrowane nicki.

CHAN_SOP_ADDED
	%s dodano do listy SOP kanau %s.

CHAN_SOP_MOVED
	%s przeniesiono do listy SOP kanau %s.

CHAN_SOP_NO_SUCH_ENTRY
	Brak wpisu (#%d) na licie SOP kanau %s.

CHAN_SOP_NOT_FOUND
	%s nie znaleziono na licie SOP kanau %s.

CHAN_SOP_NO_MATCH
	Nie znaleziono wpisw w licie SOP kanau %s.

CHAN_SOP_DELETED
	%s usunito z listy SOP kanau %s.

CHAN_SOP_DELETED_ONE
	Usunito 1 wpis z listy SOP kanau %s.

CHAN_SOP_DELETED_SEVERAL
	Usunito %d wpisw(y) z listy SOP kanau %s.

CHAN_SOP_LIST_EMPTY
	Lista SOP kanau %s jest pusta.

CHAN_SOP_LIST_HEADER
	Lista SOP kanau %s:
	  Nr   Nick

CHAN_SOP_CLEAR
	Lista SOP kanau %s zostaa wyczyszczona.

# VOP messages
CHAN_VOP_SYNTAX
	VOP kana {ADD|DEL|LIST|CLEAR} [nick | pozycja]

CHAN_VOP_DISABLED
	Modyfikacja listy VOP jest tymczasowo wyczona.

CHAN_VOP_NICKS_ONLY
	Kanaowa lista VOP moe zawiera jedynie zarejestrowane nicki.

CHAN_VOP_ADDED
	%s dodano do listy VOP kanau %s.

CHAN_VOP_MOVED
	%s przeniesiono do listy VOP kanau %s.

CHAN_VOP_NO_SUCH_ENTRY
	Brak wpisu (#%d) na licie VOP kanau %s.

CHAN_VOP_NOT_FOUND
	%s nie znaleziono na licie VOP kanau %s.

CHAN_VOP_NO_MATCH
	Nie znaleziono wpisw w licie VOP kanau %s.

CHAN_VOP_DELETED
	%s usunito z listy VOP kanau %s.

CHAN_VOP_DELETED_ONE
	Usunito 1 wpis z listy VOP kanau %s.

CHAN_VOP_DELETED_SEVERAL
	Usunito %d wpisw(y) z listy VOP kanau %s.

CHAN_VOP_LIST_EMPTY
	Lista VOP kanau %s jest pusta.

CHAN_VOP_LIST_HEADER
	Lista VOP kanau %s:
	  Nr   Nick

CHAN_VOP_CLEAR
	Lista VOP kanau %s zostaa wyczyszczona.

# ACCESS messages
CHAN_ACCESS_SYNTAX
	ACCESS kana {ADD|DEL|LIST|CLEAR} [nick [poziom] | pozycja]

CHAN_ACCESS_XOP
	Nie moesz uy tej komendy.
	Musisz uy polece VOP, AOP lub SOP.
	Napisz %R%s HELP komenda, aby uzyska wicej informacji.

CHAN_ACCESS_XOP_HOP
	Nie moesz uy tej komendy.
	Musisz uy polece VOP, HOP, AOP lub SOP.
	Napisz %R%s HELP komenda, aby uzyska wicej informacji.

CHAN_ACCESS_DISABLED
	Modyfikacja listy dostpu jest tymczasowo wyczona.

CHAN_ACCESS_LEVEL_NONZERO
	Poziom dostpu nie moe by zerem.

CHAN_ACCESS_LEVEL_RANGE
	Poziom dostpu musi by pomidzy %d a %d wcznie.

CHAN_ACCESS_NICKS_ONLY
	Kanaowa lista dostpu moe zawiera tylko zarejestrowane nicki.

CHAN_ACCESS_REACHED_LIMIT
	Moesz mie tylko %d wpisw na kanaowej licie dostpu.

CHAN_ACCESS_LEVEL_UNCHANGED
	Poziom dostpu dla %s na kanale %s jest
	nadany od %d.

CHAN_ACCESS_LEVEL_CHANGED
	Poziom dostpu dla %s na kanale %s
	zmieniono na %d.

CHAN_ACCESS_ADDED
	%s dodano do listy dostpu kanau %s z
	poziomem %d.

CHAN_ACCESS_NO_SUCH_ENTRY
	Brak wpisu (#%d) na licie dostpu kanau %s.

CHAN_ACCESS_NOT_FOUND
	%s nie znaleziono na licie dostpu kanau %s.

CHAN_ACCESS_NO_MATCH
	Nie znaleziono wpisw na licie dostpu kanau %s.

CHAN_ACCESS_DELETED
	%s usunito z listy dostpu kanau %s.

CHAN_ACCESS_DELETED_ONE
	Usunito 1 wpis z listy dostpu kanau %s.

CHAN_ACCESS_DELETED_SEVERAL
	Usunito %d wpisw(y) z listy dostpu kanau %s.

CHAN_ACCESS_LIST_EMPTY
	Lista dostpu kanau %s jest pusta.

CHAN_ACCESS_LIST_HEADER
	Lista dostpu kanau %s:
	  Nr   Poz  Nick

CHAN_ACCESS_LIST_FOOTER
	Koniec listy dostpu.

CHAN_ACCESS_LIST_XOP_FORMAT
	  %3d   %s  %s

CHAN_ACCESS_LIST_AXS_FORMAT
	  %3d  %4d  %s

CHAN_ACCESS_CLEAR
	Lista dostpu kanau %s zostaa wyczyszczona.

# AKICK responses
CHAN_AKICK_SYNTAX
	AKICK kana {ADD | STICK | UNSTICK | DEL | LIST | VIEW | ENFORCE | CLEAR} [nick-lub-maska] [powd]

CHAN_AKICK_DISABLED
	Modyfikacja listy AKICK jest tymczasowo wyczona.

CHAN_AKICK_ALREADY_EXISTS
	%s ju istnieje w licie AKICK kanau %s.

CHAN_AKICK_REACHED_LIMIT
	Moesz mie jedynie %d wpisw w licie AKICK.

CHAN_AKICK_ADDED
	%s dodano do listy AKICK kanau %s.

CHAN_AKICK_NO_SUCH_ENTRY
	Brak wpisu (#%d) na licie AKICK kanau %s.

CHAN_AKICK_NOT_FOUND
	%s nie znaleziono na licie AKICK kanau %s.

CHAN_AKICK_NO_MATCH
	Nie znaleziono wpisw na licie AKICK kanau %s.

CHAN_AKICK_STUCK
	%s jest od teraz cay czas aktywny na %s.

CHAN_AKICK_UNSTUCK
	%s nie jest ju zawsze aktywny na %s.

CHAN_AKICK_DELETED
	%s usunito z listy AKICK %s.

CHAN_AKICK_DELETED_ONE
	Usunito 1 wpis z listy AKICK kanau %s.

CHAN_AKICK_DELETED_SEVERAL
	Usunito %d wpisw z listy AKICK kanau %s.

CHAN_AKICK_LIST_EMPTY
	Lista AKICK kanau %s jest pusta.

CHAN_AKICK_LIST_HEADER
	Lista AKICK dla kanau %s:

CHAN_AKICK_LIST_FORMAT
	  %3d %s (%s)

CHAN_AKICK_VIEW_FORMAT
	%3d %s (przez %s na %s)
	    %s

CHAN_AKICK_VIEW_FORMAT_STUCK
	%3d %s (zablokowany) (przez %s na %s)
	    %s

CHAN_AKICK_ENFORCE_DONE
	Egzekucja listy AKICK kanau %s zakoczona.
	Dotyczya %d uytkownikw.

CHAN_AKICK_CLEAR
	Lista AKICK kanau %s zostaa wyczyszczona.

# LEVELS responses
CHAN_LEVELS_SYNTAX
	LEVELS kana {SET | DIS[ABLE] | LIST | RESET} [element [poziom]]

CHAN_LEVELS_XOP
	Modyfikowanie poziomw nie jest dostpne w trybie XOP.

CHAN_LEVELS_RANGE
	Poziom musi by pomidzy %d a %d wcznie.

CHAN_LEVELS_CHANGED
	Wymagany poziom dla %s
	na kanale %s zmieniono teraz na %d.

CHAN_LEVELS_UNKNOWN
	Nieznane ustawienie %s.
	Napisz %R%s HELP LEVELS DESC, aby uzyska list dostpnych moliwoci.

CHAN_LEVELS_DISABLED
	%s wyczono na kanale %s.

CHAN_LEVELS_LIST_HEADER
	Ustawienia poziomw dostpu kanau %s:

CHAN_LEVELS_LIST_DISABLED
	    %-*s  (wyczony)

CHAN_LEVELS_LIST_FOUNDER
	    %-*s  (tylko waciciel)

CHAN_LEVELS_LIST_NORMAL
	    %-*s  %d

CHAN_LEVELS_RESET
	Poziomy dostpu kanau %s zostay zresetowane do domylnych.

# Status messages
CHAN_STATUS_SYNTAX
	STATUS ERROR Bd skadni

CHAN_STATUS_NOT_REGGED
	STATUS ERROR Kana %s nie jest zarejestrowany

CHAN_STATUS_FORBIDDEN
	STATUS ERROR Kana %s jest zakazany

CHAN_STATUS_NOTONLINE
	STATUS ERROR Nick %s nie jest online

CHAN_STATUS_INFO
	STATUS %s %s %d

# INFO responses
CHAN_INFO_SYNTAX
	INFO kana [ALL]

CHAN_INFO_HEADER
	Informacje o kanale %s:

CHAN_INFO_FOUNDER
	     Waciciel: %s (%s)

CHAN_INFO_NO_FOUNDER
	     Waciciel: %s

CHAN_INFO_SUCCESSOR
	       Zastpca: %s (%s)

CHAN_INFO_NO_SUCCESSOR
	       Zastpca: %s

CHAN_INFO_DESCRIPTION
	           Opis: %s

CHAN_INFO_ENTRYMSG
	      Powitanie: %s

CHAN_INFO_TIME_REGGED
	 Zarejestrowano: %s

CHAN_INFO_LAST_USED
	        Uywano: %s

CHAN_INFO_LAST_TOPIC
	  Ostatni temat: %s

CHAN_INFO_TOPIC_SET_BY
	Ustawiony przez: %s

CHAN_INFO_URL
	      Adres www: %s

CHAN_INFO_EMAIL
	   Adres e-mail: %s

CHAN_INFO_BANTYPE
	       Typ bana: %d

CHAN_INFO_OPTIONS
	          Opcje: %s

CHAN_INFO_OPT_KEEPTOPIC
	KEEPTOPIC

CHAN_INFO_OPT_OPNOTICE
	OPNOTICE

CHAN_INFO_OPT_PEACE
	PEACE

CHAN_INFO_OPT_PRIVATE
	PRIVATE

CHAN_INFO_OPT_RESTRICTED
	RESTRICTED

CHAN_INFO_OPT_SECURE
	SECURE

CHAN_INFO_OPT_SECUREOPS
	SECUREOPS

CHAN_INFO_OPT_SECUREFOUNDER
	SECUREFOUNDER

CHAN_INFO_OPT_SIGNKICK
	SIGNKICK

CHAN_INFO_OPT_TOPICLOCK
	TOPICLOCK

CHAN_INFO_OPT_XOP
	XOP

CHAN_INFO_OPT_NONE
	Brak

CHAN_INFO_MODE_LOCK
	Blokowane tryby: %s

CHAN_INFO_EXPIRE
	         Wygasa: %s

CHAN_INFO_NO_EXPIRE
	Ten kana nie wyganie.

# LIST responses
CHAN_LIST_SYNTAX
	LIST wzorzec

CHAN_LIST_SERVADMIN_SYNTAX
	LIST wzorzec [FORBIDDEN] [SUSPENDED] [NOEXPIRE]

CHAN_LIST_HEADER
	Lista pasujcych wpisw %s:

CHAN_LIST_FORMAT
	    %-20s  %s

CHAN_LIST_END
	Koniec listy - %d/%d wpisw znalezionych.
	

# INVITE responses
CHAN_INVITE_SYNTAX
	INVITE kana

# UNBAN responses
CHAN_UNBAN_SYNTAX
	UNBAN kana

CHAN_UNBANNED
	Ban na kanale %s zosta zdjty.

# TOPIC responses
CHAN_TOPIC_SYNTAX
	TOPIC kana [temat]

# CLEAR responses
CHAN_CLEAR_SYNTAX
	CLEAR kana co

CHAN_CLEARED_BANS
	Wszystkie bany z kanau %s zostay usunite.

CHAN_CLEARED_EXCEPTS
	Wszystkie wyjtki z kanau %s zostay usunite.

CHAN_CLEARED_MODES
	Wszystkie flagi kanau %s zostay zresetowane.

CHAN_CLEARED_OPS
	Flagi +o zostay wyczyszczone na kanale %s.

CHAN_CLEARED_HOPS
	Flagi +h zostay wyczyszczone na kanale %s.

CHAN_CLEARED_VOICES
	Flagi +v zostay wyczyszczone na kanale %s.

CHAN_CLEARED_USERS
	Wszyscy uytkownicy zostali usunici z kanau %s.

CHAN_CLEARED_INVITES
	Wszystkie zaproszenia z kanau %s zostay usunite.

# GETPASS responses
CHAN_GETPASS_SYNTAX
	GETPASS kana

CHAN_GETPASS_UNAVAILABLE
	Komenda GETPASS nie dziaa, bo hasa s szyfrowane.

CHAN_GETPASS_PASSWORD_IS
	Haso kanau %s to %s.

# GETKEY responses
CHAN_GETKEY_SYNTAX
	GETKEY kana

CHAN_GETKEY_NOKEY
	Kana %s nie posiada klucza.

CHAN_GETKEY_KEY
	KEY %s %s

# SENDPASS responses
CHAN_SENDPASS_SYNTAX
	SENDPASS kana

CHAN_SENDPASS_UNAVAILABLE
	Komenda SENDPASS nie dziaa, bo hasa s szyfrowane.

CHAN_SENDPASS_SUBJECT
	Haso do kanau %s

CHAN_SENDPASS_HEAD
	Witaj!

CHAN_SENDPASS_LINE_1
	Zadae(a) wysania hasa do kanau %s na e-mail.

CHAN_SENDPASS_LINE_2
	Twoje haso to: %s.
	Dla wasnego bezpieczestwa naley to haso natychmiast zmieni na inne.

CHAN_SENDPASS_LINE_3
	Jeli nie wiesz dlaczego ta wiadomo dotara do Ciebie zignoruj j. Jeli ta sytuacja bdzie si powtarza skontaktuj si z administratorem sieci.

CHAN_SENDPASS_LINE_4
	PROSZ NIE ODPOWIADA NA T WIADOMO!

CHAN_SENDPASS_LINE_5
	Administratorzy sieci %s.

CHAN_SENDPASS_OK
	Haso do kanau %s zostao wysane.

# FORBID responses
CHAN_FORBID_SYNTAX
	FORBID kana [powd]

CHAN_FORBID_SYNTAX_REASON
	FORBID kana powd

CHAN_FORBID_SUCCEEDED
	Kana %s zosta zablokowany.

CHAN_FORBID_FAILED
	Nie mog zablokowa kanau %s!

CHAN_FORBID_REASON
	Ten kana zosta zablokowany.

# SUSPEND responses
CHAN_SUSPEND_SYNTAX
	SUSPEND kana [powd]

CHAN_SUSPEND_SYNTAX_REASON
	SUSPEND kana powd

CHAN_SUSPEND_SUCCEEDED
	Kana %s zosta zawieszony.

CHAN_SUSPEND_FAILED
	Zawieszenie kanau %s nie powiodo si!

CHAN_SUSPEND_REASON
	Ten kana zosta zawieszony.

# UNSUSPEND responses
CHAN_UNSUSPEND_SYNTAX
	UNSUSPEND kana

CHAN_UNSUSPEND_ERROR
	Nie znaleziono znaku # na pocztku nazwy kanau.

CHAN_UNSUSPEND_SUCCEEDED
	Kana %s zosta uwolniony.

CHAN_UNSUSPEND_FAILED
	Nie mog uwolni kanau %s!

# Misc responses
CHAN_EXCEPTED
	%s posiada wyjtek na %s i nie moe by zbanowany pki nie zostanie usunity.

###########################################################################
#
# MemoServ messages
#
###########################################################################
# Automatic messages
MEMO_HAVE_NEW_MEMO
	Masz jedn now wiadomo.

MEMO_HAVE_NEW_MEMOS
	Masz %d nowe(ych) wiadomoci.

MEMO_TYPE_READ_LAST
	Napisz %R%s READ LAST aby przeczyta.

MEMO_TYPE_READ_NUM
	Napisz %R%s READ %d aby przeczyta.

MEMO_TYPE_LIST_NEW
	Napisz %R%s LIST NEW,
	aby zobaczy list nowych wiadomoci.

MEMO_AT_LIMIT
	Uwaga: Osignito ju limit wiadomoci (%d).
	Nie bdziesz otrzymywa nowych wiadomoci dopki
	nie usuniesz kilku starych.

MEMO_OVER_LIMIT
	Uwaga: Maksymalny limit wiadomoci (%d) zosta osignity.
	Nie bdziesz otrzymywa nowych wiadomoci jeli kilku nie usuniesz.

MEMO_X_MANY_NOTICE
	Jest %d wiadomoci dla kanau %s.

MEMO_X_ONE_NOTICE
	Jest %d wiadomo dla kanau %s.

MEMO_NEW_X_MEMO_ARRIVED
	Jest nowa wiadomo dla kanau %s.
	Napisz %R%s READ %s %d aby j przeczyta.

MEMO_NEW_MEMO_ARRIVED
	Nasz now wiadomo od %s.
	Napisz %R%s READ %d aby j przeczyta.

# Multi-use responses
MEMO_HAVE_NO_MEMOS
	Nie masz wiadomoci.

MEMO_X_HAS_NO_MEMOS
	%s nie ma wiadomoci.

MEMO_DOES_NOT_EXIST
	Wiadomo %d nie istnieje!

MEMO_LIST_NOT_FOUND
	Nie znaleziono pasujcych wiadomoci.

# SEND responses
MEMO_SEND_SYNTAX
	SEND {nick | kana} tre

MEMO_SEND_DISABLED
	Wysyanie wiadomoci jest tymczasowo wyczone.

MEMO_SEND_PLEASE_WAIT
	Odczekaj %d sekund(y) przed ponownym uyciem komendy SEND.

MEMO_X_GETS_NO_MEMOS
	%s nie moe odbiera wiadomoci.

MEMO_X_HAS_TOO_MANY_MEMOS
	%s ma zbyt duo wiadomoci i nie moe otrzymywa nowych.

MEMO_SENT
	Wiadomo zostaa wysana do %s.

MEMO_MASS_SENT
	Wiadomo zostaa wysana do wszystkich zarejestrowanych uytkownikw.
	
# STAFF responses
MEMO_STAFF_SYNTAX
	STAFF tre wiadomoci

# CANCEL responses
MEMO_CANCEL_SYNTAX
	CANCEL {nick | kana}

MEMO_CANCEL_DISABLED
	Odwoywanie wiadomoci jest tymczasowo wyczone.

MEMO_CANCEL_NONE
	Brak wiadomoci do odwoania.

MEMO_CANCELLED
	Ostatnia wiadomo do %s zostaa odwoana.

# LIST responses
MEMO_LIST_SYNTAX
	LIST [kana] [lista | NEW]

MEMO_HAVE_NO_NEW_MEMOS
	Nie masz nowych wiadomoci.

MEMO_X_HAS_NO_NEW_MEMOS
	%s nie ma nowych wiadomoci.

MEMO_LIST_MEMOS
	Wiadomoci dla %s. Aby przeczyta, napisz: %R%s READ numer

MEMO_LIST_NEW_MEMOS
	Nowe wiadomoci dla %s. Aby przeczyta,
	napisz: %R%s READ numer

MEMO_LIST_CHAN_MEMOS
	Wiadomoci dla %s. Aby przeczyta, napisz: %R%s READ %s numer

MEMO_LIST_CHAN_NEW_MEMOS
	Nowe wiadomoci dla %s. Aby przeczyta,
	napisz: %R%s READ %s numer

MEMO_LIST_HEADER
	 Nr   Nadawca            Data/Czas

MEMO_LIST_FORMAT
	%c%3d  %-16s  %s

# READ responses
MEMO_READ_SYNTAX
	READ [kana] {lista | LAST | NEW}

MEMO_HEADER
	Wiadomo %d od %s (%s). Aby usun, napisz: %R%s DEL %d

MEMO_CHAN_HEADER
	Wiadomo %d od %s (%s). Aby usun, napisz: %R%s DEL %s %d

MEMO_TEXT
	%s

# DEL responses
MEMO_DEL_SYNTAX
	DEL [kana] {numer | list | ALL}

MEMO_DELETED_NONE
	Nie usunito adnych wiadomoci.

MEMO_DELETED_ONE
	Wiadomo %d zostaa usunita.

MEMO_DELETED_SEVERAL
	Wiadomoci %s zostay usunite.

MEMO_DELETED_ALL
	Wszystkie Twoje wiadomoci zostay usunite.

MEMO_CHAN_DELETED_ALL
	Wszystkie wiadomoci kanau %s zostay usunite.

# SET responses
MEMO_SET_SYNTAX
	SET opcja parametry

MEMO_SET_DISABLED
	Ustawianie opcji wiadomoci jest tymczasowo wyczone.

MEMO_SET_UNKNOWN_OPTION
	Nieznana opcja komendy SET %s.

# SET NOTIFY responses
MEMO_SET_NOTIFY_SYNTAX
	SET NOTIFY {ON | LOGON | NEW | MAIL | MAIL | NOMAIL | OFF }

MEMO_SET_NOTIFY_ON
	%s powiadomi Ci o wiadomociach podczas logowania i w momencie ich nadejcia.

MEMO_SET_NOTIFY_LOGON
	%s powiadomi Ci o wiadomociach podczas logowania oraz po wyczeniu /away.

MEMO_SET_NOTIFY_NEW
	%s bdzie powiadamia Ci o nowych wiadomociach w momencie ich nadejcia.

MEMO_SET_NOTIFY_OFF
	%s nie bdzie powiadamia Ci o nowych wiadomociach.

MEMO_SET_NOTIFY_MAIL
	Powiadomienie o nowych wiadomociach bd wysyane na adres e-mail.

MEMO_SET_NOTIFY_NOMAIL
	Powiadomienie o nowych wiadomociach nie bd wysyane na adres e-mail.

MEMO_SET_NOTIFY_INVALIDMAIL
	Twj nick nie ma ustawionego adresu e-mail.

# SET LIMIT responses
MEMO_SET_LIMIT_SYNTAX
	SET LIMIT [kana] limit

MEMO_SET_LIMIT_SERVADMIN_SYNTAX
	SET LIMIT [nick | kana] {limit | NONE} [HARD]

MEMO_SET_YOUR_LIMIT_FORBIDDEN
	Nie moesz zmienia swojego limitu wiadomoci.

MEMO_SET_LIMIT_FORBIDDEN
	Limit wiadomoci dla %s nie moe by zmieniany.

MEMO_SET_YOUR_LIMIT_TOO_HIGH
	Nie moesz ustawi swojego limitu wiadomoci wikszego ni %d.

MEMO_SET_LIMIT_TOO_HIGH
	Nie moesz ustawi limitu wiadomoci dla %s wikszego ni %d.

MEMO_SET_LIMIT_OVERFLOW
	Limit wiadomoci jest za duy. Limituj do %d.

MEMO_SET_YOUR_LIMIT
	Twj limit wiadomoci zosta zmieniony na %d.

MEMO_SET_YOUR_LIMIT_ZERO
	Nie bdziesz ju duej odbiera wiadomoci.

MEMO_UNSET_YOUR_LIMIT
	Twj limit wiadomoci zosta wyczony.

MEMO_SET_LIMIT
	Limit wiadomoci dla %s zmieniono na %d.

MEMO_SET_LIMIT_ZERO
	Limit wiadomoci dla %s ustawiono na 0.

MEMO_UNSET_LIMIT
	Limit wiadomoci dla %s jest wyczony.

# INFO responses
MEMO_INFO_SYNTAX
	INFO [kana]

MEMO_INFO_SERVADMIN_SYNTAX
	INFO [nick | kana]

MEMO_INFO_NO_MEMOS
	Aktualnie nie masz wiadomoci.

MEMO_INFO_MEMO
	Aktualnie masz jedn wiadomo.

MEMO_INFO_MEMO_UNREAD
	Aktualnie masz jedn wiadomo i jest ona nieprzeczytana.

MEMO_INFO_MEMOS
	Aktualnie masz %d wiadomoci.

MEMO_INFO_MEMOS_ONE_UNREAD
	Aktualnie masz %d wiadomoci, w tym jedn nieprzeczytan.

MEMO_INFO_MEMOS_SOME_UNREAD
	Aktualnie masz %d wiadomoci, z czego %d jest nieprzeczytanych.

MEMO_INFO_MEMOS_ALL_UNREAD
	Aktualnie masz %d nieprzeczytanych wiadomoci.

MEMO_INFO_LIMIT
	Twj limit wiadomoci wynosi %d.

MEMO_INFO_HARD_LIMIT
	Twj limit wiadomoci wynosi %d i nie moe by zmieniony.

MEMO_INFO_LIMIT_ZERO
	Twj limit wiadomoci wynosi 0, nie bdziesz otrzymywa nowych.

MEMO_INFO_HARD_LIMIT_ZERO
	Twj limit wiadomoci wynosi 0, nie bdziesz odbiera nowych i nie moesz zmieni tego limitu.
MEMO_INFO_NO_LIMIT
	Nie masz limitu wiadomoci, ktre moesz trzyma.

MEMO_INFO_NOTIFY_OFF
	Nie bdziesz otrzymywa informacji o nowych wiadomociach.

MEMO_INFO_NOTIFY_ON
	Bdziesz powiadomienie informacje o nowych wiadomociach
	podczas logowania i w momencie ich nadejcia.

MEMO_INFO_NOTIFY_RECEIVE
	Bdziesz otrzymywa powiadomienie o nowych wiadomociach.

MEMO_INFO_NOTIFY_SIGNON
	Bdziesz otrzymywa powiadomienie o nowych wiadomociach podczas logowania.

MEMO_INFO_X_NO_MEMOS
	%s aktualnie nie ma wiadomoci.

MEMO_INFO_X_MEMO
	%s aktualnie ma jedn wiadomo.

MEMO_INFO_X_MEMO_UNREAD
	%s ma aktualnie jedn wiadomo, ktra jest nieprzeczytana.

MEMO_INFO_X_MEMOS
	%s ma aktualnie %d wiadomoci.

MEMO_INFO_X_MEMOS_ONE_UNREAD
	%s ma aktualnie %d wiadomoci, w tym jedn nieprzeczytan.

MEMO_INFO_X_MEMOS_SOME_UNREAD
	%s ma aktualnie %d wiadomoci, z czego %d jest nieprzeczytanych.

MEMO_INFO_X_MEMOS_ALL_UNREAD
	%s ma aktualnie %d nieprzeczytanych wiadomoci.

MEMO_INFO_X_LIMIT
	%s ma limit wiadomoci %d.

MEMO_INFO_X_HARD_LIMIT
	%s ma limit wiadomoci %d i nie moe by zmieniony.

MEMO_INFO_X_NO_LIMIT
	%s nie ma limitu wiadomoci.

MEMO_INFO_X_NOTIFY_OFF
	%s nie otrzymuje powiadomie o nowych wiadomociach.

MEMO_INFO_X_NOTIFY_ON
	%s otrzymuje powiadomienia o nowych wiadomociach
	podczas logowania i w momencie ich nadejcia.

MEMO_INFO_X_NOTIFY_RECEIVE
	%s otrzymuje powiadomienia o nowych wiadomociach w momencie ich nadejcia.

MEMO_INFO_X_NOTIFY_SIGNON
	%s otrzymuje powiadomienia o nowych wiadomociach podczas logowania.

# Memo2Mail responses
MEMO_MAIL_SUBJECT
	Nowa wiadomo

MEMO_MAIL_TEXT1
	Witaj %s!

MEMO_MAIL_TEXT2
	Wanie nadesza now wiadomo od %s, ma numer %d.

MEMO_MAIL_TEXT3
	Tre wiadomoci:

# RSEND responses
MEMO_RSEND_PLEASE_WAIT
	Odczekaj %d sekund przed ponownym uyciem komendy RSEND.

MEMO_RSEND_DISABLED
	Komenda RSEND nie jest dostpna w tej sieci.

MEMO_RSEND_SYNTAX
	RSEND {nick | kana} tre

MEMO_RSEND_NICK_MEMO_TEXT
	[auto-memo] Wysana przez Ciebie wiadomo zostaa przeczytana.

MEMO_RSEND_CHAN_MEMO_TEXT
	[auto-memo] Wysana przez Ciebie wiadomo do %s zostaa przeczytana.

MEMO_RSEND_USER_NOTIFICATION
	Powiadomienie o przeczytaniu wiadomoci zostao wysane do %s.

# CHECK responses
MEMO_CHECK_SYNTAX
	CHECK nick

MEMO_CHECK_NOT_READ
	Ostatnia wysana przez Ciebie wiadomo
	do %s (w %s) jest wci nieprzeczytana.

MEMO_CHECK_READ
	Ostatnia wiadomo wysana do %s (w %s) zostaa przeczytana.

MEMO_CHECK_NO_MEMO
	%s nie posiada wiadomoci od Ciebie.

MEMO_NO_RSEND_SELF
	Nie moesz wysya wiadomoci z potwierdzeniem odbioru do siebie!

###########################################################################
#
# BotServ messages
#
###########################################################################
# Standard responses
BOT_DOES_NOT_EXIST
	Bot %s nie istnieje.

BOT_NOT_ASSIGNED
	Musisz najpierw przydzieli bota do kanau.
	Napisz %R%S HELP ASSIGN, aby uzyska wicej informacji.

BOT_NOT_ON_CHANNEL
	Nie ma bota na kanale %s.

# Kick reasons (must be a single line)
BOT_REASON_BADWORD
	Nie uywaj sowa \"%s\" na tym kanale!

BOT_REASON_BADWORD_GENTLE
	Uwaaj co piszesz!

BOT_REASON_BOLD
	Nie pogrubiaj tekstu na tym kanale!

BOT_REASON_CAPS
	Wycz CAPS LOCKa!

BOT_REASON_COLOR
	Nie uywaj kolorw na tym kanale!

BOT_REASON_FLOOD
	Przesta floodowa!

BOT_REASON_REPEAT
	Nie powtarzaj si!

BOT_REASON_REVERSE
	Nie uywaj odwracania kolorw!

BOT_REASON_UNDERLINE
	Nie uywaj podkrele na tym kanale!

# !seen replies
BOT_SEEN_BOT
	Tak! Jestem tutaj %s!

BOT_SEEN_YOU
	%s? Szukasz siebie?

BOT_SEEN_ON_CHANNEL
	%s jest teraz na kanale!

BOT_SEEN_ON_CHANNEL_AS
	%s jest teraz na kanale (jako %s)!

BOT_SEEN_ON
	Widziaem %s tutaj %s temu.

BOT_SEEN_NEVER
	Nigdy nie widziaem %s na tym kanale.

BOT_SEEN_UNKNOWN
	Nie wiem kim jest %s.

# BOT responses
BOT_BOT_SYNTAX
	BOT ADD nick user host real
	BOT CHANGE stary-nick nowy-nick [user [host [real]]]
	BOT DEL nick

BOT_BOT_ALREADY_EXISTS
	Bot %s ju istnieje.

BOT_BOT_CREATION_FAILED
	Bd, nie udao si utworzy bota.

BOT_BOT_READONLY
	Modyfikacja botw jest tymczasowo wyczona.

BOT_BOT_ADDED
	%s!%s@%s (%s) dodano do listy botw.

BOT_BOT_ANY_CHANGES
	Nic si nie zmienio.
BOT_BOT_CHANGED
	Bot %s zosta zmieniony na %s!%s@%s (%s)

BOT_BOT_DELETED
	Bot %s zosta usunity.

# BOTLIST responses
BOT_BOTLIST_HEADER
	Lista botw:

BOT_BOTLIST_PRIVATE_HEADER
	Boty zarezerwowane dla IRC operatorw:

BOT_BOTLIST_FOOTER
	%d boty(w) dostpnych.

BOT_BOTLIST_EMPTY
	Obecnie nie ma adnych botw dostpnych.
	Popro administratora serwisw o dodanie.

# ASSIGN responses
BOT_ASSIGN_SYNTAX
	ASSIGN kana nick

BOT_ASSIGN_READONLY
	Przydzielanie botw jest tymczasowo wyczone.

BOT_ASSIGN_ALREADY
	Bot %s jest ju postawiony na %s.

BOT_ASSIGN_ASSIGNED
	Bot %s zosta przypisany do %s.

# UNASSIGN responses
BOT_UNASSIGN_SYNTAX
	UNASSIGN kana

BOT_UNASSIGN_UNASSIGNED
	Nie ma adnych botw przydzielonych do %s.

# INFO responses
BOT_INFO_SYNTAX
	INFO {kana | nick}

BOT_INFO_NOT_FOUND
	%s nie jest prawidow nazw bota lub kanau.

BOT_INFO_BOT_HEADER
	Informacje o bocie %s:

BOT_INFO_BOT_MASK
		Maska: %s@%s

BOT_INFO_BOT_REALNAME
		Nazwa: %s

BOT_INFO_BOT_CREATED
	    Utworzony: %s

BOT_INFO_BOT_USAGE
	    Obecny na: %d kanaach
BOT_INFO_BOT_OPTIONS
		Opcje: %s

BOT_INFO_OPT_PRIVATE
	PRIVATE

BOT_INFO_CHAN_HEADER
	Informacje o kanale %s:

BOT_INFO_CHAN_BOT
	       Przydzielony bot: %s

BOT_INFO_CHAN_BOT_NONE
	       Przydzielony bot: (brak)

BOT_INFO_CHAN_KICK_BADWORDS
	       Kopanie za sowa: %s

BOT_INFO_CHAN_KICK_BADWORDS_BAN
	       Kopanie za sowa: %s (%d kop(y) do bana)

BOT_INFO_CHAN_KICK_BOLDS
	 Kopanie za pogrubienia: %s

BOT_INFO_CHAN_KICK_BOLDS_BAN
	 Kopanie za pogrubienia: %s (%d kop(y) do bana)

BOT_INFO_CHAN_KICK_CAPS_ON
	       Kopanie za capsa: %s (minimum %d/%d%%)

BOT_INFO_CHAN_KICK_CAPS_BAN
	       Kopanie za capsa: %s (%d kop(y) do bana; minimum %d/%d%%)

BOT_INFO_CHAN_KICK_CAPS_OFF
	       Kopanie za capsa: %s

BOT_INFO_CHAN_KICK_COLORS
	      Kopanie za kolory: %s

BOT_INFO_CHAN_KICK_COLORS_BAN
	      Kopanie za kolory: %s (%d kop(y) do bana)

BOT_INFO_CHAN_KICK_FLOOD_ON
	       Kopanie za flood: %s (%d linii w %ds)

BOT_INFO_CHAN_KICK_FLOOD_BAN
	       Kopanie za flood: %s (%d kop(y) do bana; %d linii w %ds)

BOT_INFO_CHAN_KICK_FLOOD_OFF
	       Kopanie za flood: %s

BOT_INFO_CHAN_KICK_REPEAT_ON
	 Kopanie za powtarzanie: %s (%d czasu)

BOT_INFO_CHAN_KICK_REPEAT_BAN
	 Kopanie za powtarzanie: %s (%d kop(y) do bana; %d czasu)

BOT_INFO_CHAN_KICK_REPEAT_OFF
	 Kopanie za powtarzanie: %s

BOT_INFO_CHAN_KICK_REVERSES
	 Kopanie za odw kolorw: %s

BOT_INFO_CHAN_KICK_REVERSES_BAN
	 Kopanie za odw kolorw: %s (%d kop(y) do bana)

BOT_INFO_CHAN_KICK_UNDERLINES
	Kopanie za podkrelenia: %s

BOT_INFO_CHAN_KICK_UNDERLINES_BAN
	Kopanie za podkrelenia: %s (%d kop(y) do bana)

BOT_INFO_ACTIVE
	wczone

BOT_INFO_INACTIVE
	wyczone

BOT_INFO_CHAN_OPTIONS
	             Inne opcje: %s

BOT_INFO_OPT_DONTKICKOPS
	DONTKICKOPS

BOT_INFO_OPT_DONTKICKVOICES
	DONTKICKVOICES

BOT_INFO_OPT_FANTASY
	FANTASY

BOT_INFO_OPT_GREET
	GREET

BOT_INFO_OPT_NOBOT
	NOBOT

BOT_INFO_OPT_SYMBIOSIS
	SYMBIOSIS

BOT_INFO_OPT_NONE
	Brak

# SET responses
BOT_SET_SYNTAX
	SET (kana | bot) opcja ustawienie

BOT_SET_DISABLED
	Konfigurowanie bota jest tymczasowo wyczone.

BOT_SET_UNKNOWN
	Nieznana opcja %s.
	Napisz %R%S HELP SET, aby uzyska wicej informacji.

# SET DONTKICKOPS messages
BOT_SET_DONTKICKOPS_SYNTAX
	SET kana DONTKICKOPS {ON|OFF}

BOT_SET_DONTKICKOPS_ON
	Bot nie bdzie kopa operatorw na kanale %s.

BOT_SET_DONTKICKOPS_OFF
	Bot bdzie teraz kopa operatorw na kanale %s.

# SET DONTKICKVOICES messages
BOT_SET_DONTKICKVOICES_SYNTAX
	SET kana DONTKICKVOICES {ON|OFF}

BOT_SET_DONTKICKVOICES_ON
	Bot nie bdzie kopa voicw na kanale %s.

BOT_SET_DONTKICKVOICES_OFF
	Bot bdzie kopa voicw na kanale %s.

# SET FANTASY messages
BOT_SET_FANTASY_SYNTAX
	SET kana FANTASY {ON|OFF}

BOT_SET_FANTASY_ON
	Komendy fantasy na kanale %s zostay wczone.

BOT_SET_FANTASY_OFF
	Komendy fantasy na kanale %s zostay wyczone.

# SET GREET messages
BOT_SET_GREET_SYNTAX
	SET kana GREET {ON|OFF}

BOT_SET_GREET_ON
	Witanie uytkownikw na kanale %s zostao wczone.

BOT_SET_GREET_OFF
	Witanie uytkownikw na kanale %s zostao wyczone.

# SET NOBOT
BOT_SET_NOBOT_SYNTAX
	SET nick-bota NOBOT {ON|OFF}

BOT_SET_NOBOT_ON
	Opcja NOBOT zostaa wczona na kanale %s.

BOT_SET_NOBOT_OFF
	Opcja NOBOT zostaa wyczona na kanale %s.

# SET PRIVATE
BOT_SET_PRIVATE_SYNTAX
	SET nick-bota PRIVATE {ON|OFF}

BOT_SET_PRIVATE_ON
	Opcja PRIVATE bota %s zostaa wczona.

BOT_SET_PRIVATE_OFF
	Opcja PRIVATE bota %s zostaa wyczona.

# SET SYMBIOSIS
BOT_SET_SYMBIOSIS_SYNTAX
	SET kana SYMBIOSIS {ON|OFF}

BOT_SET_SYMBIOSIS_ON
	Opcja SYMBIOSIS zostaa wczona na kanale %s.

BOT_SET_SYMBIOSIS_OFF
	Opcja SYMBIOSIS zostaa wyczona na kanale %s.

# KICK responses
BOT_KICK_SYNTAX
	KICK kana opcja {ON|OFF} [ustawienia]

BOT_KICK_DISABLED
	Konfigurowanie kopw jest tymczasowo wyczone.

BOT_KICK_UNKNOWN
	Nieznana opcja %s.
	Napisz %R%S HELP KICK, aby uzyska wicej informacji.

BOT_KICK_BAD_TTB
	%s nie moe by wzity jako ilo wykrocze do zaoenia bana.

BOT_KICK_BADWORDS_ON
	Bot bdzie kopa za zakazane sowa.
	Uyj komendy BADWORDS, aby modyfikowa list sw.

BOT_KICK_BADWORDS_ON_BAN
	Bot bdzie kopa za zakazane sowa,
	po %d kopach dla tego samego uytkownika zaoy bana.
	Uyj komendy BADWORDS, aby modyfikowa list.

BOT_KICK_BADWORDS_OFF
	Bot nie bdzie kopa za zakazane sowa.

BOT_KICK_BOLDS_ON
	Bot bdzie kopa za pogrubienia.

BOT_KICK_BOLDS_ON_BAN
	Bot bdzie kopa za pogrubienia,
	po %d kopach dla tego samego uytkownika zaoy bana.

BOT_KICK_BOLDS_OFF
	Bot nie bdzie kopa za pogrubienia.

BOT_KICK_CAPS_ON
	Bot bdzie kopa za CAPSa (due litery
	musz stanowi %d znakw %d%% caej wiadomoci).

BOT_KICK_CAPS_ON_BAN
	Bot bdzie kopa za CAPSa (due litery
	musz stanowi %d znakw %d%% caej wiadomoci).
	po %d kopach dla tego samego uytkownika zaoy bana.

BOT_KICK_CAPS_OFF
	Bot nie bdzie kopa za CAPSa.

BOT_KICK_COLORS_ON
	Bot bdzie kopa za kolory.

BOT_KICK_COLORS_ON_BAN
	Bot bdzie kopa za kolory,
	po %d kopach dla tego samego uytkownika zaoy bana.

BOT_KICK_COLORS_OFF
	Bot nie bdzie kopa za kolory.

BOT_KICK_FLOOD_ON
	Bot bdzie kopa za flood
	(%d linii w %d sekund).

BOT_KICK_FLOOD_ON_BAN
	Bot bdzie kopa za flood (%d linii w %d sekund),
	po %d kopach dla tego samego uytkownika zaoy bana.

BOT_KICK_FLOOD_OFF
	Bot nie bdzie kopa za flood.

BOT_KICK_REPEAT_ON
	Bot bdzie kopa za powtrzenia
	(uytkownikw, ktrzy napisz %d razy to samo).

BOT_KICK_REPEAT_ON_BAN
	Bot bdzie kopa za powtrzenia
	(uytkownikw, ktrzy napisz %d razy to samo),
	po %d kopach dla tego samego uytkownika zaoy bana.

BOT_KICK_REPEAT_OFF
	Bot nie bdzie kopa za powtrzenia.

BOT_KICK_REVERSES_ON
	Bot bdzie kopa za odwracanie kolorw.

BOT_KICK_REVERSES_ON_BAN
	Bot bdzie kopa za odwracanie kolorw,
	po %d kopach dla tego samego uytkownika zaoy bana.

BOT_KICK_REVERSES_OFF
	Bot nie bdzie kopa za odwracanie kolorw.

BOT_KICK_UNDERLINES_ON
	Bot bdzie kopa za podkrelenia.

BOT_KICK_UNDERLINES_ON_BAN
	Bot bdzie kopa za podkrelenia,
	po %d kopach dla tego samego uytkownika zaoy bana.

BOT_KICK_UNDERLINES_OFF
	Bot nie bdzie kopa za podkrelenia.

# BADWORDS messages
BOT_BADWORDS_SYNTAX
	BADWORDS kana {ADD|DEL|LIST|CLEAR} [sowo | pozycja] [SINGLE|START|END]

BOT_BADWORDS_DISABLED
	Modyfikacja listy zakazanych sw jest tymczasowo wyczona.

BOT_BADWORDS_REACHED_LIMIT
	Bd, moesz mie tylko %d wpisw na licie zakazanych sw.

BOT_BADWORDS_ALREADY_EXISTS
	%s ju istnieje na licie zakazanych sw kanau %s.

BOT_BADWORDS_ADDED
	%s dodano do listy zakazanych sw kanau %s.

BOT_BADWORDS_NO_SUCH_ENTRY
	Brak wpisw (#%d) na licie zakazanych sw kanau %s.

BOT_BADWORDS_NOT_FOUND
	%s nie znaleziono na licie zakazanych sw kanau %s.

BOT_BADWORDS_NO_MATCH
	Nie znaleziono pasujcych wpisw na licie zakazanych sw kanau %s.

BOT_BADWORDS_DELETED
	%s usunito z listy zakazanych sw kanau %s.

BOT_BADWORDS_DELETED_ONE
	Usunito 1 wpis z listy zakazanych sw kanau %s.

BOT_BADWORDS_DELETED_SEVERAL
	Usunito %d wpisw z listy zakazanych sw
	kanau %s.

BOT_BADWORDS_LIST_EMPTY
	Lista zakazanych sw dla kanau %s jest pusta.

BOT_BADWORDS_LIST_HEADER
	Lista zakazanych sw dla %s:
	  Nr    Sowo                          Typ

BOT_BADWORDS_LIST_FORMAT
	  %3d   %-30s %s

BOT_BADWORDS_CLEAR
	Lista zakazanych sw zostaa wyczyszczona.

# SAY responses
BOT_SAY_SYNTAX
	SAY kana tekst

# ACT responses
BOT_ACT_SYNTAX
	ACT kana tekst

# Errors
BOT_EXCEPT
	Uytkownik posiada wyjtek na kanale.

BOT_BAD_NICK
	Nick bota moe zawiera tylko prawidowe znaki.

BOT_BAD_HOST
	Host bota moe zawiera tylko prawidowe znaki.

BOT_BAD_IDENT
	Ident bota moe zawiera tylko prawidowe znaki.

BOT_LONG_IDENT
	Ident bota moe si skada maksymalnie z %d znakw.

BOT_LONG_HOST
	Host bota moe si skada maksymalnie z %d znakw.

###########################################################################
#
# OperServ messages
#
###########################################################################
# General messages
OPER_BOUNCY_MODES
	Serwisy nie mog zmienia trybw. Czy serwery s dobrze skonfigurowane?

OPER_BOUNCY_MODES_U_LINE
	Serwisy nie mog zmienia trybw. Czy U-linie serwerw s dobrze skonfigurowane?

# GLOBAL responses
OPER_GLOBAL_SYNTAX
	GLOBAL tre wiadomoci

# STATS responses
OPER_STATS_UNKNOWN_OPTION
	Nieznana opcja STATS %s.

OPER_STATS_CURRENT_USERS
	Uytkownikw  : %d (%d operatorw)

OPER_STATS_MAX_USERS
	Rekord uytk. : %d (%s)

# This is ugly, but at least it's language-portable...
# Note that you can include seconds in any of these--my personal preference
# is to only give resolution to the nearest minute when uptime is one hour
# or more, but just add a %d to get seconds as well.
OPER_STATS_UPTIME_DHMS
	Serwisy dziaaj %d dni, %02d:%02d

OPER_STATS_UPTIME_1DHMS
	Serwisy dziaaj %d dzie, %02d:%02d

OPER_STATS_UPTIME_HMS
	Serwisy dziaaj %d godzin i %d minut(y).

OPER_STATS_UPTIME_HM1S
	Serwisy dziaaj %d godzin(y) i %d minut(y).

OPER_STATS_UPTIME_H1MS
	Serwisy dziaaj %d godzin(y) i %d minut.

OPER_STATS_UPTIME_H1M1S
	Serwisy dziaaj %d godzin(y) i %d minut.

OPER_STATS_UPTIME_1HMS
	Serwisy dziaaj %d godzin i %d minut(y).

OPER_STATS_UPTIME_1HM1S
	Serwisy dziaaj %d godzin i %d minut(y).

OPER_STATS_UPTIME_1H1MS
	Serwisy dziaaj %d godzin i %d minut.

OPER_STATS_UPTIME_1H1M1S
	Serwisy dziaaj %d godzin i %d minut.

OPER_STATS_UPTIME_MS
	Serwisy dziaaj %d minut(y) i %d sekund(y).

OPER_STATS_UPTIME_M1S
	Serwisy dziaaj %d minut(y) i %d sekund.

OPER_STATS_UPTIME_1MS
	Serwisy dziaaj %d minut i %d sekund(y).

OPER_STATS_UPTIME_1M1S
	Serwisy dziaaj %d minut i %d sekund.

OPER_STATS_BYTES_READ
	Odebrano      : %5d kB

OPER_STATS_BYTES_WRITTEN
	Wysano       : %5d kB

OPER_STATS_USER_MEM
	Uytkownicy   : %6d rekordw, %5d kB

OPER_STATS_CHANNEL_MEM
	Kana         : %6d rekordw, %5d kB

OPER_STATS_GROUPS_MEM
	Grupy NS      : %6d rekordw, %5d kB

OPER_STATS_ALIASES_MEM
	Aliasy NS     : %6d rekordw, %5d kB

OPER_STATS_CHANSERV_MEM
	ChanServ      : %6d rekordw, %5d kB

OPER_STATS_BOTSERV_MEM
	BotServ       : %6d rekordw, %5d kB

OPER_STATS_HOSTSERV_MEM
	HostServ      : %6d rekordw, %5d kB

OPER_STATS_OPERSERV_MEM
	OperServ      : %6d rekordw, %5d kB

OPER_STATS_SESSIONS_MEM
	Sesji         : %6d rekordw, %5d kB

OPER_STATS_AKILL_COUNT
	Aktualna ilo wpisw AKILL: %d

OPER_STATS_AKILL_EXPIRE_DAYS
	Domylny czas wygasania AKILL: %d dni

OPER_STATS_AKILL_EXPIRE_DAY
	Domylny czas wygasania AKILL: 1 dzie

OPER_STATS_AKILL_EXPIRE_HOURS
	Domylny czas wygasania AKILL: %d godzin(y)

OPER_STATS_AKILL_EXPIRE_HOUR
	Domylny czas wygasania AKILL: 1 godzina

OPER_STATS_AKILL_EXPIRE_MINS
	Domylny czas wygasania AKILL: %d minut(y)

OPER_STATS_AKILL_EXPIRE_MIN
	Domylny czas wygasania AKILL: 1 minuta

OPER_STATS_AKILL_EXPIRE_NONE
	Domylny czas wygasania AKILL: nie wygasa

OPER_STATS_SGLINE_COUNT
	Aktualna ilo wpisw SGLINE: %d

OPER_STATS_SGLINE_EXPIRE_DAYS
	Domylny czas wygasania SGLINE: %d dni

OPER_STATS_SGLINE_EXPIRE_DAY
	Domylny czas wygasania SGLINE: 1 dzie

OPER_STATS_SGLINE_EXPIRE_HOURS
	Domylny czas wygasania SGLINE: %d godzin(y)

OPER_STATS_SGLINE_EXPIRE_HOUR
	Domylny czas wygasania SGLINE: 1 godzina

OPER_STATS_SGLINE_EXPIRE_MINS
	Domylny czas wygasania SGLINE: %d minut(y)

OPER_STATS_SGLINE_EXPIRE_MIN
	Domylny czas wygasania SGLINE: 1 minuta

OPER_STATS_SGLINE_EXPIRE_NONE
	Domylny czas wygasania SGLINE: nie wygasa

OPER_STATS_SQLINE_COUNT
	Aktualna ilo wpisw SQLINE: %d

OPER_STATS_SQLINE_EXPIRE_DAYS
	Domylny czas wygasania SQLINE: %d dni

OPER_STATS_SQLINE_EXPIRE_DAY
	Domylny czas wygasania SQLINE: 1 dzie

OPER_STATS_SQLINE_EXPIRE_HOURS
	Domylny czas wygasania SQLINE: %d godzin(y)

OPER_STATS_SQLINE_EXPIRE_HOUR
	Domylny czas wygasania SQLINE: 1 godzina

OPER_STATS_SQLINE_EXPIRE_MINS
	Domylny czas wygasania SQLINE: %d minut(y)

OPER_STATS_SQLINE_EXPIRE_MIN
	Domylny czas wygasania SQLINE: 1 minuta

OPER_STATS_SQLINE_EXPIRE_NONE
	Domylny czas wygasania SQLINE: nie wygasa

OPER_STATS_SZLINE_COUNT
	Aktualna ilo wpisw SZLINE: %d

OPER_STATS_SZLINE_EXPIRE_DAYS
	Domylny czas wygasania SZLINE: %d dni

OPER_STATS_SZLINE_EXPIRE_DAY
	Domylny czas wygasania SZLINE: 1 dzie

OPER_STATS_SZLINE_EXPIRE_HOURS
	Domylny czas wygasania SZLINE: %d godzin(y)

OPER_STATS_SZLINE_EXPIRE_HOUR
	Domylny czas wygasania SZLINE: 1 godzina

OPER_STATS_SZLINE_EXPIRE_MINS
	Domylny czas wygasania SZLINE: %d minut(y)

OPER_STATS_SZLINE_EXPIRE_MIN
	Domylny czas wygasania SZLINE: 1 minuta

OPER_STATS_SZLINE_EXPIRE_NONE
	Domylny czas wygasania SZLINE: nie wygasa

OPER_STATS_RESET
	Statystyki zostay zresetowane.

OPER_STATS_UPLINK_SERVER
	Podczony do: %s

OPER_STATS_UPLINK_CAPAB
	Uplink capab  : %s

OPER_STATS_UPLINK_SERVER_COUNT
	Serwerw      : %d

# MODE responses
OPER_MODE_SYNTAX
	MODE kana flagi

# UMODE respondes
OPER_UMODE_SYNTAX
	UMODE nick flagi

OPER_UMODE_SUCCESS
	Zmieniono flagi uytkownika dla %s.

OPER_UMODE_CHANGED
	%s zmienia Twoje flagi uytkownika.

# OLINE responses
OPER_OLINE_SYNTAX
	OLINE nick flagi

OPER_OLINE_SUCCESS
	Flagi operatora %s zostay przyznane dla %s.

OPER_OLINE_IRCOP
	Jeste teraz IRC operatorem.

# CLEARMODES responses
OPER_CLEARMODES_SYNTAX
	CLEARMODES kana [ALL]

OPER_CLEARMODES_DONE
	Tryby i bany zostay wyczyszczone na kanale %s.

OPER_CLEARMODES_ALL_DONE
	Wszystkie tryby zostay wyczyszczone na kanale %s.

# KICK responses
OPER_KICK_SYNTAX
	KICK kana nick powd

# SVSNICK responses
OPER_SVSNICK_SYNTAX
	SVSNICK nick nowy-nick

OPER_SVSNICK_NEWNICK
	Nick %s zostaje zmieniony na %s.

# ADMIN responses
OPER_ADMIN_SYNTAX
	ADMIN {ADD|DEL|LIST|CLEAR} [nick | pozycja]

OPER_ADMIN_SKELETON
	Serwisy s w trybie szkieletowym, komenda ADMIN nie jest dostpna.

OPER_ADMIN_EXISTS
	%s ju istnieje na licie administratorw serwisw.

OPER_ADMIN_REACHED_LIMIT
	Moesz mie tylko %d administratorw serwisw.

OPER_ADMIN_ADDED
	%s dodano do listy administratorw serwisw.

OPER_ADMIN_NOT_FOUND
	%s nie znaleziono na licie administratorw serwisw.

OPER_ADMIN_NO_MATCH
	Nie znaleziono pasujcych wpisw na licie administratorw serwisw.

OPER_ADMIN_DELETED
	%s usunito z listy administratorw serwisw.

OPER_ADMIN_DELETED_ONE
	Usunito 1 wpis z listy administratorw serwisw.

OPER_ADMIN_DELETED_SEVERAL
	Usunito %d wpisy(w) z listy administratorw serwisw.

OPER_ADMIN_LIST_EMPTY
	Lista administratorw serwisw jest pusta.

OPER_ADMIN_LIST_HEADER
	Lista administratorw serwisw:
	  Nr    Nick

OPER_ADMIN_LIST_FORMAT
	  %3d   %s

OPER_ADMIN_CLEAR
	Lista administratorw serwisw zostaa wyczyszczona.

OPER_ADMIN_MOVED
	%s przeniesiono na list administratorw serwisw.

# OPER responses
OPER_OPER_SYNTAX
	OPER {ADD|DEL|LIST|CLEAR} [nick | pozycja]

OPER_OPER_SKELETON
	Serwisy s w trybie szkieletowym, komenda OPER nie jest dostpna.

OPER_OPER_EXISTS
	%s ju istnieje na licie operatorw serwisw.

OPER_OPER_REACHED_LIMIT
	Moesz mie tylko %d operatorw serwisw.

OPER_OPER_ADDED
	%s dodano do listy operatorw serwisw.

OPER_OPER_NOT_FOUND
	%s nie znaleziono na licie operatorw serwisw.

OPER_OPER_NO_MATCH
	Nie znaleziono pasujcych wpisw na licie operatorw serwisw.

OPER_OPER_DELETED
	%s usunito z listy operatorw serwisw.

OPER_OPER_DELETED_ONE
	Usunito 1 wpis z listy operatorw serwisw.

OPER_OPER_DELETED_SEVERAL
	Usunito %d wpisy(w) z listy operatorw serwisw.

OPER_OPER_LIST_EMPTY
	Lista operatorw serwisw jest pusta.

OPER_OPER_LIST_HEADER
	Lista operatorw serwisw:
	  Nr    Nick

OPER_OPER_LIST_FORMAT
	  %3d   %s

OPER_OPER_CLEAR
	Lista operatorw serwisw zostaa wyczyszczona.

OPER_OPER_MOVED
	%s przeniesiono na list operatorw serwisw.

# AKILL responses
OPER_AKILL_SYNTAX
	AKILL {ADD | DEL | LIST | VIEW | CLEAR} [[+czas-trwania] {maska | pozycja} [powd]]

OPER_AKILL_EXISTS
	%s ju istnieje na licie AKILL.

OPER_AKILL_ALREADY_COVERED
	%s ju jest obejmowane przez %s.

OPER_AKILL_REACHED_LIMIT
	Moesz mie tylko %d wpisw na licie AKILL.

OPER_AKILL_NO_NICK
	Uwaga: maska AKILL nie moe zawiera nickw.
	Upewnij si, e nie dodajesz czci nicka.

OPER_AKILL_ADDED
	%s dodano do listy AKILL.

OPER_AKILL_CHANGED
	Zmieniono czas wygasania %s.

OPER_AKILL_NOT_FOUND
	%s nie znaleziono na licie AKILL.

OPER_AKILL_NO_MATCH
	Nie znaleziono pasujcych wpisw na licie AKILL.

OPER_AKILL_DELETED
	%s usunito z listy AKILL.

OPER_AKILL_DELETED_ONE
	Usunito 1 wpis z listy AKILL.

OPER_AKILL_DELETED_SEVERAL
	Usunito %d wpisy(w) z listy AKILL.

OPER_AKILL_LIST_EMPTY
	Lista AKILL jest pusta.

OPER_AKILL_LIST_HEADER
	Aktualna lista AKILL:
	  Nr    Maska                             Powd

OPER_AKILL_LIST_FORMAT
	  %3d   %-32s  %s

OPER_AKILL_VIEW_HEADER
	Aktualna lista AKILL:

# number, mask, set-by, set-time, expires, reason
OPER_AKILL_VIEW_FORMAT
	%3d  %s (przez %s na %s; %s)
	      %s

OPER_AKILL_CLEAR
	Lista AKILL zostaa wyczyszczona.

OPER_CHANKILL_SYNTAX
	CHANKILL [+czas-trwania] {#kana} [powd]

# SGLINE responses
OPER_SGLINE_SYNTAX
	SGLINE {ADD | DEL | LIST | VIEW | CLEAR} [[+czas-trwania] {maska | pozycja} [powd]]

OPER_SGLINE_UNSUPPORTED
	Komenda SGLINE nie jest dostpna w tej sieci.

OPER_SGLINE_EXISTS
	%s ju istnieje na licie SGLINE.

OPER_SGLINE_ALREADY_COVERED
	%s ju jest obejmowane przez %s.

OPER_SGLINE_REACHED_LIMIT
	Moesz mie tylko %d wpisw na licie SGLINE.

OPER_SGLINE_ADDED
	%s dodano do listy SGLINE.

OPER_SGLINE_CHANGED
	Zmieniono czas wygasania %s.

OPER_SGLINE_NOT_FOUND
	%s nie znaleziono na licie SGLINE.

OPER_SGLINE_NO_MATCH
	Nie znaleziono pasujcych wpisw na licie SGLINE.

OPER_SGLINE_DELETED
	%s usunito z listy SGLINE.

OPER_SGLINE_DELETED_ONE
	Usunito 1 wpis z listy SGLINE.

OPER_SGLINE_DELETED_SEVERAL
	Usunito %d wpisy(w) z listy SGLINE.

OPER_SGLINE_LIST_EMPTY
	Lista SGLINE jest pusta.

OPER_SGLINE_LIST_HEADER
	Aktualna lista SGLINE:
	  Nr    Maska                             Powd

OPER_SGLINE_LIST_FORMAT
	  %3d   %-32s  %s

OPER_SGLINE_VIEW_HEADER
	Aktualna lista SGLINE:

# number, mask, set-by, set-time, expires, reason
OPER_SGLINE_VIEW_FORMAT
	%3d  %s (przez %s na %s; %s)
	      %s

OPER_SGLINE_CLEAR
	Lista SGLINE zostaa wyczyszczona.

# SQLINE responses
OPER_SQLINE_SYNTAX
	SQLINE {ADD | DEL | LIST | VIEW | CLEAR} [[+czas-trwania] {maska | pozycja} [powd]]

OPER_SQLINE_CHANNELS_UNSUPPORTED
	Kanaowe SQLINE nie jest obsugiwane przez Twoje ircd.

OPER_SQLINE_EXISTS
	%s ju istnieje na licie SQLINE.

OPER_SQLINE_ALREADY_COVERED
	%s ju jest obejmowane przez %s.

OPER_SQLINE_REACHED_LIMIT
	Moesz mie tylko %d wpisw na licie SQLINE.

OPER_SQLINE_ADDED
	%s dodano do listy SQLINE.

OPER_SQLINE_CHANGED
	Zmieniono czas wygasania %s.

OPER_SQLINE_NOT_FOUND
	%s nie znaleziono na licie SQLINE.

OPER_SQLINE_NO_MATCH
	Nie znaleziono pasujcych wpisw na licie SQLINE.

OPER_SQLINE_DELETED
	%s usunito z listy SQLINE.

OPER_SQLINE_DELETED_ONE
	Usunito 1 wpis z listy SQLINE.

OPER_SQLINE_DELETED_SEVERAL
	Usunito %d wpisy(w) z listy SQLINE.

OPER_SQLINE_LIST_EMPTY
	Lista SQLINE jest pusta.

OPER_SQLINE_LIST_HEADER
	Aktualna lista SQLINE:
	  Nr    Maska                             Powd

OPER_SQLINE_LIST_FORMAT
	  %3d   %-32s  %s

OPER_SQLINE_VIEW_HEADER
	Aktualna lista SQLINE:

# number, mask, set-by, set-time, expires, reason
OPER_SQLINE_VIEW_FORMAT
	%3d  %s (przez %s na %s; %s)
	      %s

OPER_SQLINE_CLEAR
	Lista SQLINE zostaa wyczyszczona.

# SZLINE responses
OPER_SZLINE_SYNTAX
	SZLINE {ADD | DEL | LIST | VIEW | CLEAR} [[+czas-trwania] {maska | pozycja} [powd]]

OPER_SZLINE_UNSUPPORTED
	Komenda SZLINE nie jest dostpna w tej sieci.

OPER_SZLINE_EXISTS
	%s ju istnieje na licie SZLINE.

OPER_SZLINE_ALREADY_COVERED
	%s ju jest obejmowane przez %s.

OPER_SZLINE_REACHED_LIMIT
	Moesz mie tylko %d wpisw na licie SZLINE.

OPER_SZLINE_ONLY_IPS
	Uwaga: moesz dodawa jedynie maski IP do listy SZLINE.

OPER_SZLINE_ADDED
	%s dodano do listy SZLINE.

OPER_SZLINE_CHANGED
	Zmieniono czas wygasania %s.

OPER_SZLINE_NOT_FOUND
	%s nie znaleziono na licie SZLINE.

OPER_SZLINE_NO_MATCH
	Nie znaleziono pasujcych wpisw na licie SZLINE.

OPER_SZLINE_DELETED
	%s usunito z listy SZLINE.

OPER_SZLINE_DELETED_ONE
	Usunito 1 wpis z listy SZLINE.

OPER_SZLINE_DELETED_SEVERAL
	Usunito %d wpisy(w) z listy SZLINE.

OPER_SZLINE_LIST_EMPTY
	Lista SZLINE jest pusta.

OPER_SZLINE_LIST_HEADER
	Aktualna lista SZLINE:
	  Nr    Maska                             Powd

OPER_SZLINE_LIST_FORMAT
	  %3d   %-32s  %s

OPER_SZLINE_VIEW_HEADER
	Aktualna lista SZLINE:

# number, mask, set-by, set-time, expires, reason
OPER_SZLINE_VIEW_FORMAT
	%3d  %s (przez %s na %s; %s)
	      %s

OPER_SZLINE_CLEAR
	Lista SZLINE zostaa wyczyszczona.

# SET responses
OPER_SET_SYNTAX
	SET opcja ustawienie

OPER_SET_IGNORE_ON
	Opcja IGNORE zostaa wczona.

OPER_SET_IGNORE_OFF
	Opcja IGNORE zostaa wyczona.

OPER_SET_IGNORE_ERROR
	Parametrem opcji IGNORE musi by ON albo OFF.

OPER_SET_READONLY_ON
	Serwisy s teraz w trybie tylko-do-odczytu.

OPER_SET_READONLY_OFF
	Serwisy s teraz w trybie odczyt-zapis.

OPER_SET_READONLY_ERROR
	Parametrem opcji READONLY musi by ON albo OFF.

OPER_SET_LOGCHAN_ON
	Serwisy bd wysya wiadomoci na kana %s.

OPER_SET_LOGCHAN_OFF
	Serwisy nie bd ju duej wysya wiadomoci na kana.

OPER_SET_LOGCHAN_ERROR
	Parametrem dla LOGCHAN musi by ON albo OFF.
	Ponadto kana logowania musi by zdefiniowany w pliku konfiguracyjnym.

OPER_SET_DEBUG_ON
	Serwisy s teraz w trybie debugowania.

OPER_SET_DEBUG_OFF
	Serwisy nie s ju w trybie debugowania.

OPER_SET_DEBUG_LEVEL
	Serwisy s teraz w trybie debugowania (poziom %d).

OPER_SET_DEBUG_ERROR
	Parametrem opcji DEBUG musi by ON, OFF albo liczba dodatnia.

OPER_SET_NOEXPIRE_ON
	Serwisy nie s ju w trybie wygasania.

OPER_SET_NOEXPIRE_OFF
	Serwisy s teraz w trybie wygasania.

OPER_SET_NOEXPIRE_ERROR
	Parametrem opcji NOEXPIRE musi by ON albo OFF.

OPER_SET_UNKNOWN_OPTION
	Nieznana opcja %s.

OPER_SET_SQL_ON
	Obsuga SQL zostaa wczona.

OPER_SET_SQL_OFF
	Obsuga SQL zostaa wyczona.

OPER_SET_SQL_ERROR
	Parametrem opcji SQL musi by ON albo OFF.

OPER_SET_SQL_ERROR_INIT
	Bd podczas inicjacji SQL, sprawd logi.

OPER_SET_SQL_ERROR_DISABLED
	SQL nie jest skonfigurowany dla tej sieci.
	Wprowad zmiany w pliku konfiguracyjnym.

OPER_SET_LIST_OPTION_ON
	%s jest wczone

OPER_SET_LIST_OPTION_OFF
	%s jest wyczone

# NOOP responses
OPER_NOOP_SYNTAX
	NOOP {SET|REVOKE} serwer

OPER_NOOP_SET
	Wszystkie O:linie %s zostay usunite.

OPER_NOOP_REVOKE
	Wszystkie O:linie %s zostay zresetowane.

# JUPE responses
OPER_JUPE_SYNTAX
	JUPE serwer [powd]

OPER_JUPE_HOST_ERROR
	Prosz uy prawidowej nazwy serwera.

OPER_JUPE_INVALID_SERVER
	Nie mona wykluczy samych serwisw lub uplinka serwisw.

# RAW responses
OPER_RAW_SYNTAX
	RAW tekst

# UPDATE responses
OPER_UPDATING
	Aktualizacja baz danych.

# RELOAD responses
OPER_RELOAD
	Plik konfiguracyjny serwisw zosta przeadowany.

# RESTART responses
OPER_CANNOT_RESTART
	Nie zdefiniowano SERVICES_BIN; nie mog restartowa.
	Uruchom ponownie skrypt configure i przekompiluj serwisy, aby wczy komend RESTART.

# IGNORE respondes
OPER_IGNORE_SYNTAX
	IGNORE {ADD|DEL|LIST|CLEAR} [czas] [nick | maska]

OPER_IGNORE_VALID_TIME
	Musisz poda prawidow liczb dla czasu.

OPER_IGNORE_TIME_DONE
	Nick %s bdzie ignorowany przez %s.

OPER_IGNORE_PERM_DONE
	Nick %s bdzie stale ignorowany.

OPER_IGNORE_DEL_DONE
	Nick %s nie bdzie ignorowany.

OPER_IGNORE_LIST
	Lista ignorowanych przez serwisy:

OPER_IGNORE_LIST_NOMATCH
	%s nie znaleziono na licie ignorowanych.

OPER_IGNORE_LIST_EMPTY
	Lista ignorowanych jest pusta.

OPER_IGNORE_LIST_CLEARED
	Lista ignorowanych zostaa wyczyszczona.

# KILLCLONES responses
OPER_KILLCLONES_SYNTAX
	KILLCLONES nick

OPER_KILLCLONES_UNKNOWN_NICK
	Nie mog znale uytkownika %s.

# CHANLIST responses
OPER_CHANLIST_HEADER
	Lista kanaw:
	Nazwa                Tryby uyt.   Temat

OPER_CHANLIST_HEADER_USER
	Lista kanaw %s:
	Nazwa                Tryby uyt.   Temat

OPER_CHANLIST_RECORD
	%-20s  %4d +%-6s %s

OPER_CHANLIST_END
	Koniec listy kanaw.

# USERLIST responses
OPER_USERLIST_HEADER
	Lista uytkownikw:
	Nick                 Maska

OPER_USERLIST_HEADER_CHAN
	Lista uytkownikw %s:
	Nick                 Maska

OPER_USERLIST_RECORD
	%-20s %s@%s

OPER_USERLIST_END
	Koniec listy uytkownikw.

OPER_SUPER_ADMIN_ON
	Jeste teraz super-administratorem.

OPER_SUPER_ADMIN_OFF
	Nie jeste ju duej super-administratorem.

OPER_SUPER_ADMIN_SYNTAX
	Parametrem dla opcji SuperAdmin musi by ON lub OFF (musi by wczona w pliku konfiguracyjnym)

OPER_SUPER_ADMIN_WALL_ON
	%s jest teraz super-administratorem

OPER_SUPER_ADMIN_WALL_OFF
	%s nie jest ju duej super-administratorem

OPER_SUPER_ADMIN_ONLY
	Tylko super-administratorzy mog uywa tej komendy.

OPER_STAFF_LIST_HEADER
	 Na Poziom Nick

OPER_STAFF_FORMAT
	 %c %s  %s

OPER_STAFF_AFORMAT
	 %c %s  %s [%s]

# DefCon Messages
OPER_DEFCON_SYNTAX
	DEFCON [1|2|3|4|5]

OPER_DEFCON_DENIED
	Serwisy s w trybie defcon, sprbuj ponownie pniej.

OPER_DEFCON_NO_CONF
	System defcon musi by wczony w pliku konfiguracyjnym.

OPER_DEFCON_CHANGED
	Serwisy s teraz w systemie DEFCON %d

OPER_DEFCON_WALL
	%s zmieniono poziom DEFCON na %d

DEFCON_GLOBAL
	Defcon jest teraz na poziomie: %d

# Module strings
OPER_MODULE_LOADED
	Modu %s zosta zaadowany.

OPER_MODULE_UNLOADED
	Modu %s zosta wyadowany.

OPER_MODULE_LOAD_FAIL
	Nie mona zaadowa moduu %s

OPER_MODULE_REMOVE_FAIL
	Nie mona wyadowa moduu %s

OPER_MODULE_NO_UNLOAD
	Ten modu nie moe zosta wyadowany.

OPER_MODULE_LOAD_SYNTAX
	MODLOAD nazwa-pliku

OPER_MODULE_UNLOAD_SYNTAX
	MODUNLOAD nazwa-pliku

OPER_MODULE_LIST_HEADER
	Aktualna lista moduw:

OPER_MODULE_LIST
	Modu: %s [%s] [%s]

OPER_MODULE_LIST_FOOTER
	Zaadowanych moduw: %d.

OPER_MODULE_INFO_LIST
	Modu: %s Wersja: %s Autor: %s Zaadowano: %s

OPER_MODULE_CMD_LIST
	Dodane komendy: %R%s %s

OPER_MODULE_MSG_LIST
	Zapewnia IRCD handler dla : %s

OPER_MODULE_NO_LIST
	Aktualnie nie ma zaadowanych moduw.

OPER_MODULE_NO_INFO
	Informacje o module %s nie s dostpne.

OPER_MODULE_INFO_SYNTAX
	MODINFO nazwa-pliku

MODULE_HELP_HEADER
	Nastpujce komendy zostay dodane przez modu:

###########################################################################
#
# Session Limiting and Exception messages
#
###########################################################################
# EXCEPTION responses
OPER_EXCEPTION_SYNTAX
	EXCEPTION {ADD | DEL | MOVE | LIST | VIEW} [parametry]

OPER_EXCEPTION_ADD_SYNTAX
	EXCEPTION ADD [+czas-trwania] maska limit powd

OPER_EXCEPTION_DEL_SYNTAX
	EXCEPTION DEL {maska | lista}

OPER_EXCEPTION_MOVE_SYNTAX
	EXCEPTION MOVE numer pozycja

OPER_EXCEPTION_DISABLED
	Limitowanie sesji jest wyczone.

OPER_EXCEPTION_ALREADY_PRESENT
	Maska %s ju istnieje na licie wyjtkw.

OPER_EXCEPTION_TOO_MANY
	Lista wyjtkw limitw sesji jest pena!

OPER_EXCEPTION_ADDED
	Limit sesji dla %s zmieniono na %d.

OPER_EXCEPTION_MOVED
	Wyjtek dla %s (#%d) przeniesiono na pozycj %d.

OPER_EXCEPTION_NO_SUCH_ENTRY
	Nie znaleziono wpisu (#%d) na licie wyjtkw limitw sesji.

OPER_EXCEPTION_NOT_FOUND
	%s nie znaleziono na licie wyjtkw limitw sesji.

OPER_EXCEPTION_NO_MATCH
	Nie znaleziono wpisw na licie wyjtkw limitw sesji.

OPER_EXCEPTION_DELETED
	%s usunito z listy wyjtkw limitw sesji.

OPER_EXCEPTION_DELETED_ONE
	Usunito 1 wpis z listy wyjtkw limitw sesji.

OPER_EXCEPTION_DELETED_SEVERAL
	Usunito %d wpisy(w) z listy wyjtkw limitw sesji.

OPER_EXCEPTION_LIST_HEADER
	Aktualna lista wyjtkw limitw sesji:

# mask, limit
OPER_EXCEPTION_LIST_FORMAT
	%3d  %4d   %s

OPER_EXCEPTION_LIST_COLHEAD
	Nr   Limit  Host

# mask, set-by, set-time, expires, limit, reason
OPER_EXCEPTION_VIEW_FORMAT
	%3d.  %s  (przez %s na %s; %s)
	    Limit: %-4d  - %s

OPER_EXCEPTION_INVALID_LIMIT
	Nieprawidowy limit sesji. Musi by liczb nieujemn i mniejsz ni %d.

OPER_EXCEPTION_INVALID_HOSTMASK
	Nieprawidowa maska. Tylko rzeczywiste maski s prawidowe jako wyjtki.

OPER_EXCEPTION_EXISTS
	%s ju istnieje na licie wyjtkw.

OPER_EXCEPTION_CHANGED
	Wyjtek dla %s zosta zaktualizowany do %d.

# SESSION responses
OPER_SESSION_SYNTAX
	SESSION {LIST limit | VIEW host}

OPER_SESSION_LIST_SYNTAX
	SESSION LIST limit

OPER_SESSION_VIEW_SYNTAX
	SESSION VIEW host

OPER_SESSION_DISABLED
	Limitowanie sesji jest wyczone.

OPER_SESSION_INVALID_THRESHOLD
	Nieprawidowa warto progu. Musi by liczb cakowit wiksz ni 1.

OPER_SESSION_NOT_FOUND
	%s nie znaleziono na licie sesji.

OPER_SESSION_LIST_HEADER
	Hosty z przynajmniej %d sesjami:

OPER_SESSION_LIST_COLHEAD
	Sesje   Host

# limit, host
OPER_SESSION_LIST_FORMAT
	%6d    %s

# host, sessions, limit
OPER_SESSION_VIEW_FORMAT
	Host %s aktualnie posiada %d sesji z limitem %d.

# EXCEPTION help
OPER_HELP_EXCEPTION
	Skadnia: EXCEPTION ADD [+czas-trwania] maska limit powd
	          EXCEPTION DEL {maska | lista}
	          EXCEPTION MOVE numer pozycja
	          EXCEPTION LIST [maska | lista]
	          EXCEPTION VIEW [maska | lista]
	
	Pozwala administratorom serwisw na zarzdzanie list limitw
	sesji dla poszczeglnych hostw - np. serwery shell mog
	mie wiksz liczb pocze. Kiedy limit pocze zostanie
	osignity kady nowy uytkownik z takiego hosta bdzie
	rozczany z sieci. Przed rozczeniem zostanie wysane
	powiadomienie (jego tre ustawia si w pliku konfiguracyjnym).
	
	EXCEPTION ADD dodaje wskazan mask na list wyjtkw.
	Maski nick!user@host oraz user@host s nieprawidowe,
	poniewa zawieraj nick lub ident uytkownika. Dopuszczalne
	maski to np. box.host.dom lub *.host.dom. Limit musi
	by liczb nieujemn. Podanie zera oznacza wyczenie limitu.
	Format czasu jest opisany w pomocy polecenia AKILL.
	EXCEPTION DEL usuwa wskazane wpisy z listy wyjtkw.
	EXCEPTION MOVE przenosi wyjtek o wskazanym numerze na
	now pozycj. Wyjtki znajdujce si pomidzy zostan
	odpowiednio przeniesione, aby wypeni powsta luk.
	EXCEPTION LIST oraz EXCEPTION VIEW listuj wyjtki.
	Podanie maski powoduje ograniczenie wywietlanych wpisw.
	EXCEPTION VIEW zwraca dodatkowo informacje o zakadajcym,
	limicie, powodzie, masce oraz czasie.
	
	Naley pamita, e podczajcy si klient bdzie uywa
	pierwszego wyjtku o pasujcej masce. Dua lista wyjtkw i
	zbyt oglne maski powoduj pogorszenie wydajnoci serwisw.

OPER_HELP_SESSION
	Skadnia: SESSION LIST minimum
	          SESSION VIEW host
	
	Pozwala administratorom serwisw na listowanie sesji.
	
	SESSION LIST listuje hosty z przynajmniej minimum sesjami.
	Minimum musi by wiksze od 1, aby zapobiec przypadkowemu
	listowaniu duej liczby pojedynczych hostw.
	SESSION VIEW wywietla szczegowe informacje na temat 
	podanego hosta - podajc aktualny limit oraz ilo sesji.
	Parametr host moe zawiera symboli wieloznacznych.
	
	Wicej informacji na temat ograniczania liczby sesji
	znajduje si w pomocy polecenia EXCEPTION.

OPER_HELP_STAFF
	Skadnia: STAFF
	
	Wywietla nicki obsugi serwisw, poziom i status online.

OPER_HELP_DEFCON
	Skadnia: DEFCON [1|2|3|4|5]
	
	System defcon umoliwia wprowadzanie wczeniej
	zdefiniowanych ogranicze dla serwisw podczas
	prby ataku na sie.
OPER_HELP_DEFCON_NO_NEW_CHANNELS
	* Wycza rejestrowanie kanaw

OPER_HELP_DEFCON_NO_NEW_NICKS
	* Wycza rejestrowanie nickw

OPER_HELP_DEFCON_NO_MLOCK_CHANGE
	* Flagi kanaw nie bd wymuszane (MLOCK)

OPER_HELP_DEFCON_FORCE_CHAN_MODES
	* Wymusza ustawienie flag (%s) na wszystkich kanaach

OPER_HELP_DEFCON_REDUCE_SESSION
	* Uywa zredukowanego limitu sesji: %d

OPER_HELP_DEFCON_NO_NEW_CLIENTS
	* Killuje wszystkich nowych klientw

OPER_HELP_DEFCON_OPER_ONLY
	* Ignoruje zwykych uytkownikw (informuje ich o tym)

OPER_HELP_DEFCON_SILENT_OPER_ONLY
	* Cicho ignoruje zwykych uytkownikw

OPER_HELP_DEFCON_AKILL_NEW_CLIENTS
	* AKILLuje wszystkich nowych klientw

OPER_HELP_DEFCON_NO_NEW_MEMOS
	* Nowe wiadomoci nie bd wysyane

OPER_HELP_CHANKILL
	Skadnia: CHANKILL [+czas] kana powd
	
	Zakada AKILLa na kady nick na wskazanym kanale.
	Na list zostaj dodane prawdziwe adresy (ident@host),
	po czym AKILL zostaje wykonany.
###########################################################################
#
# News system messages
#
###########################################################################
NEWS_LOGON_TEXT
	[Wiadomo powitalna - %s] %s

NEWS_OPER_TEXT
	[Wiadomo dla operatorw - %s] %s

NEWS_RANDOM_TEXT
	[Losowa wiadomo - %s] %s

NEWS_LOGON_SYNTAX
	LOGONNEWS {ADD|DEL|LIST} [tekst|numer]

NEWS_LOGON_LIST_HEADER
	Wiadomoci powitalne:

NEWS_LOGON_LIST_ENTRY
	%5d (%s przez %s)
	    %s

NEWS_LOGON_LIST_NONE
	Nie ma wiadomoci powitalnych.

NEWS_LOGON_ADD_SYNTAX
	LOGONNEWS ADD tekst

NEWS_LOGON_ADD_FULL
	Lista wiadomoci powitalnych jest pena!

NEWS_LOGON_ADDED
	Dodano now wiadomo powitaln (#%d).

NEWS_LOGON_DEL_SYNTAX
	LOGONNEWS DEL {numer | ALL}

NEWS_LOGON_DEL_NOT_FOUND
	Wiadomo powitalna #%d nie zostaa znaleziona!

NEWS_LOGON_DELETED
	Wiadomo powitalna #%d zostaa skasowana.

NEWS_LOGON_DEL_NONE
	Nie ma wiadomoci powitalnych do skasowania!

NEWS_LOGON_DELETED_ALL
	Wszystkie wiadomoci powitalne zosta skasowane.

NEWS_OPER_SYNTAX
	OPERNEWS {ADD|DEL|LIST} [tekst|numer]

NEWS_OPER_LIST_HEADER
	Wiadomoci dla operatorw:

NEWS_OPER_LIST_ENTRY
	%5d (%s przez %s)
	    %s

NEWS_OPER_LIST_NONE
	Nie ma wiadomoci dla operatorw.

NEWS_OPER_ADD_SYNTAX
	OPERNEWS ADD tekst

NEWS_OPER_ADD_FULL
	Lista wiadomoci jest pena!

NEWS_OPER_ADDED
	Dodano now wiadomo dla operatorw (#%d).

NEWS_OPER_DEL_SYNTAX
	OPERNEWS DEL {numer | ALL}

NEWS_OPER_DEL_NOT_FOUND
	Wiadomo dla operatorw #%d nie zostaa znaleziona!

NEWS_OPER_DELETED
	Wiadomo dla operatorw #%d zostaa skasowana.

NEWS_OPER_DEL_NONE
	Nie ma wiadomoci dla operatorw do skasowania!

NEWS_OPER_DELETED_ALL
	Wszystkie wiadomoci dla operatorw zostay skasowane.

NEWS_RANDOM_SYNTAX
	RANDOMNEWS {ADD|DEL|LIST} [tekst|numer]

NEWS_RANDOM_LIST_HEADER
	Losowe wiadomoci:

NEWS_RANDOM_LIST_ENTRY
	%5d (%s przez %s)
	    %s

NEWS_RANDOM_LIST_NONE
	Nie ma losowych wiadomoci.

NEWS_RANDOM_ADD_SYNTAX
	RANDOMNEWS ADD tekst

NEWS_RANDOM_ADD_FULL
	Lista wiadomoci jest pena!

NEWS_RANDOM_ADDED
	Dodano now losow wiadomo (#%d).

NEWS_RANDOM_DEL_SYNTAX
	RANDOMNEWS DEL {numer | ALL}

NEWS_RANDOM_DEL_NOT_FOUND
	Losowa wiadomo #%d nie zostaa znaleziona!

NEWS_RANDOM_DELETED
	Losowa wiadomo #%d zostaa skasowana.

NEWS_RANDOM_DEL_NONE
	Nie ma losowych wiadomoci do skasowania!

NEWS_RANDOM_DELETED_ALL
	Wszystkie losowe wiadomoci zostay skasowane.

NEWS_HELP_LOGON
	Skadnia: LOGONNEWS ADD tekst
	          LOGONNEWS DEL {numer | ALL}
	          LOGONNEWS LIST
	
	Edytuje lub wywietla list wiadomoci wysyanych po
	przyczeniu uytkownika do sieci. Jeli zdefniowanych
	wiadomoci jest wicej tylko najnowsze %s zostanie
	wysanych (aby zapobiec floodowaniu). Warto NewsCount
	moe zosta zmieniona w pliku konfiguracyjym serwisw.
	
	LOGONNEWS may only be used by Services admins.

NEWS_HELP_OPER
	Skadnia: OPERNEWS ADD tekst
	          OPERNEWS DEL {numer | ALL}
	          OPERNEWS LIST
	
	Edytuje lub wywietla list wiadomoci wysyanych po
	wykonaniu polecenia /OPER. Jeli zdefiniowanych
	wiadomoci jest wicej tylko najnowsze %s zostanie
	wysanych (aby zapobiec floodowaniu). Warto NewsCount
	moe zosta zmieniona w pliku konfiguracyjym serwisw.
	
	OPERNEWS may only be used by Services admins. 

NEWS_HELP_RANDOM
	Skadnia: RANDOMNEWS ADD tekst
	          RANDOMNEWS DEL {numer | ALL}
	          RANDOMNEWS LIST
	
	Edytuje lub wywietla list losowych newsw.
	Po poczeniu z sieci uytkownik otrzyma dokadnie
	jedn wylosowan z tej listy wiadomo.
	
	RANDOMNEWS may only be used by Services admins. 

###########################################################################
#
# HelpServ help message
#
###########################################################################
HELP_HELP
	%S jest serwisem udzielajcym informacji
	na temat innych serwisw. Dostpne tematy pomocy:
	
	
	%R%s HELP
	     rejestracja i zarzdzanie nickami
	
	%R%s HELP
	     rejestracja i zarzdzanie kanaami
	
	%R%s HELP
	     wysyanie wiadomoci do uytkownikw off-line

HELP_HELP_BOT
	%R%s HELP
	     stawianie serwisowego bota na kanale

HELP_HELP_HOST
	%R%s HELP
	     ustawianie vhostw

###########################################################################
#
# NickServ help messages
#
###########################################################################
NICK_HELP_CMD_CONFIRM
	    CONFIRM     Potwierdza rejestracj nicka

NICK_HELP_CMD_RESEND
	    RESEND      Wysya ponownie kod autoryzujcy

NICK_HELP_CMD_REGISTER
	    REGISTER    Rejestruje nicka

NICK_HELP_CMD_GROUP
	    GROUP       Docza nick do wskazanej grupy

NICK_HELP_CMD_IDENTIFY
	    IDENTIFY    Identyfikuje waciciela nicka

NICK_HELP_CMD_ACCESS
	    ACCESS      Zarzdza list dostpu

NICK_HELP_CMD_SET
	    SET         Modyfikuje ustawienia nicka

NICK_HELP_CMD_SASET
	    SASET       Ustawia opcje wskazanemu nickowi

NICK_HELP_CMD_DROP
	    DROP        Usuwa nicka

NICK_HELP_CMD_RECOVER
	    RECOVER     Odcza uytkownika, ktry uywa Twojego nicka

NICK_HELP_CMD_RELEASE
	    RELEASE     Zwalnia nick po uyciu komendy RECOVER

NICK_HELP_CMD_SENDPASS
	    SENDPASS    Pomaga odzyska utracone haso

NICK_HELP_CMD_GHOST
	    GHOST       Odcza wskazany nick od serwera

NICK_HELP_CMD_ALIST
	    ALIST       Listuje kanay na ktrych masz uprawnienia

NICK_HELP_CMD_GLIST
	    GLIST       Wywietla wszystkie nicki w Twojej grupie

NICK_HELP_CMD_INFO
	    INFO        Pokazuje informacje o zarejestrowanym nicku

NICK_HELP_CMD_LIST
	    LIST        Listuje zarejestrowane nicki pasujce do wzorca

NICK_HELP_CMD_LOGOUT
	    LOGOUT      Odwraca dziaanie komendy IDENTIFY

NICK_HELP_CMD_STATUS
	    STATUS      Podaje status waciciela podanego nicka

NICK_HELP_CMD_UPDATE
	    UPDATE      Aktualizuje twj obecny status np.
	                sprawdza nowe wiadomoci

NICK_HELP_CMD_GETPASS
	    GETPASS     Podaje haso do wskazanego nicka

NICK_HELP_CMD_GETEMAIL
	    GETEMAIL    Wywietla uytkownikw zarejestrowanych z
	                podanym adresem e-mail

NICK_HELP_CMD_FORBID
	    FORBID      Blokuje podany nick

NICK_HELP_CMD_SUSPEND
	    SUSPEND     Blokuje podany nick z zachowaniem
	                wszelkich jego danych i ustawie

NICK_HELP_CMD_UNSUSPEND
	    UNSUSPEND   Uwalnia zawieszonego nicka

NICK_HELP
	%S umoliwia rejestracj nicka i zapewnia
	wyczno na jego uywanie. Ponisze komendy
	umoliwiaj zarzdzanie nickiem, aby ich uy wpisz:
	%R%S komenda
	Aby uzyska szczegowy opis polecenia wpisz:
	%R%S HELP komenda
	
	

NICK_HELP_FOOTER
	
	UWAGA: Ten serwis ma na celu umoliwienie identyfikacji
	uytkownikw. NIE suy do kradziey nickw czy innych
	zoliwych akcji. Naduycia bd skutkoway co najmniej
	utrat zarejestrowanego nicka.
	

NICK_HELP_EXPIRES
	
	Nicki nieuywane przez duszy czas s automatycznie
	usuwane po %d dniach od ostatniej identyfikacji.
	Wszelkie ustawienia oraz uprawnienia zostaj usunite.

NICK_HELP_REGISTER
	Skadnia: REGISTER haso [email]
	
	Rejestruje aktualnie uywany nick w bazie %S.
	Po rejestracji moesz uy komend SET i ACCESS
	do konfiguracji niektrych opcji nicka wedle upodoba.
	Upewnij si, e pamitasz haso rejestracyjne, bo 
	bdzie ono potrzebne w przyszoci do zmiany
	ustawie i identyfikacji. Wielko liter w hale 
	ma znaczenie!!!.
	
	Jak wybra haso?
	
	Haso musi by trudne do odgadnicia. Uywanie imion
	jako hase jest niewskazane. Bardzo krtkie haso
	moe zosta odgadnite metod prb i bdw.
	Twoje haso musi mie dugo co najmniej 5 znakw.
	Znak spacji nie moe by uyty w hale.
	
	Parametr email jest opcjonalny i od razu przy 
	rejestracji ustawia adres e-mail dla Twojego nicka. 
	Moe si zdarzy, e adres e-mail moe by wymagany 
	na niektrych sieciach. Twoja prywatno jest
	chroniona - adres nie bdzie udostpniany osobom
	trzecim.
	
	Wraz z rejestracj zostaje utworzona grupa.
	Nicki z tej samej grupy maj wsplne ustawienia,
	prawa na kanale oraz ustawienia wiadomoci.
	Aby uzyska wicej informacji napisz: 
	%R%S HELP GROUP.
	

NICK_HELP_GROUP
	Skadnia: GROUP nazwa haso
	
	Ta komenda powoduje dodanie Twojego nicka do grupy
	reprezentowanej przez nick nazwa o hale haso.
	
	Grupowanie nickw pozwala na dzielenie si ustawieniami,
	wiadomociami oraz uprawnieniami z innymi nickami z grupy.
	
	Jeli jaki nick z grupy zostanie usunity nie tracisz
	adnych ustawie czy uprawnie, jednak grupa istnieje
	dopki jest w niej przynajmniej jeden nick.
	
	Komenda moe by uyta nawet wtedy kiedy biecy nick
	nie jest zarejestrowany, w przeciwnym wypadku musisz
	si zidentyfikowa. Aby uzyska wicej informacji wpisz:
	%R%S HELP IDENTIFY
	
	Moliwe i zalecane jest uywanie tej komendy na nickach,
	ktre nie s zarejestrowane, zostan one wtedy automatycznie
	dodane do bazy %S.
	
	UWAGA: Komend mona uy take na zarejestrowanym nicku,
	naley jednak wzi pod uwag to, e jeli biecy nick jest
	ostatni ze swojej grupy, to wszystkie jego ustawienia oraz
	uprawnienia zostan usunite! Z tego powodu najlepiej grupowa
	nowy nick ze starym, a nie na odwrt. Zmiana grupy moe by
	wyczona przez administratora w niektrych sieciach.
	
	Mona by tylko w jednej grupie w danej chwili,
	czenie grup nie jest moliwe.
	
	Uwaga: wszystkie nicki w grupie maj to samo haso.

NICK_HELP_IDENTIFY
	Skadnia: IDENTIFY haso
	
	Informuje %S, e nick ktrego wanie uywasz 
	naley do Ciebie. Wiele komend wymaga identyfikacji 
	przed ich uyciem. Hasem jest to samo haso, 
	ktrego uyto przy komendzie REGISTER.

NICK_HELP_UPDATE
	Skadnia: UPDATE
	
	Aktualizuje twj obecny status, np. sprawdza czy s nowe
	wiadomoci, ustawia odpowiednie uprawnienia na kanaach,
	aktualizuje vhosta oraz flagi uytkownika.

NICK_HELP_LOGOUT
	Skadnia: LOGOUT
	
	Odwraca dziaanie komendy IDENTIFY. Po wydaniu
	tego polecenia nie bdziesz rozpoznawany jako
	waciciel nicka.
NICK_HELP_DROP
	Skadnia: DROP [nick]
	
	Usuwa nick z bazy danych %S. Usunity nick
	moe zosta ponownie zarejestrowany przez kadego.
	
	Moesz usun nick nalecy do Twojej grupy podajc
	go jako dodatkowy parametr nick.
	
	Uycie tej komendy wymaga identyfikacji z uyciem
	hasa. Aby uzyska wicej informacji wpisz:
	%R%S HELP IDENTIFY

NICK_HELP_ACCESS
	Skadnia: ACCESS ADD maska
	          ACCESS DEL maska
	          ACCESS LIST
	
	Modyfikuje lub wywietla list dostpu dla nicka.
	Lista dostpu okrela hosty uytkownikw mogcych
	uywa twojego nicka. Jeli chcesz uywa nicka z
	innego hosta musisz si najpierw zidentyfikowa
	w serwisie %S komend IDENTIFY.
	
	Przykady:
	
	    ACCESS ADD userek@ircnet.pl
	        Zezwala na dostp do nicka kademu 
	        czcemu si z domeny ircnet.pl.
	
	    ACCESS DEL userek@ircnet.pl
	        Odwraca efekt poprzedniej komendy.
	
	    ACCESS LIST
	        Wywietla aktualn list dostpu.

NICK_HELP_SET
	Skadnia: SET opcja parametry
	
	Ustawia rne opcje nicka. Dostpne opcje to:
	
	    DISPLAY    Ustawia nick reprezentujcy grup nickw
	    PASSWORD   Ustawia haso do nicka
	    LANGUAGE   Ustawia jzyk w ktrym serwisy bd
	               wysyay komunikaty
	    URL        Przypisuje adres www do nicka
	    EMAIL      Przypisuje adres e-mail do nicka
	    ICQ        Przypisuje numer ICQ do nicka
	    GREET      Przypisuje komunikat powitalny do nicka
	    KILL       Wcza lub wycza ochron nicka
	    SECURE     Wcza lub wycza bezpieczestwo nicka
	    PRIVATE    Zapobiega wywietlaniu nicka po wydaniu
	               polecenia: %R%S LIST
	    HIDE       Ukrywa poszczeglne informacje o nicku
	    MSG        Zmienia sposb komunikacji serwisw
	    AUTOOP     Wcza lub wycza automatyczne opowanie
	
	Aby uy tej komendy musisz si zidentyfikowa z uyciem
	Twojego hasa. Aby uzyska wicej informacji wpisz:
	%R%S HELP IDENTIFY
	
	Aby uzyska wicej informacji o danej opcji wpisz:
	%R%S HELP SET opcja

NICK_HELP_SET_DISPLAY
	Skadnia: SET DISPLAY nowa-nazwa
	
	Zmienia nazw reprezentujc Twoj grup nickw w
	serwisach na now. Nazwa MUSI by jednym z nickw
	nalecych do Twojej grupy.

NICK_HELP_SET_PASSWORD
	Skadnia: SET PASSWORD nowe-haso
	
	Zmienia Twoje haso do nicka.

NICK_HELP_SET_LANGUAGE
	Skadnia: SET LANGUAGE numer
	
	Zmienia jzyk jakiego uywaj serwisy odpowiadajc 
	Tobie (czyli przykadowo kiedy odpowiadaj na 
	wysan przez Ciebie komend). Numer moe by 
	wybrany z poniszej listy obsugiwanych jzykw:

NICK_HELP_SET_URL
	Skadnia: SET URL adres
	
	Przypisuje podany adres strony www nickowi.
	Ten adres bdzie si pokazywa w opisie Twojego
	nicka dostpnym po uyciu polecenia INFO.

NICK_HELP_SET_EMAIL
	Skadnia: SET EMAIL adres
	
	Przypisuje adres e-mail Twojemu nickowi. Adres
	bdzie wywietlany przy opisie Twojego nicka
	dostpnym przy uyciu komendy INFO.

NICK_HELP_SET_ICQ
	Skadnia: SET ICQ numer
	
	Przypisuje numer ICQ Twojemu nickowi, ktry
	bdzie wywietlany przy opisie Twojego nicka
	dostpnym przy uyciu komendy INFO.
	

NICK_HELP_SET_GREET
	Skadnia: SET GREET wiadomo
	
	Ustawia wiadomo powitaln dla Twojego nicka.
	Jeli kana ma przydzielonego bota, wczone witanie
	uytkownikw oraz masz odpowiedni poziom dostpu to
	wtedy ta wiadomo bdzie wysyana na kana przez bota.

NICK_HELP_SET_KILL
	Skadnia: SET KILL {ON | QUICK | IMMED | OFF}
	
	Wcza lub wycza automatyczn ochron dla nicka.
	Uytkownicy wchodzcy na chroniony nick otrzymuj
	informacje od %S, e nick jest zarejestrowany i
	jeli si nie zidentyfikuj lub go nie zmieni
	w okrelonym czasie to ich nick zostanie zmieniony
	si lub zostan odczeni od sieci.
	
	Opcja QUICK skraca czas oczekiwania na zmian
	z 60 sekund do 20. W przypadku opcji IMMED
	nick zostanie zmieniony natychmiast bez moliwoci
	identyfikacji (wstpna identyfikacja nastpuje
	na podstawie listy dostpu, dlatego t opcj
	naley stosowa z rozwag). Administrator sieci 
	moe wyczy korzystanie z IMMED.
NICK_HELP_SET_SECURE
	Skadnia: SET SECURE {ON | OFF}
	
	Wcza lub wycza opcj bezpieczestwa dla nicka.
	Wczenie SECURE wymusza na uytkowniku podanie
	hasa zanim ten zostanie rozpoznany jako waciciel
	nicka. %S nie bierze pod uwag w tym wypadku
	wystpowania adresu licie dostpu. Jeli adres 
	znajduje si na licie %S nie skilluje
	uytkownika niezalenie od ustawienia opcji KILL.

NICK_HELP_SET_PRIVATE
	Skadnia: SET PRIVATE {ON | OFF}

	Wcza lub wycza opcj PRIVATE dla nicka.
	Kiedy ta opcja jest wczona nick nie bdzie
	umieszczany na listach wywietlanych komend:
	%R%S LIST
	Jednak kady, kto zna nick moe uzyska o nim
	informacje uywajc polecenia INFO.

NICK_HELP_SET_HIDE
	Skadnia: SET HIDE {EMAIL | STATUS | USERMASK | QUIT} {ON | OFF}
	
	To polecenie pozwala na ukrycie czci informacji, ktre
	s wywietlane przez polecenie INFO serwisu %s.
	Pierwszy argument okrela ukrywan informacj:
	EMAIL - adres e-mail, USERMASK - ostatnio uywany host,
	QUIT - ostatnia wiadomo poegnalna, STATUS - status
	dostpu do serwisw. Drugi argument okrela, czy dana 
	informacja bdzie pokazywana (OFF), czy ukrywana (ON).
NICK_HELP_SET_MSG
	Skadnia: SET MSG {ON | OFF}
	
	Pozwala wybra sposb w jaki serwisy bd pisa do
	Ciebie. Kiedy ta opcja jest wczona serwisy bd
	wysya wiadomoci prywatne (query), w przeciwnym
	wypadku bd wysya powiadomienia (notice).

NICK_HELP_SET_AUTOOP
	Skadnia: SET AUTOOP {ON | OFF}
	
	Wcza lub wycza automatyczne nadawanie uprawnie
	przy wchodzeniu na kana.

NICK_HELP_SASET
	Skadnia: SASET nick opcja parametry.
	
	Ustawia rne opcje nicka wskazanemu uytkownikowi.
	Dostpne opcje to:
	
	    DISPLAY    Ustawia nick reprezentujcy grup nickw
	    PASSWORD   Ustawia haso do nicka
	    LANGUAGE   Ustawia jzyk w ktrym serwisy bd
	               wysyay komunikaty
	    URL        Przypisuje adres www do nicka
	    EMAIL      Przypisuje adres e-mail do nicka
	    ICQ        Przypisuje numer ICQ do nicka
	    GREET      Przypisuje komunikat powitalny do nicka
	    KILL       Wcza lub wycza ochron nicka
	    SECURE     Wcza lub wycza bezpieczestwo nicka
	    PRIVATE    Zapobiega wywietlaniu nicka po wydaniu
	               polecenia: %R%S LIST
	    HIDE       Ukrywa poszczeglne informacje o nicku
	    MSG        Zmienia sposb komunikacji serwisw
	    AUTOOP     Wcza lub wycza automatyczne opowanie
	    NOEXPIRE   Zapobiega wyganiciu nicka
	
	Aby uzyska wicej informacji o danej opcji wpisz:
	%R%S HELP SASET opcja

NICK_HELP_SASET_DISPLAY
	Skadnia: SASET nick DISPLAY nowa-nazwa
	
	Zmienia nazw reprezentujc grup nickw wskazanego
	uytkownika na now. Nazwa MUSI by jednym z nickw
	nalecych do tej grupy.

NICK_HELP_SASET_PASSWORD
	Skadnia: SASET nick PASSWORD nowe-haso
	
	Zmienia haso wskazanemu uytkownikowi.

NICK_HELP_SASET_URL
	Skadnia: SASET nick URL url
	
	Przypisuje podany adres www wskazanemu uytkownikowi.
	Ten adres bdzie si pokazywa w opisie jego nicka
	dostpnym po uyciu polecenia INFO.

NICK_HELP_SASET_EMAIL
	Skadnia: SASET nick EMAIL adres
	
	Przypisuje wskazanemu uytkownikowi adres e-mail.

NICK_HELP_SASET_ICQ
	Skadnia: SASET nick ICQ numer
	
	Przypisuje numer ICQ wskazanemu nickowi, ktry
	bdzie wywietlany przy opisie nicka dostpnym
	przy uyciu komendy INFO.
NICK_HELP_SASET_GREET
	Skadnia: SASET nick GREET wiadomo
	
	Ustawia wiadomo powitaln dla wskazanego uytkownika.
	Jeli kana ma przydzielonego bota, wczone witanie
	oraz uytkownik ma odpowiedni poziom dostpu to
	wtedy ta wiadomo bdzie wysyana na kana przez bota.

NICK_HELP_SASET_KILL
	Skadnia: SASET nick KILL {ON | QUICK | IMMED | OFF}
	
	Wcza lub wycza automatyczn ochron dla nicka.
	Uytkownicy wchodzcy na chroniony nick otrzymuj
	informacje od %S, e nick jest zarejestrowany i
	jeli si nie zidentyfikuj lub go nie zmieni
	w okrelonym czasie to ich nick zostanie zmieniony
	si lub zostan odczeni od sieci.
	
	Opcja QUICK skraca czas oczekiwania na zmian
	z 60 sekund do 20. W przypadku opcji IMMED
	nick zostanie zmieniony natychmiast bez moliwoci
	identyfikacji (wstpna identyfikacja nastpuje
	na podstawie listy dostpu, dlatego t opcj
	naley stosowa z rozwag). Administrator sieci 
	moe wyczy korzystanie z IMMED.
NICK_HELP_SASET_SECURE
	Skadnia: SASET nick SECURE {ON | OFF}
	
	Wcza lub wycza opcj bezpieczestwa dla nicka.
	Wczenie SECURE wymusza na uytkowniku podanie
	hasa zanim ten zostanie rozpoznany jako waciciel
	nicka. %S nie bierze pod uwag w tym wypadku
	wystpowania adresu licie dostpu. Jeli adres 
	znajduje si na licie %S nie skilluje
	uytkownika niezalenie od ustawienia opcji KILL.

NICK_HELP_SASET_PRIVATE
	Skadnia: SASET nick PRIVATE {ON | OFF}

	Wcza lub wycza opcj PRIVATE dla nicka.
	Kiedy ta opcja jest wczona nick nie bdzie
	umieszczany na listach wywietlanych komend:
	%R%S LIST
	Jednak kady, kto zna nick moe uzyska o nim
	informacje uywajc polecenia INFO.

NICK_HELP_SASET_HIDE
	Skadnia: SASET nick HIDE {EMAIL | STATUS | USERMASK | QUIT} {ON | OFF}
	
	To polecenie pozwala na ukrycie czci informacji, ktre
	s wywietlane przez polecenie INFO serwisu %s.
	Pierwszy argument okrela ukrywan informacj:
	EMAIL - adres e-mail, USERMASK - ostatnio uywany host,
	QUIT - ostatnia wiadomo poegnalna, STATUS - status
	dostpu do serwisw. Drugi argument okrela, czy dana 
	informacja bdzie pokazywana (OFF), czy ukrywana (ON).
NICK_HELP_SASET_MSG
	Skadnia: SASET nick MSG {ON | OFF}
	
	Pozwala wybra sposb w jaki serwisy bd pisa do
	wskazanego uytkownika. Kiedy ta opcja jest
	wczona serwisy bd wysya wiadomoci prywatne
	w przeciwnym wypadku bd wysya powiadomienia.

NICK_HELP_SASET_NOEXPIRE
	Skadnia: SASET nick NOEXPIRE {ON | OFF}
	
	Wcza lub wycza automatyczne usunicie nicka,
	jeli nie bdzie on uywany.

NICK_HELP_SASET_AUTOOP
	Skadnia: SASET nick AUTOOP {ON | OFF}
	
	Wcza lub wycza automatyczne nadawanie uprawnie
	wskazanemu uytkownikowi przy wchodzeniu na kana.

NICK_HELP_SASET_LANGUAGE
	Skadnia: SASET nick LANGUAGE numer
	
	Zmienia jzyk jakiego uywaj serwisy komunikujc 
	si ze wskazan osob. Numer musi by wybrany z
	listy obsugiwanych jzykw, ktra jest dostpna
	po wydaniu polecenia %R%S HELP SET LANGUAGE.

NICK_HELP_RECOVER
	Skadnia: RECOVER nick [haso]
	
	Pozwala na odzyskanie nicka jeli jest on uywany przez
	inn osob. Wykonuje te same czynnoci co %S w
	przypadku automatycznej ochrony nicka.
	
	Uycie tej komendy powoduje wprowadzenie sztucznego
	uytkownika przez %S o nicku, ktry chcesz odzyska.
	Spowoduje to odczenie uytkownika, ktry go aktualnie
	uywa. Serwis pozostanie przez minut online, aby
	uniemoliwi natychmiastowe poczenie z serwerem
	na tym samym nicku. Po tym czasie moesz zaj nick.
	Jeli nie chcesz czeka minuty moesz uy polecenia
	RELEASE (%R%S HELP RELEASE).

	Aby uy polecenia RECOVER musi by speniony jeden
	z warunkw:
	1. twj adres znajduje si na licie dostpu,
	2. jeste zidentyfikowany w grupie,
	   do ktrej naley wskazany nick,
	3. podasz prawidowe haso do nicka.

NICK_HELP_RELEASE
	Skadnia: RELEASE nick [haso]
	
	Instruuje %S aby zdj wszelkie blokady naoone
	przez automatyczn ochron nicka lub w wyniku uycia
	polecenia RECOVER. Blokada trwa %s; to polecenie
	pozwala j skrci.
	
	Aby uy polecenia RELEASE musi by speniony jeden
	z warunkw:
	1. twj adres znajduje si na licie dostpu,
	2. jeste zidentyfikowany w grupie,
	   do ktrej naley wskazany nick,
	3. podasz prawidowe haso do nicka.

NICK_HELP_GHOST
	Skadnia: GHOST nick [haso]
	
	Opcja likwiduje sesj-ducha o wskazanym nicku.
	Taka sytuacja najczciej ma miejsce wtedy, gdy
	poczenie z serwem IRC nie zostao zakoczone w
	sposb prawidowy (komputer si zawiesi lub
	wystpia awaria cza internetowego). Serwer IRC
	moe wtedy nie rozpozna zerwania poczenia i
	bdzie czeka okrelon ilo czasu na odpowied 
	od klienta.
	
	Aby uy polecenia GHOST musi by speniony jeden
	z warunkw:
	1. twj adres znajduje si na licie dostpu,
	2. jeste zidentyfikowany w grupie,
	   do ktrej naley wskazany nick,
	3. podasz prawidowe haso do nicka.

NICK_HELP_INFO
	Skadnia: INFO nick [ALL]
	
	Wywietla informacje na temat wybranego nicka:
	waciciel, kiedy ostatnio widziano, z jakiego 
	hosta oraz opcje nicka. Jeli zidentyfikowany 
	uytkownik uyje tej komendy na sobie wraz z
	parametrem ALL otrzyma wszystkie moliwe
	informacje - nawet jeli zostay one ukryte.

NICK_HELP_LIST
	Skadnia: LIST wzorzec
	
	Listuje wszystkie zarejestrowane nicki pasujce do
	podanego wzorca w postaci nick!ident@host. Nicki z
	wczon opcj PRIVATE zostan pominite.
	
	Przykady:
	
	    LIST *!adirm@mafia.ru
	        Lista wszystkich nickw pasujcych do
	        *!adirm@mafia.ru.
	
	    LIST *Bot*!*@*
	        Lista wszystkich nickw z Bot w nazwie
	        (wielko liter nie ma znaczenia).
	
	    LIST *!*@*.ircnet.pl
	        Lista wszystkich nickw z mask domeny
	        ircnet.pl

NICK_HELP_ALIST
	Skadnia: ALIST [poziom]
	
	Listuje wszystkie kanay, gdzie masz wpis na licie
	dostpu. Aby ograniczy list pokazywanych kanaw
	moesz poda poziom XOP lub numer

	Przykady:
	    ALIST Founder
	        Listuje kanay, ktrych jeste wacicielem

	    ALIST AOP
	        Listuje kanay, na ktrych masz poziom
	        AOP lub wyszy.

	    ALIST 10
	        Listuje kanay, na ktrych masz poziom
	        10. lub wyszy.

	Kanay z opcj NOEXPIRE bd oznaczone wykrzyknikiem.
NICK_HELP_GLIST
	Skadnia: GLIST
	
	Listuje wszystkie nicki z Twojej grupy.

NICK_HELP_STATUS
	Skadnia: STATUS nick...
	
	Zwraca status wskazanych uytkownikw (czy s
	rozpoznawani jako waciciele nicka).
	Odpowied ma nastpujcy format:
	
	    nick kod
	
	Gdzie nick jest tym nickiem wysanym w 
	komendzie, a kod moe oznacza:
	
	0 - uytkownik jest offline lub nick niezarejestrowany
	1 - uytkownik nie zidentyfikowa si jako waciciel nicka
	2 - uytkownik rozpoznany na podstawie listy dostpu
	3 - uytkownik rozpoznany na podstawie hasa
	
	Maksymalnie mona poda 16 nickw w jednym poleceniu.
	Reszta bdzie ignorowana. Jeli nie zostanie podany
	aden nick zostanie zwrcony twj status.

NICK_HELP_SENDPASS
	Skadnia: SENDPASS nick
	
	Wysya haso do podanego nicka na adres e-mail
	przypisany do niego. Ta komenda pomaga odzyska
	zapomniane haso.
	
	Ta komenda w niektrych sieciach moe by dostpna
	jedynie dla osb z uprawnieniami IRC operatora.
	
	Ta komenda jest niedostpna kiedy hasa s szyfrowane.

NICK_HELP_CONFIRM
	Skadnia: CONFIRM kod
	
	To polecenie umoliwia zakoczenie procesu rejestracji.
	Aby nick zosta zarejestrowany w serwisie %S naley
	wywoa to polecenie z kodem, ktry zosta wysany na
	adres e-mail podany podczas pierwszego kroku rejestracji.
	Aby si dowiedzie wicej wpisz %R%S HELP REGISTER

NICK_HELP_RESEND
	Skadnia: RESEND
	
	To polecenie powoduje ponowne wysanie kodu autoryzujcego
	na adres e-mail uytkownika, ktry wydaje polecenie.

NICK_SERVADMIN_HELP
	
	Administratorzy serwisw mog usun kady nick
	bez potrzeby identyfikacji jako jego waciciele
	oraz przeglda list dostpu do kadego nicka
	(%R%S ACCESS LIST nick).

NICK_SERVADMIN_HELP_LOGOUT
	Skadnia: LOGOUT [nick [REVALIDATE]]

	Polecenie wydane bez parametrw odwraca dziaanie
	komendy IDENTIFY - nie bdziesz rozpoznawany jako
	waciciel nicka.
	
	Administrator serwisw moe poda jako parametr nick
	uytkownika, ktry ma zosta wylogowany. Parametr
	REVALIDATE powoduje informowanie przez serwisy
	uytkownika o potrzebie ponownej identyfikacji.

NICK_SERVADMIN_HELP_DROP
	Skadnia: DROP [nick]
	
	Komenda wywoana bez parametru spowoduje usunicie
	Twojego nicka z bazy serwisu %S.
	
	Komenda uyta z parametrem usuwa wskazany nick.
	Kady uytkownik moe usuwa nicki znajdujce si
	w jego grupie bez specjalnych uprawnie. Usuwanie
	dowolnego nicka jest ograniczone do administratorw.

NICK_SERVADMIN_HELP_INFO
	
	Administratorzy serwisw mog uywa parametru
	ALL dla kadego nicka.

NICK_SERVADMIN_HELP_LIST
	Skadnia: LIST wzorzec [FORBIDDEN] [SUSPENDED] [NOEXPIRE] [UNCONFIRMED]
	
	Listuje wszystkie zarejestrowane nicki pasujce
	do podanego wzorca w postaci nick!ident@host.
	Administratorzy serwisw mog zobaczy nicki z
	ustawion opcj PRIVATE, a przy nickach z opcj
	NOEXPIRE zobacz dodany do nich wykrzyknik.
	
	Administratorzy serwisw mog take poda parametry:
	FORBIDDEN, SUSPENDED, NOEXPIRE i UNCONFIRMED, ktre
	ogranicz list wywietlanych nickw do tych, ktre
	speniaj podane warunki. Jeli zostanie podanych
	wicej warunkw, wszystkie nicki speniajce cho
	jeden z nich zostan pokazane.
	
	Przykady:
	
	    LIST *!adirm@mafia.ru
	        Lista wszystkich nickw pasujcych do
	        *!adirm@mafia.ru.
	
	    LIST *Bot*!*@*
	        Lista wszystkich nickw z Bot w nazwie
	        (wielko liter nie ma znaczenia).
	
	    LIST *!*@*.ircnet.pl
	        Lista wszystkich nickw z mask domeny
	        ircnet.pl

NICK_SERVADMIN_HELP_ALIST
	Skadnia: ALIST [nick] [poziom]
	
	Listuje wszystkie kanay na ktrych jeste na licie
	dostpu. Opcjonalnie moesz poda nick wraz z poziomem,
	co ograniczy ilo pokazywanych wpisw.
	
	Parametr nick jest przeznaczony tylko dla
	administratorw serwisw.

NICK_SERVADMIN_HELP_GLIST
	Skadnia: GLIST [nick]
	
	Polecenie wywoane bez parametrw listuje wszystkie
	nicki nalece do grupy wydajcego polecenie.
	
	Administratorzy serwisw mog jako parametr poda
	nick osoby, ktrej nicki chc sprawdzi.

NICK_SERVADMIN_HELP_GETPASS
	Skadnia: GETPASS nick
	
	Zwraca haso waciciela dla wskazanego nicka.
	UWAGA: uycie tej komendy powoduje wysanie
	informacji o jej uyciu przy pomocy WALLOP/GLOBOP.
	
	Ta komenda jest niedostpna kiedy hasa s szyfrowane.

NICK_SERVADMIN_HELP_GETEMAIL
	Skadnia: GETEMAIL uzytkownik@serwer.com
	
	Listuje nicki, ktre maj ustawiony podany adres e-mail.
	Uwaga: nie mona uywa symboli wieloznacznych (* lub ?).
	Kady przypadek uycia tej komendy jest logowany.

NICK_SERVADMIN_HELP_FORBID
	Skadnia: FORBID nick [powd]
	
	Uniemoliwia rejestracj i korzystanie ze wskazanego
	nicka. Blokad mona zdj uywajc komendy DROP.
	
	W niektrych sieciach wymagane jest podanie powodu.

NICK_SERVADMIN_HELP_SUSPEND
	Skadnia: SUSPEND nick powd
	
	Zawiesza nick uniemoliwiajc identyfikacj.

NICK_SERVADMIN_HELP_UNSUSPEND
	Skadnia: UNSUSPEND nick
	
	Uwalnia zawieszony nick.

###########################################################################
#
# ChanServ help messages
#
###########################################################################
CHAN_HELP_CMD_GETPASS
	    GETPASS     Podaje haso waciciela wskazanego kanau

CHAN_HELP_CMD_FORBID
	    FORBID      Blokuje podany kana

CHAN_HELP_CMD_SUSPEND
	    SUSPEND     Blokuje podany kana z zachowaniem
	                wszelkich jego danych i ustawie

CHAN_HELP_CMD_UNSUSPEND
	    UNSUSPEND   Uwalnia zawieszony kana

CHAN_HELP_CMD_STATUS
	    STATUS      Zwraca aktualny poziom dostpu do
	                kanau wskazanego uytkownika

CHAN_HELP_CMD_REGISTER
	    REGISTER    Rejestruje kana

CHAN_HELP_CMD_IDENTIFY
	    IDENTIFY    Identyfikuje waciciela kanau

CHAN_HELP_CMD_SET
	    SET         Modyfikuje ustawienia kanau

CHAN_HELP_CMD_AOP
	    AOP         Zarzdza list AOP (operatorw)

CHAN_HELP_CMD_SOP
	    SOP         Zarzdza list SOP (super-operatorw)

CHAN_HELP_CMD_ACCESS
	    ACCESS      Zarzdza list dostpu

CHAN_HELP_CMD_LEVELS
	    LEVELS      Zarzdza poziomami dostpu

CHAN_HELP_CMD_AKICK
	    AKICK       Zarzdza list AKICK

CHAN_HELP_CMD_DROP
	    DROP        Usuwa kana

CHAN_HELP_CMD_SENDPASS
	    SENDPASS    Pomaga odzyska utracone haso

CHAN_HELP_CMD_BAN
	    BAN         Banuje wskazan osob na kanale

CHAN_HELP_CMD_CLEAR
	    CLEAR       Usuwa wskazane obiekty z kanau

CHAN_HELP_CMD_DEVOICE
	    DEVOICE     Odbiera wskazanej osobie prawo gosu

CHAN_HELP_CMD_GETKEY
	    GETKEY      Podaje klucz do wskazanego kanau

CHAN_HELP_CMD_INFO
	    INFO        Pokazuje informacje o zarejestrowanym kanale

CHAN_HELP_CMD_INVITE
	    INVITE      Zaprasza osob wydajc polecenie na kana

CHAN_HELP_CMD_KICK
	    KICK        Wyrzuca wskazany nick z kanau

CHAN_HELP_CMD_LIST
	    LIST        Listuje zarejestrowane kanay pasujce do wzorca

CHAN_HELP_CMD_LOGOUT
	    LOGOUT      Wyloguje wskazan osob

CHAN_HELP_CMD_OP
	    OP          Nadaje wskazanej osobie uprawnienia operatora

CHAN_HELP_CMD_TOPIC
	    TOPIC       Zmienia temat podanego kanau

CHAN_HELP_CMD_UNBAN
	    UNBAN       Usuwa wszystkie bany blokujce wejcie na kana

CHAN_HELP_CMD_VOICE
	    VOICE       Nadaje wskazanej osobie prawo gosu

CHAN_HELP_CMD_VOP
	    VOP         Zarzdza list VOP (osb z prawem gosu)

CHAN_HELP_CMD_DEHALFOP
	    DEHALFOP    Odbiera wskazanej osobie uprawnienia p-operatora

CHAN_HELP_CMD_DEOWNER
	    DEOWNER     Usuwa twj status waciciela kanau

CHAN_HELP_CMD_DEPROTECT
	    DEPROTECT   Wycza ochron wskazanej osoby

CHAN_HELP_CMD_HALFOP
	    HALFOP      Nadaje wskazanej osobie uprawnienia p-operatora

CHAN_HELP_CMD_HOP
	    HOP         Zarzdza list HOP (p-operatorw)

CHAN_HELP_CMD_OWNER
	    OWNER       Nadaje Tobie status waciciela kanau

CHAN_HELP_CMD_PROTECT
	    PROTECT     Chroni wskazan osob

CHAN_HELP_CMD_ADMIN
	    ADMIN       Chroni wskazan osob

CHAN_HELP_CMD_DEADMIN
	    DEADMIN     Wycza ochron wskazanej osoby

CHAN_HELP_CMD_DEOP
	    DEOP        Odbiera wskazanej osobie uprawnienia operatora

CHAN_HELP
	%S umoliwia rejestracj kanau, zmian
	jego ustawie oraz zapobiega przed odebraniem
	kontroli nad kanaem. Ponisze komendy pozwalaj
	na zarzdzanie kanaem, aby ich uy wpisz:
	%R%S komenda
	Aby uzyska szczegowy opis polecenia wpisz:
	%R%S HELP komenda
	

CHAN_HELP_EXPIRES
	
	Uwaga! Kana ktry nie by uywany przez %d dni
	(np. nie odwiedzi go aden uytkownik umieszczony
	na licie dostpu kanau w tym czasie) zostanie
	automatycznie odrejestrowany.

CHAN_HELP_REGISTER
	Skadnia: REGISTER kana haso opis
	
	Rejestruje kana w bazie danych %S. Aby uy
	tej komendy musisz by operatorem na kanale, ktry
	chcesz zarejestrowa. Haso umoliwia pniejsz
	identyfikacj jako waciciel kanau (IDENTIFY).
	Ostatni parametr, ktry musi zosta podany, okrela
	cel istnienia kanau.
	
	Po rejestracji kanau stajesz si jego wacicielem,
	ktry moe zmienia wszystkie jego ustawienia.
	%S automatycznie nadaje uprawnienia operatora
	wacicielowi, ktry wchodzi na kana. Informacje 
	na temat nadawania uprawnie innym uytkownikom
	znajduj si w pomocy polecenia ACCESS
	(%R%S HELP ACCESS).
	
	UWAGA: Aby zarejestrowa kana naley posiada
	zarejestrowany nick, aby uzyska wicej informacji
	na temat zarzdzania nickiem wpisz: %R%s HELP

CHAN_HELP_IDENTIFY
	Skadnia: IDENTIFY kana haso
	
	Autoryzuje uytkownika w serwisie %S jako waciciela
	wskazanego kanau. Wiele wanych komend wymaga dokonania
	identyfikacji przed ich uyciem. Hasem jest to samo
	haso, ktrego uyto przy komendzie REGISTER.

CHAN_HELP_LOGOUT
	Skadnia: LOGOUT kana nick
	
	Pozwala na wylogowanie wskazanego uytkownika z kanau.
	W celu odzyskania uprawnie uytkownik bdzie musia
	ponownie si zidentyfikowa.
	
	Kady moe wylogowa siebie, natomiast waciciel kanau
	moe wylogowa kadego.

CHAN_HELP_DROP
	Skadnia: DROP kana
	
	Usuwa podany kana. Komenda moe zosta uyta
	jedynie przez waciciela kanau, po wczeniejszej
	IDENTIFYKACJI przy pomocy hasa kanau.

CHAN_HELP_SET
	Skadnia: SET kana opcja parametry
	
	Pozwala wacicielowi kanau na zmian ronych  
	opcji oraz informacji dotyczcych kanau.
	
	Dostpne opcje:
	
	    FOUNDER       Ustawia nick waciciela kanau
	    SUCCESSOR     Ustawia nick spadkobiercy kanau
	    PASSWORD      Ustawia haso waciciela
	    DESC          Ustawia opis kanau
	    URL           Przypisuje adres www do kanau
	    EMAIL         Przypisuje adres e-mail do kanau
	    ENTRYMSG      Ustawia wiadomo, ktra bdzie wysyana
	                  do uytkownikw wchodzcych na kana
	    BANTYPE       Ustawia sposb banowania przez serwisy
	    MLOCK         Blokuje zdejmowanie lub zakadanie flag
	    KEEPTOPIC     Zapamituje temat kiedy kana jest pusty
	    OPNOTICE      Wysya powiadomienie kiedy zostaj uyte
	                  komendy OP/DEOP
	    PEACE         Reguluje uycie krytycznych komend
	    PRIVATE       Zapobiega wywietlaniu kanau po wydaniu
	                  polecenia LIST
	    RESTRICTED    Ogranicza dostp do kanau
	    SECURE        Wcza lub wycza bezpieczestwo kanau
	    SECUREOPS     cile kontroluje status operatorw
	    SECUREFOUNDER cile kontroluje status waciciela
	    SIGNKICK      Podpisuje kicki kiedy uyto komendy KICK
	    TOPICLOCK     Ogranicza moliwo zmiany tematu
	    XOP           Wcza system uprawnie xOP
	                  (uycie komend SOP, AOP, HOP, VOP)
	
	Aby uzyska wicej informacji o danej opcji wpisz:
	%R%S HELP SET opcja

CHAN_HELP_SET_FOUNDER
	Skadnia: SET kana FOUNDER nick
	
	Zmienia waciciela kanau.
	Nowy nick musi by zarejestrowany.

CHAN_HELP_SET_SUCCESSOR
	Skadnia: SET kana SUCCESSOR nick
	
	Ustawia spadkobierc kanau. Jeli nick waciciela
	wyganie lub zostanie usunity kana zostaje przekazany
	spadkobiercy, ktry staje si nowym wacicielem.
	Jeeli spadkobierca jest wacicielem zbyt duej
	liczby kanaw (%d) to kana zostanie odrejestrowany.
CHAN_HELP_SET_PASSWORD
	Skadnia: SET kana PASSWORD haso
	
	Zmienia haso waciciela kanau.

CHAN_HELP_SET_DESC
	Skadnia: SET kana DESC opis
	
	Ustawia opis kanau widoczny po wydaniu polecenia LIST oraz INFO.

CHAN_HELP_SET_URL
	Skadnia: SET kana URL [url]
	
	Przypisuje adres strony www do kanau. Adres bdzie
	widoczny po uyciu polecenia INFO. Komenda wywoana
	bez parametru usuwa wczeniej ustawiony adres.

CHAN_HELP_SET_EMAIL
	Skadnia: SET kana EMAIL [adres]
	
	Przypisuje adres e-mail do kanau. Adres bdzie
	widoczny po uyciu polecenia INFO. Komenda wywoana
	bez parametru usuwa wczeniej ustawiony adres.

CHAN_HELP_SET_ENTRYMSG
	Skadnia: SET kana ENTRYMSG [tre]
	
	Ustawia tekst powiadomienia wysyanego poprzez /notice
	do uytkownikw wchodzcych na kana. Komenda wywoana
	bez parametru usuwa wczeniej ustawion wiadomo.

CHAN_HELP_SET_BANTYPE
	Skadnia: SET kana BANTYPE typ
	
	Ustala typ banw zakadanych przez serwisy.
	
	Typ banw oznaczany jest numerami od 0 do 3,
	poszczeglne numery oznaczaj:
	
	0: ban w postaci *!ident@host
	1: ban w postaci *!*ident@host
	2: ban w postaci *!*@host
	3: ban w postaci *!*ident@*.domena

CHAN_HELP_SET_KEEPTOPIC
	Skadnia: SET kana KEEPTOPIC {ON | OFF}
	
	Wcza lub wycza opcj zapamitywania tematu.
	Kiedy ta opcja jest wczona %S ustawi ostatni
	temat za kadym razem, gdy na kana bdzie wchodzi
	pierwsza osoba.

CHAN_HELP_SET_TOPICLOCK
	Skadnia: SET kana TOPICLOCK {ON | OFF}
	
	Wcza lub wycza opcj blokowania tematu kanau.
	
	Jeli ta opcja jest wczona, %S pozwoli na
	zmian tematu tylko poprzez wydanie komendy TOPIC.

CHAN_HELP_SET_MLOCK
	Skadnia: SET kana MLOCK flagi
	
	Ustawia blokad flag kanaowych. %S pozwala na 
	definiowanie, ktre flag kanaowe maj by zawsze 
	wczone, wyczone lub ustawiane dowolnie przez 
	operatorw kanau.
	
	Skadnia polecenia jest identyczna jak w komendzie 
	/MODE, tzn. flagi poprzedzone znakiem+ 
	zostan zaoone na kana, natomiast poprzedzone 
	znakiem - bd zdejmowane z kanau. W odrnieniu 
	od komendy /MODE, kade uycie SET MLOCK, 
	usunie wszystkie wczeniej zdefiniowane mody!
	
	UWAGA: W przypadku ustawiania klucza dostpu do 
	kanau (drugi przykad poniej), powinna rwnie 
	zosta aktywowana opcja RESTRICTED (zobacz 
	HELP SET RESTRICTED), w przeciwnym wypadku, 
	uytkownik wchodzcy na pusty kana, bdzie mg 
	odczyta zaoony klucz!
	
	Przykady:
	
	    SET #kana MLOCK +nt-iklps
	        Wymusza wczenie flag n oraz t, wyczenie flag
	        i, k, l, p, s; flaga m nie jest zmieniana.
	
	    SET #kana MLOCK +knst-ilmp my-key
	        Wymusza wczenie flag k, n, s, oraz t, wyczenie
	        i, l, m, oraz p. Wymusza take ustawienie klucza 
	        na warto "my-key".
	
	    SET #kana MLOCK +
	        Wycza blokowanie flag - mog by zmieniane dowolnie.

CHAN_HELP_SET_PEACE
	Skadnia: SET kana PEACE {ON | OFF}
	
	Wcza lub wycza opcj PEACE dla kanau.
	Wczenie tej opcji uniemoliwia wykopanie,
	banowanie lub odebranie uprawnie uytkownikowi,
	ktry ma poziom uprawnie wyszy lub rwny
	korzystajc z polece serwisu %S.

CHAN_HELP_SET_PRIVATE
	Skadnia: SET kana PRIVATE {ON | OFF}
	
	Wcza lub wycza opcj PRIVATE dla kanau.
	Kiedy ta opcja jest wczona kana nie bdzie
	umieszczany na listach wywietlanych komend:
	%R%S LIST

CHAN_HELP_SET_RESTRICTED
	Skadnia: SET kana RESTRICTED {ON | OFF}
	
	Wcza lub wycza opcj ograniczonego dostpu do kanau.
	Po wczeniu tej opcji tylko osoby znajdujce si na
	licie dostpu bd mogy przebywa na kanale. Pozostali
	uytkownicy bd banowani, a nastpnie usuwani z kanau.

CHAN_HELP_SET_SECURE
	Skadnia: SET kana SECURE {ON | OFF}
	
	Wcza lub wycza opcje bezpieczestwa kanau.
	Po wczeniu tej opcji tylko zarejestrowani
	uytkownicy, ktrzy si zidentyfikowali bd
	otrzymywa od serwisu %S uprawnienia
	wynikajce z wpisw na licie dostpu.

CHAN_HELP_SET_SECUREOPS
	Skadnia: SET kana SECUREOPS {ON | OFF}
	
	Wcza lub wycza opcj SECUREOPS dla kanau.
	Kiedy ta opcja jest wczona uytkownicy bez wpisu
	na licie dostpu kanau (ACCESS LIST) nie bd
	mogli posiada statusu operatora.

CHAN_HELP_SET_SECUREFOUNDER
	Skadnia: SET kana SECUREFOUNDER {ON | OFF}
	
	Wcza lub wycza opcj bezpiecznego waciciela.
	Ustawienie tej opcji powoduje ograniczenie uprawnie
	waciciela do osoby, ktra jest wpisana jako waciciel
	(a nie osb znajcych haso waciciela kanau).
	Operacje takie jak usunicie kanau, zmiana hasa,
	waciciela oraz zastpcy bd dostpne tylko
	dla jednego uytkownika.

CHAN_HELP_SET_SIGNKICK
	Skadnia: SET kana SIGNKICK {ON | LEVEL | OFF}
	
	Wcza lub wycza podpisywanie komend kick.
	Wczenie tej opcji powoduje dodawanie nicka osoby 
	wydajcej polecenie do uzasadnienia kicka.
	
	Jeli poziomy dostpu byy konfigurowane z uyciem LEVEL
	osoby majce poziom wikszy lub rwny SIGNKICK nie bd
	podpisywane. Aby uzyska wicej informacji wpisz:
	%R%S HELP LEVELS

CHAN_HELP_SET_XOP
	Skadnia: SET kana XOP {ON | OFF}
	
	Wcza lub wycza system list xOP dla kanau.
	Kiedy XOP zostanie wczony przyznawanie uprawnie
	odbywa si przy pomocy polece AOP/ SOP/ VOP.
	Wyczenie funkcji xOP wymusza korzystanie z
	polecenia ACCESS.
	
	Uwaga: w momencie wczania systemu list XOP
	wszelkie definicje poziomw dostpu zostan
	trwale zresetowane. Ponowne przejcie z XOP na
	system listy dostpu nie spowoduje odzyskania
	poprzedniej konfiguracji!
	
	Kiedy XOP zostanie wczony uytkownikom
	automatycznie zostaje przypisany odpowiedni poziom
	dostpu. Automatyczne przyporzdkowanie nie zawsze 
	musi by poprawne. Nie zaleca si przejcia na
	system XOP, jeli definicje poziomw dostpu dla 
	kanau zostay wczeniej zmodyfikowane przy pomocy 
	polecenia LEVELS.
	

CHAN_HELP_SET_OPNOTICE
	Skadnia: SET kana OPNOTICE {ON | OFF}
	
	Wcza lub wycza opcj OPNOTICE dla kanau.
	Kiedy ta opcja jest wczona, %S bdzie
	informowa uytkownikw przebywajcych na kanale,
	kiedy zostanie uyta komenda OP lub DEOP.

CHAN_HELP_AOP
	Skadnia: AOP kana ADD nick
	          AOP kana DEL {nick | numer | lista}
	          AOP kana LIST [maska | lista]
	          AOP kana CLEAR
	
	Zarzdza list AOP (AutoOP) dla kanau.
	Uytkownicy wpisani na t list bd otrzymywa
	automatycznie status operatora, maj prawo si
	odbanowa i zaprosi jeli jest taka potrzeba itd.
	
	Komenda AOP ADD dodaje podany nick do listy AOP.
	
	Komenda AOP DEL usuwa wskazane wpisy z listy.
	Jako argument przyjmuje nick, numer wpisu lub
	list (przykad poniej dla polecenia LIST).
	
	Komenda AOP LIST wywietla zawarto listy AOP.
	Parametr maska pozwala filtrowa wywietlane wpisy
	(symbol * zastpuje dowolny cig znakw w nicku).
	Jako parametr mona te poda numery wpisw na licie:
	
	   AOP kana LIST 2-5,7-9
	      Wywietli wpisy na licie od numeru 2 do 5 oraz
	      od 7 do 9.
	
	Komenda AOP CLEAR usuwa wszystkie wpisy z listy.
	
	Komendy AOP ADD oraz AOP DEL s dostpne dla
	uytkownikw z uprawnieniami SOP lub wyszymi.
	Komenda AOP CLEAR jest dostpna dla waciciela
	kanau. Wszyscy uytkownicy wpisani na list AOP
	mog uywa komendy AOP LIST.
	
	Komenda AOP moe by wyczona dla Twojego kanau,
	w takim przypadku naley uywa komendy ACCESS.
	Aby uzyska informacje o komendzie ACCESS wpisz:
	%R%S HELP ACCESS
	Aby dowiedzie si jak wczy tryb xOP wpisz:
	%R%S HELP SET XOP

CHAN_HELP_HOP
	Skadnia: HOP kana ADD nick
	          HOP kana DEL {nick | numer | lista}
	          HOP kana LIST [maska | lista]
	          HOP kana CLEAR
	
	Zarzdza list HOP (HalfOP) dla kanau.
	Uytkownicy wpisani na t list bd otrzymywa
	automatycznie status p-operatora.
	
	Komenda HOP ADD dodaje podany nick do listy HOP.
	
	Komenda HOP DEL usuwa wskazane wpisy z listy.
	Jako argument przyjmuje nick, numer wpisu lub
	list (przykad poniej dla polecenia LIST).
	
	Komenda HOP LIST wywietla zawarto listy HOP.
	Parametr maska pozwala filtrowa wywietlane wpisy
	(symbol * zastpuje dowolny cig znakw w nicku).
	Jako parametr mona te poda numery wpisw na licie:
	
	   HOP kana LIST 2-5,7-9
	      Wywietli wpisy na licie od numeru 2 do 5 oraz
	      od 7 do 9.
	
	Komenda HOP CLEAR usuwa wszystkie wpisy z listy.
	
	Komendy HOP ADD, HOP DEL oraz HOP LIST s dostpne
	dla uytkownikw z uprawnieniami AOP lub wyszymi.
	Komenda HOP CLEAR jest dostpna tylko dla
	waciciela kanau.
	
	Komenda HOP moe by wyczona dla Twojego kanau,
	w takim przypadku naley uywa komendy ACCESS.
	Aby uzyska informacje o komendzie ACCESS wpisz:
	%R%S HELP ACCESS
	Aby dowiedzie si jak wczy tryb xOP wpisz:
	%R%S HELP SET XOP

CHAN_HELP_SOP
	Skadnia: SOP kana ADD nick
	          SOP kana DEL {nick | numer | lista}
	          SOP kana LIST [maska | lista]
	          SOP kana CLEAR
	
	Zarzdza list SOP (SuperOP) dla kanau.
	Uytkownicy wpisani na t list bd otrzymywa
	automatycznie status operatora.
	
	Komenda SOP ADD dodaje podany nick do listy SOP.
	
	Komenda SOP DEL usuwa wskazane wpisy z listy.
	Jako argument przyjmuje nick, numer wpisu lub
	list (przykad poniej dla polecenia LIST).
	
	Komenda SOP LIST wywietla zawarto listy SOP.
	Parametr maska pozwala filtrowa wywietlane wpisy
	(symbol * zastpuje dowolny cig znakw w nicku).
	Jako parametr mona te poda numery wpisw na licie:
	
	   SOP kana LIST 2-5,7-9
	      Wywietli wpisy na licie od numeru 2 do 5 oraz
	      od 7 do 9.
	
	Komenda SOP CLEAR usuwa wszystkie wpisy z listy.
	
	Komendy SOP ADD, SOP DEL oraz SOP CLEAR s
	dostpne tylko dla waciciela kanau.
	Komenda SOP LIST jest dostpna dla
	uytkownikw wpisanych na list AOP.
	
	Komenda SOP moe by wyczona dla Twojego kanau,
	w takim przypadku naley uywa komendy ACCESS.
	Aby uzyska informacje o komendzie ACCESS wpisz:
	%R%S HELP ACCESS
	Aby dowiedzie si jak wczy tryb xOP wpisz:
	%R%S HELP SET XOP

CHAN_HELP_VOP
	Skadnia: VOP kana ADD nick
	          VOP kana DEL {nick | numer | lista}
	          VOP kana LIST [maska | lista]
	          VOP kana CLEAR
	
	Zarzdza list VOP (VOicePeople) dla kanau.
	Uytkownicy wpisani na t list bd otrzymywa
	automatycznie prawo gosu i bd mogli je sobie
	nada jeli bdzie taka potrzeba.
	
	Komenda VOP ADD dodaje podany nick do listy VOP.
	
	Komenda VOP DEL usuwa wskazane wpisy z listy.
	Jako argument przyjmuje nick, numer wpisu lub
	list (przykad poniej dla polecenia LIST).
		
	Komenda VOP LIST wywietla zawarto listy VOP.
	Parametr maska pozwala filtrowa wywietlane wpisy
	(symbol * zastpuje dowolny cig znakw w nicku).
	Jako parametr mona te poda numery wpisw na licie:
	
	   VOP kana LIST 2-5,7-9
	      Wywietli wpisy na licie od numeru 2 do 5 oraz
	      od 7 do 9.
	
	Komenda VOP CLEAR usuwa wszystkie wpisy z listy.
	
	Komendy VOP ADD, VOP DEL oraz VOP LIST s dostpne
	dla uytkownikw z uprawnieniami AOP lub wyszymi.
	Komenda VOP CLEAR jest dostpna tylko dla
	waciciela kanau.
	
	Komenda VOP moe by wyczona dla Twojego kanau,
	w takim przypadku naley uywa komendy ACCESS.
	Aby uzyska informacje o komendzie ACCESS wpisz:
	%R%S HELP ACCESS
	Aby dowiedzie si jak wczy tryb xOP wpisz:
	%R%S HELP SET XOP

CHAN_HELP_ACCESS
	Skadnia: ACCESS kana ADD nick level
	          ACCESS kana DEL {nick | numer | list}
	          ACCESS kana LIST [maska | list]
	          ACCESS kana CLEAR
	
	Polecenie pozwala na zarzdzanie wpisami w kanaowej
	licie dostpu (access list). Ustalony poziom
	dostpu okrela, ktrzy uytkownicy mog peni
	funkcje operatorw kanau, oraz posiada dostp do
	komend %S. Rne poziomy okrelaj inne
	przywileje.
	Napisz msg %R%S HELP ACCESS LEVELS,
	aby uzyska wicej informacji. Kady uytkownik,
	ktry nie zosta wpisany na list dostpu, posiada
	poziom uprawnie rwny 0.
	
	Polecenie ACCESS ADD dodaje podany nick do listy z
	okrelonym poziomem dostpu. Jeli nick jest ju
	wpisany na licie, jego poziom dostpu zostanie
	zmieniony zgodnie z podanym parametrem. Przyznawany
	poziom dostpu nie moe by wyszy ni poziom osoby
	wydajcej komend ADD.
	
	Polecenie ACCESS DEL usuwa wskazane wpisy z listy.
	Jako argument przyjmuje nick, numer wpisu lub
	list (przykad poniej dla polecenia LIST).
	
	Polecenie ACCESS LIST wywietla zawarto listy.
	Parametr maska pozwala zawzi wynik polecenia
	do jedynie tych wpisw, ktrych host pasuje do
	wskazanej w komendzie maski (dozwolone jest uywanie
	znaku * - zastpuje on dowolny cig znakw).
	Jako parametr mona poda take numery wpisw na
	licie, na przykad:
	
	   ACCESS kana LIST 2-5,7-9
	    Wywietli wpisy na licie od numeru 2 do 5, oraz
	    od 7 do 9.
	
	Polecenie ACCESS CLEAR usuwa wszystkie wpisy z listy.

CHAN_HELP_ACCESS_LEVELS
	Poziomy dostpu uytkownikw:
	
	Standardowe poziomy dostpu zostay podane poniej:
	   Founder  Peny dostp do polece %S.
	            Automatyczne nadawanie statusu operatora.
	            UWAGA: tylko jedna osoba moe by
	            wacicielem (Founder) kanau.
	            Nie mona nada tego uprawnienia
	            za pomoc polecenia ACCESS.
	        10  Dostp do polecenia AKICK,
	            Automatyczne nadawanie statusu operatora.
	         5  Automatyczne nadawanie statusu operatora.
	         3  Automatyczne nadawanie prawa gosu.
	         0  Brak specjalnych przywilejw.
	            Inne osoby mog nada status
	            operatora temu uytkownikowi
	            (jeli wyczono opcj secure-ops).
	        <0  Brak moliwoci penienia funkcji
	            operatora.
	
	Standardowe poziomy mog zosta zmienione, moliwe
	jest take definiowanie wasnych poziomw dostpu.
	Aby uzyska wicej informacji wpisz:
	%R%S HELP LEVELS

CHAN_HELP_AKICK
	Skadnia: AKICK kana ADD {nick | maska} [powd]
	          AKICK kana STICK maska
	          AKICK kana UNSTICK maska
	          AKICK kana DEL {nick | maska | numer-wpisu | lista}
	          AKICK kana LIST [maska | numer-wpisu | lista]
	          AKICK kana VIEW [maska | numer-wpisu | lista]
	          AKICK kana ENFORCE
	          AKICK kana CLEAR
	
	Polecenie zarzdza list AutoKick dla kanau. Jeli
	uytkownik znajdujcy si na licie AKICK, wejdzie
	na kana, %S zaoy bana, a nastpnie wykopie
	uytkownika z kanau.
	
	Polecenie AKICK ADD dodaje podany nick lub mask
	hosta do listy AutoKick. Jeli zostanie podany
	powd, bdzie on uywany przy wykopywaniu
	uytkownika dodanego do listy z kanau, jeli nie
	zostanie podany, uywany bdzie domylny:
	You have been banned from channel.
	Dodawanie zarejestrowanego nicka na list powoduje
	wykopywanie wszystkich nickw nalecych do grupy.
	
	Polecenie AKICK STICK umoliwia permanentne
	dodanie podanej maski do banw na kanale. Za kadym
	razem gdy kto zdejmie wskazanego bana z kanau,
	%S automatycznie zaoy go ponownie.
	Parametrem polecenia nie moe by nick a jedynie
	host.
	
	Polecenie AKICK UNSTICK niweluje dziaanie
	polecenia AKICK STICK - umoliwia zdjcie bana z
	kanau.
	
	AKICK DEL usuwa wskazany nick lub mask z listy AKICK.
	Jako argument przyjmuje nick, mask, numer wpisu lub
	list (przykad poniej dla polecenia LIST).
	
	AKICK LIST wywietla zawarto listy AKICK. Jeli
	zostanie podana maska tylko pasujce wpisy zostan
	pokazane.

	AKICK VIEW zwraca wicej szczegw ni AKICK LIST.
	
	Polecenie AKICK ENFORCE powoduje e %S
	usunie z kanau wszystkich uytkownikw, ktrych
	hosty pasuj do wskazanych masek w licie AKICK.
	
	Polecenie AKICK CLEAR usuwa wszystkie wpisy z listy.

CHAN_HELP_LEVELS
	Skadnia: LEVELS kana SET typ poziom
	          LEVELS kana {DIS | DISABLE} typ
	          LEVELS kana LIST
	          LEVELS kana RESET
	
	Polecenie LEVELS umoliwia przypisywanie 
	uprawnie poszczeglnym poziomom dostepu.
	Przy uyciu tej komendy moesz definiowa 
	poziomy dostpu do wszystkich funkcji %S 
	(SET FOUNDER, SET PASSWORD oraz LEVELS
	s dostpne tylko dla waciciela kanau).
	
	LEVELS SET pozwala zmieni przypisany poziom dla 
	okrelonej operacji lub ich grup. LEVELS DISABLE 
	(lub DIS w skrcie) wycza okrelon funkcj lub
	zastrzega dostp do niej dla waciciela kanau.
	LEVELS LIST wywietla aktualnie ustalone poziomy 
	dla kadej z operacji. LEVELS RESET przywraca 
	standardowe ustawienia poziomw dostpu - identyczne 
	z tymi jakie ustawiane s dla kanau po jego 
	utworzeniu (zobacz HELP ACCESS LEVELS).
	
	Aby obejrze spis wszystkich funkcji ktre mog 
	zosta przypisane poziomom dostpu, zobacz
	HELP LEVELS DESC.

CHAN_HELP_LEVELS_DESC
	Poniej znajduje si lista wszystkich dostpnych uprawnie.
	Poziomy dla AUTODEOP oraz NOJOIN to poziomy maksymalne,
	reszta uprawnie ma poziomy minimalne.

CHAN_HELP_LEVELS_DESC_FORMAT
	    %-*s  %s

CHAN_HELP_INFO
	Skadnia: INFO kana [ALL]
	
	Wywietla informacje o zarejestrowanym kanale:
	waciciel, data zaoenia, opis, blokada flag,
	czas ostatniego uycia. Kiedy zostanie podany parametr
	ALL zostan wywietlone take informacje o spadkobiercy
	kanau i wiadomoci powitalnej.
	
	Domylnie parametr ALL jest dostpny dla osb z
	uprawnieniami waciciela kanau.

CHAN_HELP_LIST
	Skadnia: LIST wzorzec
	
	Listuje kanay o nazwie pasujcej do podanego wzorca
	(kanay z opcj PRIVATE nie bd pokazywane).
	Poprzedzenie znakiem '#' powoduje podawanie zakresu,
	nazwy kanaw powinny by pisane bez znaku '#'.

CHAN_HELP_OP
	Skadnia: OP [kana [nick]]
	
	Nadaje status operatora wskazanemu uytkownikowi.
	Jeli nie zostanie podany nick operacja bdzie
	przeprowadzona na osobie wydajcej t komend.
	Jeli take nie zostanie podany kana operacja
	bdzie przeprowadzona na wszystkich kanaach na
	ktrych przebywa osoba wydajca to polecenie z
	uwzgldnieniem posiadanych uprawnie.
	
	Standardowo ta komenda jest dostpna dla uytkownikw
	wpisanych na list AOP lub posiadajcych poziom
	dostpu 5 lub wyszy.

CHAN_HELP_DEOP
	Skadnia: DEOP [kana [nick]]
	
	Odbiera status operatora wskazanemu uytkownikowi.
	Jeli nie zostanie podany nick operacja bdzie
	przeprowadzona na osobie wydajcej t komend.
	Jeli take nie zostanie podany kana operacja
	bdzie przeprowadzona na wszystkich kanaach na
	ktrych przebywa osoba wydajca to polecenie z
	uwzgldnieniem posiadanych uprawnie.
	
	Standardowo ta komenda jest dostpna dla uytkownikw
	wpisanych na list AOP lub posiadajcych poziom
	dostpu 5 lub wyszy.

CHAN_HELP_VOICE
	Skadnia: VOICE [kana [nick]]
	
	Nadaje prawo gosu wskazanemu uytkownikowi.
	Jeli nie zostanie podany nick operacja bdzie
	przeprowadzona na osobie wydajcej t komend.
	Jeli take nie zostanie podany kana operacja
	bdzie przeprowadzona na wszystkich kanaach na
	ktrych przebywa osoba wydajca to polecenie z
	uwzgldnieniem posiadanych uprawnie.
	
	Standardowo ta komenda jest dostpna dla uytkownikw
	wpisanych na list AOP lub posiadajcych przynajmniej
	5. poziom dostpu. Osoby wpisane na list VOP lub
	posiadajce 3. poziom dostpu mog j wykonywa
	jedynie na sobie.

CHAN_HELP_DEVOICE
	Skadnia: DEVOICE [kana [nick]]
	
	Odbiera prawo gosu wskazanemu uytkownikowi.
	Jeli nie zostanie podany nick operacja bdzie
	przeprowadzona na osobie wydajcej t komend.
	Jeli take nie zostanie podany kana operacja
	bdzie przeprowadzona na wszystkich kanaach na
	ktrych przebywa osoba wydajca to polecenie z
	uwzgldnieniem posiadanych uprawnie.
	
	Standardowo ta komenda jest dostpna dla uytkownikw
	wpisanych na list AOP lub posiadajcych przynajmniej
	5. poziom dostpu. Osoby wpisane na list VOP lub
	posiadajce 3. poziom dostpu mog j wykonywa
	jedynie na sobie.

CHAN_HELP_HALFOP
	Skadnia: HALFOP [kana [nick]]
	
	Nadaje status p-operatora wskazanemu uytkownikowi.
	Jeli nie zostanie podany nick operacja bdzie
	przeprowadzona na osobie wydajcej t komend.
	Jeli take nie zostanie podany kana operacja
	bdzie przeprowadzona na wszystkich kanaach na
	ktrych przebywa osoba wydajca to polecenie z
	uwzgldnieniem posiadanych uprawnie.
	
	Standardowo ta komenda jest dostpna dla uytkownikw
	wpisanych na list AOP lub posiadajcych przynajmniej
	5. poziom dostpu. Osoby wpisane na list HOP lub
	posiadajce 4. poziom dostpu mog j wykonywa
	jedynie na sobie.

CHAN_HELP_DEHALFOP
	Skadnia: DEHALFOP [kana [nick]]
	
	Odbiera status p-operatora wskazanemu uytkownikowi.
	Jeli nie zostanie podany nick operacja bdzie
	przeprowadzona na osobie wydajcej t komend.
	Jeli take nie zostanie podany kana operacja
	bdzie przeprowadzona na wszystkich kanaach na
	ktrych przebywa osoba wydajca to polecenie z
	uwzgldnieniem posiadanych uprawnie.
	
	Standardowo ta komenda jest dostpna dla uytkownikw
	wpisanych na list AOP lub posiadajcych przynajmniej
	5. poziom dostpu. Osoby wpisane na list HOP lub
	posiadajce 4. poziom dostpu mog j wykonywa
	jedynie na sobie.

CHAN_HELP_PROTECT
	Skadnia: PROTECT [kana [nick]]
	
	Nadaje ochron wskazanemu uytkownikowi.
	Jeli nie zostanie podany nick operacja bdzie
	przeprowadzona na osobie wydajcej t komend.
	Jeli take nie zostanie podany kana operacja
	bdzie przeprowadzona na wszystkich kanaach na
	ktrych przebywa osoba wydajca to polecenie z
	uwzgldnieniem posiadanych uprawnie.
	
	Standardowo ta komenda jest dostpna dla uytkownikw
	wpisanych na list SOP lub posiadajcych przynajmniej
	10. poziom dostpu.

CHAN_HELP_DEPROTECT
	Skadnia: DEPROTECT [kana [nick]]
	
	Usuwa ochron wskazanemu uytkownikowi.
	Jeli nie zostanie podany nick operacja bdzie
	przeprowadzona na osobie wydajcej t komend.
	Jeli take nie zostanie podany kana operacja
	bdzie przeprowadzona na wszystkich kanaach na
	ktrych przebywa osoba wydajca to polecenie z
	uwzgldnieniem posiadanych uprawnie.
	
	Standardowo ta komenda jest dostpna dla uytkownikw
	wpisanych na list SOP lub posiadajcych przynajmniej
	10. poziom dostpu.

CHAN_HELP_OWNER
	Skadnia: OWNER [kana]
	
	Nadaje uprawnienia waciciela kanau.
	Jeli nie zostanie podany kana operacja bdzie
	przeprowadzona na wszystkich kanaach na ktrych
	przebywa osoba wydajca to polecenie z
	uwzgldnieniem posiadanych uprawnie.
	
	Standardowo ta komenda jest dostpna tylko dla waciciela kanau.

CHAN_HELP_DEOWNER
	Skadnia: DEOWNER [kana]
	
	Odbiera uprawnienia waciciela kanau.
	Jeli nie zostanie podany kana operacja bdzie
	przeprowadzona na wszystkich kanaach na ktrych
	przebywa osoba wydajca to polecenie z
	uwzgldnieniem posiadanych uprawnie.
	
	Standardowo ta komenda jest dostpna tylko dla waciciela kanau.

CHAN_HELP_INVITE
	Skadnia: INVITE kana
	
	%S wysya uytkownikowi zaproszenie do kanau.
	
	Standardowo ta komenda jest dostpna dla uytkownikw
	wpisanych na list AOP lub posiadajcych poziom
	dostpu 5 lub wyszy.

CHAN_HELP_UNBAN
	Skadnia: UNBAN kana
	
	Sprawia, e %S zdejmie wszystkie bany, ktre
	uniemoliwiaj wydajcemu komend wejcie na
	wskazany kana.
	
	Standardowo ta komenda jest dostpna dla uytkownikw
	wpisanych na list AOP lub posiadajcych poziom
	dostpu 5 lub wyszy.

CHAN_HELP_KICK
	Skadnia: KICK [kana [nick [powd]]]
	
	Wykopuje wskazanego uytkownika z kanau.
	Pominicie nicka powoduje wyrzucenie osoby
	wydajcej polecenie. Dodatkowo pominicie
	nazwy kanau powoduje wyrzucenie wydajcego
	polecenie ze wszystkich kanaw, na ktrych
	przebywa z uwzgldnieniem uprawnie na nich
	przysugujcych.
	
	Standardowo ta komenda jest dostpna dla uytkownikw
	wpisanych na list AOP lub posiadajcych poziom
	dostpu 5 lub wyszy.

CHAN_HELP_BAN
	Skadnia: BAN [kana [nick [powd]]]
	
	Banuje wskazanego uytkownika na kanale.
	Pominicie nicka powoduje zbanowanie osoby
	wydajcej polecenie. Dodatkowo pominicie
	nazwy kanau powoduje zbanowanie wydajcego
	polecenie na wszystkich kanaach, na ktrych
	przebywa z uwzgldnieniem uprawnie na nich
	przysugujcych.

	Standardowo ta komenda jest dostpna dla uytkownikw
	wpisanych na list AOP lub posiadajcych poziom
	dostpu 5 lub wyszy.

CHAN_HELP_TOPIC
	Skadnia: TOPIC kana [temat]
	
	Wymusza na serwisie %S zmian tematu na kanale.
	Pominicie tematu powoduje usunicie istniejcego.
	Ta komenda jest uyteczna w poczeniu z ustawieniem
	TOPICLOCK. Aby uzyska wicej informacji wpisz
	%R%S HELP SET TOPICLOCK
	
	Standardowo ta komenda jest dostpna dla waciciela kanau.

CHAN_HELP_CLEAR
	Skadnia: CLEAR kana opcje
	
	Umoliwia kompleksowe usunicie niektrych ustawie na
	kanale poprzez %S. Dostpne opcje:
	
	   MODES     Usuwa tryby z kanau
	   BANS      Usuwa bany z kanau
	   EXCEPTS   Usuwa wyjtki od banw z kanau
	   INVITES   Usuwa zaproszenia z kanau
	   OPS       Odbiera wszystkim status operatora
	   HOPS      Odbiera wszystkim status p-operatora
	   VOICES    Odbiera wszystkim prawo gosu
	   USERS     Usuwa uytkownikw z kanau
	
	Standardowo ta komenda jest dostpna dla waciciela kanau.
	
CHAN_HELP_GETKEY
	Skadnia: GETKEY kana
	
	Zwraca haso wstpu do wskazanego kanau.
	Komenda jest gwnie przeznaczona dla botw,
	dlatego wynik ma format:
	
	KEY <kana> <klucz>
	
	Jeli kana nie ma klucza zostanie zwrcona
	warto "NO KEY".

CHAN_HELP_SENDPASS
	Skadnia: SENDPASS kana
	
	Wysya haso do podanego kanau na adres e-mail
	przypisany do nicka waciciela kanau. Ta komenda
	pomaga odzyska zapomniane haso.
	
	Ta komenda w niektrych sieciach moe by dostpna
	jedynie dla osb z uprawnieniami IRC operatora.
	
	Ta komenda jest niedostpna kiedy hasa s szyfrowane.

CHAN_SERVADMIN_HELP
	
	Administratorzy serwisw mog usun kady kana
	bez potrzeby identyfikacji jako jego waciciele.
	Mog przeglda list dostpu kadego kanau,
	list AKICK, ustawienia poziomw dostpu itd.

CHAN_SERVADMIN_HELP_LOGOUT
	Skadnia: LOGOUT kana nick
	
	Pozwala na wylogowanie wskazanego uytkownika z kanau.
	W celu odzyskania uprawnie uytkownik bdzie musia
	ponownie si zidentyfikowa.
	
	Kady moe wylogowa siebie, natomiast waciciel kanau
	moe wylogowa kadego.
	
	Administrator serwisw moe wylogowa dowoln osob
	z dowolnego kanau. Pominicie nicka powoduje wylogowanie
	wszystkich zidentyfikowanych osb.

CHAN_SERVADMIN_HELP_DROP
	Skadnia: DROP kana
	
	Usuwa wskazany kana. Tylko administratorzy serwisw
	mog usun kana, ktrego nie s wacicielami.

CHAN_SERVADMIN_HELP_SET
	
	Administratorzy serwisw mog ustawi kanaowi 
	opcj NOEXPIRE, ktra zapobiega wyganiciu
	kanau jeli nie jest on uywany.

CHAN_SERVADMIN_HELP_SET_NOEXPIRE
	Skadnia: SET kana NOEXPIRE {ON | OFF}
	
	Wcza lub wycza automatyczne usunicie kanau,
	jeli nie bdzie on uywany.

CHAN_SERVADMIN_HELP_INFO
	
	Administratorzy serwisw zawsze mog uywa parametru ALL.

CHAN_SERVADMIN_HELP_LIST
	Skadnia: LIST wzorzec [FORBIDDEN] [SUSPENDED] [NOEXPIRE]

	Listuje kanay o nazwie pasujcej do podanego wzorca
	(kanay z opcj PRIVATE bd pokazywane jedynie
	administratorom serwisw). Kanay z ustawion opcj
	NOEXPIRE bd miay przy nazwie dodany znak !.

	Administratorzy serwisw mog take poda parametry:
	FORBIDDEN, SUSPENDED i NOEXPIRE, ktre ogranicz list
	wywietlanych kanaw do tych, ktre speniaj podane 
	warunki. Jeli zostanie podane wicej warunkw
	wszystkie kanay speniajce cho jeden z nich 
	zostan pokazane.

CHAN_SERVADMIN_HELP_GETPASS
	Skadnia: GETPASS kana
	
	Zwraca haso waciciela dla wskazanego kanau. 
	UWAGA: uycie tej komendy powoduje wysanie
	informacji o jej uyciu przy pomocy WALLOP/GLOBOP.

CHAN_SERVADMIN_HELP_FORBID
	Skadnia: FORBID kana [powd]
	
	Uniemoliwia rejestracj i korzystanie ze wskazanego
	kanau. Blokad mona zdj uywajc komendy DROP.
	
	W niektrych sieciach wymagane jest podanie powodu.

CHAN_SERVADMIN_HELP_SUSPEND
	Skadnia: SUSPEND kana [powd]
	
	Zawiesza dziaanie wskazanego kanau.
	Blokada moe zosta zdjta z zachowaniem
	wszelkich ustawie komend UNSUSPEND.
	
	W niektrych sieciach wymagane jest podanie powodu.

CHAN_SERVADMIN_HELP_UNSUSPEND
	Skadnia: UNSUSPEND kana
	
	Uwalnia zawieszony kana. Wszystkie dane i ustawienia
	s odtworzone sprzed zawieszenia.

CHAN_SERVADMIN_HELP_STATUS
	Skadnia: STATUS kana nick
	
	Wywietla aktualny poziom dostpu (access level) 
	wskazanego nicka na kanale. Format odpowiedzi jest 
	nastpujcy:
	
	    STATUS kana nick poziom-dostpu
	
	W przypadku wystpienia bdu, format odpowiedzi 
	bdzie nastpujcy:
	
	    STATUS ERROR informacja-o-bdzie

###########################################################################
#
# MemoServ help messages
#
###########################################################################
MEMO_HELP_CMD_SEND
	    SEND        Wysya wiadomo do uytkownika/kanau

MEMO_HELP_CMD_CANCEL
	    CANCEL      Wycofuje ostatni wysan wiadomo

MEMO_HELP_CMD_LIST
	    LIST        Wywietla wszystkie wiadomoci

MEMO_HELP_CMD_READ
	    READ        Wywietla jedn lub wicej wiadomoci

MEMO_HELP_CMD_DEL
	    DEL         Kasuje jedn lub wicej wiadomoci

MEMO_HELP_CMD_SET
	    SET         Ustawia opcje zwizane z wiadomociami

MEMO_HELP_CMD_INFO
	    INFO        Wywietla informacje o wiadomociach

MEMO_HELP_CMD_RSEND
	    RSEND       Wysya wiadomo z daniem potwierdzenia odbioru

MEMO_HELP_CMD_CHECK
	    CHECK       Sprawdza czy ostatnia wiadomo zostaa przeczytana

MEMO_HELP_CMD_SENDALL
	    SENDALL     Wysya wiadomo do wszystkich
	                zarejestrowanych uytkownikw

MEMO_HELP_CMD_STAFF
	    STAFF       Wysya wiadomo do wszystkich
	                operatorw/administratorw

MEMO_HELP_HEADER
	%S umoliwia wysyanie krtkich wiadomoci
	do innych uytkownikw (niezalenie od tego czy
	s oni w danej chwili na IRCu) lub do kanaw(*).
	Aby mc uywa tego serwisu nadawca i odbiorca
	(kana lub nick) musz by zarejestrowani.
	Ponisze komendy pozwalaj na wysyanie i
	odbieranie wiadomoci, aby ich uy wpisz:
	%R%S komenda
	Aby uzyska szczegowy opis polecenia wpisz:
	%R%S HELP komenda

MEMO_HELP_ADMIN
	nie jest uywane.

MEMO_HELP_OPER
	nie jest uywane.

MEMO_HELP_FOOTER
	
	Napisz %R%S HELP polecenie aby uzyska pomoc
	na temat powyszych polece.

	(*) Domylnie kady uytkownik majcy przynajmniej 10.
	    poziom dostpu na kanale moe czyta wiadomoci,
	    ale mona to zmieni komend LEVELS serwisu %s.

MEMO_HELP_SEND
	Skadnia: SEND {nick | kana} tre-wiadomoci
	
	Wysya wiadomo wskazanej osobie lub na podany kana.
	Po wysaniu odbiorca otrzyma powiadomienie o nowej
	wiadomoci (o ile ma wczone powiadomienia).
	Adresatem musi by zarejestrowany nick lub kana.

MEMO_HELP_CANCEL
	Skadnia: CANCEL {nick | kana}
	
	Wycofuje ostatni wysan wiadomo,
	o ile nie zostaa przeczytana.

MEMO_HELP_LIST
	Skadnia: LIST [kana] [lista | NEW]
	
	Wywietla wszystkie odebrane wiadomoci. Parametr 
	NEW ogranicza list do nowych wiadomoci, ktre
	oznaczane s symbolem "*" po lewej stronie numeru.
	Mona take sprecyzowa list wywietlanych 
	wiadomoci podajc ich numery, np:

	   LIST 2-5,7-9
	      Wywietli wiadomoci od numeru 2 do 5 oraz od 7 do 9.

MEMO_HELP_READ
	Skadnia: READ [kana] {numer | lista | LAST | NEW}
	
	Wywietla tekst wskazanej wiadomoci. Parametr LAST
	oznacza ostatni z wiadomoci, NEW wywietla wszystkie
	nieprzeczytane wiadomoci. Jeli zostanie podany numer
	zostanie wywietlona wiadomo o podanym numerze. Mona
	take podawa list wiadomoci np.:
	
	   READ 2-5,7-9
	      Wywietli wiadomoci od numeru 2 do 5 oraz od 7 do 9.

MEMO_HELP_DEL
	Skadnia: DEL [kana] {numer | lista | LAST | ALL}
	
	Kasuje jedn lub wicej wiadomoci. Dopuszczalne 
	jest podanie numeru wiadomoci lub listy wiadomoci, 
	przykad poniej.
	
	Parametr LAST oznacza skasowanie ostatniej wiadomoci.
	Parametr ALL oznacza skasowanie wszystkich wiadomoci.
	
	Przykady:
	
	   DEL 1
	      Usuwa pierwsz wiadomo.
	
	   DEL 2-5,7-9
	      Kasuje wiadomoci od numeru 2 do 5 oraz od 7 do 9.

MEMO_HELP_SET
	Skadnia: SET opcja parametry
	
	Ustawia rne opcje wiadomoci. Dostpne opcje:
	
	    NOTIFY      Ustawia kiedy otrzymasz informacj
	                o nowej wiadomoci
	    LIMIT       Ustawia maksymaln liczb wiadomoci
	                jakie moesz odebra
	
	Aby uzyska wicej informacji o danej opcji wpisz:
	%R%S HELP SET opcja

MEMO_HELP_SET_NOTIFY
	Skadnia: SET NOTIFY {ON | LOGON | NEW | MAIL | NOMAIL | OFF}
	
	Ustala sposb wysania powiadomie o nowych wiadomociach:
	
	   ON      Powiadomienie zostanie wysane po 
	           zalogowaniu si, kiedy nie bdzie 
	           ustawiony tryb /AWAY oraz w momencie
	           otrzymania wiadomoci.
	   LOGON   Powiadomienie zostanie wysane jedynie 
	           po zalogowaniu si lub po wyczeniu 
	           trybu /AWAY.
	   NEW     Powiadomienie bdzie wysyane jedynie w 
	           momencie otrzymania wiadomoci.
	   MAIL    Powiadomienia bd wysyane e-mailem oraz
	           wedle pozostaych ustawie.
	   NOMAIL  Powiadomienia nie bd wysyane e-mailem.
	   OFF     Powiadomienia nie bd wysyane.
	
	Opcja ON jest kombinacj opcji LOGON oraz NEW.

MEMO_HELP_SET_LIMIT
	Skadnia: SET LIMIT [kana] limit
	
	Ustala Twoj (lub kanau) maksymaln liczb 
	wiadomoci. Jeli ustalona zostanie ona na 0, 
	przyjmowanie wiadomoci zostanie wyczone. Limit 
	nie moe by wikszy ni %d.

MEMO_HELP_INFO
	Skadnia: INFO [kana]
	
	Wywietla ilo wiadomoci, ile z nich jest 
	nieprzeczytanych oraz limit przyjmowania 
	wiadomoci. Jeli podany zostanie kana wywietlone 
	informacje bd odnosiy si do wskazanego kanau.

MEMO_SERVADMIN_HELP_SET_LIMIT
	Skadnia: SET LIMIT [nick | kana] {limit | NONE} [HARD]
	
	Ustala maksymaln ilo wiadomoci jak moe 
	posiada uytkownik lub kana. Ustalenie limitu 
	na 0, wyczy przyjmowanie wiadomoci. Parametr 
	NONE pozwoli na nielimitowan ilo wiadomoci. 
	Jeli nie podany zostanie nick lub kana zmieniony 
	zostanie limit wydajcego polecenie.
	
	Dodanie parametru HARD uniemoliwia zmian 
	limitu przez uytkownika.

	To uycie polecenia SET LIMIT jest dostpne dla 
	administratorw serwisw. Pozostali uytkownicy 
	mog jedynie modyfikowa wasny limit lub kanau na
	ktrym maj do tego uprawnienia. Nie mog wyczy 
	limitu, a take ustali jego wartoci powyej %d 
	oraz uy parametru HARD.



MEMO_SERVADMIN_HELP_INFO
	Skadnia: INFO [nick | kana]
	
	Polecenie wydane bez parametru wywietla informacje o
	liczbie odebranych wiadomoci, liczbie nowych wiadomoci
	oraz limicie wiadomoci.
	
	Jeli zostanie wskazany kana, pokazane zostan te 
	same informacje w odniesieniu do tego kanau.
	
	Administratorzy serwisw mog obejrze informacje 
	dot. dowolnych uytkownikw podajc parametr nick.
	

MEMO_HELP_STAFF
	Skadnia: STAFF tre-wiadomoci
	
	Wysya wiadomo o podanej treci do wszystkich
	operatorw i administratorw serwisw. Uytkownicy
	wpisani jednoczenie na kilka list otrzymaj
	wiadomoci kilka razy.

MEMO_HELP_SENDALL
	Skadnia: SENDALL tre-wiadomoci
	
	Wysya wiadomo do wszystkich zarejestrowanych uytkownikw.

MEMO_HELP_RSEND
	Skadnia: RSEND {nick | kana} tre-wiadomoci
	
	Wysya wiadomo wskazanej osobie lub na podany kana.
	Po wysaniu odbiorca otrzyma powiadomienie o nowej
	wiadomoci (o ile ma wczone powiadomienia).
	Adresatem musi by zarejestrowany nick lub kana.
	Kiedy wiadomo zostanie przeczytana przez odbiorc
	automatyczne potwierdzenie odbioru zostanie wysane
	do nadawcy.
MEMO_HELP_CHECK
	Skadnia: CHECK nick
	
	Sprawdza, czy ostatnia wiadomo wysana do nick
	zostaa przeczytana. Ta komenda nie dziaa dla kanaw.

###########################################################################
#
# OperServ help messages
#
###########################################################################
OPER_HELP_CMD_GLOBAL
	    GLOBAL      Wysya wiadomo do wszystkich uytkownikw

OPER_HELP_CMD_STATS
	    STATS       Pokazuje informacje o serwisach i sieci

OPER_HELP_CMD_OPER
	    OPER        Zarzdza list operatorw serwisw

OPER_HELP_CMD_ADMIN
	    ADMIN       Zarzdza list administratorw serwisw

OPER_HELP_CMD_STAFF
	    STAFF       Wywietla ekip serwisw oraz jej status

OPER_HELP_CMD_MODE
	    MODE        Zmienia flagi kanau

OPER_HELP_CMD_KICK
	    KICK        Wyrzuca uytkownika z kanau

OPER_HELP_CMD_CLEARMODES
	    CLEARMODES  Usuwa wszystkie flagi z kanau

OPER_HELP_CMD_KILLCLONES
	    KILLCLONES  Odcza wszystkich uytkownikw o danym hocie

OPER_HELP_CMD_AKILL
	    AKILL       Zarzdza list AKILL

OPER_HELP_CMD_SGLINE
	    SGLINE      Zarzdza list SGLINE

OPER_HELP_CMD_SQLINE
	    SQLINE      Zarzdza list SQLINE

OPER_HELP_CMD_SZLINE
	    SZLINE      Zarzdza list SZLINE

OPER_HELP_CMD_CHANLIST
	    CHANLIST    Listuje wszystkie kanay

OPER_HELP_CMD_USERLIST
	    USERLIST    Listuje wszystkich uytkownikw

OPER_HELP_CMD_LOGONNEWS
	    LOGONNEWS   Zarzdza wiadomociami powitalnymi

OPER_HELP_CMD_RANDOMNEWS
	    RANDOMNEWS  Zarzdza losowymi wiadomociami

OPER_HELP_CMD_OPERNEWS
	    OPERNEWS    Zarzdza wiadomociami dla operatorw

OPER_HELP_CMD_SESSION
	    SESSION     Wywietla list sesji

OPER_HELP_CMD_EXCEPTION
	    EXCEPTION   Zarzdza list wyjtkw dla limitw sesji

OPER_HELP_CMD_NOOP
	    NOOP        Tymczasowo usuwa wszystkie O:linie na serwerze

OPER_HELP_CMD_JUPE
	    JUPE        Blokuje podczanie podanego serwera

OPER_HELP_CMD_IGNORE
	    IGNORE      Zarzdza list ignorowanych przez serwisy

OPER_HELP_CMD_SET
	    SET         Ustawia rne globalne opcje serwisw

OPER_HELP_CMD_RELOAD
	    RELOAD      aduje na nowo plik konfiguracyjny

OPER_HELP_CMD_UPDATE
	    UPDATE      Wymusza natychmiastowy zapis baz na dysku

OPER_HELP_CMD_RESTART
	    RESTART     Zapisuje bazy i restartuje serwisy

OPER_HELP_CMD_QUIT
	    QUIT        Wycza serwisy bez zapisywania baz

OPER_HELP_CMD_SHUTDOWN
	    SHUTDOWN    Wycza serwisy z zapisaniem baz

OPER_HELP_CMD_DEFCON
	    DEFCON      Modyfikuje poziom systemu DefCon

OPER_HELP_CMD_CHANKILL
	    CHANKILL    AKILL wszystkich uytkownikw na kanale

OPER_HELP_CMD_OLINE
	    OLINE       Daje flagi operatora wybranemu uytkownikowi

OPER_HELP_CMD_UMODE
	    UMODE       Modyfikuje flagi wskazanego uytkownika

OPER_HELP_CMD_SVSNICK
	    SVSNICK     Wymusza zmian nicka danego uytkownika

OPER_HELP_CMD_MODLOAD
	    MODLOAD     aduje modu

OPER_HELP_CMD_MODUNLOAD
	    MODUNLOAD   Wyadowuje modu

OPER_HELP_CMD_MODINFO
	    MODINFO     Wywietla informacja o podanym module

OPER_HELP_CMD_MODLIST
	    MODLIST     Listuje zaadowane moduy

OPER_HELP
	Komendy %S:

OPER_HELP_LOGGED
	Uwaga: Wszystkie komendy odbierane przez %S s logowane!

OPER_HELP_GLOBAL
	Skadnia: GLOBAL wiadomo
	
	Pozwala administratorom wysya wiadomoci do wszystkich
	uytkownikw. Wiadomo zostanie wysana z nicka %s.

OPER_HELP_STATS
	Skadnia: STATS [AKILL | ALL | RESET | MEMORY | UPLINK]
	
	Polecenie bez parametrw wywietla biec liczb 
	uytkownikw oraz operatorw podczonych do sieci (nie
	liczc serwisw), najwiksz liczb uytkownikw liczc od 
	startu serwisw oraz czas pracy serwisw.
	
	Parametr AKILL wywietla informacje o rozmiarze listy
	AKILL oraz domylnym czasie wygasania wpisw.
	
	Parametr RESET resetuje maksymaln liczb uytkownikw
	podczonych do sieci.
	
	Parametr MEMORY wywietla informacje o zuyciu pamici
	przez serwisw. Uycie tego polecenia moe chwilowo
	zawiesi dziaanie serwisw na duych sieciach.
	
	Parametr UPLINK wywietla informacje o serwerze, do 
	ktrego serwisy s bezporednio podczone.
	
	Parametr ALL wywietla wszystkie dostpne informacje.
	
	UPTIME moe by uywane jako synonim STATS.

OPER_HELP_OPER
	Skadnia: OPER ADD nick
	          OPER DEL {nick | numer-wpisu | lista}
	          OPER LIST [maska | lista]
	          OPER CLEAR
	
	Pozwala gwnym administratorom serwisw na zarzdzanie
	list operatorw serwisw. Osoby na takiej licie po 
	identyfikacji u %s bd mogy korzysta z polece
	zarezerwowanych dla operatorw serwisw.
	
	OPER ADD dodaje wskazany nick na list operatorw.
	
	OPER DEL usuwa wskazane wpisy z listy operatorw.
	Jako argument przyjmuje nick, numer wpisu lub
	list (przykad poniej dla polecenia LIST).
	
	OPER LIST wywietla list operatorw serwisw. Jeli
	zostanie podana maska tylko pasujce wpisy zostan
	pokazane. Mona take uy listy, przykad:

	   OPER LIST 2-5,7-9
	      Listuje operatorw od 2 do 5 oraz od 7 do 9.
	
	OPER CLEAR usuwa wszystkie wpisy z listy operatorw.
	
	Kady IRC operator moe uy polecenia OPER LIST.

OPER_HELP_ADMIN
	Skadnia: ADMIN ADD nick
	          ADMIN DEL {nick | numer-wpisu | lista}
	          ADMIN LIST [maska | lista]
	          ADMIN CLEAR
	
	Pozwala gwnym administratorom serwisw na zarzdzanie
	list administratorw serwisw. Osoby na takiej licie po 
	identyfikacji u %s bd mogy korzysta z polece
	zarezerwowanych dla administratorw serwisw.
	
	ADMIN ADD dodaje wskazany nick na list administratorw.
	
	ADMIN DEL usuwa wskazane wpisy z listy administratorw.
	Jako argument przyjmuje nick, numer wpisu lub
	list (przykad poniej dla polecenia LIST).

	ADMIN LIST wywietla list administratorw serwisw. Jeli
	zostanie podana maska tylko pasujce wpisy zostan
	pokazane. Mona take uy listy, przykad:

	   ADMIN LIST 2-5,7-9
	      Listuje administratorw od 2 do 5 oraz od 7 do 9.

	ADMIN CLEAR usuwa wszystkie wpisy z listy administratorw.
	
	Kady IRC operator moe uy polecenia ADMIN LIST.

OPER_HELP_IGNORE
	Skadnia: IGNORE {ADD|DEL|LIST|CLEAR} [czas] [nick | maska]
	
	Pozwala administratorom serwisw na wczenie ignorowania
	osb na podstawie nicka lub maski przez okrelony czas lub
	do najbliszego restartu. Podajc czas mona stosowa
	jednostki: s dla sekund, m dla minut, h dla godzin
	oraz d dla dni. Kombinacja tych jednostek nie jest moliwa.
	Stae ignorowanie uzyskuje sipodajc warto 0.
	Jeli maska nie bdzie w formacie user@host oraz 
	nick!user@host to zostanie potraktowana jako nick.
	Podajc mask mona korzysta z symboli wieloznacznych.

	IRC operatorzy nie bd ignorowani.
	
OPER_HELP_MODE
	Skadnia: MODE kana flagi
	
	Pozwala operatorom serwisw na zmian flag dla wskazanego
	kanau. Parametry s identyczne jak dla komendy /MODE.

OPER_HELP_UMODE
	Skadnia: UMODE uytkownik flagi
	
	Pozwala super-administratorom zmienia flagi
	innym uytkownikom. Parametry s identyczne jak
	dla komendy /MODE.

OPER_HELP_OLINE
	Skadnia: OLINE nick flagi
	
	Pozwala super-administratorom na nadanie wskazanemu
	uytkownikowi uprawnie irc operatora z okrelonymi
	flagami. Flagi powinny by poprzedzone znakami "+" lub "-". 
	Aby usun wszystkie flagi wystarczy poda "-".

OPER_HELP_CLEARMODES
	Skadnia: CLEARMODES kana [ALL]
	
	Usuwa wszystkie binarne flagi (i,k,l,m,n,p,s,t) oraz bany
	ustawione na wskazanym kanale. Dodanie parametru ALL
	odbiera take uprawnienia (+o, +v).

OPER_HELP_KICK
	Skadnia: KICK kana nick powd
	
	Pozwala administratorom wyrzuci uytkownika z
	dowolnego kanau. Parametry s identyczne jak
	dla komendy /KICK. Do powodu zostaje doczony
	nick operatora, ktry wydaje polecenie.
	
	*** SpamMan has been kicked off channel #my_channel by %S (Alcan (Flood))

OPER_HELP_SVSNICK
	Skadnia: SVSNICK nick nowy-nick
	
	Zmienia nick wskazanemu uytkownikowi.

OPER_HELP_AKILL
	Skadnia: AKILL ADD [+czas-trwania] maska powd
	          AKILL DEL {maska | numer-wpisu | lista}
	          AKILL LIST [maska | lista]
	          AKILL VIEW [maska | lista]
	          AKILL CLEAR
	
	Pozwala operatorom serwisw na zarzdzanie list AKILL.
	Jeli uytkownik pasujcy do maski na licie podczy si
	do sieci serwisy natychmiast go rozcz oraz zao K-line
	na jego host.
	
	AKILL ADD dodaje mask (w formacie user@host lub ip)
	oraz powd (ktry musi zosta podany) na list AKILL.
	Podajc czas mona stosowa jednostki: s dla sekund,
	m dla minut, h dla godzin oraz d dla dni.
	Kombinacja tych jednostek nie jest moliwa. Domyln
	jednostk s dni (+30 oznacza 30 dni). Podanie +0
	oznacza, e wpis nie wyganie. Jeli maska zaczyna si
	znakiem + to podanie czasu jest obowizkowe (nawet jeli
	jest identyczny z domylnym). Domylny czas wygasania
	mona sprawdzi przy pomocy polecenia STATS AKILL.
	
	AKILL DEL usuwa wskazane wpisy z listy AKILL.
	Jako argument przyjmuje nick, numer wpisu lub
	list (przykad poniej dla polecenia LIST).

	AKILL LIST wywietla zawarto listy AKILL. Jeli
	zostanie podana maska tylko pasujce wpisy zostan
	pokazane. Mona take uy listy, przykad:

	   AKILL LIST 2-5,7-9
	      Listuje wpisy od 2 do 5 oraz od 7 do 9.
	
	AKILL VIEW zwraca wicej szczegw ni AKILL LIST.
	Wywietla informacje o dodajcym AKILL, dat dodania,
	dat wyganicia, mask oraz powd.
	
	AKILL CLEAR usuwa wszystkie wpisy z listy AKILL.
	

OPER_HELP_SGLINE
	Skadnia: SGLINE ADD [+czas-trwania] maska powd
	          SGLINE DEL {maska | numer-wpisu | lista}
	          SGLINE LIST [maska | lista]
	          SGLINE VIEW [maska | lista]
	          SGLINE CLEAR
	
	Pozwala operatorom serwisw na zarzdzanie list SGLINE.
	Jeli uytkownik z realname pasujcym do maski na licie
	podczy si do sieci serwisy natychmiast go rozcz.
	
	SGLINE ADD dodaje wskazan mask realname oraz 
	powd (ktry musi zosta podany) na list SGLINE.
	Podajc czas mona stosowa jednostki: s dla sekund,
	m dla minut, h dla godzin oraz d dla dni.
	Kombinacja tych jednostek nie jest moliwa. Domyln
	jednostk s dni (+30 oznacza 30 dni). Podanie +0
	oznacza, e wpis nie wyganie. Jeli maska zaczyna si
	znakiem + to podanie czasu jest obowizkowe (nawet jeli
	jest identyczny z domylnym). Domylny czas wygasania
	mona sprawdzi przy pomocy polecenia STATS AKILL.
	Uwaga: realname moe zawiera spacje, dlatego
	separatorem pomidzy mask i powodem jest dwukropek.
	
	SGLINE DEL usuwa wskazane wpisy z listy SGLINE.
	Jako argument przyjmuje mask, numer wpisu lub
	list (przykad poniej dla polecenia LIST).
	
	SGLINE LIST wywietla zawarto listy SGLINE. Jeli
	zostanie podana maska tylko pasujce wpisy zostan
	pokazane. Mona take uy listy, przykad:

	   SGLINE LIST 2-5,7-9
	      Listuje wpisy od 2 do 5 oraz od 7 do 9.
	
	SGLINE VIEW zwraca wicej szczegw ni SGLINE LIST.
	Wywietla informacje o dodajcym SGLINE, dat dodania,
	dat wyganicia, mask oraz powd.
	
	SGLINE CLEAR usuwa wszystkie wpisy z listy.

OPER_HELP_SQLINE
	Skadnia: SQLINE ADD [+czas-trwania] maska powd
	          SQLINE DEL {maska | numer-wpisu | lista}
	          SQLINE LIST [maska | lista]
	          SQLINE VIEW [maska | lista]
	          SQLINE CLEAR
	
	Pozwala operatorom serwisw na zarzdzanie list SQLINE.
	Jeli uytkownik z nickiem pasujcym do maski na licie
	podczy si do sieci serwisy natychmiast go rozcz.
	
	Jeli pierwszym znakiem maski jest # serwisy zablokuj
	moliwo korzystania z kanaw o nazwie pasujcej do
	niej (o ile IRCd obsuguje taki rodzaj blokady).
	
	SQLINE ADD dodaje wskazan mask oraz powd
	(ktry musi zosta podany) na list SQLINE.
	Podajc czas mona stosowa jednostki: s dla sekund,
	m dla minut, h dla godzin oraz d dla dni.
	Kombinacja tych jednostek nie jest moliwa. Domyln
	jednostk s dni (+30 oznacza 30 dni). Podanie +0
	oznacza, e wpis nie wyganie. Jeli maska zaczyna si
	znakiem + to podanie czasu jest obowizkowe (nawet jeli
	jest identyczny z domylnym). Domylny czas wygasania
	mona sprawdzi przy pomocy polecenia STATS AKILL.
	
	SQLINE DEL usuwa wskazane wpisy z listy SQLINE.
	Jako argument przyjmuje mask, numer wpisu lub
	list (przykad poniej dla polecenia LIST).
	
	SQLINE LIST wywietla zawarto listy SQLINE. Jeli
	zostanie podana maska tylko pasujce wpisy zostan
	pokazane. Mona take uy listy, przykad:

	   SQLINE LIST 2-5,7-9
	      Listuje wpisy od 2 do 5 oraz od 7 do 9.
	
	SQLINE VIEW zwraca wicej szczegw ni SQLINE LIST.
	Wywietla informacje o dodajcym SQLINE, dat dodania,
	dat wyganicia, mask oraz powd.

	SQLINE CLEAR usuwa wszystkie wpisy z listy.

OPER_HELP_SZLINE
	Skadnia: SZLINE ADD [+czas-trwania] maska powd
	          SZLINE DEL {maska | numer-wpisu | lista}
	          SZLINE LIST [maska | lista]
	          SZLINE VIEW [maska | lista]
	          SZLINE CLEAR
	
	Pozwala operatorom serwisw na zarzdzanie list SZLINE.
	Jeli uytkownik z adresem IP pasujcym do maski na licie
	podczy si do sieci serwisy natychmiast go rozcz.
	
	SZLINE ADD dodaje wskazan mask oraz powd
	(ktry musi zosta podany) na list SZLINE.
	Podajc czas mona stosowa jednostki: s dla sekund,
	m dla minut, h dla godzin oraz d dla dni.
	Kombinacja tych jednostek nie jest moliwa. Domyln
	jednostk s dni (+30 oznacza 30 dni). Podanie +0
	oznacza, e wpis nie wyganie. Jeli maska zaczyna si
	znakiem + to podanie czasu jest obowizkowe (nawet jeli
	jest identyczny z domylnym). Domylny czas wygasania
	mona sprawdzi przy pomocy polecenia STATS AKILL.
	
	SZLINE DEL usuwa wskazane wpisy z listy SZLINE.
	Jako argument przyjmuje mask, numer wpisu lub
	list (przykad poniej dla polecenia LIST).
	
	SZLINE LIST wywietla zawarto listy SZLINE. Jeli
	zostanie podana maska tylko pasujce wpisy zostan
	pokazane. Mona take uy listy, przykad:

	   SZLINE LIST 2-5,7-9
	      Listuje wpisy od 2 do 5 oraz od 7 do 9.
	
	SZLINE VIEW zwraca wicej szczegw ni SZLINE LIST.
	Wywietla informacje o dodajcym SZLINE, dat dodania,
	dat wyganicia, mask oraz powd.

	SZLINE CLEAR usuwa wszystkie wpisy z listy.

OPER_HELP_SET
	Skadnia: SET opcja warto
	
	Ustawia rne globalne ustawienia serwisw.
	Obecnie zdefiniowane s nastpujce ustawienia:
	    READONLY   Wcza tryb tylko-do-odczytu lub odczyt-zapis
	    LOGCHAN    Wcza raportowanie na kana
	    DEBUG      Wcza lub wycza tryb debugowania
	    NOEXPIRE   Wcza lub wycza tryb noexpire
	    SUPERADMIN Wcza lub wycza tryb super administratora
	    SQL        Wcza lub wycza obsug SQL
	    IGNORE     Wcza lub wycza tryb ignorowania
	    LIST       Listuje aktualne ustawienia

OPER_HELP_SET_READONLY
	Skadnia: SET READONLY {ON | OFF}
	
	Wcza lub wycza tryb tylko-do-odczytu. Wczenie tej
	opcji powoduje zablokowanie wykonywania zmian w ustawieniach
	serwisw, dotyczy to list dostpu kanau oraz nicka itd.
	Operatorzy serwisw z odpowiednimi uprawnieniami bd
	mogli modyfikowa list AKILL, usuwa lub blokowa nicki
	oraz kanay, ale adne z tych zmian nie zostan zapisane
	dopki tryb tylko-do-odczytu nie zostanie wyczony przed
	restartem lub wyczeniem serwisw.
	
	Ta opcja ma taki sam efekt jak argument linii polece -readonly.

OPER_HELP_SET_LOGCHAN
	Skadnia: SET LOGCHAN {ON | OFF}
	
	Wcza lub wycza wysyanie wiadomoci na podany kana, ktre
	trafiaj do logw. Aby mona byo skorzysta z tej opcji naley
	zdefiniowa w pliku konfiguracyjnym nazw kanau (LogChannel).

	Ta opcja ma taki sam efekt jak argument linii polece -logchan.

	Uwaga: Ustawiony kana musi by odpowiednio zabezpieczony,
	aby chroni prywatno uytkownikw.
OPER_HELP_SET_DEBUG
	Skadnia: SET DEBUG {ON | OFF | poziom}
	
	Wcza lub wycza tryb debugowania. W tym trybie wszystkie
	dane wysyane do serwisw i przez nie oraz wiele innych
	komunikatw zapisywane s do loga. Jeli zostanie podany 
	numer poziomu poziom tryb debugowania jest aktywowany
	ze wskazanym poziomem.
	
	Ta opcja ma taki sam efekt jak argument linii polece -debug.

OPER_HELP_SET_NOEXPIRE
	Skadnia: SET NOEXPIRE {ON | OFF}
	
	Wcza lub wycza tryb wygasania. Jeli ta opcja
	zostaa wczona nicki, kanay, wpisy na listach
	AKILL oraz wyjtkw nie bd automatycznie wygasay.
	
	Ta opcja ma taki sam efekt jak argument linii polece -noexpire.

OPER_HELP_SET_SUPERADMIN
	Skadnia: SET SUPERADMIN {ON | OFF}
	
	Ustawienie tej opcji nadaje wydajcemu polecenie
	dodatkowe uprawnienia (np. jest wacicielem 
	wszystkich kanaw w sieci).
	
	Ta opcja powinna by uywana tylko wtedy, kiedy
	jest taka potrzeba. Naley j pniej wyczy.

OPER_HELP_SET_SQL
	Skadnia: SET SQL {ON | OFF}
	
	Wcza lub wycza korzystanie z bazy danych SQL.
	Komenda ta pozwala na wyczenie serwera SQL
	podczas nieprzerwanej pracy serwisw.

OPER_HELP_SET_IGNORE
	Skadnia: SET IGNORE {ON | OFF}
	
	To ustawienie pozwala wcza/wycza system ignorowania.

OPER_HELP_SET_LIST
	Skadnia: SET LIST
	
	Listuje aktualne ustawienia serwisu %S.

OPER_HELP_NOOP
	Skadnia: NOOP SET serwer
	          NOOP REVOKE serwer
	
	NOOP SET usuwa wszystkie O:linie ze wskazanego
	serwera oraz killuje wszystkich operatorw, aby
	zapobiec zrehashowaniu serwera (przeadowanie pliku
	konfiguracyjnego usuwa efekt tego polecenia).
	
	NOOP REVOKE powoduje przywrcenie wszystkich 
	uprawnie na wskazanym serwerze.
	
	Uwaga: Serwisy nie sprawdzaj wartoci serwer.

OPER_HELP_JUPE
	Skadnia: JUPE serwer [powd]
	
	To polecenie powoduje wprowadzenie przez serwisy do sieci
	sztucznego serwera, co zapobiega podczaniu prawdziwego
	serwera o tej samej nazwie. Blokad mona zdj uywajc
	standardowego polecenia SQUIT. Jeli zostanie podany
	powd bdzie on wywietlany w polu informacyjnym serwera,
	w przeciwnym wypadku wywietlane bdzie "Juped by <nick>".

OPER_HELP_RAW
	Skadnia: RAW tekst
	
	Wysya tekst bezporednio do serwera, do ktrego s
	podczone serwisy. To polecenie ma bardzo ograniczone
	zastosowanie i moe powodowa chaos, kiedy jest uywane
	w sposb nieprawidowy. NIE UYWAJ TEGO POLECENIA
	jeli nie masz pewnoci co robisz.

OPER_HELP_UPDATE
	Skadnia: UPDATE
	
	Wymusza natychmiastowy zapis baz danych na dysku.

OPER_HELP_RELOAD
	Skadnia RELOAD
	
	Wymusza ponowne zaadowanie pliku konfiguracyjnego.
	Niektre opcje wci wymagaj restartu serwisw
	(zmiana nickw serwisw, aktywacja limitw sesji itd.).
OPER_HELP_QUIT
	Skadnia: QUIT
	
	Wymusza na serwisach natychmiastowe zakoczenie pracy bez
	zapisywania baz. To polecenie powinno by uyte jedynie,
	gdy zachodzi podejrzenie uszkodzenia baz, ktre serwisy
	przechowuj w pamici. Do normalnego zakoczenia pracy
	serwisw naley uy polecenia SHUTDOWN.

OPER_HELP_SHUTDOWN
	Skadnia: SHUTDOWN
	
	Wymusza zapisanie baz danych, a nastpnie wycza serwisy.

OPER_HELP_RESTART
	Skadnia: RESTART
	
	Wymusza zapisanie baz, a nastpnie restartuje serwisy.

OPER_HELP_CHANLIST
	Skadnia: CHANLIST [{wzorzec | nick} [SECRET]]
	
	Listuje wszystkie istniejce kanay w sieci, niezalenie od
	tego czy s zarejestrowane.
	
	Podanie wzorca ogranicza list pokazywanych kanaw.
	Podanie nicka wywietla kanay, na ktrych przebywa
	wskazany uytkownik. Dodanie parametru SECRET ogranicza
	list do kanaw z flag +s lub +p.

OPER_HELP_USERLIST
	Skadnia: USERLIST [{wzorzec | kana} [INVISIBLE]]
	
	Listuje wszystkich uytkownikw w sieci, niezalenie od
	tego czy maj zarejestrowanego nicka.
	
	Podanie wzorca ogranicza list pokazywanych uytkownikw.
	(musi by w formacie nick!ident@host). Podanie kanau 
	listuje uytkownikw przebywajcych na wskazanym kanale.
	Dodanie parametru INVISIBLE listuje tylko uytkownikw z flag +i.

OPER_HELP_MODLOAD
	Skadnia: MODLOAD nazwa-pliku
	
	To polecenie aduje wskazany modu z katalogu moduw.

OPER_HELP_MODUNLOAD
	Skadnia: MODUNLOAD nazwa-pliku
	
	To polecenie wyaduje wskazany modu.

OPER_HELP_MODINFO
	Skadnia: MODINFO nazwa-pliku
	
	To polecenie wywietla informacje na temat zaadowanego moduu

OPER_HELP_MODLIST
	Skadnia: MODLIST [Core|3rd|protocol|encryption|supported|qatested]
	
	Listuje zaadowane moduy.

###########################################################################
#
# BotServ help messages
#
###########################################################################
BOT_HELP_CMD_BOTLIST
	    BOTLIST        Listuje dostpne boty

BOT_HELP_CMD_ASSIGN
	    ASSIGN         Przydziela bota na kana

BOT_HELP_CMD_SET
	    SET            Konfiguruje bota

BOT_HELP_CMD_KICK
	    KICK           Konfiguruje opcje kopania

BOT_HELP_CMD_BADWORDS
	    BADWORDS       Zarzdza list zakazanych sw

BOT_HELP_CMD_ACT
	    ACT            Wyraa przez bota akcj (komenda /me)

BOT_HELP_CMD_INFO
	    INFO           Pokazuje informacje i ustawienia BotServa
	                   dotyczce bota lub kanau

BOT_HELP_CMD_SAY
	    SAY            Wypowiada przez bota tekst na kanale

BOT_HELP_CMD_UNASSIGN
	    UNASSIGN       Usuwa bota z kanau

BOT_HELP_CMD_BOT
	    BOT            Zarzdza sieciow list botw

BOT_HELP
	%S pozwala umieci bota na wasnym kanale.
	Zosta stworzony dla uytkownikw, ktrzy nie mog
	hostowa wasnego bota oraz dla tych sieci ktre
	nie pozwalaj na ich uywanie. Ponisze komendy
	umoliwiaj zarzdzanie botem, aby ich uy wpisz:
	%R%S komenda
	Aby uzyska szczegowy opis polecenia wpisz:
	%R%S HELP komenda

BOT_HELP_FOOTER
	Bot wejdzie na kana jeli przebywa na nim
	przynajmniej %d uytkownik(w).

BOT_HELP_BOTLIST
	Skadnia: BOTLIST
	
	Listuje dostpne w sieci boty.

BOT_HELP_ASSIGN
	Skadnia: ASSIGN kana nick
	
	Przydziela bota o wskazanym nicku na kana.

BOT_HELP_UNASSIGN
	Skadnia: UNASSIGN kana
	
	Uycie tej komendy usuwa bota z kanau.
	Bdzie mona go ponownie przydzieli w kadej
	chwili, bez potrzeby ponownego konfigurowania.

BOT_HELP_INFO
	Skadnia: INFO {kana | nick}
	
	Wywietla informacje serwisu %S o wskazanym kanale
	lub bocie. Jeli parametrem jest nazwa kanau to
	zostan pokazane informacje dotyczce kanau.
	Jeli parametrem bdzie nick bota to zostan
	pokazane informacje takie jak: data utworzenia,
	ilo obsugiwanych kanaw itp.

BOT_HELP_SET
	Skadnia: SET (kana | bot) opcja parametry
	
	Umoliwia konfiguracj nastpujcych opcji bota:
	
	   DONTKICKOPS      Bot nie kopie operatorw
	   DONTKICKVOICES   Bot nie kopie osb z prawem gosu
	   GREET            Wcza wiadomo powitaln
	   FANTASY          Wcza publiczne komendy
	   SYMBIOSIS        Przejmuje zadania ChanServa
	
	Aby uzyska wicej informacji wpisz:
	%R%S HELP SET opcja
	
	Informacja: dostp do tej komendy jest kontrolowany
	przez poziom SET.
BOT_HELP_SET_DONTKICKOPS
	Skadnia: SET kana DONTKICKOPS {ON|OFF}
	
	Wcza lub wycza opcj kopania uytkownikw
	posiadajcych status operatora nawet jeli nie
	przysuguje im poziom dostpu NOKICK.

BOT_HELP_SET_DONTKICKVOICES
	Skadnia: SET kana DONTKICKVOICES {ON|OFF}
	
	Wcza lub wycza opcj kopania uytkownikw
	posiadajcych prawo gosu nawet jeli nie
	przysuguje im poziom dostpu NOKICK.

BOT_HELP_SET_FANTASY
	Skadnia: SET kana FANTASY {ON|OFF}
	
	Wcza lub wycza dostp do publicznych polece
	na kanale takich jak: !op, !deop, !voice, !devoice,
	!kick, !kb, !unban, !seen (cze komend przyjmuje
	jako parametry nicki i powody).
	
	Uytkownicy dopuszczeni do uywania komend
	publicznych musz mie odpowiedni poziom dostpu
	do wydania danego polecenia (np. aby uywac !deop
	trzeba posiada poziom dostpu OPDEOP).

BOT_HELP_SET_GREET
	Skadnia: SET kana GREET {ON|OFF}
	
	Wcza lub wycza witanie podczas wejcia uytkownikw
	ich wasn wiadomoci powitaln. Uytkownik zostanie
	powitany, jeli bdzie mia odpowiedni poziom dostpu.

BOT_HELP_SET_SYMBIOSIS
	Skadnia: SET kana SYMBIOSIS {ON|OFF}
	
	Wcza lub wycza opcj symbiozy na kanale.
	Gdy ten tryb jest wczony wszystkie operacje,
	ktre wykonywa %s (np. opowanie) bd
	wykonywane przez bota.

BOT_HELP_KICK
	Skadnia: KICK kana opcja parametry
	
	Konfiguruje opcje kopania na kanale:
	
	   BOLDS        Kopanie za uywanie pogrubie
	   BADWORDS     Kopanie za uywanie zakazanych sw
	   CAPS         Kopanie za pisanie WIELKIMI LITERAMI
	   COLORS       Kopanie za stosowanie kolorw
	   FLOOD        Kopanie za flood
	   REPEAT       Kopanie za wielokrotne powtarzanie
	   REVERSES     Kopanie za odwracanie kolorw
	   UNDERLINES   Kopanie za uywanie podkrele
	
	Aby uzyska wicej informacji wpisz:
	%R%S HELP KICK opcja

BOT_HELP_KICK_BOLDS
	Skadnia: KICK kana BOLDS {ON|OFF} [ttb]
	
	Ustawia kopanie za pogrubianie tekstu.
	
	ttb to liczba okrelajca ile razy uytkownik
	zostanie wykopany zanim bot zaoy bana.
	Pominicie parametru ttb wycza banowanie.

BOT_HELP_KICK_COLORS
	Skadnia: KICK kana COLORS {ON|OFF} [ttb]
	
	Ustawia kopanie za uywanie kolorowego tekstu.
	
	ttb to liczba okrelajca ile razy uytkownik
	zostanie wykopany zanim bot zaoy bana.
	Pominicie parametru ttb wycza banowanie.

BOT_HELP_KICK_REVERSES
	Skadnia: KICK kana REVERSES {ON|OFF} [ttb]
	
	Ustawia kopanie za odwracanie kolorw tekstu (ctrl+r).
	
	ttb to liczba okrelajca ile razy uytkownik
	zostanie wykopany zanim bot zaoy bana.
	Pominicie parametru ttb wycza banowanie.

BOT_HELP_KICK_UNDERLINES
	Skadnia: KICK kana UNDERLINES {ON|OFF} [ttb]
	
	Ustawia kopanie za podkrelanie tekstu.
	
	ttb to liczba okrelajca ile razy uytkownik
	zostanie wykopany zanim bot zaoy bana.
	Pominicie parametru ttb wycza banowanie.

BOT_HELP_KICK_CAPS
	Skadnia: KICK kana CAPS {ON|OFF} [ttb [min [procent]]]
	
	Ustawia kopanie za uywanie WIELKICH LITER.
	
	Bot kopie jeli tekst zawiera przynajmniej min
	wielkich liter i stanowi przynajmniej procent
	caego tekstu w linii (w przypadku nie podania tych
	wartoci przyjmowane s domylne: 10 znakw i 25%).
	
	ttb to liczba okrelajca ile razy uytkownik
	zostanie wykopany zanim bot zaoy bana.
	Pominicie parametru ttb wycza banowanie.

BOT_HELP_KICK_FLOOD
	Skadnia: KICK kana FLOOD {ON|OFF} [ttb [ln [sek]]]
	
	Ustawia kopanie za flood. Wczenie tej opcji
	powoduje wykopywanie uytkownikw wysyajcych na
	kana przynajmniej ln linii tekstu w cigu sek
	sekund (w przypadku nie podania tych wartoci przyjmowane
	s domylne: 6 linii w cigu 10 sekund).
	
	ttb to liczba okrelajca ile razy uytkownik
	zostanie wykopany zanim bot zaoy bana.
	Pominicie parametru ttb wycza banowanie.

BOT_HELP_KICK_REPEAT
	Skadnia: KICK kana REPEAT {ON|OFF} [ttb [liczba]]
	
	Ustawia kopanie za powtarzanie tekstu. Wczenie tej
	opcji powoduje wykopywanie uytkownikw wysyajcych
	na kana przynajmniej liczba razy ten sam tekst
	(w przypadku nie podania tego parametru jego warto
	ustalana jest domylnie na 3).
	
	ttb to liczba okrelajca ile razy uytkownik
	zostanie wykopany zanim bot zaoy bana.
	Pominicie parametru ttb wycza banowanie.

BOT_HELP_KICK_BADWORDS
	Skadnia: KICK kana BADWORDS {ON|OFF} [ttb]
	
	Ustawia kopanie za uywanie zakazanych sw.
	
	Aby ustali list zakazanych uyj polecenia BADWORDS.
	Aby uzyska wicej informacji wpisz:
	%R%S HELP BADWORDS
	
	ttb to liczba okrelajca ile razy uytkownik
	zostanie wykopany zanim bot zaoy bana.
	Pominicie parametru ttb wycza banowanie.

BOT_HELP_BADWORDS
	Skadnia: BADWORDS kana ADD sowo [SINGLE | START | END]
	          BADWORDS kana DEL {sowo | numer-wpisu | lista}
	          BADWORDS kana LIST [maska | lista]
	          BADWORDS kana CLEAR
	
	Polecenie umoliwia zarzdzanie list niedozwolonych
	sw. Lista definiuje za jakie sowa uytkownicy mog
	zosta wyrzuceni z kanau. Aby uzyska wicej informacji
	napisz: %R%S HELP KICK BADWORDS
	
	BADWORDS ADD dodaje wskazane sowo do listy.
	Parametr SINGLE powoduje, e uytkownicy bd kopani za
	uywanie wskazanego sowa w caoci.
	Parametr START powoduje, e uytkownicy bd kopani za
	uywanie wskazanego sowa na pocztku innych wyrazw.
	Parametr END powoduje, e uytkownicy bd kopani za
	uywanie wskazanego sowa na kocu innych wyrazw.
	Pominicie parametru powoduje, e uytkownicy bd
	kopani w kadym z przypadkw, kiedy zostanie uyte 
	wskazane sowo.
	
	BADWORDS DEL usuwa wskazane wpisy z listy sw.
	Jako argument przyjmuje sowo, numer wpisu lub
	list (przykad poniej dla polecenia LIST).

	BADWORDS LIST wywietla zawarto listy sw. Jeli
	zostanie podana maska tylko pasujce wpisy zostan
	pokazane. Mona take uy listy, przykad:

	   BADWORDS kana LIST 2-5,7-9
	      Listuje wpisy od numeru 2 do 5 oraz od 7 do 9.
	
	BADWORDS CLEAR usuwa wszystkie wpisy z listy.

BOT_HELP_SAY
	Skadnia: SAY kana tekst
	
	Wypowiada przez bota podany tekst na kanale.

BOT_HELP_ACT
	Skadnia: ACT kana tekst
	
	Sprawia, e bot uyje komendy akcji (/me) przy
	wypowiadaniu podanego tekstu na kanale.

BOT_SERVADMIN_HELP_BOT
	Skadnia: BOT ADD nick ident host nazwa
	          BOT CHANGE starynick nowynick [ident [host [nazwa]]]
	          BOT DEL nick
	
	Polecenie pozwala administratorom serwisw na
	tworzenie, modyfikowanie oraz kasowanie botw
	uywanych przez uytkownikw sieci na kanaach.
	
	BOT ADD dodaje bota o podanym nicku, idencie,
	hocie oraz realname.
	BOT CHANGE pozwala na zmian nicka, identa,
	hosta lub realname bota bez jego kasowania.
	BOT DEL usuwa wskazanego bota.
	
	UWAGA: Jeli stworzony zostanie bot o nicku,
	ktry jest ju zarejestrowany, nick zostanie
	odrejestrowany. Podobnie jeli nick stworzonego
	bota bdzie uywany przez innego uytkownika,
	zostanie on wtedy skillowany.

BOT_SERVADMIN_HELP_SET
	
	Opcje dostpne dla administratorw serwisw:
	
	   NOBOT     Uniemoliwia przypisanie bota do kanau
	   PRIVATE   Zastrzega przypisywanie bota tylko dla IRC
	             Operatorw

BOT_SERVADMIN_HELP_SET_NOBOT
	Skadnia: SET kana NOBOT {ON|OFF}
	
	Polecenie to pozwala okreli kana, dla ktrego
	nie wolno przypisywa botw. Jeli w danej chwili
	bot jest przypisany do kanau, zostanie usunity.

BOT_SERVADMIN_HELP_SET_PRIVATE
	Skadnia: SET nick-bota PRIVATE {ON|OFF}
	
	Polecenie pozwala na ograniczenie przypisywania
	wskazanego bota dla uytkownikw nie bdcych
	IRC operatorami.

###########################################################################
#
# HostServ messages
#
###########################################################################
HOST_EMPTY
	Lista vhostw jest pusta.

HOST_ENTRY
	#%d Nick:%s, vhost:%s (%s - %s)

HOST_IDENT_ENTRY
	#%d Nick:%s, vhost:%s@%s (%s - %s)

HOST_SET
	Vhost dla %s zosta zmieniony na %s.

HOST_IDENT_SET
	Vhost dla %s zosta zmieniony na %s@%s.

HOST_SETALL
	Vhosty dla grupy %s zostay zmienione na %s.

HOST_DELALL
	Vhosty dla grupy %s zostay usunite.

HOST_DELALL_SYNTAX
	DELALL <nick>.

HOST_IDENT_SETALL
	Vhosty dla grupy %s zostay zmienione na %s@%s.

HOST_SET_ERROR
	Vhost musi mie format prawidowej maski hosta.

HOST_SET_IDENT_ERROR
	Ident vhosta musi mie format prawidowego identa.

HOST_SET_TOOLONG
	Bd! Vhost jest za dugi, uyj vhosta krtszego ni %d znakw.

HOST_SET_IDENTTOOLONG
	Bd! Ident jest za dugi, uyj identa krtszego ni %d znakw.

HOST_NOREG
	Nie znaleziono %s w bazie serwisu NickServ.

HOST_SET_SYNTAX
	SET <nick> <maska-hosta>.

HOST_SETALL_SYNTAX
	SETALL <nick> <maska-hosta>.

HOST_DENIED
	Brak dostpu.

HOST_NOT_ASSIGNED
	Skontaktuj si z operatorem, aby uzyska vhosta na ten nick.

HOST_ACTIVATED
	Twj vhost %s jest teraz aktywny.

HOST_IDENT_ACTIVATED
	Twj vhost %s@%s jest teraz aktywny.

HOST_ID
	Najpierw zidentyfikuj si u serwisw.

HOST_NOT_REGED
	Aby uzyska vhosta musisz by najpierw zarejestrowany.

HOST_DEL
	Vhost dla %s zosta usunity.

HOST_DEL_SYNTAX
	DEL <nick>.
HOST_OFF
	Twj vhost zosta usunity i zostao wczone normalne ukrywanie hosta.
HOST_OFF_UNREAL
	Twj vhost zosta usunity. Aby wczy standardowe ukrywanie hosta wpisz /mode %s +%s

HOST_NO_VIDENT
	Twoje IRCD nie obsuguje vIdentw, jeli nie jest to prawda zgo bd.

HOST_GROUP
	Wszystkie vhosty w grupie %s zostay zmienione na %s

HOST_IDENT_GROUP
	Wszystkie vhosty w grupie %s zostay zmienione na %s@%s

HOST_LIST_FOOTER
	Wywietlono wszystkie wpisy (Liczba: %d)

HOST_LIST_RANGE_FOOTER
	Wywietlono wpisy od %d do %d

HOST_LIST_KEY_FOOTER
	Wywietlono pasujce wpisy %s (Liczba: %d)

###########################################################################
#
# HostServ Help messages
#
###########################################################################
HOST_HELP_CMD_ON
	    ON          Aktywuje przypisanego vhosta

HOST_HELP_CMD_OFF
	    OFF         Deaktywuje przypisanego vhosta

HOST_HELP_CMD_GROUP
	    GROUP       Synchronizuje vhosty wszystkich nickw w grupie

HOST_HELP_CMD_SET
	    SET         Zmienia vhost wskazanemu uytkownikowi

HOST_HELP_CMD_SETALL
	    SETALL      Zmienia vhosty wszystkich nickw w grupie

HOST_HELP_CMD_DEL
	    DEL         Usuwa vhost wskazanego uytkownika

HOST_HELP_CMD_DELALL
	    DELALL      Usuwa vhosty wszystkich nickw w grupie

HOST_HELP_CMD_LIST
	    LIST        Listuje vhosty

HOST_OPER_HELP
	nie jest uywane.

HOST_ADMIN_HELP
	nie jest uywane.

HOST_HELP
	Komendy %S:

HOST_HELP_ON
	Skadnia: ON
	
	Aktywuje vhosta aktualnie przypisanego do uywanego nicka.
	Po uyciu tego polecenia Twj prawdziwy adres zostanie 
	zastpiony vhostem.

HOST_HELP_SET
	Skadnia: SET <nick> <vhost>.
	
	Ustawia wskazanemu uytkownikowi vhosta.
	Jeli Twoje IRCD obsuguje videnty to uywajc
	polecenia SET <nick> <ident>@<vhost>
	mona zmienia take ident.

HOST_HELP_DELALL
	Skadnia: DELALL <nick>.
	
	Usuwa wszystkie vhosty grupy, do ktrej naley wskazany nick.

HOST_HELP_SETALL
	Skadnia: SETALL <nick> <vhost>.
	
	Ustawia vhosta dla wszystkich nickw w obrbie grupy.
	Jeli IRCD obsuguje vIdenty wydanie polecenia
	SETALL <nick> <ident>@<vhost> spowoduje ustawienie
	take identw.
	
	UWAGA: to polecenie nie spowoduje zmiany vhosta
	dla nicka, ktry pniej zostanie dodany do grupy.

HOST_HELP_OFF
	Skadnia: OFF
	
	Deaktywuje vhosta aktualnie przypisanego do uywanego nicka.
	Po uyciu tego polecenia kady bdzie mg sprawdzi Twj
	prawdziwy adres uywajc polecenia /WHOIS.

HOST_HELP_DEL
	Skadnia: DEL <nick>
	
	Usuwa vhosta przypisanego do wskazanego nicka.

HOST_HELP_LIST
	Skadnia: LIST [<wzorzec>|<#X-Y>]
	
	To polecenie listuje zarejestrowane vhosty operatorowi.
	Jeli podano wzorzec tylko wpisy o pasujcych nickach
	lub vhostach zostan pokazane. Podanie np. Rob*
	spowoduje wywietlenie wszystkich wpisw zaczynajcych
	si od Rob.
	
	Jeli zostanie uyty format #X-Y to tylko wpisy nalece
	do przedziau od X do Y bd pokazane. Podanie #1-3
	spowoduje wywietlenie pierwszych 3 wpisw wpisw.
	
	Maksymalna dugo listy wywietlanej operatorowi podczas
	jednego zapytania jest okrelona przez ustawienie NSListMax.

HOST_HELP_GROUP
	Skadnia: GROUP
	
	To polecenie pozwala ustawi vhost biecego nicka
	dla wszystkich nickw w grupie.

OPER_SVSNICK_UNSUPPORTED
	Komenda SVSNICK nie jest dostpna w tej sieci.

OPER_SQLINE_UNSUPPORTED
	Komenda SQLINE nie jest dostpna w tej sieci.

OPER_SVSO_UNSUPPORTED
	Komenda OLINE nie jest dostpna w tej sieci.

OPER_UMODE_UNSUPPORTED
	Komenda UMODE nie jest dostpna w tej sieci.

OPER_SUPER_ADMIN_NOT_ENABLED
	Opcja SuperAdmin nie jest wczona w pliku konfiguracyjnym.

