# Turkish language file.
#
# (C) 2003-2010 Anope Team
# Contact us at team@anope.org
#
# Please read COPYING and README for furhter details.
#
# Based on the original code of Epona by Lara.
# Based on the original code of Services by Andy Church.
#
# When translating this file to another language, keep in mind that the
# order of parameters for sprintf() is fixed in the source code, so your
# messages need to take the same parameters in the same order as the
# English messages do.  (Obviously, this doesn't hold for the strftime()
# format lines immediately below.)  If you can't get a natural translation
# of a message without changing the order of the parameters, let us know
# (team@anope.org) which message is causing a problem and I'll see
# what I can do.
#
# In help messages, "%S" (capital S, not lowercase) refers to the name of
# the service sending the message; for example, in NickServ help messages,
# "%S" is replaced by "NickServ" (or whatever it is renamed to in
# services.conf).  The %S's do not count as sprintf() parameters, so they can be
# rearranged, removed, or added as necessary.
#
# Also in help messages, please try to limit line lengths to 60 characters
# of text (not including the leading tab).  This length was chosen because
# it does not cause line wrap under default settings on most current IRC
# clients.  Remember that format characters (control-B, control-_) are not
# included in that 60-character limit (since they don't show on the user's
# screen).  Also remember that format specifiers (%S, etc.) will expand
# when displayed, so remember to take this into account; you can assume
# that the length of a pseudoclient name (%S replacement) will be eight
# characters, so reduce the maximum line length by 6 for every %S on a
# line.
#
# Finally, remember to put a tab at the beginning of every line of text
# (including empty lines).  This has to be a tab, not spaces.

###########################################################################
# Son gncelleme - ysfm - ysfm@irc.org.tr - irc.sohbet.net.tr 		  #
# Imla ve Ceviri hatalarn ysfm@irc.org.tr adresine bildiriniz		  #
# Turkish - Trke                                                        #
###########################################################################

# For languages other than English, this string should have the following
# format:
#     language-name-in-language (language-name-in-English)
# For example, "Espaol (Spanish)" or "Franais (French)".

LANG_NAME
	Trke (Turkish)
#################################################################
# Translated by CafeiN (oytuny@yahoo.com) irc.ixir.net          #
# Modified by MeShGuL - guzelbey@cs.utk.edu - irc.arkadas.com   #
#################################################################

###########################################################################
#
# General messages
#
###########################################################################

# strftime() format strings.  man 3 strftime for information on the
# meanings of the format specifiers.  Short version:
#	%a = weekday name (short)	%H = hour
#	%b = month name (short)		%M = minute
#	%d = day of month		%S = second
#	%Y = year			%Z = time zone

# This is used as the format string for strftime() for a date and time
# together.
STRFTIME_DATE_TIME_FORMAT
	%b %d %H:%M:%S %Y %Z
# This is used as the format string for strftime() for a date alone in long
# format (English: including weekday).
STRFTIME_LONG_DATE_FORMAT
	%a %b %d %Y
# This is used as the format string for strftime() for a date alone in
# short format (English: without weekday).
STRFTIME_SHORT_DATE_FORMAT
	%b %d %Y

# These tell our strftime() what the names of months and days are.  If you
# don't use %a, %A, %b, or %B in your strftime() strings above, you can
# leave these empty.  However, if you enter names, they MUST stay in order,
# one per line, and the list MUST be complete!

# %a
STRFTIME_DAYS_SHORT
	Paz
	Pzt
	Sal
	ar
	Per
	Cum
	Cmt
# %A
STRFTIME_DAYS_LONG
	Pazar
	Pazartesi
	Sal
	aramba
	Perembe
	Cuma
	Cumartesi
# %b
STRFTIME_MONTHS_SHORT
	Oca
	ub
	Mar
	Nis
	May
	Haz
	Tem
	Au
	Eyl
	Eki
	Kas
	Ara
# %B
STRFTIME_MONTHS_LONG
	Ocak
	ubat
	Mart
	Nisan
	Mays
	Haziran
	Temmuz
	Austos
	Eyll
	Ekim
	Kasm
	Aralk


# This is used in ChanServ/NickServ INFO displays.
COMMA_SPACE
	, 


# Various error messages.
USER_RECORD_NOT_FOUND
	Dahili hata - Kullanc kayd bulunamad.
UNKNOWN_COMMAND
	Varolmayan komut %s.
UNKNOWN_COMMAND_HELP
	Varolmayan komut %s. yardm iin "%R%s HELP" yaznz.
SYNTAX_ERROR
	Kullanm: %s
MORE_INFO
	Daha fazla bilgi iin %R%s HELP %s yaznz.
NO_HELP_AVAILABLE
	%s hakknda yardm bulunamad.
OBSOLETE_COMMAND
	Bu komut artk kullanlmyor; onun yerine %s komutunu deneyin.

BAD_USERHOST_MASK
	Mask user@host eklinde tanmlanmaldr.
BAD_EXPIRY_TIME
	Geersiz zaman am sresi.
USERHOST_MASK_TOO_WIDE
	%s kapsam ar geni; Ltfen daha belirli bir mask kullann.

SERVICE_OFFLINE
	%s u an devre d.
READ_ONLY_MODE
	Not: Servisler read-only modunda; deiiklikler kaydedilmeyecektir!
PASSWORD_INCORRECT
	ifre geersiz.
INVALID_TARGET
	"/msg %s" eklinde uzun mesaj desteklenmemektedir. "/msg %s@%s" veya "/%s" eklinde deneyiniz.

# What's the difference between "Access denied" and "Permission denied"?
# Very little; you can safely make them the same message with no real loss
# of meaning.  If you want to make a distinction, "Access denied" is
# usually used more generally; for example, a non-oper trying to access
# OperServ gets "Access denied", while a non-Services admin trying to use
# NickServ SET NOEXPIRE gets "Permission denied".
ACCESS_DENIED
	Bu komuta eriiminiz yok.
PERMISSION_DENIED
	Bu komutu kullanma izniniz yok.
RAW_DISABLED
	Raw ayarlar kapal bulunuyor. DisableRaw zellii servis ayarlar dosyasnda ak grnyor.

MORE_OBSCURE_PASSWORD
	Ltfen daha zor bir ifre deneyin.  ifreler en az 5 karakter uzunlukta, kolayca tahmin edilemeyecek birey olmaldr(r: gerek isminiz, nickiniz v.b. olmamaldr), ve bolukla tab kullanlmamaldr.
PASSWORD_TOO_LONG
	ifreniz ok uzun. Ltfen daha ksa bir ifre deneyiniz.

NICK_NOT_REGISTERED
	Nickiniz kaytl deil.
NICK_NOT_REGISTERED_HELP
	Nickiniz kaytl deil.  Nick kayt hakknda bilgi almak iin %R%s HELP yazn.
NICK_X_IS_SERVICES
	%s Rumuzu servislerin bir paras olarak grnyor(Servisler Tarafndan kullanlyor).
NICK_X_NOT_REGISTERED
	%s kaytl bir nick deil.
NICK_X_IN_USE
	%s rumuzu u anda kullanlmaktadr.
NICK_X_NOT_IN_USE
	%s nicki u an kullanmda deil.
NICK_X_NOT_ON_CHAN
	%s su anda %s kanalinda degil.
NICK_X_FORBIDDEN
	%s nicki kayt edilemez ve kullanlamaz.
NICK_X_FORBIDDEN_OPER
	%s nicki yasaklanmtr. %s:
	%s
NICK_X_ILLEGAL
	%s rumuzu yasaklanm bir rumuzdur. Kullanma kapatlmtr.
NICK_X_TRUNCATED
	%s rumuzu uzun %d karakter nickten ksaltlacak.
NICK_X_SUSPENDED
	%s rumuzu askya alnmtr(Geici olarak kullanma yasaklanmtr).
CHAN_X_NOT_REGISTERED
	%s kanal kaytl deil.
CHAN_X_NOT_IN_USE
	%s kanal u an kullanmda deil.
CHAN_X_FORBIDDEN
	%s kanal kayt edilemez ve kullanlamaz.
CHAN_X_FORBIDDEN_OPER
	%s kanal yasaklanmtr. %s:
	%s
CHAN_X_SUSPENDED
	      Suspended: [%s] %s
NICK_IDENTIFY_REQUIRED
	Bu komutu kullanabilmek iin ifrenizi girmelisiniz.
	%R%s IDENTIFY ifreniz yazarak yeniden deneyiniz.
CHAN_IDENTIFY_REQUIRED
	Bu komutu kullanabilmek iin ifrenizi girmelisiniz.
	%R%s IDENTIFY %s ifreniz yazarak yeniden deneyiniz.
	
MAIL_DISABLED
	Servislerin mail gnderme zellii devre ddr.
MAIL_INVALID
	%s iin mail adresi geerli deil.
MAIL_X_INVALID
	%s geerli bir mail adresi deil.
MAIL_LATER
	u an mail gnderilemiyor; ltfen az sonra tekrar deneyin.
MAIL_DELAYED
	Ltfen %d saniye bekleyin ve tekrar deneyin.
	
NO_REASON
	Sebep yok
UNKNOWN
	<varolmayan>

# Duration system
DURATION_DAY
	1 gn
DURATION_DAYS
	%d gn
DURATION_HOUR
	1 saat
DURATION_HOURS
	%d saat
DURATION_MINUTE
	1 dakika
DURATION_MINUTES
	%d dakika
DURATION_SECOND
	1 saniye
DURATION_SECONDS
	%d saniye

# Human readable expiration
NO_EXPIRE
	zaman am yok
EXPIRES_SOON
	bir sonraki veritaban gncellemesinde zaman am sresi dolacak
EXPIRES_M
	%d dakika sonra zaman am sresi dolacak
EXPIRES_1M
	%d dakika sonra zaman am sresi dolacak
EXPIRES_HM
	%d saat, %d dakika sonra zaman am sresi dolacak
EXPIRES_H1M
	%d saat, %d dakika sonra zaman am sresi dolacak
EXPIRES_1HM
	%d saat, %d dakika sonra zaman am sresi dolacak
EXPIRES_1H1M
	%d saat, %d dakika sonra zaman am sresi dolacak
EXPIRES_D
	%d gn sonra zaman am sresi dolacak
EXPIRES_1D
	%d gn sonra zaman am sresi dolacak

# Generic Footer message
END_OF_ANY_LIST
	%s listesi sonu.


###########################################################################
#
# NickServ messages
#
###########################################################################

# Automatic messages
LIST_INCORRECT_RANGE
	Geersiz giri deniyorsunuz. Geerli arama ekli #Aranan deil Aranan'dr.
CS_LIST_INCORRECT_RANGE
	' # ' Karakteri ile baslayan bir giri yaptnz, kanal aramalarnda
	kanal ismi bana #-karakteri koymanza gerek yoktur. (anope girii #anope ekline karlk gelmektedir).

###########################################################################
#
# NickServ messages
#
###########################################################################

# Automatic messages
HELP_LIMIT_SERV_OPER
	Bu komut Services Operators kullanm icindir.
HELP_LIMIT_SERV_ADMIN
	Bu komut Services Administrators kullanm icindir.
HELP_LIMIT_SERV_ROOT
	Bu komut Services Roots kullanm icindir.
HELP_LIMIT_IRC_OPER
	Bu komut IRC Operators kullanm icindir.
HELP_LIMIT_HOST_SETTER
	Bu komut Host Setters kullanm icindir.
HELP_LIMIT_HOST_REMOVER
	Bu komut Host Removers kullanm icindir.


###########################################################################
#
# NickServ messages
#
###########################################################################

# Automatic messages
NICK_IS_REGISTERED
	Bu nick bakasna ait. Ltfen baka bir tane sein.
	(Eer bu sizin nickiniz ise, %R%s IDENTIFY ifreniz yaznz.)
NICK_IS_SECURE
	Bu nick kaytl ve korumaldr. Eer bu sizin nickiniz ise, 
	%R%s IDENTIFY ifreniz yaznz. Yada, baka bir nick sein.
NICK_MAY_NOT_BE_USED
	Bu nick kullanlamaz.  Ltfen baka bir tane sein.
FORCENICKCHANGE_IN_1_MINUTE
	Eer bir dakika iinde nickinizi deitirmezseniz, Sistem size otomatik olarak yeni bir rumuz atayacaktr.
FORCENICKCHANGE_IN_20_SECONDS
	Eer 20 saniye iinde nickinizi deitirmezseniz, Sistem size otomatik olarak yeni bir rumuz atayacaktr.
FORCENICKCHANGE_NOW
	Bu nick kaytldr; bunu kullanamazsnz.
FORCENICKCHANGE_CHANGING
	Nickiniz %s olarak deitirildi.

# REGISTER responses
NICK_REGISTER_SYNTAX
	REGISTER ifreniz [emailiniz]
NICK_REGISTER_SYNTAX_EMAIL
	REGISTER ifreniz emailiniz
NICK_REGISTRATION_DISABLED
	Nick kayd geici olarak devre ddr.
NICK_REGISTRATION_FAILED
	Nick kayd baarsz.
NICK_REG_PLEASE_WAIT
	Ltfen %d saniye REGISTER komutunu tekrar kullanmak iin bekleyin.
NICK_CANNOT_BE_REGISTERED
	%s nicki kayt edilemez.
NICK_ALREADY_REGISTERED
	%s nicki zaten kaytl!
NICK_REGISTERED
	%s nicki sizin adnza kayt edildi: %s
NICK_REGISTERED_NO_MASK
	%s Rumuzu kaytl bulunuyor.
NICK_PASSWORD_IS
	Nick ifreniz %s - lerde kullanacanz iin unutmaynz ve kimseye sylemeyiniz.

# GROUP responses
NICK_REG_DELAY
	Rumuzunuzu kayt edebilmeniz icin baglant surenizden %d saniye sonra kayt ilemini denemelisiniz.

# GROUP responses
NICK_GROUP_SYNTAX
	GROUP hedef ifre
NICK_GROUP_DISABLED
	Nick gruplama geici olarak devre d.
NICK_GROUP_FAILED
	Nick gruplama baarsz.
NICK_GROUP_PLEASE_WAIT
	GROUP komutunu tekrar kullanmadan nce ltfen %d saniye bekleyin.
NICK_GROUP_CHANGE_DISABLED
	Nickiniz zaten kaytl; nce %R%s DROP yazn.
NICK_GROUP_SAME
	%s grubunun zaten bir yesisiniz.
NICK_GROUP_TOO_MANY
	%s nickinin grubunda ok fazla nick var; listeleyip birkaini silin.
	Daha fazla bilgi iin %R%s HELP GLIST ve %R%s HELP DROP 
	yazin.
NICK_GROUP_JOINED
	%s grubuna dahil edildiniz.

# IDENTIFY responses
NICK_IDENTIFY_SYNTAX
	IDENTIFY ifreniz
NICK_IDENTIFY_FAILED
	Tanmlama baarsz.
NICK_IDENTIFY_SUCCEEDED
	ifre kabul edildi.
NICK_IDENTIFY_EMAIL_REQUIRED
	imdi nickiniz iin bir e-mail adresi belirtmelisiniz.
	Bu e-mail adresi ifrenizi unutmanz halinde ifrenizi
	isterken kullanlacaktr.
NICK_IDENTIFY_EMAIL_HOWTO
	Mail adresinizi ayarlamak iin %R%S SET EMAIL e-mailadresiniz 
	yazn. Gizliliiniz korunacaktr; bu mail adresi herhangi nc 
	ahslara verilmeyecektir.

# LOGOUT responses
NICK_ALREADY_IDENTIFIED
	Rumuzunuzu zaten sisteme tantm durumdasnz.

# UPDATE responses
NICK_UPDATE_SUCCESS
	Durum gncellendi (Cevrimdisi mesajlar, ozel adres(vhost), ayarlar, yetkiler).
	
# LOGOUT responses
NICK_LOGOUT_SYNTAX
	LOGOUT
NICK_LOGOUT_SUCCEEDED
	Nickinizin k yapld.
NICK_LOGOUT_X_SUCCEEDED
	%s nickinin k yapld.

# DROP responses
NICK_LOGOUT_SERVICESADMIN
	Ck yaplamyor %s Servis grevlisi durumunda.

# DROP responses
NICK_DROP_DISABLED
	Nick kayd silinmesi geici olarak devre ddr.
NICK_DROPPED
	Nickinizin kayd silindi (dropped).
NICK_X_DROPPED
	%s nickinin kayd silindi (dropped).

# SET responses
NICK_SET_SYNTAX
	SET zellik parametre
NICK_SET_SERVADMIN_SYNTAX
	SET [nick] zellik parametre
NICK_SET_DISABLED
	NickServ'n SET komutu geici olarak devre ddr.
NICK_SET_UNKNOWN_OPTION
	Varolmayan SET zellii: %s.

# SET DISPLAY responses
NICK_SET_OPTION_DISABLED
	%s Fonksiyonu bu sunucuda devrede degildir.

# SET DISPLAY responses
NICK_SET_DISPLAY_INVALID
	Yeni gsterim nick grubunuzdan bir nick olmaldr!
NICK_SET_DISPLAY_CHANGED
	Yeni gsterim %s.

# SET PASSWORD responses
NICK_SET_PASSWORD_FAILED
	ifre deitirilemedi.
NICK_SET_PASSWORD_CHANGED
	ifreniz deitirildi.
NICK_SET_PASSWORD_CHANGED_TO
	Nick ifreniz %s olarak deitirildi.

# SET LANGUAGE responses
NICK_SET_LANGUAGE_SYNTAX
	SET LANGUAGE numara
NICK_SET_LANGUAGE_UNKNOWN
	Varolmayan dil numaras %d.  Dil listesi iin %R%s HELP SET LANGUAGE yazn.
NICK_SET_LANGUAGE_CHANGED
	Dil Trke olarak deitirildi.

# SET URL responses
NICK_SET_URL_CHANGED
	URL adresi %s olarak deitirildi.
NICK_SET_URL_UNSET
	URL adresi silindi.

# SET EMAIL responses
NICK_SET_EMAIL_CHANGED
	E-mail adresi %s olarak deitirildi.
NICK_SET_EMAIL_UNSET
	E-mail adresi silindi.
NICK_SET_EMAIL_UNSET_IMPOSSIBLE
	E-mail adresini bu networkte silemezsiniz.

# SET ICQ responses
NICK_SET_ICQ_CHANGED
	ICQ numaras %s olarak deitirildi.
NICK_SET_ICQ_UNSET
	ICQ numaras silindi.
NICK_SET_ICQ_INVALID
	%s geerli bir numara deil.
	
# SET GREET responses
NICK_SET_GREET_CHANGED
	Karlama mesaj %s olarak deitirildi.
NICK_SET_GREET_UNSET
	Karlama mesaj silindi.

# SET PROTECT responses
NICK_SET_KILL_SYNTAX
	SET KILL {ON | QUICK | OFF}
NICK_SET_KILL_IMMED_SYNTAX
	SET KILL {ON | QUICK | IMMED | OFF}
NICK_SET_KILL_ON
	Kill korumas: AKTF.
NICK_SET_KILL_QUICK
	Kill korumas: zaman limitli olarak AKTF.
NICK_SET_KILL_IMMED
	Annda kill korumas: AKTF.
NICK_SET_KILL_IMMED_DISABLED
	HEMEN seenei bu networkte aktif deil.
NICK_SET_KILL_OFF
	Kill korumas: KAPALI.

# SET SECURE responses
NICK_SET_SECURE_SYNTAX
	SET SECURE {ON | OFF}
NICK_SET_SECURE_ON
	Gvenlik seenei: AKTF.
NICK_SET_SECURE_OFF
	Gvenlik seenei: KAPALI.

# SET PRIVATE responses
NICK_SET_PRIVATE_SYNTAX
	SET PRIVATE {ON | OFF}
NICK_SET_PRIVATE_ON
	zel seenei: AKTF.
NICK_SET_PRIVATE_OFF
	zel seenei: KAPALI.

# SET HIDE responses
NICK_SET_HIDE_SYNTAX
	SET HIDE {EMAIL | USERMASK | QUIT} {ON | OFF}
NICK_SET_HIDE_EMAIL_ON
	Artk %s INFO da e-mail adresiniz gzkmeyecek.
NICK_SET_HIDE_EMAIL_OFF
	Artk %s INFO da e-mail adresiniz gzkecek.
NICK_SET_HIDE_MASK_ON
	Artk son grndnz user@host masknz %s INFO da gzkmeyecek.
NICK_SET_HIDE_MASK_OFF
	Artk son grndnz user@host masknz %s INFO da gzkecek.
NICK_SET_HIDE_QUIT_ON
	Artk son k mesajnz(/quit) %s INFO da gzkmeyecek.
NICK_SET_HIDE_QUIT_OFF
	Artk son k mesajnz(/quit) %s INFO da gzkecek.

# SET NOEXPIRE responses
NICK_SET_HIDE_STATUS_ON
	Artk %s INFO da servisler zerindeki yetkiniz gorunecek.
NICK_SET_HIDE_STATUS_OFF
	Servisler uzerindeki yetkiniz %s bilgilerinde gzkmeyecek.
	
# SET MSG responses
NICK_SET_MSG_SYNTAX
	SET PRIVATE {ON | OFF}
NICK_SET_MSG_ON
	Servisler bundan sonra size mesaj(Genel Mesaj) ile cevap verecek.
NICK_SET_MSG_OFF
	Servisler bundan sonra size notice(Uyar mesaj) ile cevap verecek.

# SET AUTOOP responses
NICK_SET_AUTOOP_SYNTAX
	SET AUTOOP {ON | OFF}
NICK_SET_AUTOOP_ON
	Services bundan sonra otomatik yetkilendirme yapacak.
NICK_SET_AUTOOP_OFF
	Services bundan sonra otomatik yetkilendirme yapmayacak.


# SET NOEXPIRE responses
NICK_SASET_SYNTAX
	SASET rumuz ayar parametereler
NICK_SASET_DISABLED
	zgnz, bu dzenleme komutu kapal durumdadr.
NICK_SASET_UNKNOWN_OPTION
	%s gecersiz bir dzenmele girdisidir.
NICK_SASET_BAD_NICK
	%s rumuzu kaytl bulunmuyor.
NICK_SASET_OPTION_DISABLED
	%s ayarlar bu sunucu uzerinde kullanlabilir durumda degildir.

# SASET DISPLAY responses
NICK_SASET_DISPLAY_INVALID
	%s grubu gecerli bir nick grubu degil!
NICK_SASET_DISPLAY_CHANGED
	%s Yeni nick grubu olarak ayarland.

# SASET PASSWORD responses
NICK_SASET_PASSWORD_FAILED
	zgnz, %s rumuzunun sifresi degitirilemedi.
NICK_SASET_PASSWORD_CHANGED
	%s rumuzunun sifresi degistirildi degistirildi.
NICK_SASET_PASSWORD_CHANGED_TO
	%s rumuzunun sifresi %s olarak degitirildi.

# SASET LANGUAGE responses
NICK_SASET_URL_CHANGED
	%s rumuzunun silgisi %s olarak degistirildi.
NICK_SASET_URL_UNSET
	%s Rumuzunun bilgisi silindi(Bilgi belirtilmemi konuma getirildi).

# SASET EMAIL responses
NICK_SASET_EMAIL_CHANGED
	%s rumuzunun silgisi %s olarak degistirildi.
NICK_SASET_EMAIL_UNSET
	%s Rumuzunun bilgisi silindi(Bilgi belirtilmemi konuma getirildi)..
NICK_SASET_EMAIL_UNSET_IMPOSSIBLE
	Mail adresi bu sunucu iin geersiz konuma alnabilecek bir bilgi degildir.
	
# SASET ICQ responses
NICK_SASET_ICQ_CHANGED
	%s rumuzunun silgisi %s olarak degistirildi.
NICK_SASET_ICQ_UNSET
	%s Rumuzunun bilgisi silindi(Bilgi belirtilmemi konuma getirildi).
NICK_SASET_ICQ_INVALID
	%s gecerli bir numara deil.
	
# SASET GREET responses
NICK_SASET_GREET_CHANGED
	%s rumuzunun silgisi %s olarak degistirildi.
NICK_SASET_GREET_UNSET
	%s Rumuzunun bilgisi silindi(Bilgi belirtilmemi konuma getirildi).

# SASET PROTECT responses
NICK_SASET_KILL_SYNTAX
	SASET nickname KILL {ON | QUICK | OFF}
NICK_SASET_KILL_IMMED_SYNTAX
	SASET nickname KILL {ON | QUICK | IMMED | OFF}
NICK_SASET_KILL_ON
	Koruma durumu ACIK deiiklik yaplan nick %s.
NICK_SASET_KILL_QUICK
	Koruma durumu ACIK deiiklik yaplan nick %s, ksa sureli koruma aktif.
NICK_SASET_KILL_IMMED
	Koruma durumu ACIK deiiklik yaplan nick %s, bekleme suresi olmayan koruma aktif.
NICK_SASET_KILL_IMMED_DISABLED
	IMMED bu sunucu icin gecerli bir rumuz koruma durumu degildir.
NICK_SASET_KILL_OFF
	Koruma durumu KAPALI deiiklik yaplan nick %s.

# SASET SECURE responses
NICK_SASET_SECURE_SYNTAX
	SASET nickname SECURE {ON | OFF}
NICK_SASET_SECURE_ON
	%s rumuzu icin koruma ozellidi AKTIF.
NICK_SASET_SECURE_OFF
	%s rumuzu icin koruma ozellidi PASIF.

# SASET PRIVATE responses
NICK_SASET_PRIVATE_SYNTAX
	SASET nickname PRIVATE {ON | OFF}
NICK_SASET_PRIVATE_ON
	%s Rumuzu icin Ozel mesaj cevaplama Aktif.
NICK_SASET_PRIVATE_OFF
	%s Rumuzu icin Ozel mesaj cevaplama Pasif.

# SASET HIDE responses
NICK_SASET_HIDE_SYNTAX
	SET nickname HIDE {EMAIL | USERMASK | QUIT} {ON | OFF}
NICK_SASET_HIDE_EMAIL_ON
	%s Rumuzuna ait bilgi %s INFO'da gosterime kapatld.
NICK_SASET_HIDE_EMAIL_OFF
	%s Rumuzuna ait bilgi %s INFO'da gosterime acld.
NICK_SASET_HIDE_MASK_ON
	%s Rumuzuna ait bilgi %s INFO'da gosterime kapatld.
NICK_SASET_HIDE_MASK_OFF
	%s Rumuzuna ait bilgi %s INFO'da gosterime acld.
NICK_SASET_HIDE_QUIT_ON
	%s Rumuzuna ait bilgi %s INFO'da gosterime kapatld.
NICK_SASET_HIDE_QUIT_OFF
	%s Rumuzuna ait bilgi %s INFO'da gosterime acld.
NICK_SASET_HIDE_STATUS_ON
	%s Rumuzuna ait bilgi %s INFO'da gosterime kapatld.
NICK_SASET_HIDE_STATUS_OFF
	%s Rumuzuna ait bilgi %s INFO'da gosterime acld..
	
# SASET MSG responses
NICK_SASET_MSG_SYNTAX
	SASET nickname PRIVATE {ON | OFF}
NICK_SASET_MSG_ON
	Services bundan sonra %s rumuzuna mesajlar ile cevap verecek.
NICK_SASET_MSG_OFF
	Services bundan sonra %s rumuzuna notices(uyarlar) ile cevap verecek.

# SET NOEXPIRE responses
NICK_SASET_NOEXPIRE_SYNTAX
	SASET nickname NOEXPIRE {ON | OFF}
NICK_SASET_NOEXPIRE_ON
	%s rumuzu zaman amna kapatld.
NICK_SASET_NOEXPIRE_OFF
	%s rumuzu zaman amna ald.

# ACCESS responses
NICK_SASET_AUTOOP_SYNTAX
	SASET nickname AUTOOP {ON | OFF}
NICK_SASET_AUTOOP_ON
	Servisler %s rumuzuna bundan sonra otomatik olarak yetkilerini verecek.
NICK_SASET_AUTOOP_OFF
	Servisler %s rumuzuna bundan sonra otomatik olarak yetkilerini veremeyecek.

# SASET LANGUAGE responses
NICK_SASET_LANGUAGE_SYNTAX
	SASET nickname LANGUAGE numara
NICK_SASET_LANGUAGE_UNKNOWN
	Bilinmeyen dil numaras %d.  Ltfen %R%s HELP SET LANGUAGE komutu ile diller ve kodlar hakknda bilgi alnz.
NICK_SASET_LANGUAGE_CHANGED
	Language for %s changed to %s.


# ACCESS responses
NICK_ACCESS_SYNTAX
	ACCESS {ADD | DEL | LIST} [mask]
NICK_ACCESS_ALREADY_PRESENT
	%s access listenizde zaten var.
NICK_ACCESS_REACHED_LIMIT
	Bir nick iin sadece %d tane access girilebilir.
NICK_ACCESS_ADDED
	%s access listenize eklendi.
NICK_ACCESS_NOT_FOUND
	%s access listenizde bulunamad.
NICK_ACCESS_DELETED
	%s access listenizden silindi.
NICK_ACCESS_LIST
	Access listesi:
NICK_ACCESS_LIST_X
	%s nickinin access listesi:
NICK_ACCESS_LIST_EMPTY
	Size ait yetki bulunamad.
NICK_ACCESS_LIST_X_EMPTY
	%s rumuzuna ait yetki bulunamad.

# Status messages
NICK_STATUS_0
	STATUS %s 0
NICK_STATUS_1
	STATUS %s 1
NICK_STATUS_2
	STATUS %s 2
NICK_STATUS_3
	STATUS %s 3

# INFO responses
NICK_INFO_SYNTAX
	INFO nick [ALL]
NICK_INFO_REALNAME
	   %s                isim: %s
NICK_INFO_SERVICES_OPER
	      %s servis operatrdr.
NICK_INFO_SERVICES_ADMIN
	      %s servis adminidir.
NICK_INFO_SERVICES_ROOT
	%s is a services root administrator.
NICK_INFO_ADDRESS
	      Son grld adres: %s
NICK_INFO_ADDRESS_ONLINE
	      Baland adres: %s
NICK_INFO_ADDRESS_ONLINE_NOHOST
	      %s u an bal.
NICK_INFO_TIME_REGGED
	          Kayt zaman: %s
NICK_INFO_LAST_SEEN
	   Son grld tarih: %s
NICK_INFO_LAST_QUIT
	      Son k mesaj: %s
NICK_INFO_URL
	                   URL: %s
NICK_INFO_EMAIL
	         E-mail adresi: %s
NICK_INFO_VHOST
	                 vhost: %s
NICK_INFO_VHOST2
	            	vhost: %s@%s
NICK_INFO_ICQ
	                 ICQ #: %d
NICK_INFO_GREET
	      Karlama mesaj: %s
NICK_INFO_OPTIONS
	            zellikler: %s
NICK_INFO_EXPIRE
	Zaman Am: %s
# These strings MUST NOT be empty
NICK_INFO_OPT_KILL
	Kill korumas
NICK_INFO_OPT_SECURE
	Gvenlik
NICK_INFO_OPT_PRIVATE
	zel
NICK_INFO_OPT_MSG
	Message mode
NICK_INFO_OPT_AUTOOP
	Auto-op
NICK_INFO_OPT_NONE
	YOK
NICK_INFO_NO_EXPIRE
	Bu nick zaman amna uramayacak.
NICK_INFO_FOR_MORE
	Geni bilgi iin, %R%s INFO %s ALL yazn.

# LIST responses
NICK_INFO_SUSPENDED
	Bu rumuz ' %s ' sebebinden dolay askya alnmstr kullanlamaz
NICK_INFO_SUSPENDED_NO_REASON
	Bu rumuz  alnmstr kullanlamaz

# LIST responses
NICK_LIST_SYNTAX
	LIST model
NICK_LIST_SERVADMIN_SYNTAX
	LIST model [FORBIDDEN] [SUSPENDED] [NOEXPIRE] [UNCONFIRMED]
NICK_LIST_HEADER
	%s ieren kaytlarn listesi:
NICK_LIST_RESULTS
	Liste sonu - %d/%d .

# GLIST responses
NICK_ALIST_SYNTAX
	ALIST nickname
NICK_ALIST_HEADER
	Channels that you have access on:
	  Num  Channel              Level    Description 
NICK_ALIST_HEADER_X
	Channels that %s has access on:
	  Num  Channel              Level    Description 
NICK_ALIST_XOP_FORMAT
	  %3d %c%-20s %-8s %s
NICK_ALIST_ACCESS_FORMAT
	  %3d %c%-20s %-8d %s
NICK_ALIST_FOOTER
	Liste sonu - %d/%d .

# GLIST responses
NICK_GLIST_HEADER
	Grubunuzdaki nicklerin listesi:
NICK_GLIST_HEADER_X
	%s grubundaki nicklerin listesi:
NICK_GLIST_FOOTER
	Grupta %d nick var.
NICK_GLIST_REPLY
	   %c%s
NICK_GLIST_REPLY_ADMIN
	   %c%s (zaman am %s)

# RECOVER responses
NICK_RECOVER_SYNTAX
	RECOVER nick [ifre]
NICK_NO_RECOVER_SELF
	Kendizi recover edemezsiniz!
NICK_RECOVERED
	Nickiniz serbest brakld.
	%R%s RELEASE %s komutunu kullanarak %s saniye icinde nickinizi kullanabilirsiniz.

# RELEASE responses
NICK_RELEASE_SYNTAX
	RELEASE nick [ifre]
NICK_RELEASE_NOT_HELD
	%s nicki zaten serbest.
NICK_RELEASED
	Nickiniz serbest brakld.

# GHOST responses
NICK_GHOST_SYNTAX
	GHOST nick [ifre]
NICK_NO_GHOST_SELF
	Kendinizi ghost edemezsiniz!
NICK_GHOST_KILLED
	Asl kalan nickiniz kill lendi.

# GETPASS responses
NICK_GETPASS_SYNTAX
	GETPASS nick
NICK_GETPASS_UNAVAILABLE
	GETPASS komutu devre d nk ifreleme(encryption) devrede.
NICK_GETPASS_PASSWORD_IS
	%s nickinin ifresi %s.

# SENDPASS responses
NICK_GETEMAIL_SYNTAX
	GETEMAIL kullancadi@emailsunucusu 
NICK_GETEMAIL_EMAILS_ARE
	%s Rumuzu %s adresini kullanyor.
NICK_GETEMAIL_NOT_USED
	%s icin bir bilgi bulunamad.
	
# SENDPASS responses
NICK_SENDPASS_SYNTAX
	SENDPASS nick
NICK_SENDPASS_UNAVAILABLE
	SENDPASS komutu devre d nk ifreleme(encryption) devrede.
NICK_SENDPASS_SUBJECT
	Nick ifresi (%s)
NICK_SENDPASS_HEAD
	Selam,
NICK_SENDPASS_LINE_1
	%s nickinizin ifresinin e-mail adresinize yollanmasn istemisiniz.
NICK_SENDPASS_LINE_2
	Nickinizin ifresi %s Gvenlik nedenlerinden dolay, bu maili aldktan sonra deitirseniz iyi olur.
NICK_SENDPASS_LINE_3
	Eer bu mailin neden size gnderildiini bilmiyorsanz, maili ciddiye almayn.
NICK_SENDPASS_LINE_4
	LTFEN BU MALE CEVAP VERMEYN!
NICK_SENDPASS_LINE_5
	%s ynetimi.
NICK_SENDPASS_OK
	%s nickinin ifresi gnderildi.

# FORBID responses
NICK_SUSPEND_SYNTAX
	SUSPEND nickname reason
NICK_SUSPEND_SUCCEEDED
	%s u anda askya alnd.
NICK_SUSPEND_FAILED
	%s rumuzu icin ilem yaplamad!

# UNSUSPEND responses
NICK_UNSUSPEND_SYNTAX
	UNSUSPEND nickname
NICK_UNSUSPEND_SUCCEEDED
	%s kullanma acld.
NICK_UNSUSPEND_FAILED
	%s rumuzu icin ilem yaplamad!

# FORBID responses
NICK_FORBID_SYNTAX
	FORBID nick [sebep]
NICK_FORBID_SYNTAX_REASON
	FORBID nick sebep
NICK_FORBID_SUCCEEDED
	%s nickinin Kullanm yasakland.
NICK_FORBID_FAILED
	%s nickinin Kullanm yasaklanamad!

###########################################################################
#
# ChanServ messages
#
###########################################################################

# Access level descriptions
NICK_REQUESTED
	Bu rumuz icin zaten bir kayt istegi bulunuyor, ltfen mail adresinizi kontrol ederek aktivasyon bilgilerini reniniz.
NICK_REG_RESENT
	Aktivasyon kodunuz %s adresine tekrar gnderildi.
NICK_REG_UNABLE
	Rumuz kayit edilemiyor, ltfen daha sonra tekrar deneyiniz.
NICK_IS_PREREG
	Bu rumuz e-mail adresinde bulunan aktivasyon ileminin sonucunu beklemektedir.
NICK_ENTER_REG_CODE
	Aktivasyon kodu %s adresine yolland, %R%s confirm <passcode> eklinde ilemi tamamlayabilirsiniz.
NICK_CONFIRM_NOT_FOUND
	Kayt ilemine balamak icin nce "%R%s register <password> <email>" eklinde bir kayt talebinde bulunmalsnz.
NICK_CONFIRM_INVALID
	Yanl aktivasyon kodu, mail adresinizi kontrol ederek tekrar deneyiniz.
NICK_REG_MAIL_SUBJECT
	Rumuz Kayt islemi (%s)
NICK_REG_MAIL_HEAD
	Merhabalar,
NICK_REG_MAIL_LINE_1
	%s Rumuzunu kayt etmek icin bir istekte bulundunuz.
NICK_REG_MAIL_LINE_2
	Irc Sunucusu zerinde " %R%s confirm %s " komutunu kullanarak kayt ileminizi tamamlayabilirsiniz.
NICK_REG_MAIL_LINE_3
	Eer bu postann neden gnderildii hakknda bir bilginiz yok ise ltfen postay silerek adresi engelleyiniz.
NICK_REG_MAIL_LINE_4
	LTFEN BU POSTAYA CEVAP ATMAYINIZ!
NICK_REG_MAIL_LINE_5
	%s Sunucusu Yneticisi.
NICK_GETPASS_PASSCODE_IS
	%s rumuzu icin gerekli aktivasyon kodu %s.
NICK_FORCE_REG
	%s rumuzu onayland.

###########################################################################
#
# ChanServ messages
#
###########################################################################

# Access level descriptions
CHAN_LEVEL_AUTOOP
	Kanala girite ChanServ tarafndan otomatik op (+o)
CHAN_LEVEL_AUTOVOICE
	Kanala girite ChanServ tarafndan otomatik voice (+v)
CHAN_LEVEL_AUTOHALFOP
	Kanala girite ChanServ tarafndan otomatik yarm op (+h)
CHAN_LEVEL_AUTOPROTECT
	Kanala girite ChanServ tarafndan otomatik koruma (+a)
CHAN_LEVEL_AUTODEOP
	Kanal iinde op olmasn yasaklar.
CHAN_LEVEL_NOJOIN
	RESTRICTED zelliinin aktif olmas halinde kanala giremez.
CHAN_LEVEL_INVITE
	INVITE komutunu kullanmaya izinlidir.
CHAN_LEVEL_AKICK
	AKICK komutunu kullanmaya izinlidir.
CHAN_LEVEL_SET
	SET komutunu (FOUNDER/PASSWORD hari) kullanmaya izinlidir.
CHAN_LEVEL_CLEAR
	CLEAR komutunu kullanmaya izinlidir.
CHAN_LEVEL_UNBAN
	UNBAN komutunu kullanmaya izinlidir.
CHAN_LEVEL_OPDEOP
	OP/DEOP komutlarn kullanmaya izinlidir.
CHAN_LEVEL_ACCESS_LIST
	Kanaln Access listesini grntlemeye izinlidir.
CHAN_LEVEL_ACCESS_CHANGE
	Kanaln Access listesinde deiiklik yapmaya izinlidir.
CHAN_LEVEL_MEMO
	Kanala gelen mesajlari listelemeye/okumaya izinlidir.
CHAN_LEVEL_ASSIGN
	Botun assign/unassign komutlarn kullanmaya izinlidir.
CHAN_LEVEL_BADWORDS
	BADWORDS komutunu kullanmaya izinlidir.
CHAN_LEVEL_NOKICK
	Bot tarafndan kicklenmemeyi salar.
CHAN_LEVEL_FANTASIA
	Kanalda fantazi komutlarn kullanmaya izinlidir. 
CHAN_LEVEL_SAY
	SAY ve ACT komutlarn kullanmaya izinlidir.
CHAN_LEVEL_GREET
	Karlama mesaj alabilir.
CHAN_LEVEL_VOICEME
	Kendini (de)voice etmeye izinlidir.
CHAN_LEVEL_VOICE
	VOICE/DEVOICE komutlarn kullanmaya izinlidir.
CHAN_LEVEL_GETKEY
	GETKEY komutunu kullanmaya izinlidir.
CHAN_LEVEL_OPDEOPME
	Kendini (de)op etmeye izinlidir.
CHAN_LEVEL_HALFOPME
	Kendini (de)halfop etmeye izinlidir.
CHAN_LEVEL_HALFOP
	HALFOP/DEHALFOP komutlarn kullanmaya izinlidir.
CHAN_LEVEL_PROTECTME
	Kendini (de)protect etmeye izinlidir.
CHAN_LEVEL_PROTECT
	PROTECT/DEPROTECT komutlarn kullanmaya izinlidir.
CHAN_LEVEL_KICKME
	Kendini atmaya izinlidir.
CHAN_LEVEL_KICK
	KICK komutunu kullanmaya izinlidir.
CHAN_LEVEL_SIGNKICK
	SIGNKICK LEVEL kullanldnda iaretli atma yaplmaz.
CHAN_LEVEL_BANME
	Kendini banlamaya yetkili
CHAN_LEVEL_BAN
	BAN komutunu kullanmaya yetkili
CHAN_LEVEL_TOPIC
	TOPIC komutunu kullanmaya yetkili
CHAN_LEVEL_INFO
	INFO komutunu ALL seenegiyle kullanmaya yetkili

# Automatic responses
CHAN_IS_REGISTERED
	Bu kanal %s ile kaytldr.
CHAN_NOT_ALLOWED_OP
	%s kanalnda op olmaya yetkiniz yok.
CHAN_MAY_NOT_BE_USED
	Bu kanal kullanlamaz.
CHAN_NOT_ALLOWED_TO_JOIN
	Bu kanalda bulunmanza msaade yok.

# REGISTER responses
CHAN_X_INVALID
	%s geerli bir kanal deil.

# REGISTER responses
CHAN_REGISTER_SYNTAX
	REGISTER kanalad ifre aklama
CHAN_REGISTER_DISABLED
	Kanal kayd geici olarak devre ddr.
CHAN_REGISTER_NOT_LOCAL
	Local kanallar kayt edilemezler.
CHAN_MUST_REGISTER_NICK
	nce nickinizi kayt etmeniz gerekiyor.  Nick kayt hakknda bilgi iin %R%s HELP yaznz.
CHAN_MUST_IDENTIFY_NICK
	Ltfen nce %s ile bu komutu kullanarak nickinizi tantn:
	%R%s IDENTIFY ifreniz
CHAN_MAY_NOT_BE_REGISTERED
	%s kanal kayt edilemez.
CHAN_ALREADY_REGISTERED
	%s kanal zaten kaytl!
CHAN_MUST_BE_CHANOP
	Kanal kayt edebilmeniz iin kayt edilmemi bir kanala ilk girip op olmanz gerekmektedir.
CHAN_REACHED_CHANNEL_LIMIT
	%d kanallk limitinizi doldurdunuz.
CHAN_EXCEEDED_CHANNEL_LIMIT
	%d kanallk limitinizi atnz.
CHAN_REGISTRATION_FAILED
	Kanal kayd baarsz.
CHAN_REGISTERED
	%s kanal bu nicke kayt edildi: %s
CHAN_PASSWORD_IS
	Kanal ifreniz %s - ilerde kullanacanz iin unutmaynz ve kimseye sylemeyiniz.
CHAN_REGISTER_NONE_CHANNEL
	Geersiz bir kanal kaydetmek istiyorsunuz %s
CHAN_SYMBOL_REQUIRED
	Kanal kayt etmek iin # sembolunu kanal isminin bana eklemeniz gereklidir.


# IDENTIFY responses
CHAN_IDENTIFY_SYNTAX
	IDENTIFY kanalad ifreniz
CHAN_IDENTIFY_FAILED
	Geersiz ifre.
CHAN_IDENTIFY_SUCCEEDED
	ifre kabul edildi - %s kanalnda founder seviyesinde eriim kazandnz.

# LOGOUT responses
CHAN_LOGOUT_SYNTAX
	LOGOUT kanalad nick
CHAN_LOGOUT_SERVADMIN_SYNTAX
	LOGOUT kanalad [nick]
CHAN_LOGOUT_SUCCEEDED
	Kullanc %s artk %s kanal tarafndan tannmyor.
CHAN_LOGOUT_ALL_SUCCEEDED
	Tm tanml kullanclar artk %s kanal tarafndan tannmyor (kanal sahibi haric).
CHAN_LOGOUT_FOUNDER_FAILED
	%s Kanalndan yetki cks yapamazsnz (kanal sahibi sizsiniz).

# DROP responses
CHAN_DROP_SYNTAX
	DROP kanalad
CHAN_DROP_DISABLED
	Kanal kaydnn silinmesi(DROP) geici olarak devre ddr.
CHAN_DROPPED
	%s kanalnn kayd silinmitir (dropped).

# SET responses
CHAN_SET_SYNTAX
	SET kanalad zellik parametre
CHAN_SET_DISABLED
	Chanserv'n SET komutu geici olarak devre ddr.
CHAN_SET_UNKNOWN_OPTION
	Varolmayan SET zellii: %s.

# SET FOUNDER responses
CHAN_SET_FOUNDER_TOO_MANY_CHANS
	%s ok fazla kanala sahip.
CHAN_FOUNDER_CHANGED
	%s kanalnn founder %s olarak deitirildi.

# SET SUCCESSOR responses
CHAN_SUCCESSOR_CHANGED
	%s iin successor %s olarak deitirildi.
CHAN_SUCCESSOR_UNSET
	%s iin successor kaldrld.
CHAN_SUCCESSOR_IS_FOUNDER
	%s %s kanalnda successor olamaz nk zaten o kanaln founder.

# SET PASSWORD responses
CHAN_SET_PASSWORD_FAILED
	ifre deiimi baarsz.
CHAN_PASSWORD_CHANGED
	%s kanalnn ifresi deitirildi.
CHAN_PASSWORD_CHANGED_TO
	%s kanalnn ifresi %s olarak deitirildi.

# SET DESC responses
CHAN_DESC_CHANGED
	%s kanalnn aklamas %s olarak deitirildi.

# SET URL responses
CHAN_URL_CHANGED
	%s kanalnn URL adresi %s olarak deitirildi.
CHAN_URL_UNSET
	%s kanalnn URL adresi kaldrld.

# SET EMAIL responses
CHAN_EMAIL_CHANGED
	%s kanalnn e-mail adresi %s olarak deitirildi.
CHAN_EMAIL_UNSET
	%s kanalnn e-mail adresi kaldrld.

# SET ENTRYMSG responses
CHAN_ENTRY_MSG_CHANGED
	%s kanalnn giri mesaj deitirildi.
CHAN_ENTRY_MSG_UNSET
	%s kanalnn giri mesaj kaldrld.
	
# SET BANTYPE responses
CHAN_SET_BANTYPE_INVALID
	%s geerli bir ban tipi deil.
CHAN_SET_BANTYPE_CHANGED
	%s kanalnn ban tipi #%d olarak deitirildi.

# SET MLOCK responses
CHAN_SET_MLOCK_UNKNOWN_CHAR
	Varolmayan mod karakteri %c yoksayld.
CHAN_SET_MLOCK_IMPOSSIBLE_CHAR
	%c modunu kitleyemezsiniz, yoksayildi.
CHAN_SET_MLOCK_L_REQUIRED
	+L modunu kullanabilmek iin +l modunuda kullanmalisiniz.
CHAN_SET_MLOCK_K_REQUIRED
	+K modunu kullanabilmek iin +i modunuda kullanmalisiniz.
CHAN_MLOCK_CHANGED
	%s kanalnn mod kilidi %s olarak deitirildi.

# SET KEEPTOPIC responses
CHAN_SET_KEEPTOPIC_SYNTAX
	SET kanalad KEEPTOPIC {ON | OFF}
CHAN_SET_KEEPTOPIC_ON
	Kanal bal saklama %s kanal iin aktif duruma gecti.
CHAN_SET_KEEPTOPIC_OFF
	Kanal bal saklama %s kanal iin pasif duruma gecti.

# SET TOPICLOCK responses
CHAN_SET_TOPICLOCK_SYNTAX
	SET kanalad TOPICLOCK {ON | OFF}
CHAN_SET_TOPICLOCK_ON
	Kanal bal kilidi %s kanal iin aktif duruma gecti.
CHAN_SET_TOPICLOCK_OFF
	Kanal bal kilidi %s kanal iin pasif duruma gecti.

# SET PEACE responses
CHAN_SET_PEACE_SYNTAX
	SET kanaladi PEACE {ON | OFF}
CHAN_SET_PEACE_ON
	Bari secenegi %s kanal icin aktif.
CHAN_SET_PEACE_OFF
	Bari secenegi %s kanal icin pasif.

# SET PRIVATE responses
CHAN_SET_PRIVATE_SYNTAX
	SET kanalad PRIVATE {ON | OFF}
CHAN_SET_PRIVATE_ON
	zel kanal konumu %s kanal icin  aktif.
CHAN_SET_PRIVATE_OFF
	zel kanal konumu %s kanal icin  pasif.

# SET SECUREOPS responses
CHAN_SET_SECUREOPS_SYNTAX
	SET kanalad SECUREOPS {ON | OFF}
CHAN_SET_SECUREOPS_ON
	Operator korumas %s kanal icin  aktif.
CHAN_SET_SECUREOPS_OFF
	Operator korumas %s kanal icin  pasif.

# SET SECUREFOUNDER responses
CHAN_SET_SECUREFOUNDER_SYNTAX
	SET kanalad SECUREFOUNDER {ON | OFF}
CHAN_SET_SECUREFOUNDER_ON
	Kanal Sahibi korumas %s kanal icin  aktif.
CHAN_SET_SECUREFOUNDER_OFF
	Kanal Sahibi korumas %s kanal icin  pasif.

# SET RESTRICTED responses
CHAN_SET_RESTRICTED_SYNTAX
	SET kanalad RESTRICTED {ON | OFF}
CHAN_SET_RESTRICTED_ON
	Ayrcalkl giri %s kanal icin  aktif.
CHAN_SET_RESTRICTED_OFF
	Ayrcalkl giri %s kanal icin  pasif.

# SET SECURE responses
CHAN_SET_SECURE_SYNTAX
	SET kanal SECURE {ON | OFF}
CHAN_SET_SECURE_ON
	Yetki seviyesi korumasi %s kanal icin  aktif.
CHAN_SET_SECURE_OFF
	Yetki seviyesi korumasi %s kanal icin  pasif.

# SET SIGNKICK responses
CHAN_SET_SIGNKICK_SYNTAX
	SET kanalad SIGNKICK {ON | LEVEL | OFF}
CHAN_SET_SIGNKICK_ON
	%s Kanalnda kullanlan atma komutlar icin imza gosterimi aktif.
CHAN_SET_SIGNKICK_LEVEL
	%s kanal icin yetki kullanan kisi gosterimi aktif, fakat
	kanal icinde ayma komutu uygulanan kiinin yetkisi gz nnde tutulur.
CHAN_SET_SIGNKICK_OFF
	%s Kanalnda kullanlan atma komutlar icin imza gosterimi pasif.

# SET OPNOTICE responses
CHAN_SET_OPNOTICE_SYNTAX
	SET kanalad OPNOTICE {ON | OFF}
CHAN_SET_OPNOTICE_ON
	Op-notice  %s kanal icin ON.
CHAN_SET_OPNOTICE_OFF
	Op-notice  %s kanal icin OFF.

# SET XOP responses
CHAN_SET_XOP_SYNTAX
	SET kanaladi XOP {ON | OFF}
CHAN_SET_XOP_ON
	xOP listesi %s kanal icin ON.
CHAN_SET_XOP_OFF
	xOP listesi  %s kanal icin OFF.

# SET NOEXPIRE responses
CHAN_SET_NOEXPIRE_SYNTAX
	SET kanalad NOEXPIRE {ON | OFF}
CHAN_SET_NOEXPIRE_ON
	%s kanal zaman amndan karld.
CHAN_SET_NOEXPIRE_OFF
	%s kanal zaman amna eklendi.

# xOP messages
CHAN_XOP_REACHED_LIMIT
	Bir kanala toplam %d AOP/SOP/VOP kayit edilebilir.
CHAN_XOP_LIST_FORMAT
	  %3d  %s
CHAN_XOP_ACCESS
	Bu komutu kullanamazsiniz. Yerine ACCESS komutunu kullanin.
	Daha fazla bilgi iin %R%s HELP ACCESS yazin.
CHAN_XOP_NOT_AVAILABLE
	xOP sistemi geerli degil.

# AOP messages
CHAN_AOP_SYNTAX
	AOP kanal {ADD|DEL|LIST|CLEAR} [nick | liste-no]
CHAN_AOP_DISABLED
	Kanal AOP listesi degisiklikleri geici olarak devre disidir.
CHAN_AOP_NICKS_ONLY
	Kanal AOP listeleri sadece kayitli nicklerden olusabilir.
CHAN_AOP_ADDED
	%s %s kanalinin AOP listesine eklenmistir.
CHAN_AOP_MOVED
	%s nicki %s kanal AOP listesine tand.
CHAN_AOP_NO_SUCH_ENTRY
	(#%d) %s kanalinin AOP listesinde byle bir kayit bulunamadi.
CHAN_AOP_NOT_FOUND
	%s %s kanali AOP listesinde bulunamadi.
CHAN_AOP_NO_MATCH
	%s kanali AOP listesinde uyusan kayit bulunamadi.
CHAN_AOP_DELETED
	%s %s kanali AOP listesinden silindi.
CHAN_AOP_DELETED_ONE
	%s kanalinin AOP listesinden 1 kayit silindi.
CHAN_AOP_DELETED_SEVERAL
	Deleted %d entries from %s AOP list.
CHAN_AOP_LIST_EMPTY
	%s kanalinin AOP listesi bos.
CHAN_AOP_LIST_HEADER
	%s kanali AOP listesi:
	  Num  Nick
CHAN_AOP_CLEAR
	Kanalin %s AOP listesi temizlendi.

# HOP messages
CHAN_HOP_SYNTAX
	HOP kanaladi {ADD|DEL|LIST|CLEAR} [nick | liste-no]
CHAN_HOP_DISABLED
	Kanal HOP listesi degisiklikleri geici olarak devre disidir.
CHAN_HOP_NICKS_ONLY
	Kanal HOP listeleri sadece kayitli nicklerden olusabilir.
CHAN_HOP_ADDED
	%s %s kanali HOP listesine eklendi.
CHAN_HOP_MOVED
	%s nicki %s kanal HOP listesine tand.
CHAN_HOP_NO_SUCH_ENTRY
	(#%d) %s kanali HOP listesinde uyusan kayit bulunamadi.
CHAN_HOP_NOT_FOUND
	%s %s kanali HOP listesinde bulunamadi.
CHAN_HOP_NO_MATCH
	%s kanali HOP listesinde uyusan kayit bulunamadi.
CHAN_HOP_DELETED
	%s %s kanali HOP listesinden silindi.
CHAN_HOP_DELETED_ONE
	%s kanali HOP listesinden 1 kayit silindi.
CHAN_HOP_DELETED_SEVERAL
	Deleted %d entries from %s HOP list.
CHAN_HOP_LIST_EMPTY
	%s kanali HOP listesi bos.
CHAN_HOP_LIST_HEADER
	%s kanali HOP listesi:
	  Num  Nick
CHAN_HOP_CLEAR
	Kanal %s HOP listesi temizlendi.

# SOP messages
CHAN_SOP_SYNTAX
	SOP kanaladi {ADD|DEL|LIST|CLEAR} [nick | liste-no]
CHAN_SOP_DISABLED
	Kanal SOP listesi degisikligi geici olarak devre disidir.
CHAN_SOP_NICKS_ONLY
	Kanal SOP listesi sadece kayitli nicklerden olusabilir.
CHAN_SOP_ADDED
	%s %s kanali SOP listesine eklendi.
CHAN_SOP_MOVED
	%s nicki %s kanal SOP listesine tand.
CHAN_SOP_NO_SUCH_ENTRY
	(#%d) %s kanali SOP listesinde uyusan kayit bulunamadi.
CHAN_SOP_NOT_FOUND
	%s %s kanali SOP listesinde bulunamadi.
CHAN_SOP_NO_MATCH
	%s kanali SOP listesinde uyusan kayit bulunamadi.
CHAN_SOP_DELETED
	%s %s kanali SOP listesinden silindi.
CHAN_SOP_DELETED_ONE
	%s kanali SOP listesinden 1 kayit silindi.
CHAN_SOP_DELETED_SEVERAL
	Deleted %d entries from %s SOP list.
CHAN_SOP_LIST_EMPTY
	%s kanali SOP listesi bos.
CHAN_SOP_LIST_HEADER
	%s kanali SOP listesi:
	  Num  Nick
CHAN_SOP_CLEAR
	Kanal %s SOP listesi temizlendi.

# VOP messages
CHAN_VOP_SYNTAX
	VOP kanaladi {ADD|DEL|LIST|CLEAR} [nick | liste-no]
CHAN_VOP_DISABLED
	Kanal VOP listesi degisikligi geici olarak devre disidir.
CHAN_VOP_NICKS_ONLY
	Kanal VOP listeleri sadece kayitli nicklerden olusabilir.
CHAN_VOP_ADDED
	%s %s kanali VOP listesine eklendi.
CHAN_VOP_MOVED
	%s nicki %s kanal VOP listesine tand.
CHAN_VOP_NO_SUCH_ENTRY
	(#%d) %s kanali VOP listesinde uyusan kayit bulunamadi.
CHAN_VOP_NOT_FOUND
	%s %s kanali VOP listesinde bulunamadi.
CHAN_VOP_NO_MATCH
	%s kanali VOP listesinde uyusan kayit bulunamadi.
CHAN_VOP_DELETED
	%s %s kanali VOP listesinden silindi.
CHAN_VOP_DELETED_ONE
	%s kanali VOP listesinden 1 kayit silindi.
CHAN_VOP_DELETED_SEVERAL
	Silindi %d VOP listesinden kayit %s kanali.
CHAN_VOP_LIST_EMPTY
	%s kanali VOP listesi bos.
CHAN_VOP_LIST_HEADER
	%s kanali VOP listesi:
	  Num  Nick
CHAN_VOP_CLEAR
	Kanal %s VOP listesi temizlendi.

# ACCESS messages
CHAN_ACCESS_SYNTAX
	ACCESS kanalad {ADD|DEL|LIST|CLEAR} [nick [seviye] | kayt-listesi]
CHAN_ACCESS_XOP
	Bu komutu kullanamazsiniz. 
	Yerine AOP, SOP veya VOP komutlarini kullanin.
	Daha fazla bilgi iin %R%s HELP komut yazin.
CHAN_ACCESS_XOP_HOP
	Bu komutu kullanamazsnz. 
	AOP, SOP, HOP ve VOP komutlarn deneyiniz.
	%R%s HELP command eklinde daha ayrntl bilgi elde edebilirsiniz.
CHAN_ACCESS_DISABLED
	Kanal access listesinin deitirilmesi geici olarak devre ddr.
CHAN_ACCESS_LEVEL_NONZERO
	Access seviyesi sfrdan farkl bir say olmaldr.
CHAN_ACCESS_LEVEL_RANGE
	Access seviyesi %d ve %d arasnda olmaldr.
CHAN_ACCESS_NICKS_ONLY
	Kanal access listesi sadece kaytl kullanclar iermelidir.
CHAN_ACCESS_REACHED_LIMIT
	Kanalda sadece %d tane access kayd olabilir.
CHAN_ACCESS_LEVEL_UNCHANGED
	%s nickinin access seviyesi %s kanalnda zaten %d.
CHAN_ACCESS_LEVEL_CHANGED
	%s nickinin access seviyesi %s kanalnda %d olarak deitirildi.
CHAN_ACCESS_ADDED
	%s nicki %s kanalinin access listesine %d seviyeden eklendi.
CHAN_ACCESS_NO_SUCH_ENTRY
	(#%d) eklinde bir kayt %s kanalnn access listesinde bulunamad.
CHAN_ACCESS_NOT_FOUND
	%s %s kanalnn access listesinde bulunamad.
CHAN_ACCESS_NO_MATCH
	Uyuan kayt %s kanalnn access listesinde yok.
CHAN_ACCESS_DELETED
	%s %s kanalnn access listesinden silindi.
CHAN_ACCESS_DELETED_ONE
	%s kanalnn access listesinden 1 kayt silindi.
CHAN_ACCESS_DELETED_SEVERAL
	Deleted %d entries from %s access list.
CHAN_ACCESS_LIST_EMPTY
	%s kanalnn access listesi bo.
CHAN_ACCESS_LIST_HEADER
	%s kanal iin access listesi:
	  Sra   Seviye  Nick
CHAN_ACCESS_LIST_FOOTER
	access listenin sonu.
CHAN_ACCESS_LIST_XOP_FORMAT
	  %3d   %s  %s
CHAN_ACCESS_LIST_AXS_FORMAT
	  %3d  %4d  %s
CHAN_ACCESS_CLEAR
	Kanal %s access listesi temizlendi.

# AKICK responses
CHAN_AKICK_SYNTAX
	AKICK kanalad {ADD | STICK | UNSTICK | DEL | LIST | VIEW | ENFORCE | CLEAR} [nick-veya-usermask] [sebep]
CHAN_AKICK_DISABLED
	Kanal Akick listesinin deitirilmesi geici olarak devre ddr.
CHAN_AKICK_ALREADY_EXISTS
	%s nicki %s kanalnn akick listesinde zaten var.
CHAN_AKICK_REACHED_LIMIT
	Bir kanaln akick listesinde en fazla %d kii olabilir.
CHAN_AKICK_ADDED
	%s nicki %s kanalnn akick listesine eklendi.
CHAN_AKICK_NO_SUCH_ENTRY
	(#%d) eklinde bir kayt %s kanalnn akick listesinde bulunamad.
CHAN_AKICK_NOT_FOUND
	%s %s kanalnn akick listesinde bulunamad.
CHAN_AKICK_NO_MATCH
	Uyuan kayt %s kanalnn akick listesinde bulunamad.
CHAN_AKICK_STUCK
	%s artik %s kanalinda srekli aktif.
CHAN_AKICK_UNSTUCK
	%s artik %s kanalinda srekli aktif degil.
CHAN_AKICK_DELETED
	%s %s kanalnn akick listesinden silindi.
CHAN_AKICK_DELETED_ONE
	%s kanalnn akick listesinden 1 kayt silindi.
CHAN_AKICK_DELETED_SEVERAL
	Deleted %d entries from %s autokick list.
CHAN_AKICK_LIST_EMPTY
	%s kanalnn akick listesi bo.
CHAN_AKICK_LIST_HEADER
	%s kanalnn akick listesi:
CHAN_AKICK_LIST_FORMAT
	  %3d %s (%s)
CHAN_AKICK_VIEW_FORMAT
	%3d %s (by %s on %s)
	    %s
CHAN_AKICK_VIEW_FORMAT_STUCK
	%3d %s (kalici) (by %s on %s)
	    %s
CHAN_AKICK_ENFORCE_DONE
	 %s iin AKICK uygulamas tamam; %d kullanc iin geerli.
CHAN_AKICK_CLEAR
	Kanal %s akick listesi temizlendi.

# LEVELS responses
CHAN_LEVELS_SYNTAX
	LEVELS kanalad {SET | DIS[ABLE] | LIST | RESET} [madde [seviye]]
CHAN_LEVELS_XOP
	Bu modda bu komut kullanilmaz.
CHAN_LEVELS_RANGE
	Level %d ile %d arasnda olmaldr.
CHAN_LEVELS_CHANGED
	%s iin level %s kanalnda %d olarak deitirildi.
CHAN_LEVELS_UNKNOWN
	Varolmayan ayar: %s. Geerli ayar listesi iin %R%s HELP LEVELS DESC yaznz.
CHAN_LEVELS_DISABLED
	%s %s kanalnda iptal edildi.
CHAN_LEVELS_LIST_HEADER
	%s kanal iin access level ayarlar:
CHAN_LEVELS_LIST_DISABLED
	    %-*s  (kapatld)
CHAN_LEVELS_LIST_FOUNDER
	    %-*s  (sadece founder)
CHAN_LEVELS_LIST_NORMAL
	    %-*s  %d
CHAN_LEVELS_RESET
	%s iin access levelleri varsaylanlarla deitirildi.

# Status Messages
CHAN_STATUS_SYNTAX
	Durum HATASI
CHAN_STATUS_NOT_REGGED
	Durum HATASI %s kanal kaytl degil
CHAN_STATUS_FORBIDDEN
	Durum HATASI %s kanal yasakl
CHAN_STATUS_NOTONLINE
	Durum HATASI Nic %s sunucuda degil
CHAN_STATUS_INFO
	Durum %s %s %d

# INFO responses
CHAN_INFO_SYNTAX
	INFO kanalad [ALL]
CHAN_INFO_HEADER
	%s kanal iin bilgi:
CHAN_INFO_FOUNDER
	        Kanal Sahibi: %s (%s)
CHAN_INFO_NO_FOUNDER
	        Kanal Sahibi: %s
CHAN_INFO_SUCCESSOR
	      Kanal vrisi: %s (%s)
CHAN_INFO_NO_SUCCESSOR
	      Kanal vrisi: %s
CHAN_INFO_DESCRIPTION
	       Aklama: %s
CHAN_INFO_ENTRYMSG
	   Giri mesaj: %s
CHAN_INFO_TIME_REGGED
	   Kayt tarihi: %s
CHAN_INFO_LAST_USED
	 Son kullanl: %s
CHAN_INFO_LAST_TOPIC
	      Son topic: %s
CHAN_INFO_TOPIC_SET_BY
	   Topici yazan: %s
CHAN_INFO_URL
	            URL: %s
CHAN_INFO_EMAIL
	  E-mail adresi: %s
CHAN_INFO_BANTYPE
	       Ban tipi: %d
CHAN_INFO_OPTIONS
	     zellikler: %s
CHAN_INFO_OPT_KEEPTOPIC
	Topic hatrlama
CHAN_INFO_OPT_OPNOTICE
	OP Notu
CHAN_INFO_OPT_PEACE
	Baris
CHAN_INFO_OPT_PRIVATE
	zel
CHAN_INFO_OPT_RESTRICTED
	Kisitli Erisim.
CHAN_INFO_OPT_SECURE
	Gvenlik
CHAN_INFO_OPT_SECUREOPS
	Secure Ops
CHAN_INFO_OPT_SECUREFOUNDER
	Secure Founder
CHAN_INFO_OPT_SIGNKICK
	aretli atma
CHAN_INFO_OPT_TOPICLOCK
	Topic kilidi
CHAN_INFO_OPT_XOP
	xOP sistemi
CHAN_INFO_OPT_NONE
	YOK
CHAN_INFO_MODE_LOCK
	     Mod kilidi: %s
CHAN_INFO_EXPIRE
	      Zaman Am: %s
CHAN_INFO_NO_EXPIRE
	Bu kanal iin zaman am sz konusu deil.

# LIST responses
CHAN_LIST_SYNTAX
	LIST model
CHAN_LIST_SERVADMIN_SYNTAX
	LIST model [FORBIDDEN] [NOEXPIRE]
CHAN_LIST_HEADER
	%s ile uyuan kayt listesi:
CHAN_LIST_FORMAT
	    %-20s  %s
CHAN_LIST_END
	Liste sonu - %d/%d uyan kayt bulundu.

# CLIST responses
CHAN_INVITE_SYNTAX
	INVITE kanalad

# UNBAN responses
CHAN_UNBAN_SYNTAX
	UNBAN kanalad
CHAN_UNBANNED
	%s kanalndaki bannz kaldrld.

# TOPIC responses
CHAN_TOPIC_SYNTAX
	TOPIC kanaladi [konu]

# CLEAR responses
CHAN_CLEAR_SYNTAX
	CLEAR kanalad neyi
CHAN_CLEARED_BANS
	%s kanalndaki tm banlar kaldrld.
CHAN_CLEARED_EXCEPTS
	%s kanalndaki tm ayrcalklar kaldrld.
CHAN_CLEARED_MODES
	%s kanalndaki tm modlar resetlendi.
CHAN_CLEARED_OPS
	Mod +o %s kanalnda temizlendi.
CHAN_CLEARED_HOPS
	Mod +h  %s kanalnda temizlendi.
CHAN_CLEARED_VOICES
	Mod +v %s kanalnda temizlendi.
CHAN_CLEARED_USERS
	%s kanalndaki tm kullanclar atld.
CHAN_CLEARED_INVITES
	%s kanaldaki tm davetler kaldrld.

# GETPASS responses
CHAN_GETPASS_SYNTAX
	GETPASS kanalad
CHAN_GETPASS_UNAVAILABLE
	GETPASS komutu devre d nk ifreleme(encryption) devrede.
CHAN_GETPASS_PASSWORD_IS
	%s kanalnn ifresi %s.
	
# SENDPASS responses
CHAN_GETKEY_SYNTAX
	GETKEY channel
CHAN_GETKEY_NOKEY
	%s kanal sifreli degil.
CHAN_GETKEY_KEY
	KEY %s %s

# SENDPASS responses
CHAN_SENDPASS_SYNTAX
	SENDPASS kanalad
CHAN_SENDPASS_UNAVAILABLE
	SENDPASS komutu devre d nk ifreleme(encryption) devrede.
CHAN_SENDPASS_SUBJECT
	Kanal ifresi (%s)
CHAN_SENDPASS_HEAD
	Selam,
CHAN_SENDPASS_LINE_1
	%s kanalnzn ifresinin e-mail adresinize gnderilmesini istemisiniz.
CHAN_SENDPASS_LINE_2
	Kanal ifresi %s. Gvenlik nedenlerinden dolay, ifrenizi bu maili aldktan sonra deitirirseniz iyi olur.
CHAN_SENDPASS_LINE_3
	Eer bu mailin niye size gnderildiini bilmiyorsanz, ltfen ciddiye almayn.
CHAN_SENDPASS_LINE_4
	LTFEN BU MALE CEVAP VERMEYN!
CHAN_SENDPASS_LINE_5
	%s ynetimi.
CHAN_SENDPASS_OK
	%s kanalnn ifresi gnderildi.

# FORBID responses
CHAN_FORBID_SYNTAX
	FORBID kanalad [sebep]
CHAN_FORBID_SYNTAX_REASON
	FORBID kanalad sebep
CHAN_FORBID_SUCCEEDED
	%s kanalnn Kullanm yasakland.
CHAN_FORBID_FAILED
	%s kanalnn Kullanm yasaklanamad!

# Misc responses
CHAN_FORBID_REASON
	Bu kanal yasaklanm durumda.

# SUSPEND responses
CHAN_SUSPEND_SYNTAX
	SUSPEND channel [reason]
CHAN_SUSPEND_SYNTAX_REASON
	SUSPEND channel reason
CHAN_SUSPEND_SUCCEEDED
	%s bu kanal kullanma kapatld
CHAN_SUSPEND_FAILED
	%s kanal iin islem yaplamadi!
CHAN_SUSPEND_REASON
	Kanal kullanma kapatlm.

# UNSUSPEND responses
CHAN_UNSUSPEND_SYNTAX
	UNSUSPEND channel
CHAN_UNSUSPEND_ERROR
	' # ' iareti kanal isminde bulunmuyor.
CHAN_UNSUSPEND_SUCCEEDED
	%s kanal kullanma acildi.
CHAN_UNSUSPEND_FAILED
	%s kanal kullanma acilamadi!

# Misc responses
CHAN_EXCEPTED
	%s %s kanalnda ayrcalkl konumda bulunuyor ve bu konum kaldrlmadan kiiyi kanaldan atamazsnz.

###########################################################################
#
# MemoServ messages
#
###########################################################################

# Automatic messages
MEMO_HAVE_NEW_MEMO
	1 yeni mesajnz var.
MEMO_HAVE_NEW_MEMOS
	%d yeni mesajnz var.
MEMO_TYPE_READ_LAST
	Okumak iin %R%s READ LAST yazn.
MEMO_TYPE_READ_NUM
	Okumak iin %R%s READ %d yazn.
MEMO_TYPE_LIST_NEW
	Listelemek iin %R%s LIST NEW yazn.
MEMO_AT_LIMIT
	Dikkat: Maksimum mesaj saynza ulatnz (%d).  imdiki mesajlarnzdan bir kan silmezseniz yeni mesaj alamayacaksnz.
MEMO_OVER_LIMIT
	Dikkat: Maksimum mesaj saynz atnz (%d).  imdiki mesajlarnzdan bir kan silmezseniz yeni mesaj alamayacaksnz.
MEMO_X_MANY_NOTICE
	%d adet %s kanalna ait mesaj bulunuyor.
MEMO_X_ONE_NOTICE
	%d adet %s kanalna ait mesaj bulunuyor.
MEMO_NEW_X_MEMO_ARRIVED
	%s kanalnda okunmam bir mesaj bulunuyor.
	%R%s READ %s %d eklinde mesaj okuyabilirsiniz.
MEMO_NEW_MEMO_ARRIVED
	%s nickinden yeni mesajnz var.
	Okumak iin %R%s READ %d yazn.

# Multi-use responses
MEMO_HAVE_NO_MEMOS
	Hi mesajnz yok.
MEMO_X_HAS_NO_MEMOS
	%s nickinin hi mesaj yok.
MEMO_DOES_NOT_EXIST
	%d numaral mesaj bulunamad!
MEMO_LIST_NOT_FOUND
	Uyuan mesaj bulunamad.

# SEND responses
MEMO_SEND_SYNTAX
	SEND {nick | kanalad} mesaj
MEMO_SEND_DISABLED
	Mesaj yollama geici olarak devre ddr.
MEMO_SEND_PLEASE_WAIT
	Ltfen %d saniye SEND komutunu tekrar kullanmak iin bekleyin.
MEMO_X_GETS_NO_MEMOS
	%s nicki mesaj alamaz.
MEMO_X_HAS_TOO_MANY_MEMOS
	%s nickinin limiti dolduundan daha fazla mesaj alamaz.
MEMO_SENT
	%s nickine mesajnz gnderildi.
	
# CANCEL responses
MEMO_MASS_SENT
	Mesaj tm kaytl kullanclara iletildi.
	
# STAFF responses
MEMO_STAFF_SYNTAX
	STAFF memo-text
	
# CANCEL responses
MEMO_CANCEL_SYNTAX
	CANCEL {nick | kanalad}
MEMO_CANCEL_DISABLED
	Mesaj iptal etme geici olarak devre ddr.
MEMO_CANCEL_NONE
	ptal edilecek mesaj yoktu.
MEMO_CANCELLED
	%s nickine gnderilen son mesaj iptal edildi.

# LIST responses
MEMO_LIST_SYNTAX
	LIST [kanalad] [liste | NEW]
MEMO_HAVE_NO_NEW_MEMOS
	Hi yeni mesajnz yok.
MEMO_X_HAS_NO_NEW_MEMOS
	%s nickinin hi yeni mesaj yok.
MEMO_LIST_MEMOS
	%s nicki iin mesajlar.  Okumak iin: %R%s READ num yazn.
MEMO_LIST_NEW_MEMOS
	%s nicki iin yeni mesajlar.  Okumak iin: %R%s READ num yazn.
MEMO_LIST_CHAN_MEMOS
	%s kanali iin mesajlar.  Okumak iin: %R%s READ %s num yazn.
MEMO_LIST_CHAN_NEW_MEMOS
	%s kanali iin yeni mesajlar.  Okumak iin: %R%s READ %s num yazn.
MEMO_LIST_HEADER
	 Num  Gnderen          Tarih/Zaman
MEMO_LIST_FORMAT
	%c%3d  %-16s  %s

# READ responses
MEMO_READ_SYNTAX
	READ [kanalad] {liste | LAST | NEW}
MEMO_HEADER
	%d nolu mesaj %s nickinden (%s).  Silmek iin: %R%s DEL %d yazn.
MEMO_CHAN_HEADER
	%d nolu mesaj %s nickinden (%s).  Silmek iin: %R%s DEL %s %d yazn.
MEMO_TEXT
	%s

# DEL responses
MEMO_DEL_SYNTAX
	DEL [kanalad] {num | liste | ALL}
MEMO_DELETED_NONE
	Hi mesaj silinmedi.
MEMO_DELETED_ONE
	%d nolu mesaj silindi.
MEMO_DELETED_SEVERAL
	%s mesajlar silindi.
MEMO_DELETED_ALL
	Tm mesajlarnz silindi.

# SET responses
MEMO_CHAN_DELETED_ALL
	%s kanalna ait tm mesajlar silindi.

# SET responses
MEMO_SET_SYNTAX
	SET zellik parametre
MEMO_SET_DISABLED
	MemoServ'n SET komutu geici olarak devre ddr.
MEMO_SET_UNKNOWN_OPTION
	Varolmayan SET zellii: %s.

# SET NOTIFY responses
MEMO_SET_NOTIFY_SYNTAX
	SET NOTIFY {ON | LOGON | NEW | MAIL | NOMAIL | OFF}
MEMO_SET_NOTIFY_ON
	%s sizi yeni mesajlar iin balandnzda veya mesajlar size gnderildii anda uyaracak.
MEMO_SET_NOTIFY_LOGON
	%s sizi yeni mesajlar iin balandnzda veya AWAY modundan dnte uyaracak.
MEMO_SET_NOTIFY_NEW
	%s sizi yeni mesajlar iin size gnderildii anda uyaracak.
MEMO_SET_NOTIFY_OFF
	%s sizi yeni mesajlar iin uyarmayacak.

# SET LIMIT responses
MEMO_SET_NOTIFY_MAIL
	Yeni mesajlar hakknda mail adresiniz araclg ile bilgilendirileceksiniz.
MEMO_SET_NOTIFY_NOMAIL
	Mail yolu ile bilgilendirme kapatld.
MEMO_SET_NOTIFY_INVALIDMAIL
	Rumuzunuza ait gecerli bir mail adresi bulunmuyor.

# SET LIMIT responses
MEMO_SET_LIMIT_SYNTAX
	SET LIMIT [kanalad] limit
MEMO_SET_LIMIT_SERVADMIN_SYNTAX
	SET LIMIT [kullanc | kanalad] {limit | NONE} [HARD]
MEMO_SET_YOUR_LIMIT_FORBIDDEN
	Mesaj limitinizi belirlemeye izinli deilsiniz.
MEMO_SET_LIMIT_FORBIDDEN
	%s nickinin mesaj limiti deitirelemez.
MEMO_SET_YOUR_LIMIT_TOO_HIGH
	Mesaj limitinizi %d saysndan daha fazla yapamazsnz.
MEMO_SET_LIMIT_TOO_HIGH
	%s nickinin mesaj limitini %d saysndan daha fazla yapamazsnz.
MEMO_SET_LIMIT_OVERFLOW
	Mesaj limiti ok fazla; limit %d olarak deitiriliyor.
MEMO_SET_YOUR_LIMIT
	Mesaj limitiniz %d olarak ayarland.
MEMO_SET_YOUR_LIMIT_ZERO
	Limitiniz sfr olduundan artk mesaj alamayacaksnz.
MEMO_UNSET_YOUR_LIMIT
	Mesaj limitiniz kapatld.
MEMO_SET_LIMIT
	%s nickinin mesaj limiti %d olarak ayarland.
MEMO_SET_LIMIT_ZERO
	%s nickinin mesaj limiti 0 olarak ayarland.
MEMO_UNSET_LIMIT
	%s nickinin mesaj limiti kapatld.

# INFO responses
MEMO_INFO_SYNTAX
	INFO [kanalad]
MEMO_INFO_SERVADMIN_SYNTAX
	INFO [nick | kanalad]
MEMO_INFO_NO_MEMOS
	u an hi mesajnz yok.
MEMO_INFO_MEMO
	u an 1 mesajnz var.
MEMO_INFO_MEMO_UNREAD
	u an 1 mesajnz var, ve henz okunmad.
MEMO_INFO_MEMOS
	u an %d mesajnz var.
MEMO_INFO_MEMOS_ONE_UNREAD
	u an %d mesajnz var, 1 tanesi okunmam.
MEMO_INFO_MEMOS_SOME_UNREAD
	u an %d mesajnz var, %d tanesi okunmam.
MEMO_INFO_MEMOS_ALL_UNREAD
	u an %d mesajnz var; hibiri okunmam.
MEMO_INFO_LIMIT
	Mesaj limitiniz %d.
MEMO_INFO_HARD_LIMIT
	Mesaj limitiniz %d, ve deitirilemez.
MEMO_INFO_LIMIT_ZERO
	Mesaj limitiniz 0; hi mesaj alamayacaksnz.
MEMO_INFO_HARD_LIMIT_ZERO
	Mesaj limitiniz 0; hi yeni mesaj alamayacaksnz.  Bu limiti deitiremezsiniz.
MEMO_INFO_NO_LIMIT
	Saklayabileceiniz mesaj saysnda limit yok.
MEMO_INFO_NOTIFY_OFF
	Yeni mesajlar iin uyarlmayacaksnz.
MEMO_INFO_NOTIFY_ON
	Yeni mesajlar iin balandnzda ve size ulatnda uyarlacaksnz.
MEMO_INFO_NOTIFY_RECEIVE
	Yeni mesajlar iin ulatklar anda uyarlacaksnz.
MEMO_INFO_NOTIFY_SIGNON
	Yeni mesajlar iin balandnzda uyarlacaksnz.
MEMO_INFO_X_NO_MEMOS
	%s nickinin u an hi mesaj yok.
MEMO_INFO_X_MEMO
	%s nickinin u an 1 mesaj var.
MEMO_INFO_X_MEMO_UNREAD
	%s nickinin u an 1 mesaj var, ve daha okunmam.
MEMO_INFO_X_MEMOS
	%s nickinin u an %d mesaj var.
MEMO_INFO_X_MEMOS_ONE_UNREAD
	%s nickinin u an %d mesaj var, 1 tanesi okunmam.
MEMO_INFO_X_MEMOS_SOME_UNREAD
	%s nickinin u an %d mesaj var, %d tanesi okunmam.
MEMO_INFO_X_MEMOS_ALL_UNREAD
	%s nickinin u an %d mesaj var; hibiri okunmam.
MEMO_INFO_X_LIMIT
	%s nickinin mesaj limiti %d.
MEMO_INFO_X_HARD_LIMIT
	%s nickinin mesaj limiti %d, ve deitirilemez.
MEMO_INFO_X_NO_LIMIT
	%s nickinin mesaj limiti yok.
MEMO_INFO_X_NOTIFY_OFF
	%s yeni mesajlar iin uyarlmayacak.
MEMO_INFO_X_NOTIFY_ON
	%s yeni mesajlar iin balandnda ve mesajlar ulat anda uyarlacak.
MEMO_INFO_X_NOTIFY_RECEIVE
	%s yeni mesajlar ulat anda uyarlacak.
MEMO_INFO_X_NOTIFY_SIGNON
	%s yeni mesajlar iin balandnda uyarlacak.
	
###########################################################################
#
# BotServ messages
#
###########################################################################
	
# Standard responses
MEMO_MAIL_SUBJECT
	Yeni CevrimD Mesaj Bildirimi
MEMO_MAIL_TEXT1
	Nerhabalar sayn %s ,
MEMO_MAIL_TEXT2
	Bu mail yeni gnderilen Cevrimds mesajlar bilgilendirmek amaci ile gonderilmis bir e-postadr. Mesaj yollayan %s. Mesaj numaranz %d.
MEMO_MAIL_TEXT3
	Mesaj icerigi:

###########################################################################
#
# BotServ messages
#
###########################################################################
	
# Standard responses
MEMO_RSEND_PLEASE_WAIT
	RSEND komutunu kullanmadan nce %d saniye bekleyiniz sonra tekrar deneyiniz.
MEMO_RSEND_DISABLED
	Uzgunuz RSEND bu sunucuda aktif degil.
MEMO_RSEND_SYNTAX
	RSEND {nick | channel} memo-text
MEMO_RSEND_NICK_MEMO_TEXT
	[auto-memo] Gondermis oldugunuz mesaj okundu.
MEMO_RSEND_CHAN_MEMO_TEXT
	[auto-memo] %s na gondermis oldugunuz mesaj okundu.
MEMO_RSEND_USER_NOTIFICATION
	%s rumuzuna gndermis oldugu mesajn okudugunu bildiren bir bildirim
	yollanacaktr.

###########################################################################
#
# BotServ messages
#
###########################################################################
	
# Standard responses
MEMO_CHECK_SYNTAX
	CHECK nickname
MEMO_CHECK_NOT_READ
	%s rumuzuna son yollanan mesaj (yollayan %s) okunmam.
MEMO_CHECK_READ
	%s rumuzuna son yollanan mesaj (yollayan %s) okunmus durumda.
MEMO_CHECK_NO_MEMO
	%s rumuzunun sizin tarafnzdan yollanms bir mesaj bulunmuyor.

###########################################################################
#
# BotServ messages
#
###########################################################################
	
# Standard responses
MEMO_NO_RSEND_SELF
	Kendinize yolladgnz mesajlarn durumunu kontrol edemezsiniz.

###########################################################################
#
# BotServ messages
#
###########################################################################
	
# Standard responses
BOT_DOES_NOT_EXIST
	Bot %s mevcut deil.
BOT_NOT_ASSIGNED
	Bu komutu kullanmadan nce kanala bir bot sokmalsnz.
	Daha fazla bilgi iin %R%S HELP ASSIGN yazn.
BOT_NOT_ON_CHANNEL
	Bot %s kanalnda deil.
	
# Kick reasons (must be a single line)
BOT_REASON_BADWORD
	%s kelimesinin bu kanalda kullanlmas yasaktr!
BOT_REASON_BADWORD_GENTLE
	Konumalarna dikkat et!
BOT_REASON_BOLD
	Bu kanalda kaln yaz kullanlmas yasaktr!
BOT_REASON_CAPS
	Ltfen byk harf kullanmayn!
BOT_REASON_COLOR
	Ltfen bu kanalda renkli yaz kullanmayn!
BOT_REASON_FLOOD
	Flood yapma!
BOT_REASON_REPEAT
	Kendini tekrar etme!
BOT_REASON_REVERSE
	Ltfen bu kanalda Ctrl+R ile yazlm yaz kullanmayn!
BOT_REASON_UNDERLINE
	Ltfen bu kanalda alt izili yaz kullanmayn!

# !seen replies
BOT_SEEN_BOT
	Beni buldun, %s!
BOT_SEEN_YOU
	Kendinimi aryorsun, %s?
BOT_SEEN_ON_CHANNEL
	%s u anda kanalda!
BOT_SEEN_ON_CHANNEL_AS
	%s u anda kanalda (%s olarak) ! 
BOT_SEEN_ON
	%s %s nce buradayd.
BOT_SEEN_NEVER
	%s diye birini bu kanalda hi grmedim.
BOT_SEEN_UNKNOWN
	%s ahsnn kim olduunu bilmiyorum.

# BOT responses
BOT_BOT_SYNTAX
	BOT ADD nick user host gerekismi
	BOT CHANGE eskinick yeninick [user [host [gerekismi]]]
	BOT DEL nick
BOT_BOT_ALREADY_EXISTS
	%s nickli bot zaten var.
BOT_BOT_CREATION_FAILED
	Bot yaratma baarsz.
BOT_BOT_READONLY
	Botta deiiklik yapma geici olarak devre d.
BOT_BOT_ADDED
	%s!%s@%s (%s) bot listesine eklendi.
BOT_BOT_ANY_CHANGES
	Eski bilgiler imdikilerle ayn.
BOT_BOT_CHANGED
	%s botu %s!%s@%s (%s) olarak deitirildi.
BOT_BOT_DELETED
	%s botu silindi.
	
# BOTLIST responses
BOT_BOTLIST_HEADER
	Bot listesi:
BOT_BOTLIST_PRIVATE_HEADER
	IRCoplara ayrilmis botlar:
BOT_BOTLIST_FOOTER
	%d bot mevcut.
BOT_BOTLIST_EMPTY
	u an mevcut bot yok.
	Server adminine bir tane yaratmasn syleyin!
	
# ASSIGN responses
BOT_ASSIGN_SYNTAX
	ASSIGN kanalad nick
BOT_ASSIGN_READONLY
	Kanala bot sokma geici olarak devre d.
BOT_ASSIGN_ALREADY
	%s botu zaten %s kanalnda bulunuyor.
BOT_ASSIGN_ASSIGNED
	%s botu %s kanalna sokuldu.
	
# UNASSIGN responses
BOT_UNASSIGN_SYNTAX
	UNASSIGN kanalad
BOT_UNASSIGN_UNASSIGNED
	%s kanalndan bot karld.
	
# INFO responses
BOT_INFO_SYNTAX
	INFO {kanalad | nick}
BOT_INFO_NOT_FOUND
	%s geerli bir bot yada kanal deil.
BOT_INFO_BOT_HEADER
	%s botunun bilgileri:
BOT_INFO_BOT_MASK
	               Mask : %s@%s
BOT_INFO_BOT_REALNAME
	        Gerek ismi : %s
BOT_INFO_BOT_CREATED
	          Yaratl : %s
BOT_INFO_BOT_USAGE
	Kullanlan kanallar : %d kanalda
BOT_INFO_BOT_OPTIONS
	    Ayarlar : %s
BOT_INFO_OPT_PRIVATE
	zel
BOT_INFO_CHAN_HEADER
	%s kanalnn bilgileri:
BOT_INFO_CHAN_BOT
	           Botun nicki : %s
BOT_INFO_CHAN_BOT_NONE
	           Botun nicki : u an yok.
BOT_INFO_CHAN_KICK_BADWORDS
	          Kfrde atma : %s
BOT_INFO_CHAN_KICK_BADWORDS_BAN
	          Kfrde atma : %s (%d tanede ban)
BOT_INFO_CHAN_KICK_BOLDS
	     Kaln yazda atma : %s
BOT_INFO_CHAN_KICK_BOLDS_BAN
	     Kaln yazda atma : %s (%d tanede ban)
BOT_INFO_CHAN_KICK_CAPS_ON
	     Byk yazda atma : %s (minimum %d/%d%%)
BOT_INFO_CHAN_KICK_CAPS_BAN
	     Byk yazda atma : %s (%d tanede ban; minimum %d/%d%%)
BOT_INFO_CHAN_KICK_CAPS_OFF
	     Byk yazda atma : %s
BOT_INFO_CHAN_KICK_COLORS
	    Renkli yazda atma : %s
BOT_INFO_CHAN_KICK_COLORS_BAN
	    Renkli yazda atma : %s (%d tanede ban)
BOT_INFO_CHAN_KICK_FLOOD_ON
	          Floodda atma : %s (%d sra %ds)
BOT_INFO_CHAN_KICK_FLOOD_BAN
	          Floodda atma : %s (%d tanede ban; %d sra %ds)
BOT_INFO_CHAN_KICK_FLOOD_OFF
	          Floodda atma : %s
BOT_INFO_CHAN_KICK_REPEAT_ON
	         Tekrarda atma : %s (%d kez)
BOT_INFO_CHAN_KICK_REPEAT_BAN
	         Tekrarda atma : %s (%d tanede ban; %d kez)
BOT_INFO_CHAN_KICK_REPEAT_OFF
	         Tekrarda atma : %s
BOT_INFO_CHAN_KICK_REVERSES
	        Ctrl+R de atma : %s
BOT_INFO_CHAN_KICK_REVERSES_BAN
	        Ctrl+R de atma : %s (%d tanede ban)
BOT_INFO_CHAN_KICK_UNDERLINES
	Altizili yazda atma : %s
BOT_INFO_CHAN_KICK_UNDERLINES_BAN
	Altizili yazda atma : %s (%d tanede ban)
BOT_INFO_ACTIVE
	Aktif
BOT_INFO_INACTIVE
	Kapal
BOT_INFO_CHAN_OPTIONS
	         zellikler : %s
BOT_INFO_OPT_DONTKICKOPS
	Oplar koruma
BOT_INFO_OPT_DONTKICKVOICES
	Voicelar koruma
BOT_INFO_OPT_FANTASY
	Fantazi
BOT_INFO_OPT_GREET
	Karlama
BOT_INFO_OPT_NOBOT
	Bot yok
BOT_INFO_OPT_SYMBIOSIS
	Gerek bot
BOT_INFO_OPT_NONE
	YOK
	
# SET responses
BOT_SET_SYNTAX
	SET kanalad zellik ayarlar
BOT_SET_DISABLED
	Bot zellik ayar geici olarak devre d.
BOT_SET_UNKNOWN
	Varolmayan zellik %s.
	Daha fazla bilgi iin %R%S HELP SET yazn.
	
# SET DONTKICKOPS messages
BOT_SET_DONTKICKOPS_SYNTAX
	SET kanalad DONTKICKOPS {ON|OFF}
BOT_SET_DONTKICKOPS_ON
	Bot %s kanalnda oplar atmayacak .
BOT_SET_DONTKICKOPS_OFF
	Bot %s kanalnda oplarda atacak.
	
# SET DONTKICKVOICES messages
BOT_SET_DONTKICKVOICES_SYNTAX
	SET kanalad DONTKICKVOICES {ON|OFF}
BOT_SET_DONTKICKVOICES_ON
	Bot %s kanalnda voicelar atmayacak.
BOT_SET_DONTKICKVOICES_OFF
	Bot %s kanalnda voicelarda atacak.

# SET FANTASY messages
BOT_SET_FANTASY_SYNTAX
	SET kanalad FANTASY {ON|OFF}
BOT_SET_FANTASY_ON
	Fantazi modu %s kanalnda AKTF.
BOT_SET_FANTASY_OFF
	Fantazi modu %s kanalnda KAPALI.
	
# SET GREET messages
BOT_SET_GREET_SYNTAX
	SET kanalad GREET {ON|OFF}
BOT_SET_GREET_ON
	Karlama modu %s kanalnda AKTF.
BOT_SET_GREET_OFF
	Karlama modu %s kanalnda KAPALI.

# SET NOBOT
BOT_SET_NOBOT_SYNTAX
	SET kanalad NOBOT {ON|OFF}
BOT_SET_NOBOT_ON
	Bot yok modu %s kanal iin AKTF.
BOT_SET_NOBOT_OFF
	Bot yok modu %s kanal iin KAPALI.

# SET PRIVATE
BOT_SET_PRIVATE_SYNTAX
	SET kanaladi PRIVATE {ON|OFF}
BOT_SET_PRIVATE_ON
	%s botunun zel seenegi artik AKTIF.
BOT_SET_PRIVATE_OFF
	%s botunun zel seenegi artik KAPALI.
	
# SET SYMBIOSIS
BOT_SET_SYMBIOSIS_SYNTAX
	SET kanalad SYMBIOSIS {ON|OFF}
BOT_SET_SYMBIOSIS_ON
	Gerek bot modu %s kanalnda AKTF.
BOT_SET_SYMBIOSIS_OFF
	Gerek bot modu %s kanalnda KAPALI.
	
# KICK responses
BOT_KICK_SYNTAX
	KICK kanalad zellik {ON|OFF} [ayarlar]
BOT_KICK_DISABLED
	Atma ayarlar geici olarak devre d.
BOT_KICK_UNKNOWN
	Varolmayan zellik %s.
	Daha fazla bilgi iin %R%S HELP KICK yazn.
BOT_KICK_BAD_TTB
	%s deeri kullanlamaz.
BOT_KICK_BADWORDS_ON
	Bot imdi kfrlerde atacak. BADWORDS komutunu kullanarak
	listeye kfr ekleyip silebilirsiniz.
BOT_KICK_BADWORDS_ON_BAN
	Bot imdi kfrlerde atacak, ve %d atma sonrasnda 
	ayn kullancy banlayacak. BADWORDS komutunu
	kullanarak kfr ekleyip karabilirsiniz.
BOT_KICK_BADWORDS_OFF
	Bot artk kfrlerde atmayacak.
BOT_KICK_BOLDS_ON
	Bot imdi kaln yazda atacak.
BOT_KICK_BOLDS_ON_BAN
	Bot imdi kaln yazda atacak, ve 
	%d atma sonrasnda ayn kullancy banlayacak.
BOT_KICK_BOLDS_OFF
	Bot artk kaln yazda atmayacak.
BOT_KICK_CAPS_ON
	Bot imdi byk yazda atacak(Tm mesajn en az
	%d karakterini ve %d%% kadarn iermelidir).
BOT_KICK_CAPS_ON_BAN
	Bot imdi byk yazda atacak(Tm mesajn en az
	%d karakterini ve %d%% kadarn iermelidir), ve 
	%d atma sonrasnda ayn kullancy banlayacak.
BOT_KICK_CAPS_OFF
	Bot artk byk yazda atmayacak.
BOT_KICK_COLORS_ON
	Bot imdi renkli yazda atacak.
BOT_KICK_COLORS_ON_BAN
	Bot imdi renkli yazda atacak, ve 
	%d atma sonrasnda ayn kullancy banlayacak.
BOT_KICK_COLORS_OFF
	Bot artk renkli yazda atmayacak.
BOT_KICK_FLOOD_ON
	Bot imdi text floodda atacak(%d sra %d saniyede).
BOT_KICK_FLOOD_ON_BAN
	Bot imdi text floodda atacak(%d sira %d saniyede), ve 
	%d atma sonrasnda ayn kullancy banlayacak.
BOT_KICK_FLOOD_OFF
	Bot artk text floodda atmayacak.
BOT_KICK_REPEAT_ON
	Bot imdi tekrarda atacak(kullanc %d kez
	ayn eyi sylerse).
BOT_KICK_REPEAT_ON_BAN
	Bot imdi tekrarda atacak(kullanc %d kez
	ayn eyi sylerse), ve %d atma sonrasnda
	ayn kullancy banlayacak.
BOT_KICK_REPEAT_OFF
	Bot artk tekrarda atmayacak.
BOT_KICK_REVERSES_ON
	Bot imdi Ctrl+R de atacak.
BOT_KICK_REVERSES_ON_BAN
	Bot imdi Ctrl+R de atacak, ve %d atma sonrasnda 
	ayn kullancy banlayacak.
BOT_KICK_REVERSES_OFF
	Bot artk Ctrl+R de atmayacak.
BOT_KICK_UNDERLINES_ON
	Bot imdi altizili yazda atacak.
BOT_KICK_UNDERLINES_ON_BAN
	Bot imdi altizili yazda atacak, ve %d atma 
	sonrasnda ayn kullancy banlayacak.
BOT_KICK_UNDERLINES_OFF
	Bot artk altizili yazda atmayacak.
	
# BADWORDS messages
BOT_BADWORDS_SYNTAX
	BADWORDS kanalad {ADD|DEL|LIST|CLEAR} [nick | kayt-listesi]
BOT_BADWORDS_DISABLED
	Kanaln kfr listesinde deiiklik yapma geici olarak devre ddr.
BOT_BADWORDS_REACHED_LIMIT
	Bir kanalda sadece %d tane kfr kayd olabilir.
BOT_BADWORDS_ALREADY_EXISTS
	%s zaten %s kanalnn kfr listesinde var.
BOT_BADWORDS_ADDED
	%s %s kanalnn kfr listesine eklendi.
BOT_BADWORDS_NO_SUCH_ENTRY
	(#%d) eklinde bir kayt %s kanalnn kfr listesinde bulunamad.
BOT_BADWORDS_NOT_FOUND
	%s %s kanalnn kfr listesinde bulunamad.
BOT_BADWORDS_NO_MATCH
	Uyuan kayt %s kanalnn kfr listesinde bulunamad.
BOT_BADWORDS_DELETED
	%s %s kanalnn kfr listesinden karld.
BOT_BADWORDS_DELETED_ONE
	%s kanalnn kfr listesinden 1 kayt silindi.
BOT_BADWORDS_DELETED_SEVERAL
	Deleted %d entries from %s bad words list.
BOT_BADWORDS_LIST_EMPTY
	%s kanalnn kfr listesi bo.
BOT_BADWORDS_LIST_HEADER
	%s kanalnn kfr listesi:
	  Say   Kelime                           Tipi
BOT_BADWORDS_LIST_FORMAT
	  %3d   %-30s %s
BOT_BADWORDS_CLEAR
	Kfr listesi imdi bo.

# SAY responses
BOT_SAY_SYNTAX
	SAY kanalad yaz

# ACT responses
BOT_ACT_SYNTAX
	ACT kanalad yaz

###########################################################################
#
# OperServ messages
#
###########################################################################

# General messages
BOT_EXCEPT
	Kullanc kanal ayrcalkl kullanclar listesinde bulunuyor.

###########################################################################
#
# OperServ messages
#
###########################################################################

# General messages
BOT_BAD_NICK
	Bot rumuzu geerli karakterlerden olumaldr.
BOT_BAD_HOST
	Bot'un adresi geerli karakterlerden olumaldr.
BOT_BAD_IDENT
	Bot ident'i geerli karakterlerden olumaldr..
BOT_LONG_IDENT
	Bot Ident'i en fazla %d karakter olmaldr.
BOT_LONG_HOST
	Bot adresi en fazla %d karakter olmaldr.

###########################################################################
#
# OperServ messages
#
###########################################################################

# General messages
OPER_BOUNCY_MODES
	Servisler mod deitiremiyor.  Serverin doru ayarlandna emin olun.
OPER_BOUNCY_MODES_U_LINE
	Servisler mod deitiremiyor.  Serverin U:line larnn doru ayarlandna emin olun.

# GLOBAL responses
OPER_GLOBAL_SYNTAX
	GLOBAL mesaj

# STATS responses
OPER_STATS_UNKNOWN_OPTION
	Varolmayan STATS zellii: %s.
OPER_STATS_CURRENT_USERS
	u anki kullanc says: %d (%d op)
OPER_STATS_MAX_USERS
	Maximum kullanc says: %d (%s)
# This is ugly, but at least it's language-portable...
# Note that you can include seconds in any of these--my personal preference
# is to only give resolution to the nearest minute when uptime is one hour
# or more, but just add a %d to get seconds as well.
OPER_STATS_UPTIME_DHMS
	Servisler %d gndr alyor, %02d:%02d
OPER_STATS_UPTIME_1DHMS
	Servisler %d gndr alyor, %02d:%02d
OPER_STATS_UPTIME_HMS
	Servisler %d saat, %d dakikadr alyor.
OPER_STATS_UPTIME_HM1S
	Servisler %d saat, %d dakikadr alyor.
OPER_STATS_UPTIME_H1MS
	Servisler %d saat, %d dakikadr alyor.
OPER_STATS_UPTIME_H1M1S
	Servisler %d saat, %d dakikadr alyor.
OPER_STATS_UPTIME_1HMS
	Servisler %d saat, %d dakikadr alyor.
OPER_STATS_UPTIME_1HM1S
	Servisler %d saat, %d dakikadr alyor.
OPER_STATS_UPTIME_1H1MS
	Servisler %d saat, %d dakikadr alyor.
OPER_STATS_UPTIME_1H1M1S
	Servisler %d saat, %d dakikadr alyor.
OPER_STATS_UPTIME_MS
	Servisler %d dakika, %d saniyedir alyor.
OPER_STATS_UPTIME_M1S
	Servisler %d dakika, %d saniyedir alyor.
OPER_STATS_UPTIME_1MS
	Servisler %d dakika, %d saniyedir alyor.
OPER_STATS_UPTIME_1M1S
	Servisler %d dakika, %d saniyedir alyor.
OPER_STATS_BYTES_READ
	Okunan veri  : %5d kB
OPER_STATS_BYTES_WRITTEN
	Yazlan veri : %5d kB
OPER_STATS_USER_MEM
	Kullanc  : %6d kayt, %5d kB
OPER_STATS_CHANNEL_MEM
	Kanal      : %6d kayt, %5d kB
OPER_STATS_GROUPS_MEM
	NS Groups     : %6d records, %5d kB
OPER_STATS_ALIASES_MEM
	NS Aliases    : %6d records, %5d kB
OPER_STATS_CHANSERV_MEM
	ChanServ   : %6d kayt, %5d kB
OPER_STATS_BOTSERV_MEM
	BotServ    : %6d kayt, %5d kB
OPER_STATS_HOSTSERV_MEM
	HostServ      : %6d records, %5d kB
OPER_STATS_OPERSERV_MEM
	OperServ   : %6d kayt, %5d kB
OPER_STATS_SESSIONS_MEM
	Oturumlar  : %6d kayt, %5d kB
OPER_STATS_AKILL_COUNT
	u anki AKILL says: %d
OPER_STATS_AKILL_EXPIRE_DAYS
	Varsaylan AKILL zaman am: %d gn
OPER_STATS_AKILL_EXPIRE_DAY
	Varsaylan AKILL zaman am: 1 gn
OPER_STATS_AKILL_EXPIRE_HOURS
	Varsaylan AKILL zaman am: %d saat
OPER_STATS_AKILL_EXPIRE_HOUR
	Varsaylan AKILL zaman am: 1 saat
OPER_STATS_AKILL_EXPIRE_MINS
	Varsaylan AKILL zaman am: %d dakika
OPER_STATS_AKILL_EXPIRE_MIN
	Varsaylan AKILL zaman am: 1 dakika
OPER_STATS_AKILL_EXPIRE_NONE
	Varsaylan AKILL zaman am: zaman am yok
OPER_STATS_SGLINE_COUNT
	u anki SGLINE says: %d
OPER_STATS_SGLINE_EXPIRE_DAYS
	Varsaylan SGLINE zaman am sresi: %d gn
OPER_STATS_SGLINE_EXPIRE_DAY
	Varsaylan SGLINE zaman am sresi: 1 gn
OPER_STATS_SGLINE_EXPIRE_HOURS
	Varsaylan SGLINE zaman am sresi: %d saat
OPER_STATS_SGLINE_EXPIRE_HOUR
	Varsaylan SGLINE zaman am sresi: 1 saat
OPER_STATS_SGLINE_EXPIRE_MINS
	Varsaylan SGLINE zaman am sresi: %d dakika
OPER_STATS_SGLINE_EXPIRE_MIN
	Varsaylan SGLINE zaman am sresi: 1 dakika
OPER_STATS_SGLINE_EXPIRE_NONE
	Varsaylan SGLINE zaman am sresi: Zaman am yok
OPER_STATS_SQLINE_COUNT
	Su anki SQLINE sayisi: %d
OPER_STATS_SQLINE_EXPIRE_DAYS
	Varsayilan SQLINE zaman asimi sresi: %d gn
OPER_STATS_SQLINE_EXPIRE_DAY
	Varsayilan SQLINE zaman asimi sresi: 1 gn
OPER_STATS_SQLINE_EXPIRE_HOURS
	Varsayilan SQLINE zaman asimi sresi: %d saat
OPER_STATS_SQLINE_EXPIRE_HOUR
	Varsayilan SQLINE zaman asimi sresi: 1 saat
OPER_STATS_SQLINE_EXPIRE_MINS
	Varsayilan SQLINE zaman asimi sresi: %d dakika
OPER_STATS_SQLINE_EXPIRE_MIN
	Varsayilan SQLINE zaman asimi sresi: 1 dakika
OPER_STATS_SQLINE_EXPIRE_NONE
	Varsayilan SQLINE zaman asimi sresi: Zaman asimi yok
OPER_STATS_SZLINE_COUNT
	u anki SZLINE says: %d
OPER_STATS_SZLINE_EXPIRE_DAYS
	Varsaylan SZLINE zaman am sresi: %d gn
OPER_STATS_SZLINE_EXPIRE_DAY
	Varsaylan SZLINE zaman am sresi: 1 gn
OPER_STATS_SZLINE_EXPIRE_HOURS
	Varsaylan SZLINE zaman am sresi: %d saat
OPER_STATS_SZLINE_EXPIRE_HOUR
	Varsaylan SZLINE zaman am sresi: 1 saat
OPER_STATS_SZLINE_EXPIRE_MINS
	Varsaylan SZLINE zaman am sresi: %d dakika
OPER_STATS_SZLINE_EXPIRE_MIN
	Varsaylan SZLINE zaman am sresi: 1 dakika
OPER_STATS_SZLINE_EXPIRE_NONE
	Varsaylan SZLINE zaman am sresi: Zaman am yok
OPER_STATS_RESET
	statistikler resetlendi.

# MODE responses
OPER_STATS_UPLINK_SERVER
	Bagl bulunulan sunucu: %s
OPER_STATS_UPLINK_CAPAB
	Bagl An ozellikleri: %s
OPER_STATS_UPLINK_SERVER_COUNT
	Bulunan sunucular: %d

# MODE responses
OPER_MODE_SYNTAX
	MODE kanalad modlar

# CLEARMODES responses
OPER_UMODE_SYNTAX
	UMODE nick modes

# OLINE responses
OPER_UMODE_SUCCESS
	%s rumuzunun modlar deitirildi.
OPER_UMODE_CHANGED
	%s nickli kullanc sizin modlarnz deitirdi.

# OLINE responses
OPER_OLINE_SYNTAX
	OLINE nick flags
OPER_OLINE_SUCCESS
	%s yetkileri %s rumuzu icin eklendi.

# CLEARMODES responses
OPER_OLINE_IRCOP
	Su anda irc operatoru konumuna gectiniz.

# CLEARMODES responses
OPER_CLEARMODES_SYNTAX
	CLEARMODES kanalad [ALL]
OPER_CLEARMODES_DONE
	%s kanalnda modlar ve banlar temizlendi.
OPER_CLEARMODES_ALL_DONE
	%s kanalndaki tm modlar temizlendi.


# KICK responses
OPER_KICK_SYNTAX
	KICK kanalad kullanc sebep

# ADMIN responses
OPER_SVSNICK_SYNTAX
	SVSNICK nick newnick 
OPER_SVSNICK_NEWNICK
	%s rumuzu %s olarak degistirildi.
	
# ADMIN responses
OPER_ADMIN_SYNTAX
	ADMIN {ADD|DEL|LIST|CLEAR} [nick | kayt-listesi]
OPER_ADMIN_SKELETON
	Servisler iskelet modunda(skeleton); ADMIN komutu devre d.
OPER_ADMIN_EXISTS
	%s zaten Servis adminleri listesinde.
OPER_ADMIN_REACHED_LIMIT
	Sadece %d tane servis admini olabilir.
OPER_ADMIN_ADDED
	%s Servis adminleri listesine eklendi.
OPER_ADMIN_NOT_FOUND
	%s Servisler admin listesinde bulunamad.
OPER_ADMIN_NO_MATCH
	Servis adminleri listesinde uyuan kayt yok.
OPER_ADMIN_DELETED
	%s servis adminleri listesinden silindi.
OPER_ADMIN_DELETED_ONE
	Servis adminleri listesinden 1 kayt silindi.
OPER_ADMIN_DELETED_SEVERAL
	Servis adminleri listesinden %d kayt silindi.
OPER_ADMIN_LIST_EMPTY
	Servis adminleri listesi bo.
OPER_ADMIN_LIST_HEADER
	Servis adminleri listesi:
	  Num   Nick
OPER_ADMIN_LIST_FORMAT
	  %3d   %s
OPER_ADMIN_CLEAR
	Servis adminleri listesi temizlendi.
OPER_ADMIN_MOVED
	%s rumuzu servis adminleri listesine alnd.

# OPER responses
OPER_OPER_SYNTAX
	OPER {ADD|DEL|LIST|CLEAR} [nick | kayt-listesi]
OPER_OPER_SKELETON
	Servisler iskelet modunda(skeleton); OPER komutu devre d.
OPER_OPER_EXISTS
	%s zaten servis operatrleri listesinde.
OPER_OPER_REACHED_LIMIT
	Sadece %d tane servis operatr olabilir.
OPER_OPER_ADDED
	%s servis operatrleri listesine eklendi.
OPER_OPER_NOT_FOUND
	%s servis operatrleri listesinde bulunamad.
OPER_OPER_NO_MATCH
	Servis operatrleri listesinde uyuan kayt bulunamad.
OPER_OPER_DELETED
	%s servis operatrleri listesinden silindi.
OPER_OPER_DELETED_ONE
	Servis operatrleri listesinden 1 kayt silindi.
OPER_OPER_DELETED_SEVERAL
	Servis operatrleri listesinden %d kayt silindi.
OPER_OPER_LIST_EMPTY
	Servis operatrleri listesi bo.
OPER_OPER_LIST_HEADER
	Servis operatrleri listesi:
	  Num   Nick
OPER_OPER_LIST_FORMAT
	  %3d   %s
OPER_OPER_CLEAR
	Servis operatrleri listesi temizlendi.
OPER_OPER_MOVED
	%s rumuzu servis operatorleri listesine alnd.

# AKILL responses
OPER_AKILL_SYNTAX
	AKILL {ADD | DEL | LIST | VIEW | CLEAR} [[+zamanam] {mask | kayt-no} [sebep]]
OPER_AKILL_EXISTS
	%s zaten AKILL listesinde.
OPER_AKILL_ALREADY_COVERED
	%s zaten %s tarafndan deitirildi.
OPER_AKILL_REACHED_LIMIT
	Sadece %d kii AKILL listesinde olabilir.
OPER_AKILL_NO_NICK
	Hatrlatma: AKILL maskna nick eklenemez; AKILL maskna nick eklemediinizden emin olun.
OPER_AKILL_ADDED
	%s AKILL listesine eklendi.
OPER_AKILL_CHANGED
	%s nickinin zaman am sresi deitirildi.
OPER_AKILL_NOT_FOUND
	%s AKILL listesinde bulunamad.
OPER_AKILL_NO_MATCH
	Uyuan kayt AKILL listesinde bulunamad.
OPER_AKILL_DELETED
	%s AKILL listesinden silindi.
OPER_AKILL_DELETED_ONE
	AKILL listesinden 1 kayt silindi.
OPER_AKILL_DELETED_SEVERAL
	AKILL listesinden %d kayt silindi.
OPER_AKILL_LIST_EMPTY
	AKILL listesi bo.
OPER_AKILL_LIST_HEADER
	u anki AKILL listesi:
	  No    Mask                              Sebep
OPER_AKILL_LIST_FORMAT
	  %3d   %-32s  %s
OPER_AKILL_VIEW_HEADER
	u anki AKILL listesi:
# number, mask, set-by, set-time, expires, reason
OPER_AKILL_VIEW_FORMAT
	%3d  %s (%s tarafndan %s tarihinde; %s)
	      %s
OPER_AKILL_CLEAR
	AKILL listesi temizlendi.

# SGLINE responses
OPER_CHANKILL_SYNTAX
	CHANKILL [+expiry] {#channel} [reason]
# SGLINE responses
OPER_SGLINE_SYNTAX
	SGLINE {ADD | DEL | LIST | VIEW | CLEAR} [[+zamanam] {mask | kayt-sras} [sebep]]
OPER_SGLINE_UNSUPPORTED
	SGLINE bu networkte mevcut deil.
OPER_SGLINE_EXISTS
	%s zaten SGLINE listesinde.
OPER_SGLINE_ALREADY_COVERED
	%s zaten %s tarafndan deitirildi.
OPER_SGLINE_REACHED_LIMIT
	Sadece %d kii SGLINE listesinde olabilir.
OPER_SGLINE_ADDED
	%s SGLINE listesinde eklendi.
OPER_SGLINE_CHANGED
	%s nickinin zaman am sresi deitirildi.
OPER_SGLINE_NOT_FOUND
	%s SGLINE listesinde bulunamad.
OPER_SGLINE_NO_MATCH
	SGLINE listesinde uyuan kayt bulunamad.
OPER_SGLINE_DELETED
	%s SGLINE listesinden silindi.
OPER_SGLINE_DELETED_ONE
	SGLINE listesinden 1 kayt silindi.
OPER_SGLINE_DELETED_SEVERAL
	SGLINE listesinden %d kayt silindi.
OPER_SGLINE_LIST_EMPTY
	SGLINE listesi bo.
OPER_SGLINE_LIST_HEADER
	u anki SGLINE listesi:
	  No   Mask                              Sebep
OPER_SGLINE_LIST_FORMAT
	  %3d   %-32s  %s
OPER_SGLINE_VIEW_HEADER
	u anki SGLINE listesi:
# number, mask, set-by, set-time, expires, reason
OPER_SGLINE_VIEW_FORMAT
	%3d  %s (by %s on %s; %s)
	      %s
OPER_SGLINE_CLEAR
	SGLINE listesi temizlendi.

# SQLINE responses
OPER_SQLINE_SYNTAX
	SQLINE {ADD | DEL | LIST | VIEW | CLEAR} [[+zaman asimi] {mask | kayit-sirasi} [sebep]]
OPER_SQLINE_CHANNELS_UNSUPPORTED
	SQLINE kullandiginiz IRCd tarafindan desteklenmiyor, bu yzden kullanmazsiniz.
OPER_SQLINE_EXISTS
	%s zaten SQLINE listesinde mevcut.
OPER_SQLINE_ALREADY_COVERED
	%s zaten %s tarafindan degistirildi.
OPER_SQLINE_REACHED_LIMIT
	Toplam %d SQLINE olabilir.
OPER_SQLINE_ADDED
	%s SQLINE listesine eklendi.
OPER_SQLINE_CHANGED
	%s iin zaman asimi sresi degistirildi.
OPER_SQLINE_NOT_FOUND
	%s SQLINE listesinde bulunamadi.
OPER_SQLINE_NO_MATCH
	SQLINE listesinde uyusan kayit bulunamadi.
OPER_SQLINE_DELETED
	%s SQLINE listesinden silindi.
OPER_SQLINE_DELETED_ONE
	SQLINE listesinden 1 kayit silindi.
OPER_SQLINE_DELETED_SEVERAL
	SQLINE listesinden %d kayit silindi.
OPER_SQLINE_LIST_EMPTY
	SQLINE listesi bos.
OPER_SQLINE_LIST_HEADER
	Mevcut SQLINE listesi:
	  Num   Mask                              Sebep
OPER_SQLINE_LIST_FORMAT
	  %3d   %-32s  %s
OPER_SQLINE_VIEW_HEADER
	Mevcut SQLINE listesi:
# number, mask, set-by, set-time, expires, reason
OPER_SQLINE_VIEW_FORMAT
	%3d  %s (by %s on %s; %s)
	      %s
OPER_SQLINE_CLEAR
	SQLINE listesi temizlendi.

# SZLINE responses
OPER_SZLINE_SYNTAX
	SZLINE {ADD | DEL | LIST | VIEW | CLEAR} [[+zamanam] {mask | kayt-sras} [sebep]]
OPER_SZLINE_UNSUPPORTED
	SZLINE bu networkte mevcut deil.
OPER_SZLINE_EXISTS
	%s zaten SZLINE listesinde.
OPER_SZLINE_ALREADY_COVERED
	%s zaten %s tarafndan deitirildi.
OPER_SZLINE_REACHED_LIMIT
	Sadece %d kii SZLINE listesinde olabilir.
OPER_SZLINE_ONLY_IPS
	Hatrlatma: SZLINE listesine sadece IP masklarn ekleyebilirsiniz.
OPER_SZLINE_ADDED
	%s SZLINE listesine eklendi.
OPER_SZLINE_CHANGED
	%s nickinin zaman am sresi deitirildi.
OPER_SZLINE_NOT_FOUND
	%s SZLINE listesinde bulunamad.
OPER_SZLINE_NO_MATCH
	SZLINE listesinde uyuan kayt bulunamad.
OPER_SZLINE_DELETED
	%s SZLINE listesinden silindi.
OPER_SZLINE_DELETED_ONE
	SZLINE listesinden 1 kayt silindi.
OPER_SZLINE_DELETED_SEVERAL
	SZLINE listesinden %d kayt silindi.
OPER_SZLINE_LIST_EMPTY
	SZLINE listesi bo.
OPER_SZLINE_LIST_HEADER
	u anki SZLINE listesi:
	  No   Mask                              Sebep
OPER_SZLINE_LIST_FORMAT
	  %3d   %-32s  %s
OPER_SZLINE_VIEW_HEADER
	u anki SZLINE listesi:
# number, mask, set-by, set-time, expires, reason
OPER_SZLINE_VIEW_FORMAT
	%3d  %s (by %s on %s; %s)
	      %s
OPER_SZLINE_CLEAR
	SZLINE listesi temizlendi.

# SET responses
OPER_SET_SYNTAX
	SET zellik ayar
OPER_SET_IGNORE_ON
	Ignore kodu AKTIF.
OPER_SET_IGNORE_OFF
	Ignore kodu KAPALI.
OPER_SET_IGNORE_ERROR
	IGNORE ayar ON veya OFF eklinde olmaldr.
OPER_SET_READONLY_ON
	Servisler imdi read-only modunda.
OPER_SET_READONLY_OFF
	Servisler imdi read-write modunda.
OPER_SET_READONLY_ERROR
	READONLY ayar ON veya OFF eklinde olmaldr.
OPER_SET_LOGCHAN_ON
	Services is now reporting log messages to %s.
OPER_SET_LOGCHAN_OFF
	Services is no longer reporting log messages to a channel.
OPER_SET_LOGCHAN_ERROR
	Setting for LOGCHAN must be ON or OFF and LogChannel must be defined.
OPER_SET_DEBUG_ON
	Servisler imdi debug modunda.
OPER_SET_DEBUG_OFF
	Servisler imdi non-debug modunda.
OPER_SET_DEBUG_LEVEL
	Servisler imdi debug modunda (seviye %d).
OPER_SET_DEBUG_ERROR
	DEBUG ayar ON, OFF, veya pozitif bir say olmaldr.
OPER_SET_NOEXPIRE_ON
	Servisler imdi no expire modunda.
OPER_SET_NOEXPIRE_OFF
	Servisler imdi expire modunda.
OPER_SET_NOEXPIRE_ERROR
	NOEXPIRE ayar ON yada OFF olmaldr.
OPER_SET_UNKNOWN_OPTION
	Varolmayan zellik %s.
OPER_SET_SQL_ON
	SQL code kullanlabilir.
OPER_SET_SQL_OFF
	SQL code kullanlamaz.
OPER_SET_SQL_ERROR
	Sql zellii sadece ON veya OFF olarak ayarlanabilir.
OPER_SET_SQL_ERROR_INIT
	Error during init of SQL, check your logs to correct.
OPER_SET_SQL_ERROR_DISABLED
	SQL ayarlar bu sunucu icin duzenlenmi durumda degil. ltfen ayar dosyasn
	(services.conf) duzenleyiniz.
OPER_SET_LIST_OPTION_ON
	%s ack
OPER_SET_LIST_OPTION_OFF
	%s kapal

# NOOP responses
OPER_NOOP_SYNTAX
	NOOP {SET|REVOKE} server
OPER_NOOP_SET
	%s serverndaki tm O:line lar silindi.
OPER_NOOP_REVOKE
	%s serverndaki tm O:line lar resetlendi.

# JUPE responses
OPER_JUPE_SYNTAX
	JUPE serverismi [sebep]

# RAW responses
OPER_JUPE_HOST_ERROR
	Gecerli bir sunucu ad giriniz
OPER_JUPE_INVALID_SERVER
	Bal oldugunuz sunucuda bu uygulamay yapamazsnz.
	
# RAW responses
OPER_RAW_SYNTAX
	RAW yaz

# UPDATE responses
OPER_UPDATING
	Veritaban gncelleniyor.

# RELOAD responses
OPER_RELOAD
	Servislerin conf dosyas yeniden yklendi.

# RESTART responses
OPER_CANNOT_RESTART
	SERVICES_BIN tanmlanmam; restart edilemiyor.  Yeniden \2configure\2 edin ve RESTART komutunu aktifletirmek iin Servisleri yeniden derleyin.

# LISTIGNORE responses
OPER_IGNORE_SYNTAX
	IGNORE {ADD|DEL|LIST|CLEAR} [time] [nick | mask]
OPER_IGNORE_VALID_TIME
	Gecerli bir zaman giriniz.
OPER_IGNORE_TIME_DONE
	%s rumuzu %s saniyeligine servisler tarafndan engellendi.
OPER_IGNORE_PERM_DONE
	%s rumuzunu engelledim. Artk beni kullanamaz.
OPER_IGNORE_DEL_DONE
	%s rumuzu servis engellerinden kaldrld.
OPER_IGNORE_LIST
	Servisler ignore listesi:
OPER_IGNORE_LIST_NOMATCH
	%s rumuzu sunucunun engelledigi kiiler arasnda bulunmuyor.
OPER_IGNORE_LIST_EMPTY
	Ignore listesi bo.

# KILLCLONES responses
OPER_IGNORE_LIST_CLEARED
	Ignore listesi temizlendi.

# KILLCLONES responses
OPER_KILLCLONES_SYNTAX
	KILLCLONES nick
OPER_KILLCLONES_UNKNOWN_NICK
	Kullanc %s bulunamad.
	
# CHANLIST responses
OPER_CHANLIST_HEADER
	Kanal listesi:
	sim              Kullanici Modlari  Konu
OPER_CHANLIST_HEADER_USER
	%s kanal listesi:
	sim              Kullanici Modlari  Konu
OPER_CHANLIST_RECORD
	%-20s  %4d +%-6s %s
OPER_CHANLIST_END
	Kanal listesi sonu.
	
# USERLIST responses
OPER_USERLIST_HEADER
	Kullanc listesi:
	Nick                 Mask
OPER_USERLIST_HEADER_CHAN
	%s kullanc listesi:
	Nick                 Mask
OPER_USERLIST_RECORD
	%-20s %s@%s
OPER_USERLIST_END
	Kullanc listesi sonu.

# CACHE responses
OPER_SUPER_ADMIN_ON
	Su anda SuperAdminsiniz
OPER_SUPER_ADMIN_OFF
	SuperAdmin Kapatld
OPER_SUPER_ADMIN_SYNTAX
	Bu zellik ON ve OFF olarak kullanlabilir.
OPER_SUPER_ADMIN_WALL_ON
	%s Super-Admin
OPER_SUPER_ADMIN_WALL_OFF
	%s Super-Admin durumunda degil

###########################################################################
#
# Session Limiting and Exception messages
#
###########################################################################

# EXCEPTION responses
OPER_SUPER_ADMIN_ONLY
	Sadece SuperAdmin kullanmna acktr.

###########################################################################
#
# Session Limiting and Exception messages
#
###########################################################################

# EXCEPTION responses
OPER_STAFF_LIST_HEADER
	Durum Seviye Rumuz

# DefCon Messages

OPER_STAFF_FORMAT
	 %c %s  %s
OPER_STAFF_AFORMAT
	 %c %s  %s [%s]

# DefCon Messages

OPER_DEFCON_SYNTAX
	DEFCON [1|2|3|4|5]
OPER_DEFCON_DENIED
	Bu servis su anda kullanlamaz, daha sonra tekrar deneyiniz
OPER_DEFCON_NO_CONF
	DEFCON sistemi services.conf dosyasndan aclabilir
OPER_DEFCON_CHANGED
	Servislerin DEFCON girdigi artk %d
OPER_DEFCON_WALL
	%s DEFCON seviyesi %d olarak degitirildi
DEFCON_GLOBAL
	Defcon Seviyesi Su anda: %d

# Modules strings

OPER_MODULE_LOADED
	Eklenti %s yuklendi
OPER_MODULE_UNLOADED
	Eklenti %s kaldrld
OPER_MODULE_LOAD_FAIL
	Bilinmeyen eklenti %s
OPER_MODULE_REMOVE_FAIL
	Geersiz eklenti %s
OPER_MODULE_NO_UNLOAD
	Bu eklenti kaldrlamyor.
OPER_MODULE_LOAD_SYNTAX
	MODLOAD FileName
OPER_MODULE_UNLOAD_SYNTAX
	MODUNLOAD FileName
OPER_MODULE_LIST_HEADER
	Mevcut eklenti listesi:
OPER_MODULE_LIST
	Module: %s [%s] [%s]
OPER_MODULE_LIST_FOOTER
	%d eklenti ykl bulunuyor.
OPER_MODULE_INFO_LIST
	Eklenti: %s Versiyon: %s Yapmc: %s Yuklenme tarihi: %s
OPER_MODULE_CMD_LIST
	Belirtilmis komut: %R%s %s
OPER_MODULE_MSG_LIST
	Belirtilmis IRCD balants: %s
OPER_MODULE_NO_LIST
	Eklenti bulunmuyor
OPER_MODULE_NO_INFO
	%s eklentisi icin bir bilgi bulunmuyor
OPER_MODULE_INFO_SYNTAX
	MODINFO EklentiIsmi

###########################################################################
#
# Session Limiting and Exception messages
#
###########################################################################

# EXCEPTION responses
MODULE_HELP_HEADER
	Modulu yuklemek icin icerigi takip ediniz:

###########################################################################
#
# Session Limiting and Exception messages
#
###########################################################################

# EXCEPTION responses
OPER_EXCEPTION_SYNTAX
	EXCEPTION {ADD | DEL | MOVE | LIST | VIEW} [parametreler]
OPER_EXCEPTION_ADD_SYNTAX
	EXCEPTION ADD [+zamanam] mask limit sebep
OPER_EXCEPTION_DEL_SYNTAX
	EXCEPTION DEL {mask | liste}
OPER_EXCEPTION_MOVE_SYNTAX
	EXCEPTION MOVE num pozisyon
OPER_EXCEPTION_DISABLED
	Session limit koyma devre d.
OPER_EXCEPTION_ALREADY_PRESENT
	Mask %s zaten exception listesinde bulunuyor.
OPER_EXCEPTION_TOO_MANY
	Session-limit exception listesi dolu!
OPER_EXCEPTION_ADDED
	%s iin session limit %d olarak deitirildi.
OPER_EXCEPTION_MOVED
	%s (#%d) iin exception %d pozisyonuyla deitirildi.
OPER_EXCEPTION_NO_SUCH_ENTRY
	(#%d) byle bir kayt yok. session-limit exception listesi.
OPER_EXCEPTION_NOT_FOUND
	%s session-limit exception listesinde bulunamad.
OPER_EXCEPTION_NO_MATCH
	session-limit exception listesinde uyuan kayt bulunamad.
OPER_EXCEPTION_DELETED
	%s session-limit exception listesinden silindi.
OPER_EXCEPTION_DELETED_ONE
	Session-limit exception listesinden 1 kayt silindi.
OPER_EXCEPTION_DELETED_SEVERAL
	Session-limit exception listesinden %d kayt silindi.
OPER_EXCEPTION_LIST_HEADER
	u anki Session Limit Exception listesi:
# mask, limit
OPER_EXCEPTION_LIST_FORMAT
	%3d  %4d   %s
OPER_EXCEPTION_LIST_COLHEAD
	Say  Limit  Host
# mask, set-by, set-time, expires, limit, reason
OPER_EXCEPTION_VIEW_FORMAT
	%3d.  %s  (by %s on %s; %s)
	    Limit: %-4d  - %s
OPER_EXCEPTION_INVALID_LIMIT
	Geersiz session limiti. Sfrdan byk yada eit ve %d den az bir geerli tamsay olmaldr.
OPER_EXCEPTION_INVALID_HOSTMASK
	Geersiz hostmask. Sadece gerek hostmasklar exception olarak geerlidir.
OPER_EXCEPTION_EXISTS
	%s Zaten listede bulunuyor.
OPER_EXCEPTION_CHANGED
	%s - %d olarak gncellendi.

# SESSION responses
OPER_SESSION_SYNTAX
	SESSION {LIST limit | VIEW host}
OPER_SESSION_LIST_SYNTAX
	SESSION LIST limit
OPER_SESSION_VIEW_SYNTAX
	SESSION VIEW host
OPER_SESSION_DISABLED
	Session limit koyma devre d.
OPER_SESSION_INVALID_THRESHOLD
	Geersiz threshold deeri. 1 den byk geerli tamsay olmaldr.
OPER_SESSION_NOT_FOUND
	%s session listesinde bulunamad.
OPER_SESSION_LIST_HEADER
	En az %d sessionl hostlar:
OPER_SESSION_LIST_COLHEAD
	Sessionlar  Host
# limit, host
OPER_SESSION_LIST_FORMAT
	%6d    %s
# host, sessions, limit
OPER_SESSION_VIEW_FORMAT
	Host %s u anda %d session a sahip ve %d ile limitli.

# EXCEPTION help

OPER_HELP_EXCEPTION
	Kullanm: EXCEPTION ADD [+zamanam] mask limit sebep
	           EXCEPTION DEL {mask | liste}
	           EXCEPTION MOVE num pozisyon
	           EXCEPTION LIST [mask | liste]
	           EXCEPTION VIEW [mask | liste]
	
	Servis adminlerinin, belirli oturum limiti olan hostlarn 
	listesini deitirmesini salar. Shell server gibi baz 
	makinalarn varsaylandan daha fazla kullancy ayn anda
	tamasn salar. Eer bir host session(oturum) limitine
	ulamsa o hosttan balanmaya alan tm kullanclar 
	kill lenir. Kill lenmeden nce, %S'n /NOTICE i ile
	uyarlarak session limiti hakknda yardm verilir. Bu uyarnn
	ierii ayar yapmayla ilgilidir.
	
	EXCEPTION ADD exception(istisna) listesine belirtilen hostmask
	ekler. nick!user@host ve user@host masklarnn geersiz 
	olduunu unutmayn! Sadece box.host.dom ve *.host.dom gibi 
	gerek hostmasklar kullanlabilinir, nk session limitleme 
	nickleri ve username leri hesaba almaz. limit sfrdan byk 
	yada eit bir rakam olmaldr. Bu o host un ayn anda ka oturum
	(session) kaldrabileceini belirler. Sfr deeri o host un
	snrsz oturum limiti olduunu belirtir. Opsiyonel zamanam 
	parametresinin format ile ilgili yardm iin AKILL in 
	yardmna baknz.
	EXCEPTION DEL listesinden belirtilen mask  karr.
	EXCEPTION MOVE exception numarasn(num) pozisyona (position)
	evirir. Aralarndaki exceptionlarn yeri aral doldurmak iin 
	yukar yada aa deitirilecektir.
	EXCEPTION LIST ve EXCEPTION VIEW tm mevcut exceptionlar 
	gsterir; eer opsiyonel olarak mask belirtilmise, liste
	bu masklarla uyuan exceptionlarla snrlandrlr. Aradaki fark
	EXCEPTION VIEW daha gelismis bir komuttur ve exception  ekleyenin 
	nickini, o exceptionn session limitini, sebebi, host mask ve zaman 
	am tarih ve zamann gsterir.
	
	Balanan kullanc, hostuyla uyuan ilk exception kullanr. Byk 
	exception listeleri ve geni olarak uyuan exception masklar 
	servislerin performansn drr. 
	
	Servis adminleri tarafndan kullanlabilir.

OPER_HELP_SESSION
	Kullanm: SESSION LIST threshold
	           SESSION VIEW host
	
	Servis adminlerinin session listesini grntlemesini salar.
	
	SESSION LIST en az threshold sessionlardaki hostlar listeler.
	Threshold(eik) 1 den byk bir say olmaldr. Bu byk 
	ldeki tek session hostlarn yanllkla listelenmelerini 
	nlemek iindir.
	SESSION VIEW belirli bir host hakknda ayrntl bilgileri 
	grntler. Bu o anki session saysn ve session limitinide
	gsterir. host deeri wildcard(ak olarak yazlmaldr) 
	iermemelidir.
	
	Session limitleme ve belirli hostlara ve gruplara nasl session 
	limit koyulaca hakknda yardm iin EXCEPTION yardmna bakn.
	
	Servis adminleri tarafndan kullanlabilir.

###########################################################################
#
# News system messages
#
###########################################################################

OPER_HELP_STAFF
	Kullanm: STAFF

	Sunucu zerinde yetkili bulunan nicklerin yetki seviyelerini
	ve su anda bal olup olmadklarn gsterir.

OPER_HELP_DEFCON
	Kullanm: DEFCON [1|2|3|4|5]

	Defcon sistem sunucu icin onceden tanmlanms ayarlardr
	servislerin daha iyi calsmalar ve herhangi bir saldr annda
	servislerin mevcut durumunu korumak icin dzenlenmistir.

OPER_HELP_DEFCON_NO_NEW_CHANNELS
	* Yeni kanal kayt edilemez
OPER_HELP_DEFCON_NO_NEW_NICKS
	* Yeni rumuz kayt edilemez
OPER_HELP_DEFCON_NO_MLOCK_CHANGE
	* Mlock degitirilemez
OPER_HELP_DEFCON_FORCE_CHAN_MODES
	* (%s) tm kanallar icin zorunlu mod olarak atand
OPER_HELP_DEFCON_REDUCE_SESSION
	* Balant limiti azaltld %d
OPER_HELP_DEFCON_NO_NEW_CLIENTS
	* Yeni baglantlar kopartr
OPER_HELP_DEFCON_OPER_ONLY
	* Operler haric servisleri diger kullanclar engeller
OPER_HELP_DEFCON_SILENT_OPER_ONLY
	* Sessizleri engelle(operler haric)
OPER_HELP_DEFCON_AKILL_NEW_CLIENTS
	* Yeni balantlar akill listesine ekle


###########################################################################
#
# News system messages
#
###########################################################################

OPER_HELP_DEFCON_NO_NEW_MEMOS
	* Yeni cevrimdisi mesaj gonderilemez
OPER_HELP_CHANKILL
	Kullanm: CHANKILL [+expiry] channel reason

	Belirtilmis kanaldaki herkezi akill listesine ekler.
	Kullanm sonucu ident@host seklinde tm rumuzlar akill listesine alr,
	bu listeden yasak kaldrmak icin normal akill listesi kontrol edilmeli ve ayn yntem kullanlmaldr. 

###########################################################################
#
# News system messages
#
###########################################################################

NEWS_LOGON_TEXT
	[Balant Haberleri - %s] %s
NEWS_OPER_TEXT
	[Operatr Haberleri - %s] %s
NEWS_RANDOM_TEXT
	[Karisik Haberler - %s] %s

NEWS_LOGON_SYNTAX
	LOGONNEWS {ADD|DEL|LIST} [yaz|num]
NEWS_LOGON_LIST_HEADER
	Balant haberleri:
NEWS_LOGON_LIST_ENTRY
	%5d (%s by %s)
	    %s
NEWS_LOGON_LIST_NONE
	Hi balant haberi yok.
NEWS_LOGON_ADD_SYNTAX
	LOGONNEWS ADD yaz
NEWS_LOGON_ADD_FULL
	Haber listesi dolu!
NEWS_LOGON_ADDED
	Yeni balant haberleri maddesi eklendi (#%d).
NEWS_LOGON_DEL_SYNTAX
	LOGONNEWS DEL {num | ALL}
NEWS_LOGON_DEL_NOT_FOUND
	Balant haberleri maddesi #%d bulunamad!
NEWS_LOGON_DELETED
	Balant haberleri maddesi #%d silindi.
NEWS_LOGON_DEL_NONE
	Silebileceiniz balant haberleri maddesi yok!
NEWS_LOGON_DELETED_ALL
	Tm balant haberleri silindi.

NEWS_OPER_SYNTAX
	Kullanm: OPERNEWS {ADD|DEL|LIST} [yaz|num]
NEWS_OPER_LIST_HEADER
	Operatr haberleri:
NEWS_OPER_LIST_ENTRY
	%5d (%s by %s)
	    %s
NEWS_OPER_LIST_NONE
	Hi operatr haberi yok.
NEWS_OPER_ADD_SYNTAX
	Kullanm: OPERNEWS ADD yaz
NEWS_OPER_ADD_FULL
	Haber listesi dolu!
NEWS_OPER_ADDED
	Yeni operatr haberleri maddesi eklendi (#%d).
NEWS_OPER_DEL_SYNTAX
	Kullanm: OPERNEWS DEL {num | ALL}
NEWS_OPER_DEL_NOT_FOUND
	Operatr haberleri maddesi #%d bulunamad!
NEWS_OPER_DELETED
	Operatr haberleri maddesi #%d silindi.
NEWS_OPER_DEL_NONE
	Silebileceiniz operatr haberleri maddesi yok!
NEWS_OPER_DELETED_ALL
	Tm operatr haberleri maddeleri silindi.

NEWS_RANDOM_SYNTAX
	RANDOMNEWS {ADD|DEL|LIST} [yazi|no]
NEWS_RANDOM_LIST_HEADER
	Karisik haberler:
NEWS_RANDOM_LIST_ENTRY
	%5d (%s by %s)
	    %s
NEWS_RANDOM_LIST_NONE
	Hi karisik haber yok.
NEWS_RANDOM_ADD_SYNTAX
	RANDOMNEWS ADD yazi
NEWS_RANDOM_ADD_FULL
	Haber listesi dolu!
NEWS_RANDOM_ADDED
	Yeni karisik haber eklendi (#%d).
NEWS_RANDOM_DEL_SYNTAX
	RANDOMNEWS DEL {no | ALL}
NEWS_RANDOM_DEL_NOT_FOUND
	#%d numarali karisik haber bulunamadi!
NEWS_RANDOM_DELETED
	#%d numarali karisik haber silindi.
NEWS_RANDOM_DEL_NONE
	Silinecek karisik haber yok!
NEWS_RANDOM_DELETED_ALL
	Tm karisik haberler silindi.

NEWS_HELP_LOGON
	Kullanm: LOGONNEWS ADD yaz
	        LOGONNEWS DEL {num | ALL}
	        LOGONNEWS LIST
	
	Giri haberleri ve mesajlarn dzenlemek icin kullanlr. 
	Kullanc sunucuya balant anda bu belirtilen mesajlar giris yapan kullancya 
	iletilir.  (Bununla beraber, %s adetten fazla mesaj kullancya
	gonderilmez.  Eer cok fazla mesaj eklenmi bulunuyor ise
	bunlardan en yenileri kullancya ulatrlr.)
	NewsCount(Giri haberleri) zellikleri services.conf'ta belirtilmitir ve bu dosyadan ayarlanabilir.
	
	LOGONNEWS may only be used by Services admins. 

NEWS_HELP_OPER
	Kullanm: OPERNEWS ADD text
	        OPERNEWS DEL {num | ALL}
	        OPERNEWS LIST
	
	Giri haberleri ve mesajlarn dzenlemek icin kullanlr(Ynetici girileri). 
	Kullanc sunucu ierisinde ynetici konumuna gectii anda bu belirtilen mesajlar giris yapan operatore 
	iletilir.  (Bununla beraber, %s adetten fazla mesaj yneticiye
	gonderilmez.  Eer cok fazla mesaj eklenmi bulunuyor ise
	bunlardan en yenileri kullancya ulatrlr.)
	NewsCount(Giri haberleri) zellikleri services.conf'ta belirtilmitir ve bu dosyadan ayarlanabilir.
	
	OPERNEWS may only be used by Services admins. 

NEWS_HELP_RANDOM
	Kullanimi: RANDOMNEWS ADD yazi
	           RANDOMNEWS DEL {no | ALL}
	           RANDOMNEWS LIST
	
	Karisik haberleri dzenlemenizi saglar. Bir kullanici
	network e baglandigi zaman, karisik haberlerden bir tanesi
	seilerek kullaniciya gnderilir.
	
	RANDOMNEWS may only be used by Services admins. 

###########################################################################
#
# HelpServ help message
#
###########################################################################

HELP_HELP
	%S servisler hakknda bilgi vermek iin tasarlanmtr.
	Yardm konularna dier servislerin HELP komutuyla ulalr.
	
	%R%s HELP
	     nick kayt hakknda bilgiler ierir.
	
	%R%s HELP
	     kanal kayd ve kontrol hakknda bilgi ierir.
	
	%R%s HELP
	     kullanclara internette olmasalar bile mesaj gndermek
	     iin gerekli bilgileri ierir.

HELP_HELP_BOT

	%R%s HELP
	     kanallara bot sokulmas ve ayarlar hakknda bilgi ierir.

HELP_HELP_HOST

	%R%s HELP
	     for information on setting up nick vHosts

###########################################################################
#
# NickServ help messages
#
###########################################################################
NICK_HELP_CMD_CONFIRM
	    CONFIRM    Nick kayt aktivasyonu iin kullanlr. Aktivasyon kodunu tantma komutudur.
NICK_HELP_CMD_RESEND
	    RESEND     Nick Servisleri aktivasyon kodunu tekrar gnderir

NICK_HELP_CMD_REGISTER
	    REGISTER   Nickinizi kaydeder
NICK_HELP_CMD_GROUP
	    GROUP      Bir gruba dahil eder
NICK_HELP_CMD_IDENTIFY
	    IDENTIFY   ifrenizle nickinizi tantr
NICK_HELP_CMD_ACCESS
	    ACCESS     zinli adreslerin listesini dzenler
NICK_HELP_CMD_SET
	    SET        Ayarlar, kill korumasn ierir
NICK_HELP_CMD_SASET
	    SASET      Baka bir rumuzun ayarlarn dzenlemede kullanlr
NICK_HELP_CMD_DROP
	    DROP       Nickin kaydn siler
NICK_HELP_CMD_RECOVER
	    RECOVER    Nickinizi kullanan birini kill ler
NICK_HELP_CMD_RELEASE
	    RELEASE    RECOVER komutundan sonra nickinizi serbest 
	               brakr
NICK_HELP_CMD_SENDPASS
	    SENDPASS   ifrenizimi unuttunuz? Bunu deneyin
NICK_HELP_CMD_GHOST
	    GHOST      "askda kalm" bir rumuzu sunucudan atar 
NICK_HELP_CMD_ALIST
	    ALIST      Yetkili olduunuz kanallari listeler
NICK_HELP_CMD_GLIST
	    GLIST      Nick grubunuzdaki nickleri listeler
NICK_HELP_CMD_INFO
	    INFO       Belirlenen rumuza ait olan bilgileri gsterir
NICK_HELP_CMD_LIST
	    LIST       Kaytl olan nickleri seilen parametrelere gre listeler
NICK_HELP_CMD_LOGOUT
	    LOGOUT     Sisteme tanttnz(identify) rumuzun sistemden ckn salar.(Bylece yetkisiz konuma gecersiniz.)
NICK_HELP_CMD_STATUS
	    STATUS     Seilen rumuzun durum ve seviyesini gsterir
NICK_HELP_CMD_UPDATE
	    UPDATE     Durumuzunu gnceller, rnekle. Cevrimdisi mesajlarnz, Vhost vs.
NICK_HELP_CMD_GETPASS
	    GETPASS    Bir nickin ifresini renmek iindir
	               (Sadece ifreleme(encryption) devre dysa)
NICK_HELP_CMD_GETEMAIL
	    GETEMAIL   Girilen mail adresi ile o adresi kaytta kullanan kisileri eletirir 
NICK_HELP_CMD_FORBID
	    FORBID     Bir nickin kullanlmasn yasaklar
NICK_HELP_CMD_SUSPEND
	    SUSPEND    Seilen rumuzu askya alr.
NICK_HELP_CMD_UNSUSPEND
	    UNSUSPEND  Geici olarak kullanma kapatlm rumuzu kullanma aar.

NICK_HELP
	%S nickinizi "kayt" etmenizi ve dierlerinin nickinizi 
	kullanmalarn engellemeyi salar. Aadaki komutlar nicki
	kayt etmeye ve korumaya izin verir, kullanmak iin, 
	%R%S komut yazn. Belirli bir komut hakknda daha 
	fazla bilgi iin, %R%S HELP komut yazn.
	
NICK_HELP_FOOTER
	NOT: Bu servis kullanclarn kimliklerini tehlikeye 
	atmayacak ekilde tasarlanmtr. Bu nickleri "almay" 
	veya dier kt niyetli hareketleri kolaylatrmay salama
	amal deildir. %S 'n ktye Kullanm ktye 
	kullanlan kiinin nickini kaybetmesiyle sonulanacaktr.

NICK_HELP_EXPIRES
	
	Daha fazla kullanlmayan nicklerin otomatik olarak
	kaydnn silinmesi sz konusudur, mesela kullanlmayan
	nickler %d gn sonra silinirler.

NICK_HELP_REGISTER
	Kullanm: REGISTER ifre [email]
	
	%S 'n veritabanna nickinizi kaydeder. Nickinizi 
	bir kere kayt ettikten sonra nickinizin zelliklerini 
	istediiniz gibi belirlemek iin SET ve ACCESS 
	komutlarn kullanabilirsiniz. Kaytta kullandnz ifrenin
	hatrlanabilecek birey olmasna dikkat edin - ilerde
	nickinizin zelliklerinde deiiklik yaparken ve sunucuda
	kullanabilmek iin ihtiyacnz olacak. (ifrelerin byk
	kk harf hassasiyeti olduunu unutmayn! XR, xir, 
	ve ixir ifreleri birbirinden farkldr.)
	
	ifreleri seme konusunda rehber:
	
	ifreler kolayca tahmin edilebilir olmamaldr.  rnein,
	gerek isminizi ifre olarak kullanmak kt bir fikirdir.
	Nickinizi ifre olarak kullanmak daha kt bir fikirdir :)
	ve zaten %S buna izin vermez. Ayrca ksa ifreler 
	deneme yanlma yntemiyle bulunabilirler, bu yzden ifrenizin
	en az 5 karakter olmasna dikkat edin. Son olarak ifrede
	boluk kullanmamanz gerekir.
	
	email parametresi opsiyoneldir ve nickiniz iin bir 
	email adresi belirler. Fakat baz networklerde bu
	parametrenin kullanlmas zorunlu olabilir.(Unutmayn
	email adresinizi doru olarak vermeniz ilerde ifrenizi 
	unutmanz halinde ok ie yarayacaktr)
	Gizliliinize sayg duyulacak ve mail adresiniz herhangi 
	nc ahslara sylenmeyecektir.

	Bu komut ayrca nickiniz iin yeni bir grup oluturur ki bu
	ilerde gruba kaydedeceiniz nickler iin ayn zellikleri, 
	memo ayarlarn ve ayn kanal ayrcalklarn paylamanz 
	salar. Bu zellik hakknda daha fazla bilgi iin, 
	%R%S HELP GROUP yazn.


NICK_HELP_GROUP
	Kullanm: GROUP hedef ifre
	
	Bu komut nickinizin hedef gsterilen nickin grubuna katlmasn
	salar. ifre hedef gsterilen nickin ifresidir.
	
	Bir gruba dahil olmak size o gruba dahil olan tm nicklerinizin
	ayarlarn, memolarn, ve kanal ayrcalklarn paylamanz ve 
	daha fazlasn salar!
	 
	Bir grup kullanl olduu srece kalcdr. Bu demektirki eer
	gruba dahil nickleriniz kaydn silerseniz, grupta en az bir nick 
	kalmas kaydiyle yukarda aklanan paylamlar kaybetmezseniz.
	
	Bu komutu nickinizi kaydetmemi olsanz bile kullanabilirsiniz.
	Eer nickiniz zaten kaytl ise, bu komutu kullanmadan nce
	nickinizi tantmanz gerekir, daha fazla bilgi iin
	%R%S HELP IDENTIFY yazn. Sizin IRC networkunuzda
	bu mmkn olmayabilir.
	
	Bu komutu kaytl olmayan bir nickle kullanmanz nerilir nk
	bu komutu kullanc o nick otomatik olarak kaydedilir. Bunu
	kaytl bir nicklede eer network adminleri buna izin veriyorsa
	kullanabilirsiniz.
	
	Bir seferde sadece bir grupta olabilirsiniz. Grup kartrma
	mmkn deildir.
	
	Not: bir gruptaki tm nickler bir ifreye sahip olurlar.

NICK_HELP_IDENTIFY
	Kullanm: IDENTIFY ifreniz
	
	%S 'e kullandnz nickin gerek sahibinin siz olduunu
	belirtir. ou komut kullanlmadan nce bu komutla 
	tantlmanz gerektirir. ifreniz nickinizi kayt ederken 
	REGISTER komutuyla beraber kullandnzla ayndr.

NICK_HELP_UPDATE
	Kullanm: UPDATE

	Durumunuzu gnceller, rnein; Yeni cevrimdisi mesajlarnz,
	sahib oldugunuz kanal modlarn (ModeonID aktif olmaldr), vhost'unuzu  ve
	kiisel bilgilerinizi gnceller (son grnme zaman, vs.).
	
NICK_HELP_LOGOUT
	Kullanm: LOGOUT
	
	IDENTIFY komutunun yapt etkiyi tersine evirir,
	yani artk o nickin gerek sahibi olarak tannmamanz
	salar. Fakat sizden nickinizi tekrar identify etmeniz 
	istenmez.

NICK_HELP_DROP
	Kullanm: DROP [nick]
	
	%S 'n veritabanndan nickinizi siler. Silinmi bir nick
	bakas tarafndan kayt edilebilir.

	nick parametresini kullanarak belirttiiniz nicki
	grubunuzdan silebilirsiniz.
	
	Bu komutu kullanmadan nce, ifrenizle kendinizi tantmanz
	gereklidir (Daha fazla bilgi iin %R%S HELP IDENTIFY 
	yazn).

NICK_HELP_ACCESS
	Kullanm:  ACCESS ADD mask
	        ACCESS DEL mask
	        ACCESS LIST
	
	Nickinizin access litesini grntler ve deiiklikler 
	yapmanz salar. Bu listede belirtilen adresler %S 
	tarafndan nickinizi kullanabilmek iin otomatik olarak 
	tannacak adreslerdir. (bylece identify komutunu 
	kullanmanza gerek kalmaz.) Eer belirtilenden farkl bir 
	adresle balanmsanz %S 'n sizi tanmas iin 
	IDENTIFY komutunu kullanmanz gerekir.
	
	rnekler:
	
	    ACCESS ADD birisi@*.ixir.com
	        Kullanc birisi'ne ixir.com 
	        domaininden herhangi bir makineden 
	        eriim salar.
	
	    ACCESS DEL birisi@*.ixir.com
	        nceki komutun tersini yapar(siler).
	
	    ACCESS LIST
	        Mevcut access listesini grntler.

NICK_HELP_SET
	Kullanm: SET zellik parametre
	
	eitli nick zelliklerini ayarlar.  zellik unlardan biri 
	olabilir:
	
	    DISPLAY    Grubunuzun servislerde nasl grneceini ayarlar
	    PASSWORD   Nickinize ifre belirtir
	    LANGUAGE   Servislerin size hitap edecei 
	                  dili belirler
	    URL        Nickinizle bir URL yi ilikilendirir
	    EMAIL      Nickinizle bir email adresini ilikilendirir
	    ICQ        Nickinizle bir ICQ numarasn iliikilendirir
	    GREET      Nickiniz iin bir karlama mesaj belirler
	    KILL       Korumay aar kapatr
	    SECURE     Nick gvenliini aar kapatr
	    PRIVATE    Nickinizin %R%S LIST yazldnda grnmesini
	                  engeller
	    HIDE       Nickinizle ilgili baz bilgileri saklar
	    AUTOOP     Servisler sizi otomatik op yapar.    
	
	Bu komutu kullanabilmek iin nce, ifrenizle 
	kendinizi tantmanz gerekir (Daha fazla bilgi iin 
	%R%S HELP IDENTIFY yazn).
	
	Belirli bir zellik(option) hakknda bilgi almak iin
	%R%S HELP SET option yazn.

NICK_HELP_SET_DISPLAY
	Kullanm: SET DISPLAY yeni-grnm
	
	Servislerde grubunuzdaki nicklerden hangisinin gzkeceini
	ayarlar. Yeni grnm grubunuzda bulunan nicklerden biri 
	olmaldr.

NICK_HELP_SET_PASSWORD
	Kullanm: SET PASSWORD yeni ifre
	
	Nickinizi tantmak iin kullandnz ifreyi
	deitirir.

NICK_HELP_SET_LANGUAGE
	Kullanm: SET LANGUAGE numara
	
	Servislerin size hitap edecei dili belirlemenizi salar.
	(rnein, bir komut yazdnzda gelecek cevabn dili gibi).
	numara aadaki listede desteklenen dillerden biri olarak 
	belirlenir:

NICK_HELP_SET_URL
	Kullanm: SET URL url
	
	Nickiniz iin bir URL adresi belirtir. Bu URL adresi birisi
	sizin hakknzda bilgi almak iin INFO komutunu 
	kullandnda grnr.

NICK_HELP_SET_EMAIL
	Kullanm: SET EMAIL email adresiniz
	
	Nickiniz iin bir email adresi belirtir. Bu email adresi
	birisi sizin hakknzda bilgi almak iin INFO komutunu 
	kullandnda grnr.

NICK_HELP_SET_ICQ
	Kullanm: SET ICQ icqnumaranz
	
	Nickiniz iin bir ICQ numaras belirtir. Bu ICQ numaras
	birisi sizin hakknzda bilgi almak iin INFO komutunu
	kullandnda grnr.

NICK_HELP_SET_GREET
	Kullanm: SET GREET mesaj
	
	Yazdnz mesaj nickinizin karlama mesaj olarak
	belirler, bu mesaj GREET zellii aktif bir kanala 
	girdiinizde gnderilir, kanaldaki access seviyenize
	baldr.

NICK_HELP_SET_KILL
	Kullanm: SET KILL {ON | QUICK | IMMED | OFF}
	
	Nickiniz iin otomatik koruma zelliini aar ve kapatr.
	Koruma akken eer bir bakas sizin nickinizi kullanmaya 
	kalkarsa, o kiiye nicki deitirmesi iin bir dakika sre 
	verilir, eer deitirmezse %S tarafndan otomatik olarak
	deitirilir.
	
	Eer QUICK parametresini seerseniz, kullancya nickini
	deitirmesi iin 60 saniye yerine sadece 20 saniye verilir.
	Eer IMMED parametresini seerseniz kullancnn nicki
	uyarlmadan hemen deitirilir; ltfen ok gerekmedike
	bu zellii kullanmayn. Hatta network yneticileri bu
	zellii devre d brakm olabilirler.

NICK_HELP_SET_SECURE
	Kullanm: SET SECURE {ON | OFF}
	
	%S'n gvenlik zelliklerini aar ve kapatr. SECURE 
	ayar ile, nickin sahibi olarak tannmanz iin nce ifreyle 
	kendinizi tantmanz gerekir(adresinizin nickin access
	listesinde olup olmamasna bal olarak). Fakat, eer 
	adresiniz nickin access listesindeyse KILL zellii
	kullanlm olsa bile %S sizi otomatik olarak kill
	lemeyecektir.

NICK_HELP_SET_PRIVATE
	Kullanm: SET PRIVATE {ON | OFF}
	
	%S'n zel nick zelliini aar kapatr. PRIVATE ayar
	ile, %S'n LIST komutu kullanldnda nickiniz listede
	gzkmeyecektir.(Buna ramen, nickinizi bilen biri INFO 
	komutunu kullanarak hakknzda bilgi alabilir.)

NICK_HELP_SET_HIDE
	Kullanm: SET HIDE {EMAIL | USERMASK | QUIT} {ON | OFF}
	
	Birisi hakknzda bilgi almak iin %S INFO komutunu 
	kullandnda baz bilgilerin burada gzkmemesini salar.
	E-mail adresinizi (EMAIL), son grndnz user@host 
	maskn (USERMASK), ve son k mesajnz (QUIT)
	saklayabilirsiniz. kinici parametre bilginin grnp (OFF)
	grnmeyeceini (ON) belirtmenizi salar.

NICK_HELP_SET_MSG
	Kullanm: SET MSG {ON | OFF}
	
	Eer bal bulunduunuz sunucu bunu destekliyor ise servisler sizinle 
	MSG(Dz mesajlar) ile konuurlar, bu ayar aktif durumda olmazsa sizinle 
	iletiimde duyuru(notice) kullanrz.

NICK_HELP_SET_AUTOOP
	Kullanm: SET AUTOOP {ON | OFF}
	
	Servislerin otomatik op vermesini salar. Eer aktif duruma getirilir ise 
	servisler kanala girdiginizde sizi otomatik operator konumuna getirirler.

NICK_HELP_SASET
	Kullanm: SASET nickname option bilgi.
	
	Secilen rumuzun ayarlarn dzenler.  kullanlabilecek option(ayarlar) :
	
	    DISPLAY    Nick Grubunu dzenler
	    PASSWORD   Secilen rumuzun ifresini degitirir
	    URL        Secilen rumuzun kiisel sitesini degitirir
	    EMAIL      Secilen rumuzun e-posta adresini degitirir
	    ICQ        Secilen rumuzun icq numarasn degitirir
	    GREET      Secilen rumuzun karlama mesajn degitirir
	    KILL       Rumuzun gvenligini acar veya kapatr
	    SECURE     Rumuzun korumasn acar veya kapatr
	    PRIVATE    Nick'i nick listesinden ayrcalkl konuma getirir
	                   %R%S LIST
	    HIDE       Rumuzun belirlenen bilgisini INFO'da gsterimden kaldrr
	    MSG        Servislerin geri cevap secenegini belirler
	    NOEXPIRE   Nick zaman am sresini kaldrr
	    LANGUAGE   Rumuzun servisleri kullanrken alacag cevap
	               ve yardimlarda kullanlacak olan dil'i belirler
	
	Daha fazla bilgiye %R%S HELP SASET option 
	eklinde parametrelerin yardmlar ile ulasabilirsiniz. Secilen
	nickname bilgilerini deitir. 
	
	Services admins kullanm ile snrldr.

NICK_HELP_SASET_DISPLAY
	Kullanm: SASET nickname DISPLAY new-display
	
	Secilen rumuzun servisler icerisinde kullandg nick grubunu deitirir 
	Yeni grup kullanlan grup ile ayn olamaz.
	
	Services admins Kullanm ile snrlnr.

NICK_HELP_SASET_PASSWORD
	Kullanm: SASET nickname PASSWORD new-password
	
	Nick sahibinin sisteme nickini tantrken kullandg sifreyi degitirir.
	
	Services admins Kullanm ile snrlnr.

NICK_HELP_SASET_URL
	Kullanm: SASET nickname URL url
	
	Kii bilgilerinde grlen Url'i degitirir.  Bu URL
	kiinin tercihi ile belirledigi bir bilgidir
	ve INFO bilgilerinde gsterilebilir.
	
	Services admins Kullanm ile snrlnr.

NICK_HELP_SASET_EMAIL
	Kullanm: SASET nickname EMAIL address
	
	Rumuzun e-posta olarak belirledii adresi degitirir.
	
	Services admins Kullanm ile snrlnr.
	
NICK_HELP_SASET_ICQ
	Kullanm: SASET nickname ICQ number
	
	Kii bilgilerinde grlen ICQ numarasn degitirir.  Bu 
	ICQ numaras kiinin tercihi ile belirledigi bir bilgidir
	ve INFO bilgilerinde gsterilebilir.
	
	Services admins Kullanm ile snrlnr.
	
NICK_HELP_SASET_GREET
	Kullanm: SASET nickname GREET message
	
	Secilen rumuza karslama mesaj belirler, 
	bu mesaj kii kanala girdiginde servisler tarafndan 
	karlama mesaj olarak gnderilir.  
	GREET(karlama) kiinin yetkili oldugu kanallarda gnderilir.
	
	Services admins Kullanm ile snrlnr.

NICK_HELP_SASET_KILL
	Kullanm: SASET nickname KILL {ON | QUICK | IMMED | OFF}
	
	Nickin otomatik koruma zelliini aar ve kapatr.
	Koruma akken eer bir bakas o rumuzu kullanmaya 
	kalkarsa, o kiiye nicki deitirmesi iin bir dakika sre 
	verilir, eer deitirmezse %S tarafndan otomatik olarak
	deitirilir.
	
	Eer QUICK parametresini seerseniz, kullancya nickini
	deitirmesi iin 60 saniye yerine sadece 20 saniye verilir.
	Eer IMMED parametresini seerseniz kullancnn nicki
	uyarlmadan hemen deitirilir; ltfen ok gerekmedike
	bu zellii kullanmayn. Hatta bu
	zellik devre d braklm olabilirler.
	
	Services admins Kullanm ile snrlnr.

NICK_HELP_SASET_SECURE
	Kullanm: SASET nickname SECURE {ON | OFF}
	
	%S'n gvenlik zelliklerini aar ve kapatr. SECURE 
	ayar ile, nickin sahibi olarak tannmasi iin nce ifreyle 
	kiinin kendini tantmasi gerekir(adresinin nickin access
	listesinde olup olmamasna bal olarak). Fakat, eer 
	adresi nickin access listesindeyse KILL zellii
	kullanlm olsa bile %S sizi otomatik olarak kill
	lemeyecektir..
	
	Services admins Kullanm ile snrlnr.

NICK_HELP_SASET_PRIVATE
	Kullanm: SASET nickname PRIVATE {ON | OFF}
	
	%S'n zel nick zelliini aar kapatr. PRIVATE ayar
	ile, %S'n LIST komutu kullanldnda nickin listede
	gzkmemesi salanr.(Buna ramen, nicki bilen biri INFO 
	komutunu kullanarak 
	nick hakknda bilgi alabilir.)
	
	Services admins Kullanm ile snrlnr.

NICK_HELP_SASET_HIDE
	Kullanm: SASET nickname HIDE {EMAIL | STATUS | USERMASK | QUIT} {ON | OFF}
	
	Birisi rumuz hakknda bilgi almak iin %S INFO komutunu 
	kullandnda baz bilgilerin burada gzkmemesini salar.
	E-mail adresini (EMAIL), son grndn user@host 
	maskn (USERMASK), ve son k mesajn (QUIT)
	grnmez ekle alabilirsiniz. kinici parametre bilginin grnp (OFF)
	grnmeyeceini 
	(ON) belirtmenizi salar.
	
	Services admins Kullanm ile snrlnr.
	
NICK_HELP_SASET_MSG
	Kullanm: SASET nickname MSG {ON | OFF}
	
	Servislerin kiiye cevapta kullanaca yolu belirtir 
	Eer MSG zellii aktif ise, servisler mesaj kullanr,
	deilse uyar kullanr.
	
	Services admins Kullanm ile snrlnr.

NICK_HELP_SASET_NOEXPIRE
	Kullanm: SASET nickname NOEXPIRE {ON | OFF}
	
	Secilen nicki zaman amna kapatr.  Bu dzenleme 
	ON ekline getirilir ise rumuz zaman am yznden silinmez.
	
	Services admins Kullanm ile snrlnr.

NICK_HELP_SASET_AUTOOP
	Kullanm: SASET nickname AUTOOP {ON | OFF}
	
	rumuzun otomatik yetki almasn salar.
	Eer ON ekline getirlir ise nick kanala giriinde 
	otomatik olarak operator konumuna geer.

NICK_HELP_SASET_LANGUAGE
	Kullanm: SASET nickname LANGUAGE number
	
	Servislerin rumuza yolladg mesajlardaki dil secenegini ayarlamanza yarar
	(rnein kii trke semi ise, servisler trke metinleri kullanr).
	Dilnumaralari hakknda bilgilere
	%R%S HELP SET LANGUAGE komutu ile ulasabilirsiniz.

NICK_HELP_RECOVER
	Kullanm: RECOVER nickname [password]
	
	Rumuzunu bakasnn kullandgnda kullanabileceginiz bir komuttur
	%S otomatik olarak nickinizi kullanmdan kaldrr
	Bylece rumuzunuza otomatik gecebilirsiniz.
	gecebilirsiniz.
	
	Bu komutu kullandgnzda, %S sahte kullancdan
	nickinizi alr ve kiiyi sunucuda tutar
	ve rumuzunuzu geri alma sansi verir.  
	Eer girer kullanc tekrar balanr ve o rumuzu almaya kalkarsa
	%s kullanmnda olan rumuzu alamaz
	bundan sonra rumuzunuzu isterseniz, kullanmak icin RELEASE komutunu uygulamanz 
	gerekmektedir.
	Bu komut hakknda (%R%S HELP RELEASE) 
	.
	
	RECOVER komutunu kullandktan sonra
	rumuzu serbest brakmal ve nickinize gei yapmalsnz.
	yetkilerinizi ancak bu sekilde kullanabilirsiniz
	ancak bu sekilde
	kullanabilirsiniz. RECOVER sonras rumuzu kimin kullandgn WHOIS komutu ile ogrenebilirsiniz

NICK_HELP_RELEASE
	Kullanm: RELEASE nickname [password]
	
	%S belirli sebebler tarafndan kullanlan rumuzlar serbest brakmak
	icin kullanlr. Zaman korumal rumuzlar veya RECOVER
	komutu ile %s kullanmna gecen rumuzlar icin kullanlr;
	boylece rumuzu kullanlabilir duruma getirirsiniz.
	
	RELEASE komutu ancak nickserv tarafndan kullanlan nickler icin ie yarar
	/WHOIS komutu ile rumuzu kullanan adrese ulasabilirsiniz.
	RELEASE kullanm sonras nick kullanma aclr
	bundan sonra u rumuza geis yaplmal ve 
	ve nick sifresi girilmelidir.

NICK_HELP_GHOST
	Kullanm: GHOST nick [ifre]
	
	Asl kalan nickinizin balantsn koparr. Asl kalan nick 
	aslnda hayalet nicktir fakat IRC server bunun hala hatta
	olduunu sanar. Genellikle bu durum bilgisayarnzn kmesi 
	yada modem balantnzn serverdayken kopmas durumunda 
	gerekleir.
	
	GHOST komutunu bir nick zerinde kullanabilmek iin o an
	/WHOIS inizdeki adresin o nickin access listesinde olmas, 
	o nick iin doru ifrenin belirtilmi olmas yada o nickin
	grubundaki baka bir nickin tantlm olmas gerekir.

NICK_HELP_INFO
	Kullanm: INFO nick [ALL]
	
	Belirtilen nick hakknda o nickin sahibi, son grld adres ve 
	zaman, ve nickin zellikleri gibi bilgiler verir. Eer nick 
	hakknda bilgi alrken o nickin sahibi sizseniz ve tantmsanz 
	ALL parametresini kullandnzda bilgiler gizli olsa bile o 
	nick hakkndaki tm bilgiler grnr.

NICK_HELP_LIST
	Kullanm: LIST model
	
	nick!user@host formatnda, belirtilen modeli ieren
	tm kaytl nickleri listeler. PRIVATE zellii aktif olan
	nickler listelenmez.
	
	rnekler:
	
	    LIST *!aliuser@ixir.com
	        identi aliuser@ixir.com olan tm kaytl nickleri 
	        listeler.
	
	    LIST *Bot*!*@*
	        Bot kelimesini ieren tm kaytl nickleri listeler.
	       (byk kk harf hassasiyeti vardr.)
	
	    LIST *!*@*.ixir.com
	        ixir.com domainine sahip tm kaytl nickleri listeler.

NICK_HELP_ALIST
	Kullanm: ALIST [level]
	
	Yetkili oldugunuz tm kanallar ve seviyelerini listeler.
	Listelemede xOP veya access seneceklerine gre tarama yapabilirsiniz. 
	Bir secenek belirtilmez ise tm yetkili bulundugunuz kanallari listeler.

	rnekler:
	    ALIST Founder
	        Sahibi bulundugunuz kanallari
	    listeler.

	    ALIST AOP
	        AOP yetkisine sahip oldugunuz kanallar listeler 
	    ve daha buyuk yetkileride gsterir.

	    ALIST 10
	        10 seviyesinde yetkiye sahip oldugunuz kanallar listeler 
	    ve daha buyuk seviyelerinizide kapsar.
	
	Kanallarda zaman am kapal ise yan NOEXPIRE zellii ack ise 
	bunlar iaretle belirtir.
	
NICK_HELP_GLIST
	Kullanm: GLIST
	
	Grubunuzda bulunan tm rumuzlar listeler.

NICK_HELP_STATUS
	Kullanm: STATUS nick...
	
	Nickin kullanc tarafndan nickin sahibi olarak tantlp 
	tantlmadn gsterir. Cevap u formattadr:
	
	    nick durum-kodu
	
	nick komutta yazlan nick, ve durum-kodu da
	aadakilerden biridir:
	
	    0 - Byle bir kullanc bal deil veya nick 
	           kaytl deil
	    1 - Kullanc nickin sahibi olarak tantlmam
	    2 - Kullanc nickin sahibi olarak access listesinden 
	           tantlm
	    3 - Kullanc nickin sahibi olarak ifreyle tantlm
	
	Her komutta en fazla 16 nick iin cevap verilir; gerisi 
	yoksaylr. If no nickname is given, your status
	will be returned.

NICK_HELP_SENDPASS
	Kullanm: SENDPASS nick
	
	Belirtilen nickin ifresini nickin kaytlarnda belirtilmi 
	email adresine gnderir.
	
	Baz networklerde sadece IRC operatrleri kullanabilir.
	
	Eer ifreleme(encryption) aktifse bu komut devre d kalr.

NICK_HELP_CONFIRM
	Kullanm: CONFIRM aktivasyon-kodu
	
	Bu nick kayt srasndaki 2. admdr.
	Rumuzunuzu kayt edebilmek icin daha nceden
	%S (veya aktivasyon servisi) tarafndan 
	e-posta adresinize yollanan aktivasyon kodunuzu confirm komutu ile sisteme gndermelisiniz.
	Eer kodu bilmiyorsanz %R%S HELP RESEND ile tekrar edinme bilgilerine ulasabilirsiniz. Daha nceden
	bir kayt isteginiz yok ise: %R%S HELP REGISTER eklinde kayt ilemi hakknda yardm alabilirsiniz.

NICK_HELP_RESEND
	Kullanm: RESEND
	
	Bu komut ulamam veya doru olmayan aktivasyon kodunu
	mail adresinize tekrar gndermek icin kullanlr.

NICK_SERVADMIN_HELP
	Servis adminleri herhangi bir nickin tantmasna gerek olmadan 
	kaydn silebilir(drop) ve herhangi bir nickin access listesini 
	grntleyebilir. (%R%S ACCESS LIST nick).

NICK_SERVADMIN_HELP_LOGOUT
	Kullanm: LOGOUT [nick [REVALIDATE]]
	
	Parametre kullanlmazsa, IDENTIFY komutunun yapt 
	etkiyi tersine evirir, yani artk o nickin gerek sahibi
	olarak tannmamanz salar. Fakat sizden nickinizi tekrar
	identify etmeniz istenmez.
	
	Parametre kullanlrsada aynsn yapar ama buna ek olarak
	REVALIDATE belirtilirse servisler o kiiye nickini yeniden 
	identify etmesini syler. Servis adminlerinin Kullanmyla
	snrldr.

NICK_SERVADMIN_HELP_DROP
	Kullanm: DROP [nick]
	
	Parametreye gerek olmadan, %S veritabanndan nickinizi siler.
	
	Parametreyle, belirtilen bir nicki veritabanndan siler.
	Grubunuzda bulunan herhangi bir nicki zel ayrcalklara
	gerek olmadan silebilirsiniz. Bu ilemler Servis adminleri 
	tarafndan yaplabilir.

NICK_SERVADMIN_HELP_INFO
	
	Servis adminleri ALL parametresini herhangi bir nick iin 
	kullanabilirler.

NICK_SERVADMIN_HELP_LIST
	Kullanm: LIST model [FORBIDDEN] [SUSPENDED] [NOEXPIRE] [UNCONFIRMED]
	
	Belirtilen modele uyuan tm kaytl nickleri nick!user@host 
	formatnda listeler. PRIVATE zelli aktif olan kullanclar 
	sadece servis adminleri tarafndan grntlenir. NOEXPIRE 
	ayar olan nicklerde servis adminleri iin asl bir ! bulunur.
	
	If the FORBIDDEN, SUSPENDED, NOEXPIRE or UNCONFIRMED options are given, only
	nicks which, respectively, are FORBIDDEN, SUSPENDED, UNCONFIRMED or have the
	NOEXPIRE flag set will be displayed. If multiple options are
	given, all nicks matching at least one option will be displayed.
	These options are limited to Services admins.  
	
	rnekler:
	
	    LIST *!aliuser@ixir.com
	        identi aliuser@ixir.com olan tm kaytl nickler 
	        listelenir.
	
	    LIST *Bot*!*@*
	        simlerinde Bot yazan tm kaytl nickler listelenir
	        (kk byk harf hassasiyeti vardr).
	
	    LIST * NOEXPIRE
	        Zaman asimi olmayan tm kaytl nickler listelenir.

NICK_SERVADMIN_HELP_ALIST
	Kullanm: ALIST [nickname] [level]
	
	Secilen rumuzun yetkiye sahip oldugu kanllar listeler.
	Belirli parametreler ile daha dar bir alanda listeme yaplabilir 
	Bu taramalarda rumuz iin  
	belirlenen seviye ve bunun stndeki yetkiler gsterilir.

	Sadece Servis adminleri tarafndan kullanlr.

NICK_SERVADMIN_HELP_GLIST
	Kullanm: GLIST [nickname]
	
	Bir parametre eklenmeden de kullanlr. Secilen rumuzun nick grubunu ve o gruptak
	rumuzlar gsterir .
	
	Bir parametre ile kullanlr ise, grupta o parametre ile
	eleen rumuzlar gsterilir.
	Sadece Servis adminleri tarafndan kullanlr.

NICK_SERVADMIN_HELP_GETPASS
	Kullanm: GETPASS nick
	
	Belirtilen nickin ifresini syler. Unutmaynki bu komutun
	her kullanlnda , kullanlan nick ve komutu kullanan
	kii kaydedilerek WALLOPS/GLOBOPS olarak gnderilir.
	
	Sadece Servis adminleri tarafndan kullanlr.
	
	(Bu komut ifreleme(encryption) aktif olduu zaman devre ddr.)

NICK_SERVADMIN_HELP_GETEMAIL
	Kullanm: GETEMAIL user@emailhost

	Secilen mail ile eleen rumuzu gsterir. Not
	Baka rumuzlarin mail adresleri ile kullanmaynz.
	Elemeleri daha sonra paylamaynz.
	Kii bilgilerini kullanmaynz.

	Services admins Kullanm ile snrlnr.

NICK_SERVADMIN_HELP_FORBID
	Kullanm: FORBID nick [sebep]
	
	Belirtilen nickin kullanlmasn ve kayt edilmesini engeller.
	Nick drop edilerek iptal edilebilir.
	
	Baz networklerde, sebep yazlmas gereklidir.
	
	Sadece Servis adminleri tarafndan kullanlr.

###########################################################################
#
# ChanServ help messages
#
###########################################################################

NICK_SERVADMIN_HELP_SUSPEND
	Kullanm: SUSPEND nickname sebeb / UNSUSPEND nickname

	SUSPENDs / UNSUSPENDs rumuzu kullanmn gecici olarak kapatr.
	
	Sadece Servis adminleri tarafndan kullanlr.

###########################################################################
#
# ChanServ help messages
#
###########################################################################

NICK_SERVADMIN_HELP_UNSUSPEND
	Kullanm: UNSUSPEND nickname

	UNSUSPEND Rumuzu eski bilgileri ile kullanma acar.

	Sadece Servis adminleri tarafndan kullanlr.

###########################################################################
#
# ChanServ help messages
#
###########################################################################
CHAN_HELP_CMD_GETPASS
	    GETPASS    Bir kanaln founder ifresini ister
CHAN_HELP_CMD_FORBID
	    FORBID     Kanal kullanma kapatr
CHAN_HELP_CMD_SUSPEND
	    SUSPEND    Kanal bilgilerini silmeden gecici olarak
	               kullanma kapatr
CHAN_HELP_CMD_UNSUSPEND
	    UNSUSPEND  Askya alnm kanal kullanma acr
CHAN_HELP_CMD_STATUS
	    STATUS     Kullancnn kanaldaki access seviyesini syler
CHAN_HELP_CMD_REGISTER
	    REGISTER   Kanal kaydeder
CHAN_HELP_CMD_IDENTIFY
	    IDENTIFY   ifreyle sizi kanaln sahibi olarak tanmlar
CHAN_HELP_CMD_SET
	    SET        Kanal zelliklerini ve bilgisini ayarlar
CHAN_HELP_CMD_AOP
	    AOP        AOP listesini dzenler
CHAN_HELP_CMD_SOP
	    SOP        SOP listesini dzenler
CHAN_HELP_CMD_ACCESS
	    ACCESS     Ayrcalkl kullanclar belirler deitirir
CHAN_HELP_CMD_LEVELS
	    LEVELS     Access seviyelerini isteinize gre dzenler
CHAN_HELP_CMD_AKICK
	    AKICK      Autokick listesini dzenler
CHAN_HELP_CMD_DROP
	    DROP       Kanal kaydn siler
CHAN_HELP_CMD_SENDPASS
	    SENDPASS   Kayp ifrelerinizi syler
CHAN_HELP_CMD_BAN
	    BAN        Belirtilen nicki kanalda yasaklar
CHAN_HELP_CMD_CLEAR
	    CLEAR      Kanal ayarlarn sfrlar
CHAN_HELP_CMD_DEVOICE
	    DEVOICE    Secilen rumuzdan Voice yetkisini geri alr
CHAN_HELP_CMD_GETKEY
	    GETKEY     Secilen kanaln anahtar ifresini alr
CHAN_HELP_CMD_INFO
	    INFO       Kanal bilgilerini gsterir
CHAN_HELP_CMD_INVITE
	    INVITE     Chanserv sizi kanala davet eder
CHAN_HELP_CMD_KICK
	    KICK       Rumuzu kanaldan atar
CHAN_HELP_CMD_LIST
	    LIST       Girilen parametreye gre listeme yapar
CHAN_HELP_CMD_LOGOUT
	    LOGOUT     Kanaldan yetki cks yapar
CHAN_HELP_CMD_OP
	    OP         Secilen rumuzu operator yapar
CHAN_HELP_CMD_TOPIC
	    TOPIC      Kanal basln ayarlar
CHAN_HELP_CMD_UNBAN
	    UNBAN      Kanaldaki yasaklamalar kaldrr
CHAN_HELP_CMD_VOICE
	    VOICE      Secilen rumuza voice verir
CHAN_HELP_CMD_VOP
	    VOP        Vop (Konuskan insanlar) listesini dzenler
CHAN_HELP_CMD_DEHALFOP
	    DEHALFOP   Secilen rumuzdan Yardmc operator yetkisini alr 
CHAN_HELP_CMD_DEOWNER
	    DEOWNER    Kanal sahibi konumundan ayrmay salar
CHAN_HELP_CMD_DEPROTECT
	    DEPROTECT  Kanal ynetici konumundan ayrmay salar
CHAN_HELP_CMD_HALFOP
	    HALFOP     Secilen rumuzu yardmc operator yapar
CHAN_HELP_CMD_HOP
	    HOP        HOP listesini duzenler
CHAN_HELP_CMD_OWNER
	    OWNER      Kanal sahibi konumuna alr
CHAN_HELP_CMD_PROTECT
	    PROTECT    Kanal Yneticisi konumuna alr
CHAN_HELP_CMD_ADMIN
	    ADMIN      Kanal Admini konumuna alir
CHAN_HELP_CMD_DEADMIN
	    DEADMIN    Kanal Admini konumundan geri alir
CHAN_HELP_CMD_DEOP
	    DEOP       Kanal yneticisi konumundan geri alr

CHAN_HELP
	%S kanallarnz kayt etmenizi ve kontrol etmenizi
	salar. %S kt niyetli kullanclarn kanallar ele 
	geirmelerini(takeover), kanalda kimlerin op olacan sizin
	tarafnzdan beliryerek engeller. Mevcut komutlar aada 
	listelenmitir; onlar kullanmak iin %R%S komut
	yazn. Belirli bir komut hakknda daha fazla bilgi iin,
	%R%S HELP komut yazn.
	 
	
CHAN_HELP_EXPIRES
	
	Unutmayn %d gn kullanlmayan kanallarn
	(kanaln access listesinde olan bir kimse o sre iinde 
	kanala girmezse ) kayd silinir.

CHAN_HELP_REGISTER
	Kullanm: REGISTER kanalad ifre aklama
	
	%S veritabanna belirtilen kanal ekler yani kaydeder.
	Bu komutu kullanabilmek iin kayt etmek istediiniz kanal
	nceden kaytl olmamal ve kanalda op olmalsnz. ifre
	kanal zelliklerinde deiiklikler yapmanz iin ilerde
	lazm olacaktr. Son parametre kanaln genel bir tanmdr
	ve mutlaka belirtilmelidir.
	
	Kanal kayt ettiiniz zaman, kanaln "founder" ' olursunuz.
	Kanal founder kanaln tm zelliklerini deitirme yetkisine 
	sahip olan kiidir; %S kanala girdiiniz zaman size
	otomatik kanal opu hakkn verecektir. Kanal opu hakkn
	bakalarnada vermek iin gerekli bilgiyi ACCESS komutunun
	yardmna bakarak alabilirsiniz (%R%S HELP ACCESS).
	
	NOT: Bir kanal kaydedebilmek iin, nce nickinizi kaydetmelisiniz.
	Eer kaydetmediyseniz %R%s HELP yazarak nasl yapacanz
	hakknda bilgi alabilirsiniz.

CHAN_HELP_IDENTIFY
	Kullanm: IDENTIFY kanalad ifre
	
	%S tarafndan kanaln founder olarak tannmanz salar.
	Birok komutu kullanabilmek iin kendinizi kanaln sahibi
	(founder) olarak bu komutu kullanarak tantmanz gerekir.
	ifre kanal kaydederken  kullandnz ifreyle ayndr.

CHAN_HELP_LOGOUT
	Kullanm: LOGOUT kanalad nick
	
	Bu komut belirtilen nickin artk belirtilen kanal iin
	tanmlanmamasn salar.
	
	Eer kanaln founder iseniz istediiniz kii zerinde,
	deilseniz kendi zerinizde bu komutu kullanabilirsiniz.

CHAN_HELP_DROP
	Kullanm: DROP kanalad
	
	Kanaln kaydn siler.  Sadece kanal founder tarafndan
	kullanlabilir ve o kiinin nce IDENTIFY komutunu kullanarak
	kanaln sahibi olduunu belirtmesi gerekir.

CHAN_HELP_SET
	Kullanm: SET kanalad zellik parametre
	
	Kanal foundernn eitli kanal zelliklerini ve dier bilgileri
	ayarlamasn salar.
	
	Mevcut zellikler:
	
	    FOUNDER       Kanal foundern belirler
	    SUCCESSOR     Kanal successorn belirler
	    PASSWORD      Founder ifresini belirler
	    DESC          Kanal aklamasn belirler
	    URL           Kanala bir URL adresini ilikilendirir
	    EMAIL         Kanala bir E-mail adresini ilikilendirir
	    ENTRYMSG      Kanala giren kullanclara gnderilecek mesaj
	                   belirler
	    BANTYPE       Servislerin kanalda ne tip ban koyacan belirler
	    KEEPTOPIC     Kanalda kimse olmasa bile topii hatrlar
	    TOPICLOCK     Topic sadece SET TOPIC komutuyla deitirilir
	    MLOCK         Kanal modlarn kitler yada aar
	    PRIVATE       LIST komutuyla kanal listelenmez
	    RESTRICTED    Kanala izinli giri gerektirir
	    SECURE        %S gvenlik zelliklerini aktifletirir
	    SECUREOPS     Kanal opu durumunun sk kontroln salar
	    SECUREFOUNDER Kanal founder durumunun sk kontroln salar
	    SIGNKICK      KICK komutuyla yaplan atmalar iaretler
	    OPNOTICE      OP/DEOP komutlar kullanldnda mesaj yollar
	    PEACE         kritik komutlarin kullanilmasini engeller
	    XOP           Ayricalik sistemleri arasinda geisi saglar

	
	Belirli bir zellik hakknda daha fazla bilgi iin
	%R%S HELP zellik yazn.

CHAN_HELP_SET_FOUNDER
	Kullanm: SET kanalad FOUNDER nick
	
	Kanal foundern deitirir.  Yeni nickin kaytl 
	olmas gereklidir.

CHAN_HELP_SET_SUCCESSOR
	Kullanm: SET kanalad SUCCESSOR nick
	
	Kanal successorn belirler, deitirir. Eer bir kanaln
	foundernn nicki zaman amna urayp kayd silinirse
	yada kanal kaytlyken nickin kayd bilerek silinirse(drop)
	successor kanaln yeni founder durumuna gelir. Fakat eer
	successornda ok fazla kaytl kanal varsa(%d) veya kanal
	iin bir successor belirtilmemise kanaln kayd silinir(drop).
	Komutta belirtilen nickin kaytl olmas gereklidir.

CHAN_HELP_SET_PASSWORD
	Kullanm: SET kanalad PASSWORD ifre
	
	Kanal foundernn ifresini deitirir.

CHAN_HELP_SET_DESC
	Kullanm: SET kanalad DESC aklama
	
	LIST ve INFO komutlar kullanldnda gzkecek kanal 
	aklamasn belirler.

CHAN_HELP_SET_URL
	Kullanm: SET kanalad URL [urladresi]
	
	Belirtilen URL adresini kanal ile ilikilendirir. Bu URL 
	adresi birisi kanal hakknda bilgi almak iin INFO 
	komutunu kullandnda gzkr. Eer urladresi parametresi
	belirtilmezse kanal iin nceden belirtilen URL adresi
	silinir.

CHAN_HELP_SET_EMAIL
	Kullanm: SET kanalad EMAIL [emailadresi]
	
	Belirtilen E-mail adresini kanal ile ilikilendirir.Bu E-mail 
	adresi birisi kanal hakknda bilgi almak iin INFO komutunu 
	kullandnda gzkr. Eer emailadresi parametresi
	belirtilmezse kanal iin nceden belirtilen E-mail adresi
	silinir.

CHAN_HELP_SET_ENTRYMSG
	Kullanm: SET kanalad ENTRYMSG [mesaj]
	
	Kanala giren kullanclara notice eklinde gnderilecek
	mesaj belirler.  Eer mesaj parametresi belirtilmezse
	giren kullancya bir mesaj gnderilmez.

CHAN_HELP_SET_BANTYPE
	Kullanm: SET kanalad BANTYPE bantipi
	
	Servislerin birini kanaldan banlarken kullanaca ban 
	tipini belirler.
	
	bantipi 0 ile 3 arasnda bir saydr ve anlamlar udur:
	
	0: *!user@host formatnda ban iin
	1: *!*user@host formatnda ban iin
	2: *!*@host formatnda ban iin
	3: *!*user@*.domain formatnda ban iin

CHAN_HELP_SET_KEEPTOPIC
	Kullanm: SET kanalad KEEPTOPIC {ON | OFF}
	
	Bir kanal iin topic hatrlamay aktifletirir yada kapatr.
	topic hatrlama aktifse kanal kapansa bile kanal topic i
	%S tarafndan hatrlanr ve birisi kanala girdiinde bu
	topic geerli olur.

CHAN_HELP_SET_TOPICLOCK
	Kullanm: SET kanalad TOPICLOCK {ON | OFF}
	
	Bir kanal iin topic kilidini aktifletirir yada kapatr.
	topic kilidi aktifse, %S SET TOPIC komutunun
	dnda kanal topic inin deitirilmesine izin vermez.

CHAN_HELP_SET_MLOCK
	Kullanm: SET kanalad MLOCK modlar
	
	Bir kanal iin mod-kilidini aktifletirir. %S belirlediiniz
	modlarn her zaman ak yada kapal olacan ayarlar.

	+ ile belirtilen modlar aik olarak, - ile belirtilen modlar
	kapali olarak kitlenir.
	
	Dikkat:  Eer ikinci rnekteki gibi bir mod kilidi koyarsanz,
	kanaln RESTRICTED zelliinide aktifletirmeniz gerekir
	(HELP SET RESTRICTED e bakn), yoksa kanal boken ilk
	giren kii kanal key ini(anahtar) grebilir!
	
	rnekler:
	
	    SET #kanalad MLOCK +nt-iklps
	        n ve t modlarn hep ak, i, k, l, p, ve s modlarn hep
	        ak olarak ayarlar. m modu ise istenildii gibi ayarlanabilir
	        ak yada kapal.
	
	    SET #kanalad MLOCK +knst-ilmp anahtar
	        k, n, s, ve t modlar hep ak, ve i, l, m, ve p modlar
	        hep kapal. Ayrca kanal anahtarn belirler ve hep o 
	        anahtar olmasn salar.
	
	    SET #kanalad MLOCK +
	        Mod kilidini kaldrr; ve tm kanal modlarn alp 
	        kapanacak ekilde serbest brakr.

CHAN_HELP_SET_PEACE
	Kullanimi: SET kanaladi PEACE {ON | OFF}
	
	Bir kanalin peace zelligini aar veya kapatir.
	peace zelligi ayarlandiginda, hic kimse seviyesi kendinden
	yksek veya esit olanlari atamaz, banlayamaz veya %S
	seviyesini degistiremez.

CHAN_HELP_SET_PRIVATE
	Kullanm: SET kanalad PRIVATE {ON | OFF}
	
	Bir kanal iin private zelliini aar kapatr. private zellii
	aktifse, %R%S LIST komutuyla kanal listelenemez.

CHAN_HELP_SET_RESTRICTED
	Kullanm: SET kanalad RESTRICTED {ON | OFF}
	
	Enables or disables the restricted access option for a
	channel.  When restricted access is set, users not on
	the access list will instead be kicked and banned from the channel.

CHAN_HELP_SET_SECURE
	Kullanm: SET kanalad SECURE {ON | OFF}
	
	Bir kanal iin %S'n gvenlik zelliklerini aar veya 
	kapatr. SECURE zellii aktifse, sadece nicki kaytl
	ve %s ile nickini tantm kullanclar kanalda access 
	alabilirler ve access listesindeki statlerini
	alabilirler.(mesela op olabilirler)

CHAN_HELP_SET_SECUREOPS
	Kullanm: SET kanalad SECUREOPS {ON | OFF}
	
	Bir kanal iin gvenli op zelliini aar veya kapatr.
	gvenli op zellii aktifse, access listesinde olmayan
	kullanclar kanalda op olamazlar.

CHAN_HELP_SET_SECUREFOUNDER
	Kullanm: SET kanalad SECUREFOUNDER {ON | OFF}
	
	Bir kanal iin gvenli founder zelliini aar yada kapatr.
	gvenli founder zellii aktifse, sadece gerek founder 
	kanaln kaydn silebilir, kanal ifresini deitirebilir yada
	kanal foundern ve successor n deitirebilir. Kanal 
	ifresiyle kendilerini %S'e kanal founder olarak tantan 
	ama nicki foundern nicki olmayanlar bu komutlar kullanamazlar.

CHAN_HELP_SET_SIGNKICK
	Kullanm: SET kanalad SIGNKICK {ON | LEVEL | OFF}
	
	Bir kanal iin iaretli atmay aar yada kapatr.
	SIGNKICK ayarland zaman, %S KICK
	komutuyla yaplan atmalarda komutu kullanan kiinin
	nicki atma sebebinde yer alr.
	
	Eer LEVEL parametresini kullanrsanz, seviyesi
	SIGNKICK seviyesine eit yada fazla olanlarn yapt
	atmalarda atann nicki sebepte gzkmez. Daha fazla
	bilgi iin %R%S HELP LEVELS yazn.

CHAN_HELP_SET_XOP
	Kullanimi: SET kanaladi XOP {ON | OFF}
	
	Bir kanalin xOP sistemini aar veya kapatir. XOP
	ayarlandigi zaman, AOP/SOP/VOP komutlariyla
	yetkileri dzenlemelisiniz, aksi takdirde ACCESS
	komutunu kullanmalisiniz.
	
	Teknik Not: Access sisteminden xOP sisteminde
	getiginizde seviye ayarlariniz degistirilir, bu
	yzden tekrar access sistemine getiginizde ayni
	ayarlari bulamazsiniz! 
	
	Access sisteminden xOP sistemine getiginizde listedeki
	ayricaliklari kontrol edip listenizdeki nicklerin dogru
	xOP ayarlarinda bulundugunu kontrol edin, nk sistemin
	tahmin etmesi her zaman dogru olmayabilir... Eger LEVELS
	komutuyla komut seviye ayarlarini degistirdiyseniz xOP
	sistemini kullanmaniz nerilmez.
	
	Bunlarin disinda xOP sisteminden access sistemine gemek
	bir problem ikarmaz.

CHAN_HELP_SET_OPNOTICE
	Kullanm: SET kanalad OPNOTICE {ON | OFF}
	
	Bir kanal iin op-notu zelliini aar yada kapatr.
	op-notu zellii aktifse, %S kanala bir kullanc 
	zerinde OP veya DEOP komutlarnn kullanldn
	belirten bir mesaj gnderir.

CHAN_HELP_AOP
	Kullanm: AOP kanaladi ADD nick
	           AOP kanaladi DEL {nick | kayit-no | liste}
	           AOP kanaladi LIST [mask | liste]
	           AOP kanaladi CLEAR
	
	Bir kanalin AOP (otoop) listesini dzenler. AOP listesi
	o kanalda kullaniciya otomatik olarak op olma, gerekirse 
	kendi banlarini kaldirma veya davet edilme, giriste karsilama
	mesajlarini grntleme, vs yetkilerini verir.
	
	AOP ADD komutu belirtilen nicki AOP listesine ekler.
	
	AOP DEL komutu belirtilen nicki AOP listesinden siler.  
	Eger kayit numaralari belirtilirse, o numaralara ait nickler
	silinir. (Asagidaki rnegi inceleyin.)
	
	AOP LIST komutu AOP listesini gsterir. Eger bir hostmask
	belirtilmisse, sadece onla uyusan kayitlari gsterir. Eger 
	kayit numaralari belirtilmisse o numaralarla uyusan kayitlari
	gsterir; rnegin:

	   AOP #kanal LIST 2-5,7-9
	      2 den 5 e ve 7 den 9 a kadar olan kayitlari gsterir.
	      
	AOP CLEAR komutu AOP listesindeki tm kayitlari siler.
	
	AOP ADD ve AOP DEL komutlarini kanal SOP lari veya st
	kullanabilir. AOP CLEAR komutunu ise sadece kanal founderi
	kullanabilir. Ayrica, AOP listesindeki herhangi biri AOP LIST 
	komutunu kullanabilir.
	
	Bu komutu kanaliniz iin devre disi birakabilirsiniz. O zaman
	access komutlarini kullanmalisiniz. Access komutlari hakkinda
	bilgi almak iin  %R%S HELP ACCESS yazin. 
	Access ile xOP arasinda geis yapabilmek iin gerekli bilgilere
	%R%S HELP SET XOP yazarak ulasabilirsiniz.

CHAN_HELP_HOP
	Kullanm: HOP kanaladi ADD nick
	           HOP kanaladi DEL {nick | kayit-no | liste}
	           HOP kanaladi LIST [mask | liste]
	           HOP kanaladi CLEAR
	
	Bir kanalin HOP (HalfOP) listesini dzenler. HOP
	listesinde bulunan bir kisi kanalda otomatik olarak
	halfop olur.
	
	HOP ADD komutu belirtilen nicki HOP listesine ekler.
	
	HOP DEL komutu belirtilen nicki HOP listesinden siler.
	Eger kayit numaralari listesi belirtilirse, bu kayitlar
	silinir. (Asagidaki rnegi inceleyin.)
	
	HOP LIST komutu HOP listesini gsterir. Eger bir hostmask
	belirtilmisse, o hostmask la uyusan kayitlar gsterilir.
	Eger kayit numaralari listesi belirtilmisse, o numaralardaki
	nickler gsterilir; rnegin:

	   HOP #kanaladi LIST 2-5,7-9
	       2 den 5 e ve 7 den 9 a kadar olan kayitlari gsterir.
	      
	HOP CLEAR komutu HOP listesindeki tm kayitlari temziler.
	
	HOP ADD, HOP DEL ve HOP LIST komutlarini AOP lar ve st
	HOP CLEAR komutunu ise sadece founder kullanabilir.
	
	Bu komutu kanaliniz iin devre disi birakabilirsiniz. O zaman
	access komutlarini kullanmalisiniz. Access komutlari hakkinda
	bilgi almak iin  %R%S HELP ACCESS yazin. 
	Access ile xOP arasinda geis yapabilmek iin gerekli bilgilere
	%R%S HELP SET XOP yazarak ulasabilirsiniz.

CHAN_HELP_SOP
	Kullanm: SOP kanaladi ADD nick
	           SOP kanaladi DEL {nick | kayit-no | liste}
	           SOP kanaladi LIST [mask | liste]
	           SOP kanaladi CLEAR
	
	Bir kanalin SOP (SuperOP) listesini dzenler. SOP
	listesindekiler AOP larin sahip oldugu tm yetkilere 
	sahiptir. Ayrica AutoKick ve BadWords listesini
	dzenleyebilirler, kanal memolarini okuyabilirler, vs.
	
	SOP ADD komutu belirtilen nicki SOP listesine ekler.
	
	SOP DEL komutu belirtilen nicki SOP listesinden siler.
	Eger kayit numaralari listesi belirtilmisse, bu kayitlar
	silinir. (Asagidaki rnegi inceleyin.)
	
	SOP LIST komutu SOP listesini grntler. Eger bir
	hostmask belirtilmisse o hostmaskla uyusan kayitlar
	gsterilir. Eger kayit numaralari listesi belirtilmisse
	o numaralardaki nickler gsterilir; rnegin:

	   SOP #kanaladi LIST 2-5,7-9
	      2 den 5 e ve 7 den 9 a kadar olan kayitlar gsterilir.
	      
	SOP CLEAR komutu SOP listesindeki tm kayitlari temizler.
	
	SOP ADD, SOP DEL ve SOP CLEAR komutlarini sadece kanal
	founderi kullanabilir. Ama AOP listesindeki herhangi biri
	SOP LIST komutunu kullanabilir.
	
	Bu komutu kanaliniz iin devre disi birakabilirsiniz. O zaman
	access komutlarini kullanmalisiniz. Access komutlari hakkinda
	bilgi almak iin  %R%S HELP ACCESS yazin. 
	Access ile xOP arasinda geis yapabilmek iin gerekli bilgilere
	%R%S HELP SET XOP yazarak ulasabilirsiniz.

CHAN_HELP_VOP
	Kullanm: VOP kanaladi ADD nick
	           VOP kanaladi DEL {nick | kayit-no | liste}
	           VOP kanaladi LIST [mask | liste]
	           VOP kanaladi CLEAR
	
	Bir kanalin VOP (otovoice) listesini dzenler. VOP
	listesindekiler kanalda otomatik olarak voice alirlar.
	
	VOP ADD komutu belirtilen nicki VOP listesine ekler.
	
	VOP DEL komutu belirtilen nicki VOP listesindene siler.
	Eger kayit numaralari listesi belirtilmisse, o kayitlar
	silinir. (Asagidaki rnegi inceleyin.)
	
	VOP LIST komutu VOP listesini grntler. Eger bir
	hostmask belirtilmisse o hostmaskla uyusan kayitlar
	listelenir. Eger kayit numaralari listesi belirtilmisse
	o numaralardaki nickler gsterilir; rnegin:

	   VOP #kanaladi LIST 2-5,7-9
	      2 den 5 e ve 7 den 9 a kadar olan kayitlar gsterilir.
	      
	VOP CLEAR komutu VOP listesindeki tm kayitlari temizler.
	
	VOP ADD, VOP DEL ve VOP LIST komutlarini AOP lar ve st,
	VOP CLEAR komutunu ise sadece founder kullanabilir.
	
	Bu komutu kanaliniz iin devre disi birakabilirsiniz. O zaman
	access komutlarini kullanmalisiniz. Access komutlari hakkinda
	bilgi almak iin  %R%S HELP ACCESS yazin. 
	Access ile xOP arasinda geis yapabilmek iin gerekli bilgilere
	%R%S HELP SET XOP yazarak ulasabilirsiniz.

CHAN_HELP_ACCESS
	Kullanm:  ACCESS kanalad ADD nick seviye
	            ACCESS kanalad DEL {nick | kayt-no | liste}
	            ACCESS kanalad LIST [mask | liste]
	            ACCESS kanalad CLEAR
	
	Bir kanal iin access listesi oluturur. Access listesi
	kanalda kimlerin op olacan ve %S komutlarna
	kimlerin eriimi olacan belirtir. Deiik access
	seviyeleri deiik komutlara eriim salar. Ayrntl bilgi
	iin %R%S HELP ACCESS LEVELS yazn. Access
	listesinde olmayan kullanclarn seviyesi 0 dr.
	
	ACCESS ADD komutu belirtilen nicki belirtilen seviyeden
	access listesine ekler; eer o kii zaten access listesindeyse
	seviyesini belirtilen seviyeyle deitirir. Belirtilen seviye 
	komutu kullanan kiinin seviyesinden az olmaldr, eer 
	belirtilen nick zaten access listesindeyse komutu kullanan 
	kiinin access seviyesi onunkinden byk olmaldr.
	
	ACCESS DEL komutu belirtilen nicki access listesinden siler.
	eer kayt numaras belirtilmise o kayt numaras olan kiinin 
	accessi silinir.(Aadaki LIST iin verilen rnee bakn.)
	
	ACCESS LIST komutu access listesini grntler. Eer * l 
	bir mask belirtilirse o maskla uyuan kiiler listelenir. 
	Eer kayt numaras listesi belirtilirse o kiiler listelenir.
	rnein:
	
	   ACCESS #kanalad LIST 2-5,7-9
	      2'den 5'e ve 7'den 9'a kadar olan access kaytlar
	      listelenir.
	      
	ACCESS CLEAR komutu tm access listesini temizler.

CHAN_HELP_ACCESS_LEVELS
	Kullanc access seviyeleri
	
	Varsaylan olarak, aadaki access seviyeleri tanmlanmtr:
	
	   Founder   %S fonksiyonlarna tam eriim hakk vardr.
	                     kanal girer girmez op olur. Unutmaynki
	                     sadece bir kii founder olma hakkna 
	                     sahiptir. (ACCESS komutuyla verilemez.)
	        10   AKICK komutuna eriimi vardr; otomatik oplanr.
	         5   Otomatik oplanr.
	         3   Otomatik voice lanr.
	         0   Bir zellii yoktur; dier oplar tarafndan
	                     oplanabilir (gvenli-op kapalysa).
	        <0   Kanalda oplanamaz.
	
	Bu seviyeler LEVELS komutu kullanlarak deitirilebilir, veya
	yenileri eklenebilir, bilgi iin %R%S HELP LEVELS 
	yazn.

CHAN_HELP_AKICK
	Kullanm:  AKICK channel ADD {nick | mask} [reason]
	            AKICK channel STICK mask
	            AKICK channel UNSTICK mask
	            AKICK channel DEL {nick | mask | entry-num | list}
	            AKICK channel LIST [mask | entry-num | list]
	            AKICK channel VIEW [mask | entry-num | list]
	            AKICK kanalad ENFORCE
	            AKICK kanalad CLEAR
	
	Bir kanal iin AutoKick listesi oluturur.  Eer Akick 
	listesindeki bir kullanc kanala girmeye alrsa, Bu
	kii %S tarafndan banlanr ve kanaldan atlr.
	
	AKICK ADD komutu belirtilen nicki yada mask Akick
	listesine ekler. Eer komutla beraber birde sebep
	belirtilmise bu sebep kullanc kanaldan atlrken
	kullanlr; eer kullanlmazsa geerli sebep olan
	"You have been banned from the channel" kullanlr.

	AKICK STICK komutu belirtilen maski kalici olarak
	banlar. Eger biri bani kaldirmaya alisirsa, %S
	otomatik olarak yeniden banlar. Bunu kayitli nickler
	iin kullanamazsiniz.
	
	AKICK UNSTICK komutu AKICK STICK komutunun etkilerini
	iptal eder, bylece bani kaldirabilirsiniz.
	
	AKICK DEL komutu belirtilen nicki yada mask Akick
	listesinden siler. Fakat bu komutla nceden Akick 
	listesindeyken banlanm birinin ban manuel olarak
	alana kadar kalkmaz.
	
	AKICK LIST komutu Akick listesinde kimlerin olduunu
	listeler, yada opsiyonel olarak belirtilen maskla uyuan 
	Akick listesindeki kullanclar listeler.
	
	AKICK VIEW komutu AKICK LIST komutunun daha aklayc
	versiyonudur.
	
	AKICK ENFORCE komutu %S'n mevcut akick listesinde bulunan 
	masklara sahip kullanclar kanaldan atmasn salar.
	
	AKICK CLEAR komutu akick listesinde bulunan tm kaytlar
	siler.

CHAN_HELP_LEVELS
	Kullanm:  LEVELS kanalad SET tip seviye
	            LEVELS kanalad {DIS | DISABLE} tip
	            LEVELS kanalad LIST
	            LEVELS kanalad RESET
	
	LEVELS komutu bir kanaldaki access seviyelerinin iyi
	kontroln salar. Bu komutla, %S'n birok
	fonksiyonu iin gereken access seviyelerini
	belirleyebilirsiniz. (SET FOUNDER ve SET PASSWORD
	komutlar ve bu komut sadece kanal founder tarafndan
	kullanlabilir.)
	
	LEVELS SET komutu bir fonksiyon yada fonksiyon gruplar iin
	access seviyelerini deitirmeye yarar. LEVELS DISABLE (veya
	ksaca DIS) otomatik bir zellii kapatr yada founderdan 
	bakasnn kullanmasn engeller. LEVELS LIST komutu 
	fonksiyonlar yada fonksiyon gruplar iin mevcut seviyeleri 
	gsterir. LEVELS RESET komutu seviyeleri varsaylan deerlerine
	geri evirir. (HELP ACCESS LEVELS e bakn).
	
	Seviyeleri ayarlanabilecek fonksiyonlar iin, HELP LEVELS DESC e 
	bakn.

CHAN_HELP_LEVELS_DESC
	Aada seviyeleri deitirilebilecek  fonksiyonlar listelidir.
	Dikkat edilirse AUTODEOP ve NOJOIN deerleri maximum, dierleri
	minimum seviyelerdir.

CHAN_HELP_LEVELS_DESC_FORMAT
	    %-*s  %s

CHAN_HELP_INFO
	Kullanm: INFO kanalad [ALL]
	
	Belirtilen kaytl kanalla ilgili bilgiler sunar. Bu 
	bilgilerin ieriinde kanaln founder, kayt zaman,
	son kullanld zaman, aklamas, ve varsa mod kilidi
	bulunur. Eer kanaln founder olarak kendinizi 
	tantmsanz ve ALL parametresini belirtmiseniz
	giri mesaj ve successor hakkndada bilgi alabilirsiniz.

	Varsayilan olarak, ALL seenegini founderlar kullanabilir.

CHAN_HELP_LIST
	Kullanm: LIST model
	
	Belirtilen modelle uyuan tm kaytl kanallar listeler.
	(PRIVATE zellii aktif olan kanallar listelenmez.)

CHAN_HELP_OP
	Kullanm: OP [#kanalad [nick]]
	
	Belirtilen nicki kanalda oplar. Eer nick belirtilmemise,
	kendinizi oplarsnz. Eer kanal ve nick belirtilmemise,
	bulunduunuz tm kanalda sizi oplar, tabi eer op accessiniz
	ve bu komutu kullanmaya yetkiniz varsa.
	
	Varsaylan olarak, AOP lar ile access seviyesi 5 ve zeri
	olanlar kullanabilir.

CHAN_HELP_DEOP
	Kullanm: DEOP [#kanalad [nick]]
	
	Belirtilen nicki kanalda deoplar. Eer nick belirtilmemise,
	kendinizi deoplarsnz. Eer nick ve kanal belirtilmemise,
	bulunduunuz tm kanallarda sizi deoplar, tabi eer bu komutu 
	kullanmaya yetkiniz varsa.
	
	Varsaylan olarak, AOP lar veya access seviyesi 5 ve zeri
	olanlar kullanabilir.

CHAN_HELP_VOICE
	Kullanm: VOICE [#kanalad [nick]]
	
	Belirtilen nicke kanalda voice verir. Eer nick belirtilmemise,
	size voice verir. Eer kanal ve nick belirtilmemise, size
	bulunduunuz tm kanallarda voice verir, tabi eer accessiniz ve
	bu komutu kullanmaya izniniz varsa.
	
	Varsaylan olarak, AOP lar ile access seviyesi 5 ve zeri olanlar
	kullanabilir, veya VOP lar ile access seviyesi 3 ve yukar olanlar
	kendilerine voice vermek iin kullanabilirler.

CHAN_HELP_DEVOICE
	Kullanm: DEVOICE [#kanalad [nick]]
	
	Belirtilen nicki kanalda devoice eder. Eer nick belirtilmemise,
	sizi devoice eder. Eer kanal ve nick belirtilmemise sizi,
	bulunduunuz tm kanallarda devoice eder, tabi eer accessiniz
	ve bu komutu kullanmaya izniniz varsa.
	
	Varsaylan olarak, AOP lar, access seviyesi 5 ve zeri olanlar
	kullanabilir, veya VOP lar ile access seviyesi 3 ve zeri olanlar
	kendilerini devoice etmek iin kullanabilirler.

CHAN_HELP_HALFOP
	Kullanm: HALFOP [#kanalad [nick]]
	
	Belirtilen nicki kanalda halfop(yarmop) yapar. Eer nick
	belirtilmemise, sizi halfop yapar. Eer nick ve kanal
	belirtilmemise, sizi bulunduunuz tm kanallarda halfop yapar,
	tabi eer bu komutu kullanmaya izniniz varsa.
	
	Varsaylan olarak, AOP lar ile access seviyesi 5 ve zeri
	olanlar kullanabilir, veya HOP lar ile access seviyesi 4 ve
	zeri olanlar kendilerini halfop yapmak iin kullanabilir.

CHAN_HELP_DEHALFOP
	Kullanm: DEHALFOP [#kanalad [nick]]
	
	Belirtilen nickin halfopunu(yarmop) alr. Eer nick
	belirtilmemise, sizin halfopunuz alr. Eer kanal ve nick 
	belirtilmemise, bulunduunuz tm kanallardan halfopunuzu
	alr, tabi eer bu komutu kullanmaya izniniz varsa.
	
	Varsaylan olarak, AOP lar veya 5 ve zeri access seviyesi
	olanlar kullanabilir, ayrica HOP lar veya access seviyesi
	4 ve zeri olanlar kendi halfoplarn alabilirler.

CHAN_HELP_PROTECT
	Kullanm: PROTECT [#kanalad [nick]]
	
	Belirtilen nicki kanalda korur. Eer nick belirtilmezse,
	sizi korur. Eer nick ve kanal belirtilmezse sizi bulunduunuz
	tm kanallarda koruyacaktr, tabi eer bu komutu kullanmaya
	izniniz varsa.
	
	Varsaylan olarak, founder kullanabilir, veya SOP lar ile access
	seviyesi 10 ve zeri olanlar kendilerinde kullanabilirler.

CHAN_HELP_DEPROTECT
	Kullanm: DEPROTECT [#kanalad [nick]]
	
	Belirtilen nickin korumasn kaldrr. Eer nick belirtilmemise,
	sizin korumanz kaldrr. Eer kanal ve nick belirtilmezse, 
	sizin bulunduunuz tm kanallardaki korumalarnz kaldrr, 
	tabi eer bu komutu kullanmaya izniniz varsa.
	
	Varsaylan olarak, founder kullanabilir, veya SOP lar ile
	access seviyesi 10 ve zeri olanlar kendilerinde kullanabilir.

CHAN_HELP_OWNER
	Kullanm: OWNER [#kanaladi]
	
	Belirtilen kanalda owner stats verilir. Eger kanal
	belirtilmemisse bulundugunuz tm kanallarda size owner
	stats verilir. Tabi bu yetkinizin olup olmamasina
	baglidir.
	
	Belirtilen kanal founderlarinin kullanma yetkisi vardir.

CHAN_HELP_DEOWNER
	Kullanm: DEOWNER [#kanaladi]
	
	Belirtilen kanaldaki owner statnz kaldirir. Eger
	kanal belirtilmezse bulundugunuz tm kanallardaki owner
	statnz kaldirir. Tabi bu yetkinizin olup olmamasina
	baglidir.
	
	Belirtilen kanal founderlarinin kullanma yetkisi vardir.

CHAN_HELP_INVITE
	Kullanm: INVITE kanalad
	
	%S'e sizi belirtilen kanala davet etmesini syler.

	Varsaylan olarak AOP lar ile access seviyesi 5 veya
	zeri olanlar kullanabilir.

CHAN_HELP_UNBAN
	Kullanm: UNBAN kanalad
	
	%S'e sizin kanala girmenizi engelleyen tm banlar kaldrmasn
	syler.

	Varsaylan olarak, AOP lar ile 5 ve zeri access seviyesi olanlar
	kullanabilir.

CHAN_HELP_KICK
	Kullanm: KICK [#kanalad [nick [sebep]]]
	
	Belirtilen nicki kanaldan atar. Eer nick belirtilmemise
	sizi atar. Eer kanal ve nick belirtilmemise, sizi 
	bulunduunuz tm kanallardan atar.
	
	Varsaylan olarak, AOP lar ile access seviyesi 5 ve zeri
	olanlar bu komutu kullanabilir.

CHAN_HELP_BAN
	Kullanm: BAN [#kanaladi [nick [sebep]]]
	
	Belirtilen nicki kanaldan banlar. Eger nick belirtilmezse
	sizi banlar. Eger nick ve kanal belirtilmezse sizi bulundugunuz
	tm kanallardan banlar.
	
	Varsayilan olarak, AOP larin veya 5. seviyeden access i olanlarin
	ve stnn kullanma yetkisi vardir.

CHAN_HELP_TOPIC
	Kullanm: TOPIC kanaladi [konu]
	
	%S belirtilen kanala belirtilen konuyu yazar.Eger
	topic belirtilmemisse, bos bir konu yazilir. Bu
	komut SET TOPICLOCK aktif oldugu zaman kullanislidir.
	Daha fazla bilgi iin %R%S HELP SET TOPICLOCK
	yazin.
	
	Varsayilan olarak, founderin kullanma yetkisi vardir.

CHAN_HELP_CLEAR
	Kullanm: CLEAR kanalad neyi
	
	%S'e belirtilen ayar kaldrmasn syler. neyi
	unlardan biri olmaldr:
	
	     MODES    Kanal modlarn temizler. (r. i,k,l,m,n,p,s,t
	                   modlarn temizler).
	     BANS     Kanaldaki tm banlar kaldrr.
	     EXCEPTS  Clears all excepts on the channel.
	     INVITES  Clears all invites on the channel.
	     OPS      Kanal opu statsnde olanlarn (mode +o)
	                  oplarn alr.
	     HOPS     Removes channel-halfoperator status (mode +h) from
	                  all channel halfoperators, if supported.
	     VOICES   Voice statsnde olanlarn (mode +v) voice larn
	                  alr.
	     USERS    Tm kullanclar kanaldan atar.
	
	Varsaylan olarak, founder tarafindan kullanilabilir.

CHAN_HELP_GETKEY
	Kullanm: GETKEY kanalad
	
	Belirtilen kanaln anahtarn syler. Bu komut botlar
	veya scriptler tarafndan kullanlmak zere tasarlanmtr,
	ve kts u ekildedir:
	
	KEY <kanalad> <anahtar>
	
	Eer bir anahtar yoksa anahtar ksmnda "NO KEY" olacaktr.

CHAN_HELP_SENDPASS
	Kullanm: SENDPASS kanalad
	
	Kanaln ifresini foundern nick kaytlarnda belirtilen
	e-mail adresine gnderir. Bu komut kanal ifresini 
	unutanlarn ok iine yarayacaktr.
	
	Baz networklerde IRC operatrlerinin Kullanmyla 
	snrlandrlm olabilir.
	
	Bu komut ifreleme(encryption) aktifken devre ddr.

CHAN_SERVADMIN_HELP
	
	Servis adminleri kanaln kaydn ifreyle tantmadan silebilir,
	ve access, Akick ve seviye ayarlarn grntleyebilirler.

CHAN_SERVADMIN_HELP_LOGOUT
	Kullanm: LOGOUT kanalad [nick]
	
	Bu komut belirtilen nickin artk belirtilen kanalda
	tanmlanmamasn salar.
	
	Eer kanal founder iseniz, istediiniz kiide, deilseniz
	sadece kendinizde bu komutu kullanabilirsiniz.
	
	Eer Servis admini iseniz, kanal founder olmanza gerek
	olmadan istediiniz kiide bu komutu kullanabilirsiniz.
	Hatta nick parametresini bo brakarak o kanalda kendini
	kanala tantm herkesi tanmlanmam yapabilirsiniz.

CHAN_SERVADMIN_HELP_DROP
	Kullanm: DROP kanalad
	
	Belirtilen kanaln kaydn siler. Sadece Servis adminleri
	kanal tantmadan kaydn silebilirler.

CHAN_SERVADMIN_HELP_SET
	
	Servis adminleri NOEXPIRE zelliini ayarlayarak istedikleri
	kanaln zaman amna uramasn engelleyebilirler.
	Ek olarak, Servis adminleri ifreyle kanal tantmaya gerek 
	olmadan bir kanaln tm zelliklerini ayarlayabilirler.

CHAN_SERVADMIN_HELP_SET_NOEXPIRE
	Kullanm: SET kanalad NOEXPIRE {ON | OFF}
	
	Belirtilen kanaln zaman asimina urayp uramayacan 
	belirler. Bunu ON olarak ayarlamak kanaln zaman amna 
	uramasn engelleyecektir.
	
	Servis adminlerinin Kullanmyla snrldr.

CHAN_SERVADMIN_HELP_INFO
	
	Servis adminleri herhangi bir kanal iin ALL parametresini
	kullanabilirler.

CHAN_SERVADMIN_HELP_LIST
	Kullanm: LIST model [FORBIDDEN] [NOEXPIRE]
	
	Belirtilen modelle uyuan tm kaytl kanallar listeler.
	PRIVATE zellii ayarl kanallar sadece Servis adminleri
	tarafndan grntlenir. NOEXPIRE zellii olan kanallarn
	yannda Servis adminleri iin ! iareti bulunur.
	
	Eer FORBIDDEN veya NOEXPIRE zellikleri belirtilmise,
	sadece yasakl(FORBIDDEN) yada zaman amna(NOEXPIRE) 
	uramayacak kanallar listelenir. Eer her iki zellikte 
	belirtilmise, her iki tip kanalda listelenir. Bu komutlar
	Servis adminlerinin Kullanmyla snrldr.

CHAN_SERVADMIN_HELP_GETPASS
	Kullanm: GETPASS kanalad
	
	Belirtilen kanaln ifresini syler. Unutmaynki bu
	komut ne zaman kullanlsa, Komutu kullanann ve komutta
	kullanlan kanaln ad kaydedilir ve WALLOPS/GLOBOPS olarak
	gnderilir.
	
	Servis adminlerinin Kullanmyla snrldr.

CHAN_SERVADMIN_HELP_FORBID
	Kullanm: FORBID kanalad [sebep]
	
	Belirtilen kanaln birisi tarafndan kayt edilmesini veya 
	kullanlmasn nler. Kanal droplanarak iptal edilir.
	
	Baz networklerde sebep gereklidir.
	
	Servis adminlerinin Kullanmyla snrldr.

CHAN_SERVADMIN_HELP_SUSPEND
	Kullanm: SUSPEND channel [reason]
	
	Kanaln kullanmn yasaklar.
	Kanal tekrar amak icin UNSUSPEND kullanldgnda
	kanal bilgi ve ayarlarn tekrar kullanma acar.
	
	Bir cok sunucuda ihtiyac duyulan bir uygulamadr.
	
	Services admins Kullanm ile snrlnr.

CHAN_SERVADMIN_HELP_UNSUSPEND
	Kullanm: UNSUSPEND channel
	
	Kanal kullanma aar. Tm bilgi ve ayarlar
	yasaklanmadan nceki hali ile kullanma sunar.
	
	Services admins Kullanm ile snrlnr.

CHAN_SERVADMIN_HELP_STATUS
	Kullanm: STATUS kanalad nick
	
	Belirtilen nickin belirtilen kanaldaki access seviyesini
	syler. Cevabn format u ekildedir:
	
	    STATUS kanalad nick access-seviyesi
	
	Eer bir hata olursa, cevabun format yle olur:
	
	    STATUS ERROR hata-mesaj
	
	Servis adminlerinin Kullanmyla snrldr.

###########################################################################
#
# MemoServ help messages
#
###########################################################################

MEMO_HELP_CMD_SEND
	    SEND   Nicke veya kanala mesaj gnderir
MEMO_HELP_CMD_CANCEL
	    CANCEL Son gnderilen mesaj iptal eder
MEMO_HELP_CMD_LIST
	    LIST   Mesajlarnz listeler
MEMO_HELP_CMD_READ
	    READ   Mesajlar okumanz salar
MEMO_HELP_CMD_DEL
	    DEL    Mesajlar silmenizi salar
MEMO_HELP_CMD_SET
	    SET    Mesajlarla ilgili ayarlar yapar
MEMO_HELP_CMD_INFO
	    INFO   Mesajlar Hakknda bilgi almanz saglar
MEMO_HELP_CMD_RSEND
	    RSEND  Taahhutlu mesaj yollamanz salar:)
MEMO_HELP_CMD_CHECK
	    CHECK  Kiinin son mesajn okuyup okumadgn kontrol eder
MEMO_HELP_CMD_SENDALL
	    SENDALL  Tm kaytl kullanclara mesaj yollamanizi saglar
MEMO_HELP_CMD_STAFF
	    STAFF      Tm grevlilere mesaj yollamanizi saglar

MEMO_HELP_HEADER
	%S kullanclarn birbirlerine veya kanallara(*) online 
	olmasalar bile mesaj gndermelerini salar. Mesaj gnderebilmek
	iin gnderenin nicki, gnderilenin nicki veya kanaln kaytl
	olmas gereklidir.
	
	%S'n mevcut komutlar:
	

MEMO_HELP_ADMIN
	Kullanlmyor.
MEMO_HELP_OPER
	Kullanlmyor.
MEMO_HELP_FOOTER
	
	Yukardaki herhangi bir komut hakknda yardm iin 
	%R%S HELP komut yazn.
	
	(*) Varsaylan olarak, kanal mesajlarn o kanalda access
	    seviyesi en az 10 olanlar okuyabilir. Bu %s LEVELS 
	    komutuyla deitirebilir.

MEMO_HELP_SEND
	Kullanm: SEND {nick | kanalad} mesaj
	
	Belirtilen nicke veya kanala yazlan mesaj gnderir.
	Nicke gnderirken, gnderilen kii yeni mesaj olduuna dair
	bir not alr. Mesaj gnderilen nick/kanal kaytl olmaldr.

MEMO_HELP_CANCEL
	Kullanm: CANCEL {nick | kanalad}
	
	Belirtilen kanala yada nicke gnderilen son mesaj iptal eder,
	tabi eer o mesaj siz komutu kullandnz srada okunmamsa.

MEMO_HELP_LIST
	Kullanm: LIST [kanalad] [liste | NEW]
	
	Mevcut mesajlarnz listeler. NEW parametresi sadece yeni
	okunmam mesajlar listeler. Okunmam mesajlar mesaj 
	numarasnn solunda "*" ile iaretlidir. Aadaki rnekte
	olduu gibi belirli numaralarda listeleyebilirsiniz:
	
	   LIST 2-5,7-9
	      2'den 5'e ve 7'den 9'a kadar olan mesajlar listeler.

MEMO_HELP_READ
	Kullanm: READ [kanalad] {num | liste | LAST | NEW}
	
	Belirtilen mesajlar okumanz salar. Eer LAST belirtilmise
	en son gelen mesajnz okursunuz. Eer NEW belirtilmise tm 
	yeni mesajlarn okursunuz. Eer bir numara belirtirseniz (num)
	o numaraya ait mesaj okursunuz. Aadaki rnekteki gibi belirli
	numaralarda okuyabilirsiniz:
	
	   READ 2-5,7-9
	      2'den 5'e ve 7'den 9'a kadar olan mesajlar gsterir.

MEMO_HELP_DEL
	Kullanm: DEL [kanalad] {num | liste | LAST | ALL}
	
	Belirtilen mesajlar siler. Aadaki rnekteki gibi birden
	fazla mesajda silebilirsiniz.
	
	If LAST is given, the last memo will be deleted.
	Eer ALL parametresi belirtilmise, tm mesajlarnz silinir.
	
	rnekler:
	
	   DEL 1
	      lk gelen mesajnz siler.
	
	   DEL 2-5,7-9
	      2'den 5'e ve 7'den 9'a kadar olan mesajlar siler.

MEMO_HELP_SET
	Kullanm: SET zellik parametre
	
	eitli mesaj ayarlarn yapar. zellik aadakilerden 
	biri olabilir:
	
	    NOTIFY      Yeni mesajlarda ne zaman uyarlacanz
	                    belirler (sadece nickler iindir)
	    LIMIT       Alabileceiniz maksimum mesaj saysn
	                    belirler
	
	Belirli bir zellik hakknda daha fazla bilgi iin, 
	%R%S HELP SET zellik yazn.

MEMO_HELP_SET_NOTIFY
	Kullanm: SET NOTIFY {ON | LOGON | NEW | MAIL | NOMAIL | OFF}
	
	Yeni mesajlarda ne zaman uyarlacanz belirler:
	
	    ON      Yeni mesajlar iin balandnzda, away den 
	               dnte ve size gnderildikleri anda 
	               uyarlrsnz.
	    LOGON   Yeni mesajlar iin balandnzda ve away den
	               dnte uyarlrsnz.
	    NEW     Yeni mesajlar iin sadece size gnderildikleri 
	               anda uyarlrsnz.
	    MAIL    You will be notified of memos by email aswell as
	                any other settings you have.
	    NOMAIL  You will not be notified of memos by email.
	    OFF     Yeni mesajlar iin herhangi bir uyar almazsnz.
	
	ON parametresi LOGON ve NEW 'in kombinasyonudur

MEMO_HELP_SET_LIMIT
	Kullanm: SET LIMIT [kanalad] limit
	
	Sizin alabileceiniz (yada belirtilen kanaln) maksimum mesaj
	saysn belirler. Eer bunu 0 yaparsanz kimse size mesaj 
	gnderemeyecektir. Ayrca bu limiti %d den fazla yapamazsnz.

MEMO_HELP_INFO
	Kullanm: INFO [kanalad]
	
	Sahip olduunuz mesaj says, ka tanesinin okunmad, ve 
	alabileceiniz maksimum mesaj says gibi bilgiler verir.
	Eer kanalad parametresi belirtilirse ayn bilgiyi o kanal
	iin gsterir.

MEMO_SERVADMIN_HELP_SET_LIMIT
	Kullanm: SET LIMIT [kullanc | kanalad] {limit | NONE} [HARD]
	
	Bir kullanccn yada kanaln alabilecei maksimum mesaj
	saysn belirler. Bunu 0 yapmak kullancnn mesaj almasn 
	engeller; NONE yapmaksa kullancnn istedii kadar mesaj
	alp saklamasn salar. Eer kanal veya nick belirtilmezse,
	kendi limitinizi ayarlarsnz.
	
	HARD parametresini eklemek kullancnn bu limiti deitirmesini
	engeller. Bunu eklememekde, kullancnn limiti deitirmesine izin
	verir. (Bir nceki limit ayarnda HARD kullanlm olsa bile).
	
	SET LIMIT komutunun Kullanm Servis adminleriyle snrldr.
	Dier kullanclar limitlerini kaldramaz, %d zeri bir limit 
	belirleyemez, ve hard limitini ayarlayamaz. Sadece gerekli 
	ayrcalklar varsa bir kanaln mesaj limitini ve kendi mesaj
	limitlerini ayarlayabilirler.

MEMO_SERVADMIN_HELP_INFO
	Kullanm: INFO [nick | kanalad]
	
	Parametre kullanlmazsa, sahip olduunuz mesajlar, ka 
	tanesinin okunmam olduunu, ve toplam ka tane mesaj 
	alabileceiniz hakknda bilgiler verir.
	
	Kanalad parametresiyle, ayn bilgiyi belirtilen kanal
	iin verir.
	
	Nick parametresiyle, ayn bilgiyi belirtilen nick iin
	verir. Kullanm Servis adminleriyle snrldr.

###########################################################################
#
# OperServ help messages
#
###########################################################################

MEMO_HELP_STAFF
	Kullanm: STAFF memo-text

	Tm servis grevlilerine  memaj yollamanz saglar.
	Note: If you have opers on both the oper list and the
	admin list they will recive the memo twice.  The same
	applies for oper's on the Root list as well as other
	lists.

###########################################################################
#
# OperServ help messages
#
###########################################################################

MEMO_HELP_SENDALL
	Kullanm: SENDALL mesaj

	Tm kaytl kullanclara mesaj yollamanz saglar.

###########################################################################
#
# OperServ help messages
#
###########################################################################

MEMO_HELP_RSEND
	Kullanm: RSEND {nick | channel} memo-text
	
	Bir nick veya kanal mesaj yollayabilirsiniz
	memo-text.  Bir rumuza yolladgnz zaman 
	Kii yeni mesaj aldgna dair uyarlr. Yollanan hedef
	kaytl bir rumuz veya kanal olmaldr.
	Mesaj okundugu zaman yollayan kiiye, okuyan kiilerin okuduguna dair
	bir uyari bilgisi iletilir.
	Bir baska deyi ile iadeli taahhutlu mektup gibidir.:)

###########################################################################
#
# OperServ help messages
#
###########################################################################

MEMO_HELP_CHECK
	Kullanm: CHECK nick
	
	Yollanan rumuzun son mesaj okudugunu veya okumadgn gosterir
	Not: Sadece rumuzlarda kullanlr, kanal mesajlarnda geerli degildir.

###########################################################################
#
# OperServ help messages
#
###########################################################################

OPER_HELP_CMD_GLOBAL
	    GLOBAL      Tm kullanclara mesaj gnderir
OPER_HELP_CMD_STATS
	    STATS       Servislerin ve networkun durumunu gsterir
OPER_HELP_CMD_OPER
	    OPER        Servis operatr listesini dzenler
OPER_HELP_CMD_ADMIN
	    ADMIN       Servis adminleri listesini dzenler
OPER_HELP_CMD_STAFF
	    STAFF       Sunucu grevlilerini durumlarna gre listeler
OPER_HELP_CMD_MODE
	    MODE        Bir kanaln modlarn deitirir
OPER_HELP_CMD_KICK
	    KICK        Bir kullancy kanaldan atar
OPER_HELP_CMD_CLEARMODES
	    CLEARMODES  Bir kanaln modlarn temizler
OPER_HELP_CMD_KILLCLONES
	    KILLCLONES  Ayni ip'deki tum kullanicilari kill'ler.
OPER_HELP_CMD_AKILL
	    AKILL       AKILL listesini dzenler
OPER_HELP_CMD_SGLINE
	    SGLINE      SGLINE listesini dzenler
OPER_HELP_CMD_SQLINE
	    SQLINE      SQLINE listesini dzenler
OPER_HELP_CMD_SZLINE
	    SZLINE      SZLINE listesini dzenler
OPER_HELP_CMD_CHANLIST
	    CHANLIST    Tm kanal kaytlarn listeler
OPER_HELP_CMD_USERLIST
	    USERLIST    Tm kullanc kaytlarn listeler
OPER_HELP_CMD_LOGONNEWS
	    LOGONNEWS   Balant srasnda kullancnn grecei mesaj 
	                belirler
OPER_HELP_CMD_RANDOMNEWS
	    RANDOMNEWS  Baglanti sirasina kullaniciya gnderilen karisik
	                mesajlari belirler
OPER_HELP_CMD_OPERNEWS
	    OPERNEWS    Oper olan kullanclarn grntleyecei mesaj 
	                belirler
OPER_HELP_CMD_SESSION
	    SESSION     Host session(oturum) larn listesini gsterir
OPER_HELP_CMD_EXCEPTION
	    EXCEPTION   Session-limit exception listesini dzenler
OPER_HELP_CMD_NOOP
	    NOOP        Geici olarak tm O:line lar kaldrr
OPER_HELP_CMD_JUPE
	    JUPE        Bir server' "Kullanlmaz" yapar
OPER_HELP_CMD_IGNORE
	    IGNORE      Servis engel listesini dzenler
OPER_HELP_CMD_SET
	    SET         eitli global servis zelliklerini ayarlar
OPER_HELP_CMD_RELOAD
	    RELOAD      Servislerin conf dosyasn yeniden ykler
OPER_HELP_CMD_UPDATE
	    UPDATE      Diskteki Servis veritabannn hemen
	                gncellenmesini salar

OPER_HELP_CMD_RESTART
	    RESTART     Veritabann kaydeder ve servisleri yeniden 
	                balatr

OPER_HELP_CMD_QUIT
	    QUIT        Servis programn kapatr
OPER_HELP_CMD_SHUTDOWN
	    SHUTDOWN    Servisler programn kayt ederek kapatr
OPER_HELP_CMD_DEFCON
	    DEFCON      DEFCON sistemini elle dzenlemenizi salar
OPER_HELP_CMD_CHANKILL
	    CHANKILL    Secilen kanaldaki tm kullanclar sunucudan atar
OPER_HELP_CMD_OLINE
	    OLINE       Eklenen rumuza oper yetkisi verir
OPER_HELP_CMD_UMODE
	    UMODE       Kullancnn modlarn degitirir
OPER_HELP_CMD_SVSNICK
	    SVSNICK     Kii nickini zorla deitirir
OPER_HELP_CMD_MODLOAD
	    MODLOAD     Eklenti ykler
OPER_HELP_CMD_MODUNLOAD
	    MODUNLOAD   Eklenti kaldrr
OPER_HELP_CMD_MODINFO
	    MODINFO     Eklentinin bilgilerini verir
OPER_HELP_CMD_MODLIST
	    MODLIST     Eklentileri listeler

OPER_HELP
	%S komutlar:

OPER_HELP_LOGGED
	Not: %S'e gnderilen tm komutlarn kayd tutulur!

OPER_HELP_GLOBAL
	Kullanm: GLOBAL mesaj
	
	IRCoplarn networkteki tm kullanclara mesaj yollamasn
	salar. Mesajlar %s nickinden gnderilir.

OPER_HELP_STATS
	Kullanm: STATS [AKILL | ALL | RESET]
	
	Hibir parametre yokken, mevcut kullanc saysn ve online
	olan IRCoplar(Servisler hari), Servisler balatldndan 
	beri bal olan en fazla kullanc saysn, ve servislerin
	alma sresini gsterir.
	
	AKILL parametresiyle, mevcut AKILL listesini ve o anki 
	varsaylan zaman am sresini gsterir.
	
	ALL parametresi sadece Servis adminleri tarafndan 
	kullanlabilir, ve servislerin kulland hafza(memory) 
	hakknda bilgi verir. Byk networklerde bu komutun kullanlmas
	servisleri ksa bir sre dondurabilir, bu yzden tekrar kullanmaya
	kalkmayn!
	
	RESET parametresi nceki maksimum kullanc saysn o anda
	networkte bulunan kullanc saysyla deitirir.
	
	UPTIME komutu STATS komutunun alternatifi olarak kullanlabilir.

OPER_HELP_OPER
	Kullanm: OPER ADD nick
	           OPER DEL {nick | kayt-num | liste}
	           OPER LIST [mask | liste]
	           OPER CLEAR
	
	Servis Root Servis operatrleri listesine belirtilen 
	nicki ekleyip karmasn salar. Nicki Servis operatrleri
	listesinde olan ve kendini %s ile tantm olan kullanclar
	Servis operatrleri komutlarn kullanabilir.
	
	OPER ADD komutu belirtilen nicki servis operatrleri listesine
	ekler.
	
	OPER DEL komutu belirtilen nicki servis operatrleri listesinden
	siler. Eer bir kayt numaras listesi verilmise, bu kaytlar
	silinir. (Aadaki LIST ile ilgili rnei inceleyin.)
	
	OPER LIST komutu servis operatrleri listesini grntler.
	Eer yldzl(wildcard) bir mask belirtilirse, sadece o maskla
	uyuan kaytlar listelenir. Eerbir kayt numaras listesi 
	belirtilirse, sadece o kaytlar gsterilir; rnein:
	
	   OPER LIST 2-5,7-9
	      Servis operatrlerinden kayd 2 den 5 e ve 7 den 9 a
	      kadar olanlar listelenir.
	
	OPER CLEAR komutu servis operatrleri listesindeki tm kaytlar
	siler.
	
	Herhangi bir IRC operatr OPER LIST komutunu kullanabilir.

OPER_HELP_ADMIN
	Kullanm: ADMIN ADD nick
	           ADMIN DEL {nick | kayt-num | liste}
	           ADMIN LIST [mask | liste]
	           ADMIN CLEAR
	
	Servis root unun Servis adminleri listesine 
	belirtilen nicki ekleyip karmasn salar. Nicki Servis 
	adminleri listesinde olan ve kendini %s ile tantm olan
	kullanc Servis adminlerini komutlarn kullanabilir.
	
	ADMIN ADD komutu servis adminleri listesine belirtilen nicki
	ekler.
	
	ADMIN DEL komutu belirtilen nicki servis adminleri listesinden
	siler. Eer kayt numaralar listesi verilmise, bu kaytlar 
	silinir. (Aadaki LIST rneini inceleyin.)
	
	ADMIN LIST komutu servis adminleri listesini grntler.
	Eer yldzl(wildcard) bir mask belirtilmise, sadece bu
	maskla uyuan kaytlar grntlenir. Eer bir kayt numaras 
	listesi belirtilmise, sadece o kaytlar gsterilir; rnein:
	
	   ADMIN LIST 2-5,7-9
	      Servis adminleri kaytlarndan 2 den 5 e ve 7 den 9 a
	      kadar olanlar listelenir.
	      
	ADMIN CLEAR komutu tm servis adminlerinin kaytlarn siler.

	Herhangi bir IRC operatr ADMIN LIST komutunu kullanabilir.
	Dier tm ADMIN komutlarn Servis rootlar kullanabilir.

OPER_HELP_IGNORE
	Kullanm: IGNORE {ADD|DEL|LIST|CLEAR} [time] [nick | mask]
	
	Servis adminler tarafndan kullanlr. 
	Belirli bir sre veya servisler yeniden balatlana kadar kiinin servisler tarafndan
	engellenmesini salar. Varsaylan zaman degeri saniyedir.
	Eer farkl zaman bicimleri istenir ise: saniye icin s,dakika icin m, 
	saat icin h ve gn icin d kullanlabilir. 
	Birleik kombinasyonlar desteklenmez.
	Kiiyi servislerden tamamen engellemek icin, 0 girdisi belirtilmelidir.
	Eger mask kullanlacak ise, user@host
	veya nick!user@host,.
	kullanlmaldr.
	
	Engelleme IRC Operatorleri tarafndan kullanlamaz.

OPER_HELP_MODE
	Kullanm: MODE kanalad modlar
	
	Servis operatrlerinin herhangi bir kanaln modlarn
	ayarlamasn salar. Parametreler standart /MODE komutununkiyle
	ayndr.
	
	Servis operatrlerinin Kullanmyla snrldr.

OPER_HELP_UMODE
	Kullanm: UMODE user modes
	
	Super Admins kullanmna ack olmakla beraber.
	standart /MODE komutu gerine kullanlan komuttur.
	Secilen kiinin modlarn degitirmek icin kullanlr.

OPER_HELP_OLINE
	Kullanm: OLINE user flags
	
	Super Admins kullanmna acktr kiiye Oper yetkisi verir.
	Seilen parametreler "+" veya "-" eklinde belirtilmelidir. 
	tm modlar snomasklar kaldrmak icin  "-" kullanlabilir.

OPER_HELP_CLEARMODES
	Kullanm: CLEARMODES kanalad [ALL]
	
	Bir kanaldaki tm modlar (i,k,l,m,n,p,s,t) ve banlar
	temizler. Eer ALL parametresi belirtilmise, tm
	oplar (+o) ve voicelar (+v) temizler.
	
	Servis operatrlerinin Kullanmyla snrldr.

OPER_HELP_KICK
	Kullanm: KICK kanalad kullanc sebep
	
	IRCoplarn herhangi bir kullancy kanaldan atmalarn
	salar. Parametreler standart /KICK komutununkiyle ayndr.
	Kick mesajnda komutu kullanan IRCop un nickide belirtilir.
	rnein:
	
	*** SpamMan has been kicked off channel #my_channel by %S (MJJ (Flood))
	
	Servis operatrlerinin Kullanmyla snrldr.

OPER_HELP_SVSNICK
	Kullanm: SVSNICK nick newnick
	
	Kiinin rumuzunu degitirmek icin kullanlr.
	Super Admins kullanm icindir.

OPER_HELP_AKILL
	Kullanm: AKILL ADD [+zamanam] mask sebep
	           AKILL DEL {mask | kayt-no | liste}
	           AKILL LIST [mask | liste]
	           AKILL VIEW [mask | liste]
	           AKILL CLEAR
	
	Servis operatrlerinin AKILL listesini iletmesini salar.
	Eer AKILL listesineki mask la uyuan bir kullanc
	balanmaya alrsa, Servisler o kullancy KILL ler ve,
	destekleyen server tiplerinde, tm serverlarn o maska K-line
	koymasn salar.
	
	AKILL ADD belirtilen user@host maskn AKILL listesine
	belirtilen sebeple(mutlaka belirtilmelidir) birlikte
	ekler. AKILL DEL belirtilen mask eer listedeyse AKILL 
	listesinden karr. AKILL LIST mevcut tm AKILL leri
	gsterir; eer opsiyonel olarak mask belirtilmise, AKILL
	listesi belirtilen maskla uyuanlarla snrlandrlr. 
	
	AKILL VIEW, AKILL LIST in daha aklayc versiyonudur, 
	ve AKILL i ekleyeni, eklenme tarihini, ne zaman sona ereceini,
	user@host maskyla ve sebeple birlikte gsterir.
	
	Opsiyonel olarak, zaman am sresi AKILL ADD komutuyla
	birlikte belirtilebilir. Zaman am sresi user@host maskndan
	nce gelir, ve bir tamsay olarak unlardan birinden nce gelir, 
	d (gn), h (saat), veya m (dakika). 1h30m gibi kombinasyonlar 
	kullanlamaz. Eer birim belirleyici belirtilmemise varsaylan 
	olarak gn kullanlr (yani +30 un anlam 30 gndr). Zaman 
	amna uramayacak bir AKILL eklemek iin +0 kullann. Eer 
	eklenecek mask + ile balarsa zaman am sresi belirtilmelidir. 
	Mevcut varsaylan AKILL zaman am sresi STATS AKILL komutuyla 
	bulunabilir.

	AKILL CLEAR AKILL listesindeki tm kaytlar siler.
	
	sebep sadece IRC operatrleri tarafndan kullanlmak iindir,
	ve kullanclarn KILL mesajlarnda gzkmez.
	
	Servis operatrlerinin Kullanmyla snrldr.

OPER_HELP_SGLINE
	Kullanm: SGLINE ADD [+zamanam] mask:sebep
	         SGLINE DEL {mask | kayt-no | liste}
	           SGLINE LIST [mask | liste]
	           SGLINE VIEW [mask | liste]
	           SGLINE CLEAR
	
	Servis operatrlerinin SGLINE listesi oluturmalarn salar.
	Eer SGLINE listesindeki bir kullanc gerek ismi(realname)
	servera balanmaya alan bir kullancnnkiyle uyuuyorsa
	o kullancnn servera balanmas engellenir.
	
	SGLINE ADD komutu belirtilen realname(gerek isim) mask n
	SGLINE listesine bir sebeple(belirtilmesi zorunludur) 
	birlikte ekler.
	zamanam zaman belirleyici olarak tanmlanr ve unlar birini
	takip etmelidir: d (gn), h (saat), veya m (dakika). 1h30m
	eklindeki kombinasyonlar kullanlamaz. Eer zaman tanmlayc e
	konulmazsa varsaylan olarak gn kabul edilir (yani +30 un manas
	30 gndr). Zaman amna uramayacak bir SGLINE eklemek iin +0
	kullann.  Eklenecek realname mask  + ile balyorsa, o zaman
	zaman am sresi varsaylanla ayn olsa bile belirtilmelidir.
	Mevcut SGLINE varsaylan zaman am sresi STATS AKILL komutuyla
	bulunabilir.
	Not: realname mask boluk ierebileceinden bunla sebep arasnda iki
	nokta stste(:) kullanlmaldr.
	
	SGLINE DEL komutu belirtilen mask(eer listede mevcutsa) SGLINE 
	listesinden siler. eer bir kayt numaralar listesi belirtilmise
	o kaytlar silinir. (Aadaki LIST iin verilmi rnei inceleyin.)
	
	SGLINE LIST komutu SGLINE listesini grntler. Eer bir yldzl
	mask verilmise, sadece o maskla uyuan kaytlar ieren bir liste
	grntlenir.  Eer bir kayt numaralar listesi belirtilmise,
	sadece o kaytlar grntlenir; rnein:
	
	   SGLINE LIST 2-5,7-9
	      2 den 5 e 7 den 9 a kadar olan SGLINE kaytlarn listeler.
	      
	SGLINE VIEW komutu SGLINE LIST komutunun daha aklayc bilgi 
	veren eklidir, ve SGLINE  kimin eklediini, eklendii tarihi, ve
	ne zaman sona ereceini realname ve sebeple birlikte gsterir.
	
	SGLINE CLEAR komutu SGLINE listesindeki tm kaytlar siler.
	
	Servis operatrlerinin Kullanmyla snrldr.

OPER_HELP_SQLINE
	Kullanimi: SQLINE ADD [+zamanasimi] mask sebep
	           SQLINE DEL {mask | kayit-no | liste}
	           SQLINE LIST [mask | liste]
	           SQLINE VIEW [mask | liste]
	           SQLINE CLEAR
	
	Servis adminlerinin SQLINE listesini ynetmelerini saglar.
	Eger SQLINE listesindeki masklardan biriyle uyusan bir nick
	servera baglanmaya alisirsa, servisler buna izin vermezler.
	
	eger maskin ilk karakteri # ise servisler onla uyusan 
	kanallarin kullanilmasina izin vermezler. (destekleyen IRCd
	yazilimlarinda geerlidir).
	
	SQLINE ADD belirtilen maski belirtilen sebeple (mutlaka
	belirtilmelidir) birlikte SQLINE listesine ekler. zaman asimi
	ardinda d (gn), h (saat), veya m (dakika) olan bir sayi
	olmalidir..  1h30m seklindeki kombinasyonlar geersizdir.
	eger son ekleme harfi belirtilmemisse, varsayilan olarak gn
	kullanilir. (yani +30 30 gn demektir). Zaman asimina ugramasini
	istemediginiz bir SQLINE eklemek iin +0 kullanin.  
	Egegr eklenecek maskin basinda + varsa, zaman asimi sresi
	belirtilmelidir, aksi halde zaman asimi sresi varsayilanla ayni
	olacaktir. Mevcut SQLINE varsayilan zaman asimi sresi STATS AKILL
	komutuyla bulunabilir.
	
	SQLINE DEL komutu belirtilen maski SQLINE listesinden siler.
	Eger kayit numaralari listesi belirtilmisse, o kayitlari siler.
	(Asagidaki rnegi inceleyin.)
	
	SQLINE LIST komutu SQLINE listesini gsterir. Egegr bir mask
	belirtilmisse, maskla uyusan kayitlar gsterilir. Egegr kayit
	numaralari listesi belirtilmisse, o numaralara karsilik olan
	kayitlar gsterilir; rnegin:

	   SQLINE LIST 2-5,7-9
	      2 den 5 e ve 7 den 9 a kadar olan SQLINE kayitlari
	      gsterilir.
	      
	SQLINE VIEW komutu SQLINE LIST komutunun daha gelismisidir,
	ve SQLINE kaydini ekleyeni, eklendigi tarihi, sresinin ne zaman
	bitecegini, mask ve sebeple beraber gsterir.
	
	SQLINE CLEAR SQLINE listesindeki tm kayitlari temizler.
	
	Servis operatrlerinin kullanimiyla sinirlidir.

OPER_HELP_SZLINE
	Kullanm: SZLINE ADD [+zamanam] mask sebep
	           SZLINE DEL {mask | kayt-no | liste}
	           SZLINE LIST [mask | liste]
	           SZLINE VIEW [mask | liste]
	           SZLINE CLEAR
	
	Servis operatrlerinin SZLINE listesi oluturmalarn salar.
	Eer SZLINE listesindeki bir IP numarasyla uyuan bir kii
	servera balanmaya alrsa buna izin verilmez. (ve bu IP
	numaras PTR RR olsada olmasada gerekletirilir).
	
	SZLINE ADD komutu belirtilen IP maskn SZLINE listesine
	belirtilen bir sebeple(ki mutlaka belirtilmelidir) birlikte
	ekler. zamanam zaman belirleyici olarak tanmlanr ve 
	unlardan birini takip etmelidir: d (gn), h (saat), veya
	m (dakika). 1h30m eklindeki kombinasyonlar kullanlamaz.
	Eer zaman tanmlayc e belirtilmemise, varsaylan olarak
	gn kullanlr (yani +30 30 gn demektir).  Zaman amna 
	uramayacak bir SZLINE eklemek iin +0 kullann.  Eer
	eklenecek realname mask + ile balyorsa, zaman am sresi
	varsaylanla ayn olsa bile belirtilmelidir. Mevcut SZLINE 
	varsaylan zaman am sresi STATS AKILL komutuyla renilebilir.
	
	SZLINE DEL komutu belirtilen mask eer mevcutsa SZLINE 
	listesinden siler. Eer kayt numaralar listesi belirtilmise,
	bu kaytlar silinir. (LIST iin verilmi aadaki rnei inceleyin.)
	
	SZLINE LIST komutu SZLINE listesini grntler. Eer yldzl bir
	mask belirtilmise, sadece o maskla uyuan kaytlar grntlenir.
	Eer kayt numaralar listesi belirtilmise, sadece o kaytlar 
	gsterilir;  rnein:
	
	   SZLINE LIST 2-5,7-9
	      2 den 5 e 7 den 9 a kadar olan kaytlar grntler.
	      
	SZLINE VIEW komutu SZLINE LIST komutunun daha geni bilgi veren 
	bir eklidir, ve SZLINE  kimin eklediini, eklendii tarihi, ve ne
	zaman sona ereceini, IP mask ve sebeple birlikte grntler.
	
	SZLINE CLEAR komutu SZLINE listesindeki tm kaytlar siler.
	
	Servis operatrlerinin Kullanmyla snrldr.

OPER_HELP_SET
	Kullanm: SET zellik ayar
	
	eitli global servis zelliklerini ayarlar.  zellikler
	aada tanmlanmtr:
	    READONLY   Read-only ve read-write modunu ayarlar
	    LOGCHAN    Report log messages to a channel
	    DEBUG      Debug modunu aktifletirir yada kapatr
	    NOEXPIRE   No expire modunu aktifletirir yada kapatr
	    SUPERADMIN Activate or deactivate super-admin mode
	    SQL   	 Activate or deactivate sql mode
	    IGNORE     Activate or deactivate ignore mode
	    LIST       List the options
	
	Servis adminlerinin Kullanmyla snrldr.

OPER_HELP_SET_READONLY
	Kullanm: SET READONLY {ON | OFF}
	
	Read-only modunu aar yada kapatr. Read-only modunda,
	normal kullanclar herhangi bir servis verisini deitiremezler,
	bunun iinde kanal ve nick access listeleri v.s. vardr.
	Yeterli ayrcalklar olan IRCoplar servislerin AKILL listesini
	deitirebilir, nicklerin ve kanallarn kaydn silebilir yada 
	yasaklayabilir, fakat deiiklikler servisler kapatlmadan yada
	tekrar balatlmadan nce read-only modu kapatlmazsa kaydedilmez.
	
	-readonly komut satr zelliiyle ayndr.

OPER_HELP_SET_LOGCHAN
	Kullanm: SET LOGCHAN {ON | OFF}

	Bu ayar servis kaytlarnnn bir kanala aktarlmasnn baslatlmas
	icin kullanlr. Kaytlar kayt dosyasna ilenmesi istenilmis ilemlerdir. LogChannel 
	Servis ayar dosyasi servies.conf'ta tanmlanr. Bir tanmlama 
	Bulunmuyor ise bu zellik aktif edilemez.
	
	Bu ozellik -logchan seklndede kullanlabilir.

	Not: Bu zellik kanal iyi korunmaz ise cok byk bir gvenlik ag ortaya ckartr, 
	kanal yeterince iyi koruyamyorsaniz aktif etmeyiniz. Unutmayn neredeyse tm ilemler bu kanala yansitilacaktir.

OPER_HELP_SET_DEBUG
	Kullanm: SET DEBUG {ON | OFF | num}
	
	Debug modunu aar yada kapatr. Debug modunda, servislere 
	gnderilen ve alnan tm veriler dier bir ka debug 
	mesajlaryla beraber bir kayt dosyasna yazlr. Eer num 
	parametresi belirtilmise, debug modu num a bal debug 
	seviye ayar ile aktifletirilir.
	
	-debug komut satr zelliiyle ayndr.

OPER_HELP_SET_NOEXPIRE
	Kullanm: SET NOEXPIRE {ON | OFF}
	
	No expire modunu aar yada kapatr. No expire modunda,
	nickler, kanallar, akiller, ve exceptionlar mod kapanana
	kadar zaman amna uramazlar.
	
	-noexpire komut satr zelliiyle ayndr.

OPER_HELP_SET_SUPERADMIN
	Kullanm: SET SUPERADMIN {ON | OFF}

	Bu zellik ekstra yetkilendirme anlamna gelir
	Sper admin olan kisi hereyin "founder" (sahibi) konumuna gecer...

	Bu nerilen bir zellik degildir, Eer yinede ihtiya duyarsaniz
	isteginizi gerceklestirdikten sonra uzun sre bal kalmadan  ck yapmanizi neririz.

OPER_HELP_SET_SQL
	Kullanm: SET SQL {ON | OFF}

	Bu ayar Anope ile Sql sunucunuzun birbirine baglanmasn saglar,
	Bu zellik Sql sunucunun servisler akken dmesi sonucu
	tekrar balant kurulmas icin kullanlr.

OPER_HELP_SET_IGNORE
	Kullanm: SET IGNORE {ON | OFF}

	Anope ignore sisteminin aktif veya pasif konuma alnmasn 
	salar.

OPER_HELP_SET_LIST
	Kullanm: SET LIST

	Secilen %S parametresi ile ilgili yardim icin kullanlr

OPER_HELP_NOOP
	Kullanm: NOOP SET server
	           NOOP REVOKE server
	
	NOOP SET komutu belirtilen serverdaki tm O:line lar
	siler ve tm ircoplar rehash komutunu kullanp komutun
	etkisini yok etmemeleri iin killer.
	
	NOOP REVOKE komutu belirtilen serverdaki tm kaldrlm
	O:line lar yeniden oluturur.
	
	Not: server parametresinin doruluu servisler tarafndan
	kontrol edilmez.
	
	Services adminlerinin Kullanmyla snrldr.

OPER_HELP_JUPE
	Kullanm: JUPE server [sebep]
	
	Servislere bir servern Jupiter yaplmasn syler. -- Bu,
	servislere bir sahte server balayarak, gerek servern o 
	isimden balanmasn engeller. JUPE modu standart SQUIT
	kullanlarak kaldrlabilir. Eer sebep belirtilmise,
	bu server bilgi satrna yazlr; belirtilmezse server bilgi
	satrnda "Jupitered by <nick>" yazs yer alr, ve server 
	jupiter edenin nicki yazlr.
	
	Servis adminlerinin Kullanmyla snrldr.

OPER_HELP_RAW
	Kullanm: RAW yaz
	
	Servislerin bal olduu server a direk bir yaz gnderir.
	Bu komutun kullanm alanlar snrldr, ve yanl kullanlrsa
	networkte ok byk hasara yol aabilir. Tam olarak ne 
	yaptnz bilmiyorsanz BU KOMUTU KULLANMAYIN!
	
	Servis adminlerinin Kullanmyla snrldr.

OPER_HELP_UPDATE
	Kullanm: UPDATE
	
	Komutu gnderir gnderirmez servislerin tm veri taban 
	dosyalarn gncellemelerini salar.
	
	Servis adminlerinin Kullanmyla snrldr.

OPER_HELP_RELOAD
	Kullanm: RELOAD
	
	Servislerin conf dosyasn yeniden yklemesine neden olur.
	Unutmaynki baz direktifler hala servislerin yeniden 
	balatlmasn gerektirir. (Servislerin nickleri, session 
	limitinin aktifletirilmesi, etc.)
	
	Servis adminlerinin Kullanmyla snrldr.

OPER_HELP_QUIT
	Kullanm: QUIT
	
	Servislerin birden kapanmasna neden olur; veritabanlar
	kaydedilmez. Bu komut veritabanlarnn hafzadaki 
	kopyalarna zarar gelmesinden korkuluyorsa ve 
	yedeklenmemilerse kullanlmamaldr. Normal kapatmalar 
	iin, SHUTDOWN komutunu kullann.
	
	Servis adminlerinin Kullanmyla snrldr.

OPER_HELP_SHUTDOWN
	Kulanm: SHUTDOWN
	
	Servislerin tm veritabanlarn kaydederek kapanmasn salar.
	
	Servis adminlerinin Kullanmyla snrldr.

OPER_HELP_RESTART
	Kullanm: RESTART
	
	Servislerin tm veritabanlarn kaydederek yeniden 
	balamasn salar.
	
	Servis adminlerinin Kullanmyla snrldr.	

OPER_HELP_CHANLIST
	Kullanm: CHANLIST [{model | nick} [SECRET]]
	
	Networkte o an kullanlan kanallar kaytl olsun olmasn 
	listeler.
	
	Eer model belirtilmise, onla uyuan kanallar listeler. 
	Eer nickname belirtilmise, o kullancnn bulunduu 
	kanallar listeler. Eer SECRET belirtilmise, sadece model
	le uyuan ve +s veya +p modunda olan kanallar listelenir.
	
	Servis adminlerinin Kullanmyla snrldr.

OPER_HELP_USERLIST
	Kullanm: USERLIST [{model | kanalad} [INVISIBLE]]
	
	Networkte o an bulunan tm kullanclar kaytl olsun olmasn 
	listeler.
	
	Eer model belirtilmise, onla uyuan kullanclar listeler
	(nick!user@host formatnda olmaldr). Eer kanalad 
	belirtilmise, sadece o kanalda bulunan kullanclar listeler.
	Eer INVISIBLE belirtilmise, sadece +i modundaki kullanclar 
	listelenir.
	
	Servis adminlerinin Kullanmyla snrldr.

OPER_HELP_MODLOAD
	Kullanm: MODLOAD FileName

	Eklentileri yklenemek icin eklenti ismi ile beraber
	kullanlr.

	Services Roots kullanm icindir.

OPER_HELP_MODUNLOAD
	Kullanm: MODUNLOAD FileName

	Ykl olan bir eklentiyi kaldrmak icin eklenti ad belirtilerek
	kullanlr.

	Services Roots kullanm icindir.

OPER_HELP_MODINFO
	Kullanm: MODINFO FileName

	Eklenti hakknda bilgi almak icin kullanlr

	Services Roots kullanm icindir.

OPER_HELP_MODLIST
	Kullanm: MODLIST [Core|3rd|protocol|encryption|supported|qatested]

	Eklentileri listelemek icin kullanlabilir.

	Services Roots kullanm icindir.


###########################################################################
#
# BotServ help messages
#
###########################################################################


BOT_HELP_CMD_BOTLIST
	BOTLIST            Mevcut botlar listeler
BOT_HELP_CMD_ASSIGN
	ASSIGN             Kanala bot sokar
BOT_HELP_CMD_SET
	SET                Bot zelliklerini ayarlar
BOT_HELP_CMD_KICK
	KICK               Atma zelliklerini ayarlar
BOT_HELP_CMD_BADWORDS
	BADWORDS           Kfr listesi oluturur
BOT_HELP_CMD_ACT
	ACT                Bota "/me" komutu eklinde mesaj gndermek icin kullanlr
BOT_HELP_CMD_INFO
	INFO               Bir kanal veya bot hakknda bilgi almak icin kullanlr
BOT_HELP_CMD_SAY
	SAY                Botun yazlan yazy kanala yollamasn saglar
BOT_HELP_CMD_UNASSIGN
	UNASSIGN           botu kanaldan ckartr
BOT_HELP_CMD_BOT
	BOT                Networkn bot listesini dzenler

BOT_HELP
	%S kanalnzda bir botunuzun olmasn salar. Bu
	servis bot konfigrasyonundan anlamayanlar yada
	bota izin vermeyen networkler iin gelitirilmitir.
	Mevcut komutlar aada listelenmitir. Kullanmak iin
	%R%S command yazn. Belirli bir komut hakknda
	daha fazla bilgi iin, %R%S HELP komut
	yazn.
	
BOT_HELP_FOOTER
	Kanalda en az %d kullanc olduu zaman bot kanala girer.

BOT_HELP_BOTLIST
	Kullanm: BOTLIST
	
	Networkte mevcut olan tm botlar listeler.

BOT_HELP_ASSIGN
	Kullanm: ASSIGN kanalad botunnicki
	
	Belirtilen nickteki botu belirtilen kanala sokar. Bundan 
	sonra botun ayarlarn ihtiyalarnza uygun ekilde 
	yapabilirsiniz.

BOT_HELP_UNASSIGN
	Kullanm: UNASSIGN kanalad
	
	Belirtilen kanaldan botu karr. Bu komutu kullandktan
	sonra bot bir daha kanala girmeyecektir. Fakat yaplm bot
	ayarlar saklanr, bylece istediinz zaman tekrar ayar 
	yapmaya gerek olmadan kanala bot sokabilirsiniz.

BOT_HELP_INFO
	Kullanm: INFO {kanalad | botunnicki}
	
	Bir kanal yada bot hakknda %S bilgisini gsterir. Eer
	parametre kanalsa, aktif atma zellikleri hakknda bilgi
	alrsnz. Eer parametre nickse, bot hakknda yaratlma 
	zaman veya bulunduu kanal says gibi bilgiler alrsnz.

BOT_HELP_SET
	Kullanm: SET kanalad zellik parametre
	
	Bot zelliklerini ayarlar. zellik unlardan biri olabilir:
	
	    DONTKICKOPS      Botun atmasna kar oplar korur
	    DONTKICKVOICES   Botun atmasna kar voice lar korur
	    GREET            Greet mesajn aktifletirir
	    FANTASY          Fantazi komutlarn aktifletirir
	    SYMBIOSIS        Gerek bot gibi davranmasn salar.
	
	Belirli bir komut hakknda daha fazla bilgi iin 
	%R%S HELP SET zellik yazn.
	
	Not: Bu komuta access eriimi seviye(level) ayaryla salanr.

BOT_HELP_SET_DONTKICKOPS
	Kullanm: SET kanalad DONTKICKOPS {ON|OFF}
	
	Kanalda op korumasn aar yada kapatr.
	Aktifletirildii zaman, oplar bot tarafnda NOKICK
	seviyeleri olmasalar bile atlmazlar.

BOT_HELP_SET_DONTKICKVOICES
	Kullanm: SET kanalad DONTKICKVOICES {ON|OFF}
	
	Kanalda voice korumasn aar yada kapatr.
	Aktifletirildii zaman, voice lar bot tarafndan
	NOKICK seviyeleri olmasalar bile atlmazlar.

BOT_HELP_SET_FANTASY
	Kullanm: SET kanalad FANTASY {ON|OFF}
	
	Kanalda fantazi modunu aar yada kapatr.
	Aktifletirildii zaman, kulanclar kanalda
	!op, !deop, !voice, !devoice, !kick, !kb, 
	!unban, !seen gibi komutlar kullanabilirler. 
	(nasl kullanldklarn renmek iin; onlar 
	nickle ve nicksiz kullann vede bazlarndada sebep 
	belirtin).
	
	Unutmaynki fantazi komutlarn kullanmak
	isteyen kullanclarn FANTASIA ve komutun 
	gerektirdii dier seviyelere yeterli access
	seviyesi olmas gereklidir. (rnein, !op
	komutunu kullanmak iin, kullancnn OPDEOP
	seviyesine yeterli access i olmaldr).

BOT_HELP_SET_GREET
	Kullanm: SET kanalad GREET {ON|OFF}
	
	Kanalda karlama modunu aar yada kapatr.
	Aktifletirildii zaman, bot kanala giren 
	kullanclara bir karlama mesaj gnderir,
	tabi eer bu kiilerin yeterli access leri varsa.

BOT_HELP_SET_SYMBIOSIS
	Kullanm: SET kanalad SYMBIOSIS {ON|OFF}
	
	Kanalda simbiyoz modunu aar yada kapatr.
	Aktifletirildii zaman bot %s'n yapt hereyi
	kendisi yapar. Modelar, kickler, ve giri mesaj gibi.

BOT_HELP_KICK
	Kullanm: KICK kanalad zellik parametre
	
	Botun kick lerini ayarlar. zellik unlardan biri olabilir:
	
	    BOLDS         Kaln yazda atar
	    BADWORDS      Kfrde atar
	    CAPS          Byk yazda atar
	    COLORS        Renkli yazda atar
	    FLOOD         Flood da atar
	    REPEAT        Kendini tekrar edenleri atar
	    REVERSES      Ctrl+r nin kullanlmasnda atar
	    UNDERLINES    Altizgili yazda atar
	
	Belirli bir zellik hakknda daha fazla bilgi iin
	%R%S HELP KICK zellik yazn.
	
	Not: Bu komuta eriim seviye(level) ayaryla yaplr.

BOT_HELP_KICK_BOLDS
	Kullanm: KICK kanalad BOLDS {ON|OFF} [bas]
	
	Kaln yazda atmay aar yada kapatr. 
	Aktifletirildiinde bu zellik bota kaln yaz
	kullananlar atmasn syler.
	
	bas banlamadan nce kiinin ka kez atlacan 
	belirler. Kaldrmak iin komutta bas  belirtmeyin.

BOT_HELP_KICK_COLORS
	Kullanm: KICK kanalad COLORS {ON|OFF} [bas]
	
	Renkli yazda atmay aar yada kapatr. 
	Aktifletirildiinde bu zellik bota renkli yaz 
	kullananlar atmasn syler.
	
	bas banlamadan nce kiinin ka kez atlacan 
	belirler. Kaldrmak iin komutta bas  belirtmeyin.

BOT_HELP_KICK_REVERSES
	Kullanm: KICK kanalad REVERSES {ON|OFF} [bas]
	
	Ctrl+r nin kullanlmasnda atmay aar yada kapatr. 
	Aktifletirildiinde bu zellik bota Ctrl+r yi 
	kullananlar atmasn syler.
	
	bas banlamadan nce kiinin ka kez atlacan 
	belirler. Kaldrmak iin komutta bas  belirtmeyin.

BOT_HELP_KICK_UNDERLINES
	Kullanm: KICK kanalad UNDERLINES {ON|OFF} [bas]
	
	Altizgili yazda atmay aar yada kapatr.
	Aktifletirildiinde bu zellik bota altizgili
	yazanlar atmasn syler.
	
	bas banlamadan nce kiinin ka kez atlacan 
	belirler. Kaldrmak iin komutta bas  belirtmeyin.

BOT_HELP_KICK_CAPS
	Kullanm: KICK kanalad CAPS {ON|OFF} [bas [min [yzde]]]
	
	Byk yazda atmay aar yada kapatr.
	Aktifletirildiinde bu zellik bota byk yaz
	kullananlar atmasn syler.
	
	Bot belirtilen en az(min) byk harfin toplam yaznn
	yzdesine%% bal olarak atar. (Belirtilmemise,
	varsaylan olarak 10 karakter ve 25%% de atar).
	
	bas banlamadan nce kiinin ka kez atlacan 
	belirler. Kaldrmak iin komutta bas  belirtmeyin.

BOT_HELP_KICK_FLOOD
	Kullanm: KICK kanalad FLOOD {ON|OFF} [bas [sra [sn]]]
	
	Flood da atmay aar yada kapatr. Aktifletirildiinde
	bu zellik bota sn saniyede enaz sra srada flood
	yapanlar atmasn syler. (Belirtilmemise varsaylan
	olarak 10 saniyede 6 sra da atar).
	
	bas banlamadan nce kiinin ka kez atlacan 
	belirler. Kaldrmak iin komutta bas  belirtmeyin.

BOT_HELP_KICK_REPEAT
	Kullanm: KICK #kanalad REPEAT {ON|OFF} [bas [say]]
	
	Tekrar yazlan ayn yazda atmay aar yada kapar.
	Aktifletirildiinde bu zellik bota kendilerini
	say kez tekrar edenleri atmasn syler. (Eer
	say belirtilmemise, varsaylan olarak 3 tr).
	
	bas banlamadan nce kiinin ka kez atlacan 
	belirler. Kaldrmak iin komutta bas  belirtmeyin.

BOT_HELP_KICK_BADWORDS
	Kullanm: KICK #channel BADWORDS {ON|OFF} [bas]
	
	Kfrde atmay aar yada kapatr. Aktifletirildiinde
	bu zellik bota kfr edenleri atmasn syler.
	
	Bir kanal iin kfr belirlemek iin BADWORDS komutunu
	kullanabilirsiniz. Ayrntlar iin  %R%S HELP BADWORDS
	yazn.
	
	bas banlamadan nce kiinin ka kez atlacan 
	belirler. Kaldrmak iin komutta bas  belirtmeyin.

BOT_HELP_BADWORDS
	Kullanm:  BADWORDS kanalad ADD kelime [SINGLE | START | END]
	            BADWORDS kanalad DEL {kelime | kayt-no | liste}
	            BADWORDS kanalad LIST [mask | liste]
	            BADWORDS kanalad CLEAR
	
	Bir kanal iin kfr listesi dzenler. Kfr listesi
	kfrde atma aktifletirildii zaman hangi kelimelerde
	atlacan belirler. Daha fazla bilgi iin 
	%R%S HELP KICK BADWORDS yazn.
	
	BADWORDS ADD komutu belirtilen kelimeyi kfr listesine
	ekler. Eer SINGLE parametresi belirtilmise, atma ilemi
	kullanc o kelimenin tamamn sylerse yaplr. Eer START
	parametresi belirtilmise, kullanc o kelimeyle balayan 
	birey sylediinde atlr. Eer END parametresi belirtilmise
	kullanc o kelimeyle biten birey sylediinde atlr.
	Eer bir parametre kullanmazsanz, atma ilemi kullanc o 
	kelimeyi her kullandnda yaplr.
	
	BADWORDS DEL komutu belirtilen kelimeyi kfr listesinden 
	siler. Eer kayt numaras listesi verilirse, o kelimeler
	silinir. (LIST iin aadaki rnei inceleyin) 
	
	BADWORDS LIST komutu kfr listesini grntler. Eer
	bir kfrn bir ksm belirtilmise, o ksma uyan kfrler
	listelenir. Eer bir kayt numaras listesi belirtilmise,
	sadece o kfrler listelenir; rnein:
	
	   BADWORDS #kanalad LIST 2-5,7-9
	      2'den 5'e ve 7'den 9'a kadar olan kfrler 
	      listelenir.
	      
	BADWORDS CLEAR komutu tm kfr listesini temizler.

BOT_HELP_SAY
	Kullanm: SAY kanalad yaz
	
	Botun belirtilen yazy belirtilen kanalda sylemesini salar.

BOT_HELP_ACT
	Kullanm: ACT kanalad yaz
	
	Botun belirtilen yazyla belirtilen kanalda "/me" komutunun 
	yaptn kendi zerinde yapmasn salar.

BOT_SERVADMIN_HELP_BOT
	Kullanm: BOT ADD nick user host gerekismi
	        BOT CHANGE eskinick yeninick [user [host [gerekismi]]]
	        BOT DEL nick
	
	Servis adminlerinin kullanclarn kanallarnda kullanmas 
	iin botlar yaratmasn, deitirmesini ve silmesini salar.
	
	BOT ADD belirtilen nickte, username, hostname ve gerek 
	isimde bir bot ekler. Doruluk snamas yaplmadnda komutu
	kullanrken ok dikkatli olun.
	BOT CHANGE botun nickini, username ini, hostname ini veya
	gerek ismini silmeye gerek kalmadan deitirmeyi salar.
	BOT DEL belirtilen botu bot listesinden siler.
	
	Not: Eer botun nicki olarak, kaytl bir nick
	kullanrsanz o nickin kayd silinir(drop). Ayrca
	o an bir kuulanc bu nicki kullanyorsa kill lenir.

BOT_SERVADMIN_HELP_SET
	
	Bu zellikleri servis adminlerini kullanabilir:
	
	    NOBOT            Bir kanala bot girmesini engeller.
	    PRIVATE          Botun IRC operatrleri haricinde kanallara
	                        sokulmasini engeller

	                        
BOT_SERVADMIN_HELP_SET_NOBOT
	Kullanm: SET kanalad NOBOT {ON|OFF}
	
	Bu zellik bir kanal bot sokulamaz hale getirir. Eer
	kanala zaten bir bot sokulmusa otomatik olarak o bot
	kanaldan karlr.
	
	Servis adminlerinin Kullanmyla snrldr.

BOT_SERVADMIN_HELP_SET_PRIVATE
	Kullanm: SET botun-nicki PRIVATE {ON|OFF}
	
	Bu zellik IRC Operatrleri disindaki userlarin bu
	botlari kanallara sokmalarini engeller.
	
	Bu komutu Servis Adminleri kullanabilir.
HOST_EMPTY
	vhost listesi bo.
HOST_ENTRY
	#%d Nick:%s, vhost:%s (%s - %s)
HOST_IDENT_ENTRY
	#%d Nick:%s, vhost:%s@%s (%s - %s)
HOST_SET
	%s icin vhost %s olarak ayarland.
HOST_IDENT_SET
	%s icin ident %s@%s olarak ayarland.
HOST_SETALL
	%s icin vhost %s olarak ayarland.
HOST_DELALL
	%s icin vhost kaldrld.
HOST_DELALL_SYNTAX
	DELALL <nick>.
HOST_IDENT_SETALL
	%s icin ident %s@%s olarak ayarland.
HOST_SET_ERROR
	Hata! bir vhost sadece A-Z, a-z, 0-9, '.' ve '-' karakterlerini icermelidir.
HOST_SET_IDENT_ERROR
	vhost ident gecerli karakterlerden olumaldr
HOST_SET_TOOLONG
	HATA! Vhost cok uzun, %d karakterden ksa bir host olusturunuz.
HOST_SET_IDENTTOOLONG
	HATA! kimlik cok uzun, %d karakterden ksa bir kimlik olusturunuz..
HOST_NOREG
	%s nickserv veribankasinda bulunmuyor.
HOST_SET_SYNTAX
	SET <nick> <hostmask>.
HOST_SETALL_SYNTAX
	SETALL <nick> <hostmask>.
HOST_DENIED
	Yetkiniz yeterli degil.
HOST_NOT_ASSIGNED
	Vhost talebi icin irc operatorleriniz ile iletisime geciniz.
HOST_ACTIVATED
	%s vhostunuz aktif.
HOST_IDENT_ACTIVATED
	%s@%s vhost ve identiniz aktif.
HOST_ID
	nce servislerimize kendinizi tantmalsnz.
HOST_NOT_REGED
	Vhost istegi icin ncelikle kaytl bir rumuza sahip olmalsnz
HOST_DEL
	%s vhostu silindi.
HOST_DEL_SYNTAX
	DEL <nick>.

###########################################################################
#
# HostServ Help messages
#
###########################################################################
HOST_OFF
	Vhost silindi ve sifrelemi hostunuz kullanlyor.
HOST_OFF_UNREAL
	Vhost silindi fakat ifreleme yaplamadi ltfen tekrar balant kurunuz veya /mode %s +%s komutunu deneyiniz
HOST_NO_VIDENT
	IRCD sisteminiz vIdent'i desteklemiyor. Eer bu doru deilse sorunu bize iletiniz

###########################################################################
#
# HostServ Help messages
#
###########################################################################
HOST_GROUP
	%s grubu icin vhost %s
HOST_IDENT_GROUP
	%s grubu icin vident %s@%s

###########################################################################
#
# HostServ Help messages
#
###########################################################################
HOST_LIST_FOOTER
	Tm kaytlar gsteriliyor (Veri: %d)
HOST_LIST_RANGE_FOOTER
	gsterilen kaytlar %d - %d
HOST_LIST_KEY_FOOTER
	Eleen veriler verilen %s (Veri: %d)

###########################################################################
#
# HostServ Help messages
#
###########################################################################
HOST_HELP_CMD_ON
	    ON          Vhostunuzu aktif eder
HOST_HELP_CMD_OFF
	    OFF         Vhostunuzu deaktif eder
HOST_HELP_CMD_GROUP
	    GROUP       Grubunuza vhost atar
HOST_HELP_CMD_SET
	    SET         Baska bir kullannn vhostunu dzenlemenize yarar
HOST_HELP_CMD_SETALL
	    SETALL      Bir gruptaki tm nicklere o vhost'u atar
HOST_HELP_CMD_DEL
	    DEL         Kullancnn vhostunu siler
HOST_HELP_CMD_DELALL
	    DELALL      Gruptaki tm vhostlar siler
HOST_HELP_CMD_LIST
	    LIST        Vhostlar hakknda bilgi verir.
HOST_OPER_HELP
	n/a
HOST_ADMIN_HELP
	n/a

HOST_HELP
	%S Komutlar:

HOST_HELP_ON
	Kullanm: ON

	Belirlenmis vhostu aktif duruma getirir.
	Bu komut kullanldgnda /WHOIS komutunda bu adresiniz gorunuz
	gerek IP adresinizi sadece siz gorursunuz.

HOST_HELP_SET
	Kullanm: SET <nick> <hostmask>.

	Secilen rumuza vhost atamanz salar
	Eer IRCD sisteminiz Idents'i destekliyor ise,
	SET <nick> <ident>@<hostmask> komutu ile 
	vhost atayabilirsiniz.

	Services operatorleri kullanmna acktr.

HOST_HELP_DELALL
	Kullanm: DELALL <nick>.

	Secilen rumuzun grubundaki tm nicklerin vhostlarno
	silmek icin kullanlr.

	Host Dzenleyici Kullanmna acktr.


HOST_HELP_SETALL
	Kullanm: SETALL <nick> <hostmask>.

	Secilen rumuza ait grubtaki nicklere vhost atamanz salar
	Eer IRCD sisteminiz Idents'i destekliyor ise,
	SETALL <nick> <ident>@<hostmask> komutu ile 
	vhost atayabilirsiniz.

	* NOT, Bu komut daha sonradan gruba katlan nicklere
	vhost atamaz.

	Services operatorleri kullanmna acktr.

HOST_HELP_OFF
	Kullanm: OFF

	Vhost'u pasif konuma getirir.
	Bu komutu kullandktan sonra herhangi birisi size /whois
	cektiginde sizin gercek IP adresinizi grr.

HOST_HELP_DEL
	Kullanm: DEL <nick>

	Veritabanndan rumuza ait olan vhostu kaldrmak icin
	kullanlr.

	Services operatorleri kullanmna acktr.

HOST_HELP_LIST
	Kullanm: LIST [<key>|<#X-Y>]

	Bu komut vhostlar irc operatorlarine listelemed kullanlr
	Eer bir anahtar secilir ise ona elecen ve hostlar gosterilir
	rneklemek gerekir ise - Rob* - eklinde bir girdide
	"Rob" ile baslayan bilgiler gosterilir

	Eer #X-Y eklinde bir girdi verilir ise, sadece X
	ve Y aralg gsterilir, rnek. #1-3 kullanlr ise sadece ilk 3
	nick/vhost gosterilir.

	En fazla gosterilecek bilgi says NSListMax belirtilmitir.
	Cok fazla eleme olmas durumunda liste 1 defada gosterilemeyebilir.

	Services operatorleri kullanmna acktr.

HOST_HELP_GROUP
	Kullanm: GROUP
	
	Bu komut belirtilmis grup icin vhost atar
	Baz grublardaki herkezin ayn vhostu almasn
	salar.

OPER_SVSNICK_UNSUPPORTED
	ZGNZ, SVSNICK Bu sunucuda desteklenmiyor.

OPER_SQLINE_UNSUPPORTED
	ZGNZ, SQLINE Bu sunucuda desteklenmiyor.

OPER_SVSO_UNSUPPORTED
	ZGNZ, OLINE Bu sunucuda desteklenmiyor.

OPER_UMODE_UNSUPPORTED
	ZGNZ, UMODE Bu sunucuda desteklenmiyor.

OPER_SUPER_ADMIN_NOT_ENABLED
	SuperAdmin services.conf'ta aktif durumda degil

